/* CanvasText.c generated by valac 0.45.91, the Vala compiler
 * generated from CanvasText.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <libxml/tree.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <pango/pangocairo.h>

#define TYPE_CANVAS_TEXT (canvas_text_get_type ())
#define CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CANVAS_TEXT, CanvasText))
#define CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CANVAS_TEXT, CanvasTextClass))
#define IS_CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CANVAS_TEXT))
#define IS_CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CANVAS_TEXT))
#define CANVAS_TEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CANVAS_TEXT, CanvasTextClass))

typedef struct _CanvasText CanvasText;
typedef struct _CanvasTextClass CanvasTextClass;
typedef struct _CanvasTextPrivate CanvasTextPrivate;
enum  {
	CANVAS_TEXT_0_PROPERTY,
	CANVAS_TEXT_TEXT_PROPERTY,
	CANVAS_TEXT_POSX_PROPERTY,
	CANVAS_TEXT_POSY_PROPERTY,
	CANVAS_TEXT_WIDTH_PROPERTY,
	CANVAS_TEXT_HEIGHT_PROPERTY,
	CANVAS_TEXT_MARKUP_PROPERTY,
	CANVAS_TEXT_EDIT_PROPERTY,
	CANVAS_TEXT_NUM_PROPERTIES
};
static GParamSpec* canvas_text_properties[CANVAS_TEXT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
typedef struct _Block3Data Block3Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
#define _pango_layout_line_unref0(var) ((var == NULL) ? NULL : (var = (pango_layout_line_unref (var), NULL)))
enum  {
	CANVAS_TEXT_RESIZED_SIGNAL,
	CANVAS_TEXT_NUM_SIGNALS
};
static guint canvas_text_signals[CANVAS_TEXT_NUM_SIGNALS] = {0};

struct _CanvasText {
	GObject parent_instance;
	CanvasTextPrivate * priv;
};

struct _CanvasTextClass {
	GObjectClass parent_class;
	void (*load) (CanvasText* self, xmlNode* n);
	void (*resize) (CanvasText* self, gdouble diff);
};

struct _CanvasTextPrivate {
	gchar* _text;
	gboolean _markup;
	gboolean _edit;
	gint _cursor;
	gint _column;
	PangoLayout* _pango_layout;
	gint _selstart;
	gint _selend;
	gint _selanchor;
	gdouble _max_width;
	gdouble _width;
	gdouble _height;
	gdouble _posx;
	gdouble _posy;
};

struct _Block3Data {
	int _ref_count_;
	CanvasText* self;
	gchar* str;
};

static gint CanvasText_private_offset;
static gpointer canvas_text_parent_class = NULL;

GType canvas_text_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CanvasText, g_object_unref)
GType draw_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
CanvasText* canvas_text_new (DrawArea* da,
                             gdouble max_width);
CanvasText* canvas_text_construct (GType object_type,
                                   DrawArea* da,
                                   gdouble max_width);
void canvas_text_update_size (CanvasText* self,
                              gboolean call_resized);
CanvasText* canvas_text_new_with_text (DrawArea* da,
                                       gdouble max_width,
                                       const gchar* txt);
CanvasText* canvas_text_construct_with_text (GType object_type,
                                             DrawArea* da,
                                             gdouble max_width,
                                             const gchar* txt);
void canvas_text_copy (CanvasText* self,
                       CanvasText* ct);
gdouble canvas_text_get_posx (CanvasText* self);
void canvas_text_set_posx (CanvasText* self,
                           gdouble value);
gdouble canvas_text_get_posy (CanvasText* self);
void canvas_text_set_posy (CanvasText* self,
                           gdouble value);
const gchar* canvas_text_get_text (CanvasText* self);
gint canvas_text_max_width (CanvasText* self);
void canvas_text_set_font (CanvasText* self,
                           PangoFontDescription* font);
gboolean canvas_text_is_wrapped (CanvasText* self);
gchar* canvas_text_get_wrapped_text (CanvasText* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda34_ (Block3Data* _data3_,
                  PangoLayoutLine* item);
static void ___lambda34__gfunc (gconstpointer data,
                         gpointer self);
gboolean canvas_text_is_within (CanvasText* self,
                                gdouble x,
                                gdouble y);
gboolean utils_is_within_bounds (gdouble x,
                                 gdouble y,
                                 gdouble bx,
                                 gdouble by,
                                 gdouble bw,
                                 gdouble bh);
void canvas_text_load (CanvasText* self,
                       xmlNode* n);
static void canvas_text_real_load (CanvasText* self,
                            xmlNode* n);
void canvas_text_set_text (CanvasText* self,
                           const gchar* value);
static gchar* canvas_text_unmarkup (CanvasText* self,
                             const gchar* markup);
GType theme_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
static gchar* canvas_text_name_markup (CanvasText* self,
                                Theme* theme);
gchar* utils_color_from_rgba (GdkRGBA* rgba);
GdkRGBA* theme_get_color (Theme* self,
                          const gchar* name);
gboolean canvas_text_get_markup (CanvasText* self);
gboolean canvas_text_get_edit (CanvasText* self);
void canvas_text_resize (CanvasText* self,
                         gdouble diff);
static void canvas_text_real_resize (CanvasText* self,
                              gdouble diff);
static void canvas_text_update_column (CanvasText* self);
void canvas_text_set_cursor_at_char (CanvasText* self,
                                     gdouble x,
                                     gdouble y,
                                     gboolean motion);
void canvas_text_set_cursor_at_word (CanvasText* self,
                                     gdouble x,
                                     gdouble y,
                                     gboolean motion);
void canvas_text_clear_selection (CanvasText* self);
static void canvas_text_adjust_selection (CanvasText* self,
                                   gint last_cursor);
void canvas_text_set_cursor_none (CanvasText* self);
void canvas_text_set_cursor_all (CanvasText* self,
                                 gboolean motion);
static void canvas_text_cursor_by_char (CanvasText* self,
                                 gint dir);
void canvas_text_move_cursor (CanvasText* self,
                              gint dir);
void canvas_text_selection_by_char (CanvasText* self,
                                    gint dir);
static void canvas_text_cursor_by_line (CanvasText* self,
                                 gint dir);
void canvas_text_move_cursor_vertically (CanvasText* self,
                                         gint dir);
void canvas_text_selection_vertically (CanvasText* self,
                                       gint dir);
void canvas_text_move_cursor_to_start (CanvasText* self);
void canvas_text_move_cursor_to_end (CanvasText* self);
void canvas_text_selection_to_start (CanvasText* self);
void canvas_text_selection_to_end (CanvasText* self);
static gint canvas_text_find_word (CanvasText* self,
                            gint start,
                            gint dir);
void canvas_text_move_cursor_by_word (CanvasText* self,
                                      gint dir);
void canvas_text_selection_by_word (CanvasText* self,
                                    gint dir);
void canvas_text_backspace (CanvasText* self);
void canvas_text_delete (CanvasText* self);
void canvas_text_insert (CanvasText* self,
                         const gchar* s);
gchar* canvas_text_get_selected_text (CanvasText* self);
void canvas_text_get_cursor_pos (CanvasText* self,
                                 gint* x,
                                 gint* ytop,
                                 gint* ybot);
void canvas_text_draw (CanvasText* self,
                       cairo_t* ctx,
                       Theme* theme,
                       GdkRGBA* fg,
                       gdouble alpha);
void utils_set_context_color_with_alpha (cairo_t* ctx,
                                         GdkRGBA* color,
                                         gdouble alpha);
gdouble canvas_text_get_width (CanvasText* self);
gdouble canvas_text_get_height (CanvasText* self);
void canvas_text_set_markup (CanvasText* self,
                             gboolean value);
void canvas_text_set_edit (CanvasText* self,
                           gboolean value);
static void canvas_text_finalize (GObject * obj);
static void _vala_canvas_text_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_canvas_text_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
canvas_text_get_instance_private (CanvasText* self)
{
	return G_STRUCT_MEMBER_P (self, CanvasText_private_offset);
}

CanvasText*
canvas_text_construct (GType object_type,
                       DrawArea* da,
                       gdouble max_width)
{
	CanvasText * self = NULL;
	PangoLayout* _tmp0_;
	PangoLayout* _tmp1_;
	PangoLayout* _tmp2_;
#line 95 "../src/CanvasText.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 95 "../src/CanvasText.vala"
	self = (CanvasText*) g_object_new (object_type, NULL);
#line 96 "../src/CanvasText.vala"
	self->priv->_max_width = max_width;
#line 97 "../src/CanvasText.vala"
	_tmp0_ = gtk_widget_create_pango_layout ((GtkWidget*) da, NULL);
#line 97 "../src/CanvasText.vala"
	_g_object_unref0 (self->priv->_pango_layout);
#line 97 "../src/CanvasText.vala"
	self->priv->_pango_layout = _tmp0_;
#line 98 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_pango_layout;
#line 98 "../src/CanvasText.vala"
	pango_layout_set_wrap (_tmp1_, PANGO_WRAP_WORD_CHAR);
#line 99 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 99 "../src/CanvasText.vala"
	pango_layout_set_width (_tmp2_, ((gint) self->priv->_max_width) * PANGO_SCALE);
#line 100 "../src/CanvasText.vala"
	canvas_text_update_size (self, FALSE);
#line 95 "../src/CanvasText.vala"
	return self;
#line 308 "CanvasText.c"
}

CanvasText*
canvas_text_new (DrawArea* da,
                 gdouble max_width)
{
#line 95 "../src/CanvasText.vala"
	return canvas_text_construct (TYPE_CANVAS_TEXT, da, max_width);
#line 317 "CanvasText.c"
}

CanvasText*
canvas_text_construct_with_text (GType object_type,
                                 DrawArea* da,
                                 gdouble max_width,
                                 const gchar* txt)
{
	CanvasText * self = NULL;
	PangoLayout* _tmp0_;
	PangoLayout* _tmp1_;
	PangoLayout* _tmp2_;
	gchar* _tmp3_;
#line 104 "../src/CanvasText.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 104 "../src/CanvasText.vala"
	g_return_val_if_fail (txt != NULL, NULL);
#line 104 "../src/CanvasText.vala"
	self = (CanvasText*) g_object_new (object_type, NULL);
#line 105 "../src/CanvasText.vala"
	self->priv->_max_width = max_width;
#line 106 "../src/CanvasText.vala"
	_tmp0_ = gtk_widget_create_pango_layout ((GtkWidget*) da, txt);
#line 106 "../src/CanvasText.vala"
	_g_object_unref0 (self->priv->_pango_layout);
#line 106 "../src/CanvasText.vala"
	self->priv->_pango_layout = _tmp0_;
#line 107 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_pango_layout;
#line 107 "../src/CanvasText.vala"
	pango_layout_set_wrap (_tmp1_, PANGO_WRAP_WORD_CHAR);
#line 108 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 108 "../src/CanvasText.vala"
	pango_layout_set_width (_tmp2_, ((gint) self->priv->_max_width) * PANGO_SCALE);
#line 109 "../src/CanvasText.vala"
	_tmp3_ = g_strdup (txt);
#line 109 "../src/CanvasText.vala"
	_g_free0 (self->priv->_text);
#line 109 "../src/CanvasText.vala"
	self->priv->_text = _tmp3_;
#line 110 "../src/CanvasText.vala"
	canvas_text_update_size (self, FALSE);
#line 104 "../src/CanvasText.vala"
	return self;
#line 363 "CanvasText.c"
}

CanvasText*
canvas_text_new_with_text (DrawArea* da,
                           gdouble max_width,
                           const gchar* txt)
{
#line 104 "../src/CanvasText.vala"
	return canvas_text_construct_with_text (TYPE_CANVAS_TEXT, da, max_width, txt);
#line 373 "CanvasText.c"
}

void
canvas_text_copy (CanvasText* self,
                  CanvasText* ct)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	PangoLayout* _tmp5_;
	PangoLayout* _tmp6_;
	PangoFontDescription* _tmp7_;
	PangoLayout* _tmp8_;
#line 114 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/CanvasText.vala"
	g_return_if_fail (ct != NULL);
#line 115 "../src/CanvasText.vala"
	_tmp0_ = ct->priv->_posx;
#line 115 "../src/CanvasText.vala"
	canvas_text_set_posx (self, _tmp0_);
#line 116 "../src/CanvasText.vala"
	_tmp1_ = ct->priv->_posy;
#line 116 "../src/CanvasText.vala"
	canvas_text_set_posy (self, _tmp1_);
#line 117 "../src/CanvasText.vala"
	self->priv->_max_width = ct->priv->_max_width;
#line 118 "../src/CanvasText.vala"
	_tmp2_ = canvas_text_get_text (ct);
#line 118 "../src/CanvasText.vala"
	_tmp3_ = _tmp2_;
#line 118 "../src/CanvasText.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 118 "../src/CanvasText.vala"
	_g_free0 (self->priv->_text);
#line 118 "../src/CanvasText.vala"
	self->priv->_text = _tmp4_;
#line 119 "../src/CanvasText.vala"
	_tmp5_ = self->priv->_pango_layout;
#line 119 "../src/CanvasText.vala"
	_tmp6_ = ct->priv->_pango_layout;
#line 119 "../src/CanvasText.vala"
	_tmp7_ = pango_layout_get_font_description (_tmp6_);
#line 119 "../src/CanvasText.vala"
	pango_layout_set_font_description (_tmp5_, _tmp7_);
#line 120 "../src/CanvasText.vala"
	_tmp8_ = self->priv->_pango_layout;
#line 120 "../src/CanvasText.vala"
	pango_layout_set_width (_tmp8_, ((gint) self->priv->_max_width) * PANGO_SCALE);
#line 121 "../src/CanvasText.vala"
	canvas_text_update_size (self, TRUE);
#line 427 "CanvasText.c"
}

gint
canvas_text_max_width (CanvasText* self)
{
	gint result = 0;
#line 125 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 126 "../src/CanvasText.vala"
	result = (gint) self->priv->_max_width;
#line 126 "../src/CanvasText.vala"
	return result;
#line 440 "CanvasText.c"
}

void
canvas_text_set_font (CanvasText* self,
                      PangoFontDescription* font)
{
	PangoLayout* _tmp0_;
#line 130 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/CanvasText.vala"
	g_return_if_fail (font != NULL);
#line 131 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 131 "../src/CanvasText.vala"
	pango_layout_set_font_description (_tmp0_, font);
#line 132 "../src/CanvasText.vala"
	canvas_text_update_size (self, TRUE);
#line 458 "CanvasText.c"
}

gboolean
canvas_text_is_wrapped (CanvasText* self)
{
	gboolean result = FALSE;
	PangoLayout* _tmp0_;
#line 136 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 137 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 137 "../src/CanvasText.vala"
	result = pango_layout_is_wrapped (_tmp0_);
#line 137 "../src/CanvasText.vala"
	return result;
#line 474 "CanvasText.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 141 "../src/CanvasText.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 141 "../src/CanvasText.vala"
	return _data3_;
#line 484 "CanvasText.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 141 "../src/CanvasText.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 494 "CanvasText.c"
		CanvasText* self;
#line 141 "../src/CanvasText.vala"
		self = _data3_->self;
#line 141 "../src/CanvasText.vala"
		_g_free0 (_data3_->str);
#line 141 "../src/CanvasText.vala"
		_g_object_unref0 (self);
#line 141 "../src/CanvasText.vala"
		g_slice_free (Block3Data, _data3_);
#line 504 "CanvasText.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1395 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1395 "glib-2.0.vapi"
	end = _tmp0_;
#line 1396 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1396 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1397 "glib-2.0.vapi"
		result = maxlen;
#line 1397 "glib-2.0.vapi"
		return result;
#line 528 "CanvasText.c"
	} else {
		gchar* _tmp2_;
#line 1399 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1399 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1399 "glib-2.0.vapi"
		return result;
#line 537 "CanvasText.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1408 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 556 "CanvasText.c"
	} else {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 560 "CanvasText.c"
	}
#line 1408 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1410 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 566 "CanvasText.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1412 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1412 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1412 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 576 "CanvasText.c"
	}
#line 1415 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1416 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1417 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 584 "CanvasText.c"
	} else {
#line 1419 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 588 "CanvasText.c"
	}
#line 1421 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1422 "glib-2.0.vapi"
		len = string_length - offset;
#line 594 "CanvasText.c"
	}
#line 1424 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1425 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1425 "glib-2.0.vapi"
	result = _tmp3_;
#line 1425 "glib-2.0.vapi"
	return result;
#line 604 "CanvasText.c"
}

static void
__lambda34_ (Block3Data* _data3_,
             PangoLayoutLine* item)
{
	CanvasText* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 144 "../src/CanvasText.vala"
	self = _data3_->self;
#line 144 "../src/CanvasText.vala"
	g_return_if_fail (item != NULL);
#line 145 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 145 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 145 "../src/CanvasText.vala"
	_tmp2_ = string_substring (_tmp1_, (glong) item->start_index, (glong) item->length);
#line 145 "../src/CanvasText.vala"
	_tmp3_ = _tmp2_;
#line 145 "../src/CanvasText.vala"
	_tmp4_ = g_strconcat (_tmp3_, "\n", NULL);
#line 145 "../src/CanvasText.vala"
	_tmp5_ = _tmp4_;
#line 145 "../src/CanvasText.vala"
	_tmp6_ = g_strconcat (_data3_->str, _tmp5_, NULL);
#line 145 "../src/CanvasText.vala"
	_g_free0 (_data3_->str);
#line 145 "../src/CanvasText.vala"
	_data3_->str = _tmp6_;
#line 145 "../src/CanvasText.vala"
	_g_free0 (_tmp5_);
#line 145 "../src/CanvasText.vala"
	_g_free0 (_tmp3_);
#line 645 "CanvasText.c"
}

static void
___lambda34__gfunc (gconstpointer data,
                    gpointer self)
{
#line 144 "../src/CanvasText.vala"
	__lambda34_ (self, (PangoLayoutLine*) data);
#line 654 "CanvasText.c"
}

gchar*
canvas_text_get_wrapped_text (CanvasText* self)
{
	gchar* result = NULL;
	Block3Data* _data3_;
	GSList* lines = NULL;
	PangoLayout* _tmp0_;
	GSList* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 141 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 141 "../src/CanvasText.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 141 "../src/CanvasText.vala"
	_data3_->_ref_count_ = 1;
#line 141 "../src/CanvasText.vala"
	_data3_->self = g_object_ref (self);
#line 142 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 142 "../src/CanvasText.vala"
	_tmp1_ = pango_layout_get_lines_readonly (_tmp0_);
#line 142 "../src/CanvasText.vala"
	lines = _tmp1_;
#line 143 "../src/CanvasText.vala"
	_tmp2_ = g_strdup ("");
#line 143 "../src/CanvasText.vala"
	_data3_->str = _tmp2_;
#line 144 "../src/CanvasText.vala"
	g_slist_foreach (lines, ___lambda34__gfunc, _data3_);
#line 147 "../src/CanvasText.vala"
	_tmp3_ = g_strdup (_data3_->str);
#line 147 "../src/CanvasText.vala"
	result = _tmp3_;
#line 147 "../src/CanvasText.vala"
	block3_data_unref (_data3_);
#line 147 "../src/CanvasText.vala"
	_data3_ = NULL;
#line 147 "../src/CanvasText.vala"
	return result;
#line 697 "CanvasText.c"
}

gboolean
canvas_text_is_within (CanvasText* self,
                       gdouble x,
                       gdouble y)
{
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 151 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 152 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_posx;
#line 152 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_posy;
#line 152 "../src/CanvasText.vala"
	result = utils_is_within_bounds (x, y, _tmp0_, _tmp1_, self->priv->_width, self->priv->_height);
#line 152 "../src/CanvasText.vala"
	return result;
#line 718 "CanvasText.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
#line 944 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 945 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 945 "glib-2.0.vapi"
	return result;
#line 731 "CanvasText.c"
}

static void
canvas_text_real_load (CanvasText* self,
                       xmlNode* n)
{
	gchar* x = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* y = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* mw = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gboolean _tmp10_ = FALSE;
	xmlNode* _tmp11_;
#line 158 "../src/CanvasText.vala"
	_tmp0_ = (gchar*) xmlGetProp (n, (xmlChar*) "posx");
#line 158 "../src/CanvasText.vala"
	x = _tmp0_;
#line 159 "../src/CanvasText.vala"
	_tmp1_ = x;
#line 159 "../src/CanvasText.vala"
	if (_tmp1_ != NULL) {
#line 757 "CanvasText.c"
		const gchar* _tmp2_;
#line 160 "../src/CanvasText.vala"
		_tmp2_ = x;
#line 160 "../src/CanvasText.vala"
		canvas_text_set_posx (self, double_parse (_tmp2_));
#line 763 "CanvasText.c"
	}
#line 163 "../src/CanvasText.vala"
	_tmp3_ = (gchar*) xmlGetProp (n, (xmlChar*) "posy");
#line 163 "../src/CanvasText.vala"
	y = _tmp3_;
#line 164 "../src/CanvasText.vala"
	_tmp4_ = y;
#line 164 "../src/CanvasText.vala"
	if (_tmp4_ != NULL) {
#line 773 "CanvasText.c"
		const gchar* _tmp5_;
#line 165 "../src/CanvasText.vala"
		_tmp5_ = y;
#line 165 "../src/CanvasText.vala"
		canvas_text_set_posy (self, double_parse (_tmp5_));
#line 779 "CanvasText.c"
	}
#line 168 "../src/CanvasText.vala"
	_tmp6_ = (gchar*) xmlGetProp (n, (xmlChar*) "maxwidth");
#line 168 "../src/CanvasText.vala"
	mw = _tmp6_;
#line 169 "../src/CanvasText.vala"
	_tmp7_ = mw;
#line 169 "../src/CanvasText.vala"
	if (_tmp7_ != NULL) {
#line 789 "CanvasText.c"
		const gchar* _tmp8_;
		PangoLayout* _tmp9_;
#line 170 "../src/CanvasText.vala"
		_tmp8_ = mw;
#line 170 "../src/CanvasText.vala"
		self->priv->_max_width = double_parse (_tmp8_);
#line 171 "../src/CanvasText.vala"
		_tmp9_ = self->priv->_pango_layout;
#line 171 "../src/CanvasText.vala"
		pango_layout_set_width (_tmp9_, ((gint) self->priv->_max_width) * PANGO_SCALE);
#line 800 "CanvasText.c"
	}
#line 174 "../src/CanvasText.vala"
	_tmp11_ = n->children;
#line 174 "../src/CanvasText.vala"
	if (_tmp11_ != NULL) {
#line 806 "CanvasText.c"
		xmlNode* _tmp12_;
		xmlElementType _tmp13_;
#line 174 "../src/CanvasText.vala"
		_tmp12_ = n->children;
#line 174 "../src/CanvasText.vala"
		_tmp13_ = _tmp12_->type;
#line 174 "../src/CanvasText.vala"
		_tmp10_ = _tmp13_ == XML_TEXT_NODE;
#line 815 "CanvasText.c"
	} else {
#line 174 "../src/CanvasText.vala"
		_tmp10_ = FALSE;
#line 819 "CanvasText.c"
	}
#line 174 "../src/CanvasText.vala"
	if (_tmp10_) {
#line 823 "CanvasText.c"
		xmlNode* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 175 "../src/CanvasText.vala"
		_tmp14_ = n->children;
#line 175 "../src/CanvasText.vala"
		_tmp15_ = (gchar*) xmlNodeGetContent (_tmp14_);
#line 175 "../src/CanvasText.vala"
		_tmp16_ = _tmp15_;
#line 175 "../src/CanvasText.vala"
		canvas_text_set_text (self, _tmp16_);
#line 175 "../src/CanvasText.vala"
		_g_free0 (_tmp16_);
#line 837 "CanvasText.c"
	}
#line 156 "../src/CanvasText.vala"
	_g_free0 (mw);
#line 156 "../src/CanvasText.vala"
	_g_free0 (y);
#line 156 "../src/CanvasText.vala"
	_g_free0 (x);
#line 845 "CanvasText.c"
}

void
canvas_text_load (CanvasText* self,
                  xmlNode* n)
{
#line 156 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/CanvasText.vala"
	CANVAS_TEXT_GET_CLASS (self)->load (self, n);
#line 856 "CanvasText.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 878 "CanvasText.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 882 "CanvasText.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 888 "CanvasText.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 892 "CanvasText.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp0_) {
#line 896 "CanvasText.c"
		gchar* _tmp2_;
#line 1482 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1482 "glib-2.0.vapi"
		result = _tmp2_;
#line 1482 "glib-2.0.vapi"
		return result;
#line 904 "CanvasText.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1485 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1485 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1485 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1485 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1485 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1485 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1485 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1485 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 932 "CanvasText.c"
				goto __catch21_g_regex_error;
			}
#line 1485 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1485 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1485 "glib-2.0.vapi"
			return NULL;
#line 941 "CanvasText.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1486 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1486 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1486 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 955 "CanvasText.c"
				goto __catch21_g_regex_error;
			}
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1486 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1486 "glib-2.0.vapi"
			return NULL;
#line 966 "CanvasText.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1486 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1486 "glib-2.0.vapi"
		result = _tmp10_;
#line 1486 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1486 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
		return result;
#line 980 "CanvasText.c"
	}
	goto __finally21;
	__catch21_g_regex_error:
	{
		GError* e = NULL;
#line 1484 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1484 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1488 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1484 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 994 "CanvasText.c"
	}
	__finally21:
#line 1484 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1484 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1484 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1484 "glib-2.0.vapi"
		return NULL;
#line 1005 "CanvasText.c"
	}
}

static gchar*
canvas_text_unmarkup (CanvasText* self,
                      const gchar* markup)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 181 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 181 "../src/CanvasText.vala"
	g_return_val_if_fail (markup != NULL, NULL);
#line 182 "../src/CanvasText.vala"
	_tmp0_ = string_replace (markup, "&", "&amp;");
#line 182 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 182 "../src/CanvasText.vala"
	_tmp2_ = string_replace (_tmp1_, "<", "&lt;");
#line 182 "../src/CanvasText.vala"
	_tmp3_ = _tmp2_;
#line 182 "../src/CanvasText.vala"
	_tmp4_ = string_replace (_tmp3_, ">", "&gt;");
#line 182 "../src/CanvasText.vala"
	_tmp5_ = _tmp4_;
#line 182 "../src/CanvasText.vala"
	_g_free0 (_tmp3_);
#line 182 "../src/CanvasText.vala"
	_g_free0 (_tmp1_);
#line 182 "../src/CanvasText.vala"
	result = _tmp5_;
#line 182 "../src/CanvasText.vala"
	return result;
#line 1044 "CanvasText.c"
}

static gint
string_index_of_nth_char (const gchar* self,
                          glong c)
{
	gint result = 0;
	gchar* _tmp0_;
#line 1230 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1231 "glib-2.0.vapi"
	_tmp0_ = g_utf8_offset_to_pointer (self, c);
#line 1231 "glib-2.0.vapi"
	result = (gint) (_tmp0_ - ((gchar*) self));
#line 1231 "glib-2.0.vapi"
	return result;
#line 1061 "CanvasText.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
#line 1428 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1429 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1429 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1429 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1430 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1431 "glib-2.0.vapi"
		start = string_length + start;
#line 1088 "CanvasText.c"
	}
#line 1433 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1434 "glib-2.0.vapi"
		end = string_length + end;
#line 1094 "CanvasText.c"
	}
#line 1436 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1436 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1100 "CanvasText.c"
	} else {
#line 1436 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1104 "CanvasText.c"
	}
#line 1436 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1437 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1437 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1112 "CanvasText.c"
	} else {
#line 1437 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1116 "CanvasText.c"
	}
#line 1437 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1438 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1439 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1439 "glib-2.0.vapi"
	result = _tmp4_;
#line 1439 "glib-2.0.vapi"
	return result;
#line 1128 "CanvasText.c"
}

static gchar*
canvas_text_name_markup (CanvasText* self,
                         Theme* theme)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp56_ = NULL;
	gboolean _tmp57_ = FALSE;
	gboolean _tmp58_;
	gboolean _tmp59_;
#line 186 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 187 "../src/CanvasText.vala"
	if (self->priv->_selstart != self->priv->_selend) {
#line 187 "../src/CanvasText.vala"
		_tmp0_ = theme != NULL;
#line 1147 "CanvasText.c"
	} else {
#line 187 "../src/CanvasText.vala"
		_tmp0_ = FALSE;
#line 1151 "CanvasText.c"
	}
#line 187 "../src/CanvasText.vala"
	if (_tmp0_) {
#line 1155 "CanvasText.c"
		gchar* fg = NULL;
		GdkRGBA* _tmp1_;
		GdkRGBA* _tmp2_;
		GdkRGBA _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* bg = NULL;
		GdkRGBA* _tmp6_;
		GdkRGBA* _tmp7_;
		GdkRGBA _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gint spos = 0;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gint epos = 0;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* begtext = NULL;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* endtext = NULL;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* seltext = NULL;
		const gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		const gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		const gchar* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		const gchar* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		const gchar* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
#line 188 "../src/CanvasText.vala"
		_tmp1_ = theme_get_color (theme, "textsel_foreground");
#line 188 "../src/CanvasText.vala"
		_tmp2_ = _tmp1_;
#line 188 "../src/CanvasText.vala"
		_tmp3_ = *_tmp2_;
#line 188 "../src/CanvasText.vala"
		_tmp4_ = utils_color_from_rgba (&_tmp3_);
#line 188 "../src/CanvasText.vala"
		_tmp5_ = _tmp4_;
#line 188 "../src/CanvasText.vala"
		_g_free0 (_tmp2_);
#line 188 "../src/CanvasText.vala"
		fg = _tmp5_;
#line 189 "../src/CanvasText.vala"
		_tmp6_ = theme_get_color (theme, "textsel_background");
#line 189 "../src/CanvasText.vala"
		_tmp7_ = _tmp6_;
#line 189 "../src/CanvasText.vala"
		_tmp8_ = *_tmp7_;
#line 189 "../src/CanvasText.vala"
		_tmp9_ = utils_color_from_rgba (&_tmp8_);
#line 189 "../src/CanvasText.vala"
		_tmp10_ = _tmp9_;
#line 189 "../src/CanvasText.vala"
		_g_free0 (_tmp7_);
#line 189 "../src/CanvasText.vala"
		bg = _tmp10_;
#line 190 "../src/CanvasText.vala"
		_tmp11_ = canvas_text_get_text (self);
#line 190 "../src/CanvasText.vala"
		_tmp12_ = _tmp11_;
#line 190 "../src/CanvasText.vala"
		spos = string_index_of_nth_char (_tmp12_, (glong) self->priv->_selstart);
#line 191 "../src/CanvasText.vala"
		_tmp13_ = canvas_text_get_text (self);
#line 191 "../src/CanvasText.vala"
		_tmp14_ = _tmp13_;
#line 191 "../src/CanvasText.vala"
		epos = string_index_of_nth_char (_tmp14_, (glong) self->priv->_selend);
#line 192 "../src/CanvasText.vala"
		_tmp15_ = canvas_text_get_text (self);
#line 192 "../src/CanvasText.vala"
		_tmp16_ = _tmp15_;
#line 192 "../src/CanvasText.vala"
		_tmp17_ = string_slice (_tmp16_, (glong) 0, (glong) spos);
#line 192 "../src/CanvasText.vala"
		_tmp18_ = _tmp17_;
#line 192 "../src/CanvasText.vala"
		_tmp19_ = canvas_text_unmarkup (self, _tmp18_);
#line 192 "../src/CanvasText.vala"
		_tmp20_ = _tmp19_;
#line 192 "../src/CanvasText.vala"
		_g_free0 (_tmp18_);
#line 192 "../src/CanvasText.vala"
		begtext = _tmp20_;
#line 193 "../src/CanvasText.vala"
		_tmp21_ = canvas_text_get_text (self);
#line 193 "../src/CanvasText.vala"
		_tmp22_ = _tmp21_;
#line 193 "../src/CanvasText.vala"
		_tmp23_ = canvas_text_get_text (self);
#line 193 "../src/CanvasText.vala"
		_tmp24_ = _tmp23_;
#line 193 "../src/CanvasText.vala"
		_tmp25_ = string_slice (_tmp22_, (glong) epos, (glong) g_utf8_strlen (_tmp24_, (gssize) -1));
#line 193 "../src/CanvasText.vala"
		_tmp26_ = _tmp25_;
#line 193 "../src/CanvasText.vala"
		_tmp27_ = canvas_text_unmarkup (self, _tmp26_);
#line 193 "../src/CanvasText.vala"
		_tmp28_ = _tmp27_;
#line 193 "../src/CanvasText.vala"
		_g_free0 (_tmp26_);
#line 193 "../src/CanvasText.vala"
		endtext = _tmp28_;
#line 194 "../src/CanvasText.vala"
		_tmp29_ = fg;
#line 194 "../src/CanvasText.vala"
		_tmp30_ = g_strconcat ("<span foreground=\"", _tmp29_, NULL);
#line 194 "../src/CanvasText.vala"
		_tmp31_ = _tmp30_;
#line 194 "../src/CanvasText.vala"
		_tmp32_ = g_strconcat (_tmp31_, "\" background=\"", NULL);
#line 194 "../src/CanvasText.vala"
		_tmp33_ = _tmp32_;
#line 194 "../src/CanvasText.vala"
		_tmp34_ = bg;
#line 194 "../src/CanvasText.vala"
		_tmp35_ = g_strconcat (_tmp33_, _tmp34_, NULL);
#line 194 "../src/CanvasText.vala"
		_tmp36_ = _tmp35_;
#line 194 "../src/CanvasText.vala"
		_tmp37_ = g_strconcat (_tmp36_, "\">", NULL);
#line 194 "../src/CanvasText.vala"
		_tmp38_ = _tmp37_;
#line 194 "../src/CanvasText.vala"
		_tmp39_ = canvas_text_get_text (self);
#line 194 "../src/CanvasText.vala"
		_tmp40_ = _tmp39_;
#line 194 "../src/CanvasText.vala"
		_tmp41_ = string_slice (_tmp40_, (glong) spos, (glong) epos);
#line 194 "../src/CanvasText.vala"
		_tmp42_ = _tmp41_;
#line 194 "../src/CanvasText.vala"
		_tmp43_ = canvas_text_unmarkup (self, _tmp42_);
#line 194 "../src/CanvasText.vala"
		_tmp44_ = _tmp43_;
#line 194 "../src/CanvasText.vala"
		_tmp45_ = g_strconcat (_tmp38_, _tmp44_, NULL);
#line 194 "../src/CanvasText.vala"
		_tmp46_ = _tmp45_;
#line 194 "../src/CanvasText.vala"
		_tmp47_ = g_strconcat (_tmp46_, "</span>", NULL);
#line 194 "../src/CanvasText.vala"
		_tmp48_ = _tmp47_;
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp46_);
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp44_);
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp42_);
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp38_);
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp36_);
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp33_);
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp31_);
#line 194 "../src/CanvasText.vala"
		seltext = _tmp48_;
#line 195 "../src/CanvasText.vala"
		_tmp49_ = begtext;
#line 195 "../src/CanvasText.vala"
		_tmp50_ = seltext;
#line 195 "../src/CanvasText.vala"
		_tmp51_ = g_strconcat (_tmp49_, _tmp50_, NULL);
#line 195 "../src/CanvasText.vala"
		_tmp52_ = _tmp51_;
#line 195 "../src/CanvasText.vala"
		_tmp53_ = endtext;
#line 195 "../src/CanvasText.vala"
		_tmp54_ = g_strconcat (_tmp52_, _tmp53_, NULL);
#line 195 "../src/CanvasText.vala"
		_tmp55_ = _tmp54_;
#line 195 "../src/CanvasText.vala"
		_g_free0 (_tmp52_);
#line 195 "../src/CanvasText.vala"
		result = _tmp55_;
#line 195 "../src/CanvasText.vala"
		_g_free0 (seltext);
#line 195 "../src/CanvasText.vala"
		_g_free0 (endtext);
#line 195 "../src/CanvasText.vala"
		_g_free0 (begtext);
#line 195 "../src/CanvasText.vala"
		_g_free0 (bg);
#line 195 "../src/CanvasText.vala"
		_g_free0 (fg);
#line 195 "../src/CanvasText.vala"
		return result;
#line 1380 "CanvasText.c"
	}
#line 197 "../src/CanvasText.vala"
	_tmp58_ = canvas_text_get_markup (self);
#line 197 "../src/CanvasText.vala"
	_tmp59_ = _tmp58_;
#line 197 "../src/CanvasText.vala"
	if (_tmp59_) {
#line 197 "../src/CanvasText.vala"
		_tmp57_ = TRUE;
#line 1390 "CanvasText.c"
	} else {
		gboolean _tmp60_;
		gboolean _tmp61_;
#line 197 "../src/CanvasText.vala"
		_tmp60_ = canvas_text_get_edit (self);
#line 197 "../src/CanvasText.vala"
		_tmp61_ = _tmp60_;
#line 197 "../src/CanvasText.vala"
		_tmp57_ = _tmp61_;
#line 1400 "CanvasText.c"
	}
#line 197 "../src/CanvasText.vala"
	if (_tmp57_) {
#line 1404 "CanvasText.c"
		const gchar* _tmp62_;
		const gchar* _tmp63_;
		gchar* _tmp64_;
#line 197 "../src/CanvasText.vala"
		_tmp62_ = canvas_text_get_text (self);
#line 197 "../src/CanvasText.vala"
		_tmp63_ = _tmp62_;
#line 197 "../src/CanvasText.vala"
		_tmp64_ = g_strdup (_tmp63_);
#line 197 "../src/CanvasText.vala"
		_g_free0 (_tmp56_);
#line 197 "../src/CanvasText.vala"
		_tmp56_ = _tmp64_;
#line 1418 "CanvasText.c"
	} else {
		const gchar* _tmp65_;
		const gchar* _tmp66_;
		gchar* _tmp67_;
#line 197 "../src/CanvasText.vala"
		_tmp65_ = canvas_text_get_text (self);
#line 197 "../src/CanvasText.vala"
		_tmp66_ = _tmp65_;
#line 197 "../src/CanvasText.vala"
		_tmp67_ = canvas_text_unmarkup (self, _tmp66_);
#line 197 "../src/CanvasText.vala"
		_g_free0 (_tmp56_);
#line 197 "../src/CanvasText.vala"
		_tmp56_ = _tmp67_;
#line 1433 "CanvasText.c"
	}
#line 197 "../src/CanvasText.vala"
	result = _tmp56_;
#line 197 "../src/CanvasText.vala"
	return result;
#line 1439 "CanvasText.c"
}

void
canvas_text_update_size (CanvasText* self,
                         gboolean call_resized)
{
	PangoLayout* _tmp0_;
#line 203 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 204 "../src/CanvasText.vala"
	if (_tmp0_ != NULL) {
#line 1453 "CanvasText.c"
		gint text_width = 0;
		gint text_height = 0;
		PangoLayout* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		PangoLayout* _tmp4_;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
#line 206 "../src/CanvasText.vala"
		_tmp1_ = self->priv->_pango_layout;
#line 206 "../src/CanvasText.vala"
		_tmp2_ = canvas_text_name_markup (self, NULL);
#line 206 "../src/CanvasText.vala"
		_tmp3_ = _tmp2_;
#line 206 "../src/CanvasText.vala"
		pango_layout_set_markup (_tmp1_, _tmp3_, -1);
#line 206 "../src/CanvasText.vala"
		_g_free0 (_tmp3_);
#line 207 "../src/CanvasText.vala"
		_tmp4_ = self->priv->_pango_layout;
#line 207 "../src/CanvasText.vala"
		pango_layout_get_size (_tmp4_, &_tmp5_, &_tmp6_);
#line 207 "../src/CanvasText.vala"
		text_width = _tmp5_;
#line 207 "../src/CanvasText.vala"
		text_height = _tmp6_;
#line 208 "../src/CanvasText.vala"
		self->priv->_width = (gdouble) (text_width / PANGO_SCALE);
#line 209 "../src/CanvasText.vala"
		self->priv->_height = (gdouble) (text_height / PANGO_SCALE);
#line 210 "../src/CanvasText.vala"
		if (call_resized) {
#line 211 "../src/CanvasText.vala"
			g_signal_emit (self, canvas_text_signals[CANVAS_TEXT_RESIZED_SIGNAL], 0);
#line 1488 "CanvasText.c"
		}
	}
}

static void
canvas_text_real_resize (CanvasText* self,
                         gdouble diff)
{
	PangoLayout* _tmp0_;
#line 218 "../src/CanvasText.vala"
	self->priv->_max_width = self->priv->_max_width + diff;
#line 219 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 219 "../src/CanvasText.vala"
	pango_layout_set_width (_tmp0_, ((gint) self->priv->_max_width) * PANGO_SCALE);
#line 220 "../src/CanvasText.vala"
	canvas_text_update_size (self, TRUE);
#line 1506 "CanvasText.c"
}

void
canvas_text_resize (CanvasText* self,
                    gdouble diff)
{
#line 217 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 217 "../src/CanvasText.vala"
	CANVAS_TEXT_GET_CLASS (self)->resize (self, diff);
#line 1517 "CanvasText.c"
}

static void
canvas_text_update_column (CanvasText* self)
{
	gint line = 0;
	gint cpos = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	PangoLayout* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
#line 224 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 226 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 226 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 226 "../src/CanvasText.vala"
	cpos = string_index_of_nth_char (_tmp1_, (glong) self->priv->_cursor);
#line 227 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 227 "../src/CanvasText.vala"
	pango_layout_index_to_line_x (_tmp2_, cpos, FALSE, &_tmp3_, &_tmp4_);
#line 227 "../src/CanvasText.vala"
	line = _tmp3_;
#line 227 "../src/CanvasText.vala"
	self->priv->_column = _tmp4_;
#line 1546 "CanvasText.c"
}

void
canvas_text_set_cursor_at_char (CanvasText* self,
                                gdouble x,
                                gdouble y,
                                gboolean motion)
{
	gint cursor = 0;
	gint trailing = 0;
	gint adjusted_x = 0;
	gdouble _tmp0_;
	gint adjusted_y = 0;
	gdouble _tmp1_;
	PangoLayout* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gboolean _tmp5_;
#line 231 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 233 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_posx;
#line 233 "../src/CanvasText.vala"
	adjusted_x = ((gint) (x - _tmp0_)) * PANGO_SCALE;
#line 234 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_posy;
#line 234 "../src/CanvasText.vala"
	adjusted_y = ((gint) (y - _tmp1_)) * PANGO_SCALE;
#line 235 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 235 "../src/CanvasText.vala"
	_tmp5_ = pango_layout_xy_to_index (_tmp2_, adjusted_x, adjusted_y, &_tmp3_, &_tmp4_);
#line 235 "../src/CanvasText.vala"
	cursor = _tmp3_;
#line 235 "../src/CanvasText.vala"
	trailing = _tmp4_;
#line 235 "../src/CanvasText.vala"
	if (_tmp5_) {
#line 1585 "CanvasText.c"
		gint cindex = 0;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 236 "../src/CanvasText.vala"
		_tmp6_ = canvas_text_get_text (self);
#line 236 "../src/CanvasText.vala"
		_tmp7_ = _tmp6_;
#line 236 "../src/CanvasText.vala"
		cindex = g_utf8_strlen (_tmp7_, (gssize) (cursor + trailing));
#line 237 "../src/CanvasText.vala"
		if (motion) {
#line 238 "../src/CanvasText.vala"
			if (cindex > self->priv->_selanchor) {
#line 239 "../src/CanvasText.vala"
				self->priv->_selend = cindex;
#line 1601 "CanvasText.c"
			} else {
#line 240 "../src/CanvasText.vala"
				if (cindex < self->priv->_selanchor) {
#line 241 "../src/CanvasText.vala"
					self->priv->_selstart = cindex;
#line 1607 "CanvasText.c"
				} else {
#line 243 "../src/CanvasText.vala"
					self->priv->_selstart = cindex;
#line 244 "../src/CanvasText.vala"
					self->priv->_selend = cindex;
#line 1613 "CanvasText.c"
				}
			}
		} else {
#line 247 "../src/CanvasText.vala"
			self->priv->_selstart = cindex;
#line 248 "../src/CanvasText.vala"
			self->priv->_selend = cindex;
#line 249 "../src/CanvasText.vala"
			self->priv->_selanchor = cindex;
#line 1623 "CanvasText.c"
		}
#line 251 "../src/CanvasText.vala"
		self->priv->_cursor = self->priv->_selend;
#line 252 "../src/CanvasText.vala"
		canvas_text_update_column (self);
#line 1629 "CanvasText.c"
	}
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1091 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1091 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1092 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1092 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1094 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1094 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1654 "CanvasText.c"
		gchar* _tmp2_;
#line 1095 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1095 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1095 "glib-2.0.vapi"
		return result;
#line 1662 "CanvasText.c"
	} else {
#line 1097 "glib-2.0.vapi"
		result = -1;
#line 1097 "glib-2.0.vapi"
		return result;
#line 1668 "CanvasText.c"
	}
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1693 "CanvasText.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 1701 "CanvasText.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 1707 "CanvasText.c"
	}
}

void
canvas_text_set_cursor_at_word (CanvasText* self,
                                gdouble x,
                                gdouble y,
                                gboolean motion)
{
	gint cursor = 0;
	gint trailing = 0;
	gint adjusted_x = 0;
	gdouble _tmp0_;
	gint adjusted_y = 0;
	gdouble _tmp1_;
	PangoLayout* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gboolean _tmp5_;
#line 257 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 259 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_posx;
#line 259 "../src/CanvasText.vala"
	adjusted_x = ((gint) (x - _tmp0_)) * PANGO_SCALE;
#line 260 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_posy;
#line 260 "../src/CanvasText.vala"
	adjusted_y = ((gint) (y - _tmp1_)) * PANGO_SCALE;
#line 261 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 261 "../src/CanvasText.vala"
	_tmp5_ = pango_layout_xy_to_index (_tmp2_, adjusted_x, adjusted_y, &_tmp3_, &_tmp4_);
#line 261 "../src/CanvasText.vala"
	cursor = _tmp3_;
#line 261 "../src/CanvasText.vala"
	trailing = _tmp4_;
#line 261 "../src/CanvasText.vala"
	if (_tmp5_) {
#line 1747 "CanvasText.c"
		gint word_start = 0;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gint _tmp10_;
		gint word_end = 0;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 262 "../src/CanvasText.vala"
		cursor += trailing;
#line 263 "../src/CanvasText.vala"
		_tmp6_ = canvas_text_get_text (self);
#line 263 "../src/CanvasText.vala"
		_tmp7_ = _tmp6_;
#line 263 "../src/CanvasText.vala"
		_tmp8_ = string_substring (_tmp7_, (glong) 0, (glong) cursor);
#line 263 "../src/CanvasText.vala"
		_tmp9_ = _tmp8_;
#line 263 "../src/CanvasText.vala"
		_tmp10_ = string_last_index_of (_tmp9_, " ", 0);
#line 263 "../src/CanvasText.vala"
		_g_free0 (_tmp9_);
#line 263 "../src/CanvasText.vala"
		word_start = _tmp10_;
#line 264 "../src/CanvasText.vala"
		_tmp11_ = canvas_text_get_text (self);
#line 264 "../src/CanvasText.vala"
		_tmp12_ = _tmp11_;
#line 264 "../src/CanvasText.vala"
		word_end = string_index_of (_tmp12_, " ", cursor);
#line 265 "../src/CanvasText.vala"
		if (word_start == -1) {
#line 265 "../src/CanvasText.vala"
			self->priv->_selstart = 0;
#line 1783 "CanvasText.c"
		} else {
			gint windex = 0;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gboolean _tmp15_ = FALSE;
#line 265 "../src/CanvasText.vala"
			_tmp13_ = canvas_text_get_text (self);
#line 265 "../src/CanvasText.vala"
			_tmp14_ = _tmp13_;
#line 265 "../src/CanvasText.vala"
			windex = g_utf8_strlen (_tmp14_, (gssize) word_start);
#line 265 "../src/CanvasText.vala"
			if (!motion) {
#line 265 "../src/CanvasText.vala"
				_tmp15_ = TRUE;
#line 1799 "CanvasText.c"
			} else {
#line 265 "../src/CanvasText.vala"
				_tmp15_ = windex < self->priv->_selanchor;
#line 1803 "CanvasText.c"
			}
#line 265 "../src/CanvasText.vala"
			if (_tmp15_) {
#line 265 "../src/CanvasText.vala"
				self->priv->_selstart = windex + 1;
#line 1809 "CanvasText.c"
			}
		}
#line 266 "../src/CanvasText.vala"
		if (word_end == -1) {
#line 1814 "CanvasText.c"
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 267 "../src/CanvasText.vala"
			_tmp16_ = canvas_text_get_text (self);
#line 267 "../src/CanvasText.vala"
			_tmp17_ = _tmp16_;
#line 267 "../src/CanvasText.vala"
			self->priv->_selend = g_utf8_strlen (_tmp17_, (gssize) -1);
#line 1823 "CanvasText.c"
		} else {
			gint windex = 0;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gboolean _tmp20_ = FALSE;
#line 269 "../src/CanvasText.vala"
			_tmp18_ = canvas_text_get_text (self);
#line 269 "../src/CanvasText.vala"
			_tmp19_ = _tmp18_;
#line 269 "../src/CanvasText.vala"
			windex = g_utf8_strlen (_tmp19_, (gssize) word_end);
#line 270 "../src/CanvasText.vala"
			if (!motion) {
#line 270 "../src/CanvasText.vala"
				_tmp20_ = TRUE;
#line 1839 "CanvasText.c"
			} else {
#line 270 "../src/CanvasText.vala"
				_tmp20_ = windex > self->priv->_selanchor;
#line 1843 "CanvasText.c"
			}
#line 270 "../src/CanvasText.vala"
			if (_tmp20_) {
#line 271 "../src/CanvasText.vala"
				self->priv->_selend = windex;
#line 1849 "CanvasText.c"
			}
		}
#line 274 "../src/CanvasText.vala"
		self->priv->_cursor = self->priv->_selend;
#line 275 "../src/CanvasText.vala"
		canvas_text_update_column (self);
#line 1856 "CanvasText.c"
	}
}

void
canvas_text_clear_selection (CanvasText* self)
{
#line 280 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 281 "../src/CanvasText.vala"
	self->priv->_selend = self->priv->_cursor;
#line 281 "../src/CanvasText.vala"
	self->priv->_selstart = self->priv->_selend;
#line 1869 "CanvasText.c"
}

static void
canvas_text_adjust_selection (CanvasText* self,
                              gint last_cursor)
{
#line 288 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 289 "../src/CanvasText.vala"
	if (last_cursor == self->priv->_selstart) {
#line 290 "../src/CanvasText.vala"
		if (self->priv->_cursor <= self->priv->_selend) {
#line 291 "../src/CanvasText.vala"
			self->priv->_selstart = self->priv->_cursor;
#line 1884 "CanvasText.c"
		} else {
#line 293 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_cursor;
#line 1888 "CanvasText.c"
		}
	} else {
#line 296 "../src/CanvasText.vala"
		if (self->priv->_cursor >= self->priv->_selstart) {
#line 297 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_cursor;
#line 1895 "CanvasText.c"
		} else {
#line 299 "../src/CanvasText.vala"
			self->priv->_selstart = self->priv->_cursor;
#line 1899 "CanvasText.c"
		}
	}
}

void
canvas_text_set_cursor_none (CanvasText* self)
{
#line 305 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 306 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 1911 "CanvasText.c"
}

void
canvas_text_set_cursor_all (CanvasText* self,
                            gboolean motion)
{
#line 310 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/CanvasText.vala"
	if (!motion) {
#line 1922 "CanvasText.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
#line 312 "../src/CanvasText.vala"
		self->priv->_selstart = 0;
#line 313 "../src/CanvasText.vala"
		_tmp0_ = canvas_text_get_text (self);
#line 313 "../src/CanvasText.vala"
		_tmp1_ = _tmp0_;
#line 313 "../src/CanvasText.vala"
		self->priv->_selend = g_utf8_strlen (_tmp1_, (gssize) -1);
#line 314 "../src/CanvasText.vala"
		self->priv->_selanchor = self->priv->_selend;
#line 315 "../src/CanvasText.vala"
		self->priv->_cursor = self->priv->_selend;
#line 1937 "CanvasText.c"
	}
}

static void
canvas_text_cursor_by_char (CanvasText* self,
                            gint dir)
{
	gint last = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 320 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 321 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 321 "../src/CanvasText.vala"
	last = g_utf8_strlen (_tmp1_, (gssize) -1);
#line 322 "../src/CanvasText.vala"
	self->priv->_cursor = self->priv->_cursor + dir;
#line 323 "../src/CanvasText.vala"
	if (self->priv->_cursor < 0) {
#line 324 "../src/CanvasText.vala"
		self->priv->_cursor = 0;
#line 1962 "CanvasText.c"
	} else {
#line 325 "../src/CanvasText.vala"
		if (self->priv->_cursor > last) {
#line 326 "../src/CanvasText.vala"
			self->priv->_cursor = last;
#line 1968 "CanvasText.c"
		}
	}
#line 328 "../src/CanvasText.vala"
	canvas_text_update_column (self);
#line 1973 "CanvasText.c"
}

void
canvas_text_move_cursor (CanvasText* self,
                         gint dir)
{
#line 332 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/CanvasText.vala"
	canvas_text_cursor_by_char (self, dir);
#line 334 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 1986 "CanvasText.c"
}

void
canvas_text_selection_by_char (CanvasText* self,
                               gint dir)
{
	gint last_cursor = 0;
#line 338 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 339 "../src/CanvasText.vala"
	last_cursor = self->priv->_cursor;
#line 340 "../src/CanvasText.vala"
	canvas_text_cursor_by_char (self, dir);
#line 341 "../src/CanvasText.vala"
	canvas_text_adjust_selection (self, last_cursor);
#line 2002 "CanvasText.c"
}

static gpointer
_pango_layout_line_ref0 (gpointer self)
{
#line 356 "../src/CanvasText.vala"
	return self ? pango_layout_line_ref (self) : NULL;
#line 2010 "CanvasText.c"
}

static void
canvas_text_cursor_by_line (CanvasText* self,
                            gint dir)
{
	gint line = 0;
	gint x = 0;
	gint cpos = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	PangoLayout* _tmp2_;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
#line 345 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 347 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 347 "../src/CanvasText.vala"
	cpos = string_index_of_nth_char (_tmp1_, (glong) self->priv->_cursor);
#line 348 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 348 "../src/CanvasText.vala"
	pango_layout_index_to_line_x (_tmp2_, cpos, FALSE, &_tmp3_, &_tmp4_);
#line 348 "../src/CanvasText.vala"
	line = _tmp3_;
#line 348 "../src/CanvasText.vala"
	x = _tmp4_;
#line 349 "../src/CanvasText.vala"
	line += dir;
#line 350 "../src/CanvasText.vala"
	if (line < 0) {
#line 351 "../src/CanvasText.vala"
		self->priv->_cursor = 0;
#line 2047 "CanvasText.c"
	} else {
		PangoLayout* _tmp5_;
#line 352 "../src/CanvasText.vala"
		_tmp5_ = self->priv->_pango_layout;
#line 352 "../src/CanvasText.vala"
		if (line >= pango_layout_get_line_count (_tmp5_)) {
#line 2054 "CanvasText.c"
			const gchar* _tmp6_;
			const gchar* _tmp7_;
#line 353 "../src/CanvasText.vala"
			_tmp6_ = canvas_text_get_text (self);
#line 353 "../src/CanvasText.vala"
			_tmp7_ = _tmp6_;
#line 353 "../src/CanvasText.vala"
			self->priv->_cursor = g_utf8_strlen (_tmp7_, (gssize) -1);
#line 2063 "CanvasText.c"
		} else {
			gint index = 0;
			gint trailing = 0;
			PangoLayoutLine* line_layout = NULL;
			PangoLayout* _tmp8_;
			PangoLayoutLine* _tmp9_;
			PangoLayoutLine* _tmp10_;
			PangoLayoutLine* _tmp11_;
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
#line 356 "../src/CanvasText.vala"
			_tmp8_ = self->priv->_pango_layout;
#line 356 "../src/CanvasText.vala"
			_tmp9_ = pango_layout_get_line (_tmp8_, line);
#line 356 "../src/CanvasText.vala"
			_tmp10_ = _pango_layout_line_ref0 (_tmp9_);
#line 356 "../src/CanvasText.vala"
			line_layout = _tmp10_;
#line 357 "../src/CanvasText.vala"
			_tmp11_ = line_layout;
#line 357 "../src/CanvasText.vala"
			pango_layout_line_x_to_index (_tmp11_, self->priv->_column, &_tmp12_, &_tmp13_);
#line 357 "../src/CanvasText.vala"
			index = _tmp12_;
#line 357 "../src/CanvasText.vala"
			trailing = _tmp13_;
#line 358 "../src/CanvasText.vala"
			_tmp14_ = canvas_text_get_text (self);
#line 358 "../src/CanvasText.vala"
			_tmp15_ = _tmp14_;
#line 358 "../src/CanvasText.vala"
			self->priv->_cursor = g_utf8_strlen (_tmp15_, (gssize) (index + trailing));
#line 352 "../src/CanvasText.vala"
			_pango_layout_line_unref0 (line_layout);
#line 2100 "CanvasText.c"
		}
	}
}

void
canvas_text_move_cursor_vertically (CanvasText* self,
                                    gint dir)
{
#line 366 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 367 "../src/CanvasText.vala"
	canvas_text_cursor_by_line (self, dir);
#line 368 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 2115 "CanvasText.c"
}

void
canvas_text_selection_vertically (CanvasText* self,
                                  gint dir)
{
	gint last_cursor = 0;
#line 372 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 373 "../src/CanvasText.vala"
	last_cursor = self->priv->_cursor;
#line 374 "../src/CanvasText.vala"
	canvas_text_cursor_by_line (self, dir);
#line 375 "../src/CanvasText.vala"
	canvas_text_adjust_selection (self, last_cursor);
#line 2131 "CanvasText.c"
}

void
canvas_text_move_cursor_to_start (CanvasText* self)
{
#line 379 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 380 "../src/CanvasText.vala"
	self->priv->_cursor = 0;
#line 381 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 2143 "CanvasText.c"
}

void
canvas_text_move_cursor_to_end (CanvasText* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 385 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 386 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 386 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 386 "../src/CanvasText.vala"
	self->priv->_cursor = g_utf8_strlen (_tmp1_, (gssize) -1);
#line 387 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 2161 "CanvasText.c"
}

void
canvas_text_selection_to_start (CanvasText* self)
{
#line 391 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 392 "../src/CanvasText.vala"
	if (self->priv->_selstart == self->priv->_selend) {
#line 393 "../src/CanvasText.vala"
		self->priv->_selstart = 0;
#line 394 "../src/CanvasText.vala"
		self->priv->_selend = self->priv->_cursor;
#line 395 "../src/CanvasText.vala"
		self->priv->_cursor = 0;
#line 2177 "CanvasText.c"
	} else {
#line 397 "../src/CanvasText.vala"
		self->priv->_selstart = 0;
#line 398 "../src/CanvasText.vala"
		self->priv->_cursor = 0;
#line 2183 "CanvasText.c"
	}
}

void
canvas_text_selection_to_end (CanvasText* self)
{
#line 403 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 404 "../src/CanvasText.vala"
	if (self->priv->_selstart == self->priv->_selend) {
#line 2194 "CanvasText.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 405 "../src/CanvasText.vala"
		self->priv->_selstart = self->priv->_cursor;
#line 406 "../src/CanvasText.vala"
		_tmp0_ = canvas_text_get_text (self);
#line 406 "../src/CanvasText.vala"
		_tmp1_ = _tmp0_;
#line 406 "../src/CanvasText.vala"
		self->priv->_selend = g_utf8_strlen (_tmp1_, (gssize) -1);
#line 407 "../src/CanvasText.vala"
		_tmp2_ = canvas_text_get_text (self);
#line 407 "../src/CanvasText.vala"
		_tmp3_ = _tmp2_;
#line 407 "../src/CanvasText.vala"
		self->priv->_cursor = g_utf8_strlen (_tmp3_, (gssize) -1);
#line 2213 "CanvasText.c"
	} else {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 409 "../src/CanvasText.vala"
		_tmp4_ = canvas_text_get_text (self);
#line 409 "../src/CanvasText.vala"
		_tmp5_ = _tmp4_;
#line 409 "../src/CanvasText.vala"
		self->priv->_selend = g_utf8_strlen (_tmp5_, (gssize) -1);
#line 410 "../src/CanvasText.vala"
		_tmp6_ = canvas_text_get_text (self);
#line 410 "../src/CanvasText.vala"
		_tmp7_ = _tmp6_;
#line 410 "../src/CanvasText.vala"
		self->priv->_cursor = g_utf8_strlen (_tmp7_, (gssize) -1);
#line 2231 "CanvasText.c"
	}
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1210 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1211 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1211 "glib-2.0.vapi"
	return result;
#line 2246 "CanvasText.c"
}

static gint
canvas_text_find_word (CanvasText* self,
                       gint start,
                       gint dir)
{
	gint result = 0;
	gboolean alnum_found = FALSE;
#line 415 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 416 "../src/CanvasText.vala"
	alnum_found = FALSE;
#line 417 "../src/CanvasText.vala"
	if (dir == 1) {
#line 2262 "CanvasText.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		{
			gint i = 0;
#line 418 "../src/CanvasText.vala"
			i = start;
#line 2269 "CanvasText.c"
			{
				gboolean _tmp0_ = FALSE;
#line 418 "../src/CanvasText.vala"
				_tmp0_ = TRUE;
#line 418 "../src/CanvasText.vala"
				while (TRUE) {
#line 2276 "CanvasText.c"
					const gchar* _tmp2_;
					const gchar* _tmp3_;
					gint index = 0;
					const gchar* _tmp4_;
					const gchar* _tmp5_;
					const gchar* _tmp6_;
					const gchar* _tmp7_;
#line 418 "../src/CanvasText.vala"
					if (!_tmp0_) {
#line 2286 "CanvasText.c"
						gint _tmp1_;
#line 418 "../src/CanvasText.vala"
						_tmp1_ = i;
#line 418 "../src/CanvasText.vala"
						i = _tmp1_ + 1;
#line 2292 "CanvasText.c"
					}
#line 418 "../src/CanvasText.vala"
					_tmp0_ = FALSE;
#line 418 "../src/CanvasText.vala"
					_tmp2_ = canvas_text_get_text (self);
#line 418 "../src/CanvasText.vala"
					_tmp3_ = _tmp2_;
#line 418 "../src/CanvasText.vala"
					if (!(i < g_utf8_strlen (_tmp3_, (gssize) -1))) {
#line 418 "../src/CanvasText.vala"
						break;
#line 2304 "CanvasText.c"
					}
#line 419 "../src/CanvasText.vala"
					_tmp4_ = canvas_text_get_text (self);
#line 419 "../src/CanvasText.vala"
					_tmp5_ = _tmp4_;
#line 419 "../src/CanvasText.vala"
					index = string_index_of_nth_char (_tmp5_, (glong) i);
#line 420 "../src/CanvasText.vala"
					_tmp6_ = canvas_text_get_text (self);
#line 420 "../src/CanvasText.vala"
					_tmp7_ = _tmp6_;
#line 420 "../src/CanvasText.vala"
					if (g_unichar_isalnum (string_get_char (_tmp7_, (glong) index))) {
#line 421 "../src/CanvasText.vala"
						alnum_found = TRUE;
#line 2320 "CanvasText.c"
					} else {
#line 422 "../src/CanvasText.vala"
						if (alnum_found) {
#line 423 "../src/CanvasText.vala"
							result = i;
#line 423 "../src/CanvasText.vala"
							return result;
#line 2328 "CanvasText.c"
						}
					}
				}
			}
		}
#line 426 "../src/CanvasText.vala"
		_tmp8_ = canvas_text_get_text (self);
#line 426 "../src/CanvasText.vala"
		_tmp9_ = _tmp8_;
#line 426 "../src/CanvasText.vala"
		result = g_utf8_strlen (_tmp9_, (gssize) -1);
#line 426 "../src/CanvasText.vala"
		return result;
#line 2342 "CanvasText.c"
	} else {
		{
			gint i = 0;
#line 428 "../src/CanvasText.vala"
			i = start - 1;
#line 2348 "CanvasText.c"
			{
				gboolean _tmp10_ = FALSE;
#line 428 "../src/CanvasText.vala"
				_tmp10_ = TRUE;
#line 428 "../src/CanvasText.vala"
				while (TRUE) {
#line 2355 "CanvasText.c"
					gint index = 0;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 428 "../src/CanvasText.vala"
					if (!_tmp10_) {
#line 2363 "CanvasText.c"
						gint _tmp11_;
#line 428 "../src/CanvasText.vala"
						_tmp11_ = i;
#line 428 "../src/CanvasText.vala"
						i = _tmp11_ - 1;
#line 2369 "CanvasText.c"
					}
#line 428 "../src/CanvasText.vala"
					_tmp10_ = FALSE;
#line 428 "../src/CanvasText.vala"
					if (!(i >= 0)) {
#line 428 "../src/CanvasText.vala"
						break;
#line 2377 "CanvasText.c"
					}
#line 429 "../src/CanvasText.vala"
					_tmp12_ = canvas_text_get_text (self);
#line 429 "../src/CanvasText.vala"
					_tmp13_ = _tmp12_;
#line 429 "../src/CanvasText.vala"
					index = string_index_of_nth_char (_tmp13_, (glong) i);
#line 430 "../src/CanvasText.vala"
					_tmp14_ = canvas_text_get_text (self);
#line 430 "../src/CanvasText.vala"
					_tmp15_ = _tmp14_;
#line 430 "../src/CanvasText.vala"
					if (g_unichar_isalnum (string_get_char (_tmp15_, (glong) index))) {
#line 431 "../src/CanvasText.vala"
						alnum_found = TRUE;
#line 2393 "CanvasText.c"
					} else {
#line 432 "../src/CanvasText.vala"
						if (alnum_found) {
#line 433 "../src/CanvasText.vala"
							result = i + 1;
#line 433 "../src/CanvasText.vala"
							return result;
#line 2401 "CanvasText.c"
						}
					}
				}
			}
		}
#line 436 "../src/CanvasText.vala"
		result = 0;
#line 436 "../src/CanvasText.vala"
		return result;
#line 2411 "CanvasText.c"
	}
}

void
canvas_text_move_cursor_by_word (CanvasText* self,
                                 gint dir)
{
#line 441 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 442 "../src/CanvasText.vala"
	self->priv->_cursor = canvas_text_find_word (self, self->priv->_cursor, dir);
#line 443 "../src/CanvasText.vala"
	self->priv->_selend = self->priv->_selstart;
#line 2425 "CanvasText.c"
}

void
canvas_text_selection_by_word (CanvasText* self,
                               gint dir)
{
#line 447 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 448 "../src/CanvasText.vala"
	if (self->priv->_cursor == self->priv->_selstart) {
#line 449 "../src/CanvasText.vala"
		self->priv->_cursor = canvas_text_find_word (self, self->priv->_cursor, dir);
#line 450 "../src/CanvasText.vala"
		if (self->priv->_cursor <= self->priv->_selend) {
#line 451 "../src/CanvasText.vala"
			self->priv->_selstart = self->priv->_cursor;
#line 2442 "CanvasText.c"
		} else {
#line 453 "../src/CanvasText.vala"
			self->priv->_selstart = self->priv->_selend;
#line 454 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_cursor;
#line 2448 "CanvasText.c"
		}
	} else {
#line 457 "../src/CanvasText.vala"
		self->priv->_cursor = canvas_text_find_word (self, self->priv->_cursor, dir);
#line 458 "../src/CanvasText.vala"
		if (self->priv->_cursor >= self->priv->_selstart) {
#line 459 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_cursor;
#line 2457 "CanvasText.c"
		} else {
#line 461 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_selstart;
#line 462 "../src/CanvasText.vala"
			self->priv->_selstart = self->priv->_cursor;
#line 2463 "CanvasText.c"
		}
	}
}

static gchar*
string_splice (const gchar* self,
               glong start,
               glong end,
               const gchar* str)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gsize str_size = 0UL;
	const gchar* _result_ = NULL;
	void* _tmp6_;
	gchar* dest = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
#line 1442 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1443 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1443 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1443 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1444 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1445 "glib-2.0.vapi"
		start = string_length + start;
#line 2503 "CanvasText.c"
	}
#line 1447 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1448 "glib-2.0.vapi"
		end = string_length + end;
#line 2509 "CanvasText.c"
	}
#line 1450 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1450 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 2515 "CanvasText.c"
	} else {
#line 1450 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 2519 "CanvasText.c"
	}
#line 1450 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1451 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1451 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 2527 "CanvasText.c"
	} else {
#line 1451 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 2531 "CanvasText.c"
	}
#line 1451 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1452 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1455 "glib-2.0.vapi"
	if (str == NULL) {
#line 1456 "glib-2.0.vapi"
		str_size = (gsize) 0;
#line 2541 "CanvasText.c"
	} else {
		gint _tmp4_;
		gint _tmp5_;
#line 1458 "glib-2.0.vapi"
		_tmp4_ = strlen ((const gchar*) str);
#line 1458 "glib-2.0.vapi"
		_tmp5_ = _tmp4_;
#line 1458 "glib-2.0.vapi"
		str_size = (gsize) _tmp5_;
#line 2551 "CanvasText.c"
	}
#line 1461 "glib-2.0.vapi"
	_tmp6_ = g_malloc0 (((string_length - (end - start)) + str_size) + 1);
#line 1461 "glib-2.0.vapi"
	_result_ = _tmp6_;
#line 1463 "glib-2.0.vapi"
	_tmp7_ = _result_;
#line 1463 "glib-2.0.vapi"
	dest = (gchar*) _tmp7_;
#line 1465 "glib-2.0.vapi"
	_tmp8_ = dest;
#line 1465 "glib-2.0.vapi"
	memcpy (_tmp8_, self, (gsize) start);
#line 1466 "glib-2.0.vapi"
	_tmp9_ = dest;
#line 1466 "glib-2.0.vapi"
	dest = _tmp9_ + start;
#line 1468 "glib-2.0.vapi"
	_tmp10_ = dest;
#line 1468 "glib-2.0.vapi"
	memcpy (_tmp10_, str, str_size);
#line 1469 "glib-2.0.vapi"
	_tmp11_ = dest;
#line 1469 "glib-2.0.vapi"
	dest = _tmp11_ + str_size;
#line 1471 "glib-2.0.vapi"
	_tmp12_ = dest;
#line 1471 "glib-2.0.vapi"
	memcpy (_tmp12_, ((gchar*) self) + end, (gsize) (string_length - end));
#line 1473 "glib-2.0.vapi"
	_tmp13_ = _result_;
#line 1473 "glib-2.0.vapi"
	_result_ = NULL;
#line 1473 "glib-2.0.vapi"
	result = (gchar*) _tmp13_;
#line 1473 "glib-2.0.vapi"
	return result;
#line 2589 "CanvasText.c"
}

void
canvas_text_backspace (CanvasText* self)
{
#line 468 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 469 "../src/CanvasText.vala"
	if (self->priv->_cursor > 0) {
#line 470 "../src/CanvasText.vala"
		if (self->priv->_selstart != self->priv->_selend) {
#line 2601 "CanvasText.c"
			gint spos = 0;
			const gchar* _tmp0_;
			const gchar* _tmp1_;
			gint epos = 0;
			const gchar* _tmp2_;
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 471 "../src/CanvasText.vala"
			_tmp0_ = canvas_text_get_text (self);
#line 471 "../src/CanvasText.vala"
			_tmp1_ = _tmp0_;
#line 471 "../src/CanvasText.vala"
			spos = string_index_of_nth_char (_tmp1_, (glong) self->priv->_selstart);
#line 472 "../src/CanvasText.vala"
			_tmp2_ = canvas_text_get_text (self);
#line 472 "../src/CanvasText.vala"
			_tmp3_ = _tmp2_;
#line 472 "../src/CanvasText.vala"
			epos = string_index_of_nth_char (_tmp3_, (glong) self->priv->_selend);
#line 473 "../src/CanvasText.vala"
			_tmp4_ = canvas_text_get_text (self);
#line 473 "../src/CanvasText.vala"
			_tmp5_ = _tmp4_;
#line 473 "../src/CanvasText.vala"
			_tmp6_ = string_splice (_tmp5_, (glong) spos, (glong) epos, NULL);
#line 473 "../src/CanvasText.vala"
			_tmp7_ = _tmp6_;
#line 473 "../src/CanvasText.vala"
			canvas_text_set_text (self, _tmp7_);
#line 473 "../src/CanvasText.vala"
			_g_free0 (_tmp7_);
#line 474 "../src/CanvasText.vala"
			self->priv->_cursor = self->priv->_selstart;
#line 475 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_selstart;
#line 2640 "CanvasText.c"
		} else {
			gint spos = 0;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gint epos = 0;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gint _tmp16_;
#line 477 "../src/CanvasText.vala"
			_tmp8_ = canvas_text_get_text (self);
#line 477 "../src/CanvasText.vala"
			_tmp9_ = _tmp8_;
#line 477 "../src/CanvasText.vala"
			spos = string_index_of_nth_char (_tmp9_, (glong) (self->priv->_cursor - 1));
#line 478 "../src/CanvasText.vala"
			_tmp10_ = canvas_text_get_text (self);
#line 478 "../src/CanvasText.vala"
			_tmp11_ = _tmp10_;
#line 478 "../src/CanvasText.vala"
			epos = string_index_of_nth_char (_tmp11_, (glong) self->priv->_cursor);
#line 479 "../src/CanvasText.vala"
			_tmp12_ = canvas_text_get_text (self);
#line 479 "../src/CanvasText.vala"
			_tmp13_ = _tmp12_;
#line 479 "../src/CanvasText.vala"
			_tmp14_ = string_splice (_tmp13_, (glong) spos, (glong) epos, NULL);
#line 479 "../src/CanvasText.vala"
			_tmp15_ = _tmp14_;
#line 479 "../src/CanvasText.vala"
			canvas_text_set_text (self, _tmp15_);
#line 479 "../src/CanvasText.vala"
			_g_free0 (_tmp15_);
#line 480 "../src/CanvasText.vala"
			_tmp16_ = self->priv->_cursor;
#line 480 "../src/CanvasText.vala"
			self->priv->_cursor = _tmp16_ - 1;
#line 2681 "CanvasText.c"
		}
	}
}

void
canvas_text_delete (CanvasText* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 486 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 487 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 487 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 487 "../src/CanvasText.vala"
	_tmp2_ = strlen (_tmp1_);
#line 487 "../src/CanvasText.vala"
	_tmp3_ = _tmp2_;
#line 487 "../src/CanvasText.vala"
	if (self->priv->_cursor < _tmp3_) {
#line 488 "../src/CanvasText.vala"
		if (self->priv->_selstart != self->priv->_selend) {
#line 2707 "CanvasText.c"
			gint spos = 0;
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			gint epos = 0;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 489 "../src/CanvasText.vala"
			_tmp4_ = canvas_text_get_text (self);
#line 489 "../src/CanvasText.vala"
			_tmp5_ = _tmp4_;
#line 489 "../src/CanvasText.vala"
			spos = string_index_of_nth_char (_tmp5_, (glong) self->priv->_selstart);
#line 490 "../src/CanvasText.vala"
			_tmp6_ = canvas_text_get_text (self);
#line 490 "../src/CanvasText.vala"
			_tmp7_ = _tmp6_;
#line 490 "../src/CanvasText.vala"
			epos = string_index_of_nth_char (_tmp7_, (glong) self->priv->_selend);
#line 491 "../src/CanvasText.vala"
			_tmp8_ = canvas_text_get_text (self);
#line 491 "../src/CanvasText.vala"
			_tmp9_ = _tmp8_;
#line 491 "../src/CanvasText.vala"
			_tmp10_ = string_splice (_tmp9_, (glong) spos, (glong) epos, NULL);
#line 491 "../src/CanvasText.vala"
			_tmp11_ = _tmp10_;
#line 491 "../src/CanvasText.vala"
			canvas_text_set_text (self, _tmp11_);
#line 491 "../src/CanvasText.vala"
			_g_free0 (_tmp11_);
#line 492 "../src/CanvasText.vala"
			self->priv->_cursor = self->priv->_selstart;
#line 493 "../src/CanvasText.vala"
			self->priv->_selend = self->priv->_selstart;
#line 2746 "CanvasText.c"
		} else {
			gint spos = 0;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gint epos = 0;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 495 "../src/CanvasText.vala"
			_tmp12_ = canvas_text_get_text (self);
#line 495 "../src/CanvasText.vala"
			_tmp13_ = _tmp12_;
#line 495 "../src/CanvasText.vala"
			spos = string_index_of_nth_char (_tmp13_, (glong) self->priv->_cursor);
#line 496 "../src/CanvasText.vala"
			_tmp14_ = canvas_text_get_text (self);
#line 496 "../src/CanvasText.vala"
			_tmp15_ = _tmp14_;
#line 496 "../src/CanvasText.vala"
			epos = string_index_of_nth_char (_tmp15_, (glong) (self->priv->_cursor + 1));
#line 497 "../src/CanvasText.vala"
			_tmp16_ = canvas_text_get_text (self);
#line 497 "../src/CanvasText.vala"
			_tmp17_ = _tmp16_;
#line 497 "../src/CanvasText.vala"
			_tmp18_ = string_splice (_tmp17_, (glong) spos, (glong) epos, NULL);
#line 497 "../src/CanvasText.vala"
			_tmp19_ = _tmp18_;
#line 497 "../src/CanvasText.vala"
			canvas_text_set_text (self, _tmp19_);
#line 497 "../src/CanvasText.vala"
			_g_free0 (_tmp19_);
#line 2782 "CanvasText.c"
		}
	}
}

void
canvas_text_insert (CanvasText* self,
                    const gchar* s)
{
	gint slen = 0;
#line 503 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 503 "../src/CanvasText.vala"
	g_return_if_fail (s != NULL);
#line 504 "../src/CanvasText.vala"
	slen = g_utf8_strlen (s, (gssize) -1);
#line 505 "../src/CanvasText.vala"
	if (self->priv->_selstart != self->priv->_selend) {
#line 2800 "CanvasText.c"
		gint spos = 0;
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gint epos = 0;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 506 "../src/CanvasText.vala"
		_tmp0_ = canvas_text_get_text (self);
#line 506 "../src/CanvasText.vala"
		_tmp1_ = _tmp0_;
#line 506 "../src/CanvasText.vala"
		spos = string_index_of_nth_char (_tmp1_, (glong) self->priv->_selstart);
#line 507 "../src/CanvasText.vala"
		_tmp2_ = canvas_text_get_text (self);
#line 507 "../src/CanvasText.vala"
		_tmp3_ = _tmp2_;
#line 507 "../src/CanvasText.vala"
		epos = string_index_of_nth_char (_tmp3_, (glong) self->priv->_selend);
#line 508 "../src/CanvasText.vala"
		_tmp4_ = canvas_text_get_text (self);
#line 508 "../src/CanvasText.vala"
		_tmp5_ = _tmp4_;
#line 508 "../src/CanvasText.vala"
		_tmp6_ = string_splice (_tmp5_, (glong) spos, (glong) epos, s);
#line 508 "../src/CanvasText.vala"
		_tmp7_ = _tmp6_;
#line 508 "../src/CanvasText.vala"
		canvas_text_set_text (self, _tmp7_);
#line 508 "../src/CanvasText.vala"
		_g_free0 (_tmp7_);
#line 509 "../src/CanvasText.vala"
		self->priv->_cursor = self->priv->_selstart + slen;
#line 510 "../src/CanvasText.vala"
		self->priv->_selend = self->priv->_selstart;
#line 2839 "CanvasText.c"
	} else {
		gint cpos = 0;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 512 "../src/CanvasText.vala"
		_tmp8_ = canvas_text_get_text (self);
#line 512 "../src/CanvasText.vala"
		_tmp9_ = _tmp8_;
#line 512 "../src/CanvasText.vala"
		cpos = string_index_of_nth_char (_tmp9_, (glong) self->priv->_cursor);
#line 513 "../src/CanvasText.vala"
		_tmp10_ = canvas_text_get_text (self);
#line 513 "../src/CanvasText.vala"
		_tmp11_ = _tmp10_;
#line 513 "../src/CanvasText.vala"
		_tmp12_ = string_splice (_tmp11_, (glong) cpos, (glong) cpos, s);
#line 513 "../src/CanvasText.vala"
		_tmp13_ = _tmp12_;
#line 513 "../src/CanvasText.vala"
		canvas_text_set_text (self, _tmp13_);
#line 513 "../src/CanvasText.vala"
		_g_free0 (_tmp13_);
#line 514 "../src/CanvasText.vala"
		self->priv->_cursor = self->priv->_cursor + slen;
#line 2868 "CanvasText.c"
	}
}

gchar*
canvas_text_get_selected_text (CanvasText* self)
{
	gchar* result = NULL;
#line 522 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 523 "../src/CanvasText.vala"
	if (self->priv->_selstart != self->priv->_selend) {
#line 2880 "CanvasText.c"
		gint spos = 0;
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gint epos = 0;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 524 "../src/CanvasText.vala"
		_tmp0_ = canvas_text_get_text (self);
#line 524 "../src/CanvasText.vala"
		_tmp1_ = _tmp0_;
#line 524 "../src/CanvasText.vala"
		spos = string_index_of_nth_char (_tmp1_, (glong) self->priv->_selstart);
#line 525 "../src/CanvasText.vala"
		_tmp2_ = canvas_text_get_text (self);
#line 525 "../src/CanvasText.vala"
		_tmp3_ = _tmp2_;
#line 525 "../src/CanvasText.vala"
		epos = string_index_of_nth_char (_tmp3_, (glong) self->priv->_selend);
#line 526 "../src/CanvasText.vala"
		_tmp4_ = canvas_text_get_text (self);
#line 526 "../src/CanvasText.vala"
		_tmp5_ = _tmp4_;
#line 526 "../src/CanvasText.vala"
		_tmp6_ = string_slice (_tmp5_, (glong) spos, (glong) epos);
#line 526 "../src/CanvasText.vala"
		result = _tmp6_;
#line 526 "../src/CanvasText.vala"
		return result;
#line 2912 "CanvasText.c"
	}
#line 528 "../src/CanvasText.vala"
	result = NULL;
#line 528 "../src/CanvasText.vala"
	return result;
#line 2918 "CanvasText.c"
}

void
canvas_text_get_cursor_pos (CanvasText* self,
                            gint* x,
                            gint* ytop,
                            gint* ybot)
{
	gint _vala_x = 0;
	gint _vala_ytop = 0;
	gint _vala_ybot = 0;
	gint index = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	PangoRectangle rect = {0};
	PangoLayout* _tmp2_;
	PangoRectangle _tmp3_ = {0};
	gdouble _tmp4_;
	PangoRectangle _tmp5_;
	gdouble _tmp6_;
	PangoRectangle _tmp7_;
	PangoRectangle _tmp8_;
#line 532 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 533 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 533 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 533 "../src/CanvasText.vala"
	index = string_index_of_nth_char (_tmp1_, (glong) self->priv->_cursor);
#line 534 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 534 "../src/CanvasText.vala"
	pango_layout_index_to_pos (_tmp2_, index, &_tmp3_);
#line 534 "../src/CanvasText.vala"
	rect = _tmp3_;
#line 535 "../src/CanvasText.vala"
	_tmp4_ = self->priv->_posx;
#line 535 "../src/CanvasText.vala"
	_tmp5_ = rect;
#line 535 "../src/CanvasText.vala"
	_vala_x = (gint) (_tmp4_ + (_tmp5_.x / PANGO_SCALE));
#line 536 "../src/CanvasText.vala"
	_tmp6_ = self->priv->_posy;
#line 536 "../src/CanvasText.vala"
	_tmp7_ = rect;
#line 536 "../src/CanvasText.vala"
	_vala_ytop = (gint) (_tmp6_ + (_tmp7_.y / PANGO_SCALE));
#line 537 "../src/CanvasText.vala"
	_tmp8_ = rect;
#line 537 "../src/CanvasText.vala"
	_vala_ybot = _vala_ytop + ((gint) (_tmp8_.height / PANGO_SCALE));
#line 532 "../src/CanvasText.vala"
	if (x) {
#line 532 "../src/CanvasText.vala"
		*x = _vala_x;
#line 2975 "CanvasText.c"
	}
#line 532 "../src/CanvasText.vala"
	if (ytop) {
#line 532 "../src/CanvasText.vala"
		*ytop = _vala_ytop;
#line 2981 "CanvasText.c"
	}
#line 532 "../src/CanvasText.vala"
	if (ybot) {
#line 532 "../src/CanvasText.vala"
		*ybot = _vala_ybot;
#line 2987 "CanvasText.c"
	}
}

void
canvas_text_draw (CanvasText* self,
                  cairo_t* ctx,
                  Theme* theme,
                  GdkRGBA* fg,
                  gdouble alpha)
{
	PangoLayout* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	GdkRGBA _tmp5_;
	PangoLayout* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
#line 541 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 541 "../src/CanvasText.vala"
	g_return_if_fail (ctx != NULL);
#line 541 "../src/CanvasText.vala"
	g_return_if_fail (theme != NULL);
#line 541 "../src/CanvasText.vala"
	g_return_if_fail (fg != NULL);
#line 544 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 544 "../src/CanvasText.vala"
	_tmp1_ = canvas_text_name_markup (self, theme);
#line 544 "../src/CanvasText.vala"
	_tmp2_ = _tmp1_;
#line 544 "../src/CanvasText.vala"
	pango_layout_set_markup (_tmp0_, _tmp2_, -1);
#line 544 "../src/CanvasText.vala"
	_g_free0 (_tmp2_);
#line 547 "../src/CanvasText.vala"
	_tmp3_ = self->priv->_posx;
#line 547 "../src/CanvasText.vala"
	_tmp4_ = self->priv->_posy;
#line 547 "../src/CanvasText.vala"
	cairo_move_to (ctx, _tmp3_, _tmp4_);
#line 548 "../src/CanvasText.vala"
	_tmp5_ = *fg;
#line 548 "../src/CanvasText.vala"
	utils_set_context_color_with_alpha (ctx, &_tmp5_, alpha);
#line 549 "../src/CanvasText.vala"
	_tmp6_ = self->priv->_pango_layout;
#line 549 "../src/CanvasText.vala"
	pango_cairo_show_layout (ctx, _tmp6_);
#line 550 "../src/CanvasText.vala"
	cairo_new_path (ctx);
#line 553 "../src/CanvasText.vala"
	_tmp7_ = canvas_text_get_edit (self);
#line 553 "../src/CanvasText.vala"
	_tmp8_ = _tmp7_;
#line 553 "../src/CanvasText.vala"
	if (_tmp8_) {
#line 3047 "CanvasText.c"
		gint cpos = 0;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		PangoRectangle rect = {0};
		PangoLayout* _tmp11_;
		PangoRectangle _tmp12_ = {0};
		GdkRGBA* _tmp13_;
		GdkRGBA* _tmp14_;
		GdkRGBA _tmp15_;
		gdouble ix = 0.0;
		gdouble iy = 0.0;
		gdouble _tmp16_;
		PangoRectangle _tmp17_;
		gdouble _tmp18_;
		PangoRectangle _tmp19_;
		PangoRectangle _tmp20_;
#line 554 "../src/CanvasText.vala"
		_tmp9_ = canvas_text_get_text (self);
#line 554 "../src/CanvasText.vala"
		_tmp10_ = _tmp9_;
#line 554 "../src/CanvasText.vala"
		cpos = string_index_of_nth_char (_tmp10_, (glong) self->priv->_cursor);
#line 555 "../src/CanvasText.vala"
		_tmp11_ = self->priv->_pango_layout;
#line 555 "../src/CanvasText.vala"
		pango_layout_index_to_pos (_tmp11_, cpos, &_tmp12_);
#line 555 "../src/CanvasText.vala"
		rect = _tmp12_;
#line 556 "../src/CanvasText.vala"
		_tmp13_ = theme_get_color (theme, "text_cursor");
#line 556 "../src/CanvasText.vala"
		_tmp14_ = _tmp13_;
#line 556 "../src/CanvasText.vala"
		_tmp15_ = *_tmp14_;
#line 556 "../src/CanvasText.vala"
		utils_set_context_color_with_alpha (ctx, &_tmp15_, alpha);
#line 556 "../src/CanvasText.vala"
		_g_free0 (_tmp14_);
#line 558 "../src/CanvasText.vala"
		_tmp16_ = self->priv->_posx;
#line 558 "../src/CanvasText.vala"
		_tmp17_ = rect;
#line 558 "../src/CanvasText.vala"
		ix = (_tmp16_ + (_tmp17_.x / PANGO_SCALE)) - 1;
#line 559 "../src/CanvasText.vala"
		_tmp18_ = self->priv->_posy;
#line 559 "../src/CanvasText.vala"
		_tmp19_ = rect;
#line 559 "../src/CanvasText.vala"
		iy = _tmp18_ + (_tmp19_.y / PANGO_SCALE);
#line 560 "../src/CanvasText.vala"
		_tmp20_ = rect;
#line 560 "../src/CanvasText.vala"
		cairo_rectangle (ctx, ix, iy, (gdouble) 1, (gdouble) (_tmp20_.height / PANGO_SCALE));
#line 561 "../src/CanvasText.vala"
		cairo_fill (ctx);
#line 3104 "CanvasText.c"
	}
}

const gchar*
canvas_text_get_text (CanvasText* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_text;
#line 50 "../src/CanvasText.vala"
	result = _tmp0_;
#line 50 "../src/CanvasText.vala"
	return result;
#line 3121 "CanvasText.c"
}

void
canvas_text_set_text (CanvasText* self,
                      const gchar* value)
{
	const gchar* _tmp0_;
#line 52 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_text;
#line 53 "../src/CanvasText.vala"
	if (g_strcmp0 (_tmp0_, value) != 0) {
#line 3135 "CanvasText.c"
		gchar* _tmp1_;
#line 54 "../src/CanvasText.vala"
		_tmp1_ = g_strdup (value);
#line 54 "../src/CanvasText.vala"
		_g_free0 (self->priv->_text);
#line 54 "../src/CanvasText.vala"
		self->priv->_text = _tmp1_;
#line 55 "../src/CanvasText.vala"
		canvas_text_update_size (self, TRUE);
#line 3145 "CanvasText.c"
	}
#line 52 "../src/CanvasText.vala"
	g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_TEXT_PROPERTY]);
#line 3149 "CanvasText.c"
}

gdouble
canvas_text_get_posx (CanvasText* self)
{
	gdouble result;
#line 59 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 59 "../src/CanvasText.vala"
	result = self->priv->_posx;
#line 59 "../src/CanvasText.vala"
	return result;
#line 3162 "CanvasText.c"
}

void
canvas_text_set_posx (CanvasText* self,
                      gdouble value)
{
#line 59 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/CanvasText.vala"
	if (canvas_text_get_posx (self) != value) {
#line 59 "../src/CanvasText.vala"
		self->priv->_posx = value;
#line 59 "../src/CanvasText.vala"
		g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_POSX_PROPERTY]);
#line 3177 "CanvasText.c"
	}
}

gdouble
canvas_text_get_posy (CanvasText* self)
{
	gdouble result;
#line 60 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 60 "../src/CanvasText.vala"
	result = self->priv->_posy;
#line 60 "../src/CanvasText.vala"
	return result;
#line 3191 "CanvasText.c"
}

void
canvas_text_set_posy (CanvasText* self,
                      gdouble value)
{
#line 60 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/CanvasText.vala"
	if (canvas_text_get_posy (self) != value) {
#line 60 "../src/CanvasText.vala"
		self->priv->_posy = value;
#line 60 "../src/CanvasText.vala"
		g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_POSY_PROPERTY]);
#line 3206 "CanvasText.c"
	}
}

gdouble
canvas_text_get_width (CanvasText* self)
{
	gdouble result;
#line 62 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 63 "../src/CanvasText.vala"
	result = self->priv->_width;
#line 63 "../src/CanvasText.vala"
	return result;
#line 3220 "CanvasText.c"
}

gdouble
canvas_text_get_height (CanvasText* self)
{
	gdouble result;
#line 67 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 68 "../src/CanvasText.vala"
	result = self->priv->_height;
#line 68 "../src/CanvasText.vala"
	return result;
#line 3233 "CanvasText.c"
}

gboolean
canvas_text_get_markup (CanvasText* self)
{
	gboolean result;
#line 72 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "../src/CanvasText.vala"
	result = self->priv->_markup;
#line 73 "../src/CanvasText.vala"
	return result;
#line 3246 "CanvasText.c"
}

void
canvas_text_set_markup (CanvasText* self,
                        gboolean value)
{
#line 75 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/CanvasText.vala"
	if (self->priv->_markup != value) {
#line 77 "../src/CanvasText.vala"
		self->priv->_markup = value;
#line 78 "../src/CanvasText.vala"
		canvas_text_update_size (self, TRUE);
#line 3261 "CanvasText.c"
	}
#line 75 "../src/CanvasText.vala"
	g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_MARKUP_PROPERTY]);
#line 3265 "CanvasText.c"
}

gboolean
canvas_text_get_edit (CanvasText* self)
{
	gboolean result;
#line 83 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 84 "../src/CanvasText.vala"
	result = self->priv->_edit;
#line 84 "../src/CanvasText.vala"
	return result;
#line 3278 "CanvasText.c"
}

void
canvas_text_set_edit (CanvasText* self,
                      gboolean value)
{
#line 86 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/CanvasText.vala"
	if (self->priv->_edit != value) {
#line 88 "../src/CanvasText.vala"
		self->priv->_edit = value;
#line 89 "../src/CanvasText.vala"
		canvas_text_update_size (self, TRUE);
#line 3293 "CanvasText.c"
	}
#line 86 "../src/CanvasText.vala"
	g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_EDIT_PROPERTY]);
#line 3297 "CanvasText.c"
}

static void
canvas_text_class_init (CanvasTextClass * klass,
                        gpointer klass_data)
{
#line 28 "../src/CanvasText.vala"
	canvas_text_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/CanvasText.vala"
	g_type_class_adjust_private_offset (klass, &CanvasText_private_offset);
#line 28 "../src/CanvasText.vala"
	((CanvasTextClass *) klass)->load = (void (*) (CanvasText*, xmlNode*)) canvas_text_real_load;
#line 28 "../src/CanvasText.vala"
	((CanvasTextClass *) klass)->resize = (void (*) (CanvasText*, gdouble)) canvas_text_real_resize;
#line 28 "../src/CanvasText.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_canvas_text_get_property;
#line 28 "../src/CanvasText.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_canvas_text_set_property;
#line 28 "../src/CanvasText.vala"
	G_OBJECT_CLASS (klass)->finalize = canvas_text_finalize;
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_TEXT_PROPERTY, canvas_text_properties[CANVAS_TEXT_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_POSX_PROPERTY, canvas_text_properties[CANVAS_TEXT_POSX_PROPERTY] = g_param_spec_double ("posx", "posx", "posx", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_POSY_PROPERTY, canvas_text_properties[CANVAS_TEXT_POSY_PROPERTY] = g_param_spec_double ("posy", "posy", "posy", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_WIDTH_PROPERTY, canvas_text_properties[CANVAS_TEXT_WIDTH_PROPERTY] = g_param_spec_double ("width", "width", "width", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_HEIGHT_PROPERTY, canvas_text_properties[CANVAS_TEXT_HEIGHT_PROPERTY] = g_param_spec_double ("height", "height", "height", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_MARKUP_PROPERTY, canvas_text_properties[CANVAS_TEXT_MARKUP_PROPERTY] = g_param_spec_boolean ("markup", "markup", "markup", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_EDIT_PROPERTY, canvas_text_properties[CANVAS_TEXT_EDIT_PROPERTY] = g_param_spec_boolean ("edit", "edit", "edit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	canvas_text_signals[CANVAS_TEXT_RESIZED_SIGNAL] = g_signal_new ("resized", TYPE_CANVAS_TEXT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3334 "CanvasText.c"
}

static void
canvas_text_instance_init (CanvasText * self,
                           gpointer klass)
{
	gchar* _tmp0_;
#line 28 "../src/CanvasText.vala"
	self->priv = canvas_text_get_instance_private (self);
#line 31 "../src/CanvasText.vala"
	_tmp0_ = g_strdup ("");
#line 31 "../src/CanvasText.vala"
	self->priv->_text = _tmp0_;
#line 32 "../src/CanvasText.vala"
	self->priv->_markup = TRUE;
#line 33 "../src/CanvasText.vala"
	self->priv->_edit = FALSE;
#line 34 "../src/CanvasText.vala"
	self->priv->_cursor = 0;
#line 35 "../src/CanvasText.vala"
	self->priv->_column = 0;
#line 36 "../src/CanvasText.vala"
	self->priv->_pango_layout = NULL;
#line 37 "../src/CanvasText.vala"
	self->priv->_selstart = 0;
#line 38 "../src/CanvasText.vala"
	self->priv->_selend = 0;
#line 39 "../src/CanvasText.vala"
	self->priv->_selanchor = 0;
#line 40 "../src/CanvasText.vala"
	self->priv->_max_width = (gdouble) 200;
#line 41 "../src/CanvasText.vala"
	self->priv->_width = (gdouble) 0;
#line 42 "../src/CanvasText.vala"
	self->priv->_height = (gdouble) 0;
#line 59 "../src/CanvasText.vala"
	self->priv->_posx = (gdouble) 0;
#line 60 "../src/CanvasText.vala"
	self->priv->_posy = (gdouble) 0;
#line 3374 "CanvasText.c"
}

static void
canvas_text_finalize (GObject * obj)
{
	CanvasText * self;
#line 28 "../src/CanvasText.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CANVAS_TEXT, CanvasText);
#line 31 "../src/CanvasText.vala"
	_g_free0 (self->priv->_text);
#line 36 "../src/CanvasText.vala"
	_g_object_unref0 (self->priv->_pango_layout);
#line 28 "../src/CanvasText.vala"
	G_OBJECT_CLASS (canvas_text_parent_class)->finalize (obj);
#line 3389 "CanvasText.c"
}

GType
canvas_text_get_type (void)
{
	static volatile gsize canvas_text_type_id__volatile = 0;
	if (g_once_init_enter (&canvas_text_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CanvasTextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) canvas_text_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CanvasText), 0, (GInstanceInitFunc) canvas_text_instance_init, NULL };
		GType canvas_text_type_id;
		canvas_text_type_id = g_type_register_static (G_TYPE_OBJECT, "CanvasText", &g_define_type_info, 0);
		CanvasText_private_offset = g_type_add_instance_private (canvas_text_type_id, sizeof (CanvasTextPrivate));
		g_once_init_leave (&canvas_text_type_id__volatile, canvas_text_type_id);
	}
	return canvas_text_type_id__volatile;
}

static void
_vala_canvas_text_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	CanvasText * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CANVAS_TEXT, CanvasText);
#line 28 "../src/CanvasText.vala"
	switch (property_id) {
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_TEXT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_string (value, canvas_text_get_text (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_POSX_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_double (value, canvas_text_get_posx (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_POSY_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_double (value, canvas_text_get_posy (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_WIDTH_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_double (value, canvas_text_get_width (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_HEIGHT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_double (value, canvas_text_get_height (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_MARKUP_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_boolean (value, canvas_text_get_markup (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_EDIT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_boolean (value, canvas_text_get_edit (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 3458 "CanvasText.c"
		default:
#line 28 "../src/CanvasText.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/CanvasText.vala"
		break;
#line 3464 "CanvasText.c"
	}
}

static void
_vala_canvas_text_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	CanvasText * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CANVAS_TEXT, CanvasText);
#line 28 "../src/CanvasText.vala"
	switch (property_id) {
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_TEXT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_text (self, g_value_get_string (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_POSX_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_posx (self, g_value_get_double (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_POSY_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_posy (self, g_value_get_double (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_MARKUP_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_markup (self, g_value_get_boolean (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_EDIT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_edit (self, g_value_get_boolean (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 3508 "CanvasText.c"
		default:
#line 28 "../src/CanvasText.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/CanvasText.vala"
		break;
#line 3514 "CanvasText.c"
	}
}

