/* UndoBuffer.c generated by valac 0.45.91, the Vala compiler
 * generated from UndoBuffer.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>

#define TYPE_UNDO_BUFFER (undo_buffer_get_type ())
#define UNDO_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_BUFFER, UndoBuffer))
#define UNDO_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_BUFFER, UndoBufferClass))
#define IS_UNDO_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_BUFFER))
#define IS_UNDO_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_BUFFER))
#define UNDO_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_BUFFER, UndoBufferClass))

typedef struct _UndoBuffer UndoBuffer;
typedef struct _UndoBufferClass UndoBufferClass;
typedef struct _UndoBufferPrivate UndoBufferPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_UNDO_ITEM (undo_item_get_type ())
#define UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_ITEM, UndoItem))
#define UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_ITEM, UndoItemClass))
#define IS_UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_ITEM))
#define IS_UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_ITEM))
#define UNDO_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_ITEM, UndoItemClass))

typedef struct _UndoItem UndoItem;
typedef struct _UndoItemClass UndoItemClass;
enum  {
	UNDO_BUFFER_0_PROPERTY,
	UNDO_BUFFER_NUM_PROPERTIES
};
static GParamSpec* undo_buffer_properties[UNDO_BUFFER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	UNDO_BUFFER_BUFFER_CHANGED_SIGNAL,
	UNDO_BUFFER_NUM_SIGNALS
};
static guint undo_buffer_signals[UNDO_BUFFER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _UndoBuffer {
	GObject parent_instance;
	UndoBufferPrivate * priv;
};

struct _UndoBufferClass {
	GObjectClass parent_class;
};

struct _UndoBufferPrivate {
	DrawArea* _da;
	GArray* _undo_buffer;
	GArray* _redo_buffer;
	gboolean _debug;
};

static gint UndoBuffer_private_offset;
static gpointer undo_buffer_parent_class = NULL;
static gint undo_buffer__current_id;
static gint undo_buffer__current_id = 0;

GType undo_buffer_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UndoBuffer, g_object_unref)
GType draw_area_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DrawArea, g_object_unref)
GType undo_item_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UndoItem, g_object_unref)
UndoBuffer* undo_buffer_new (DrawArea* da);
UndoBuffer* undo_buffer_construct (GType object_type,
                                   DrawArea* da);
static void _g_object_unref0_ (gpointer var);
static void _vala_UndoItem_free_function_content_of (gpointer data);
void undo_buffer_clear (UndoBuffer* self);
gboolean undo_buffer_undoable (UndoBuffer* self);
gboolean undo_buffer_redoable (UndoBuffer* self);
void undo_buffer_undo (UndoBuffer* self);
void undo_item_undo (UndoItem* self,
                     DrawArea* da);
void undo_buffer_output (UndoBuffer* self,
                         const gchar* msg);
void undo_buffer_redo (UndoBuffer* self);
void undo_item_redo (UndoItem* self,
                     DrawArea* da);
gchar* undo_buffer_undo_tooltip (UndoBuffer* self);
const gchar* undo_item_get_name (UndoItem* self);
gchar* undo_buffer_redo_tooltip (UndoBuffer* self);
void undo_buffer_add_item (UndoBuffer* self,
                           UndoItem* item);
void undo_item_set_id (UndoItem* self,
                       gint value);
void undo_buffer_replace_item (UndoBuffer* self,
                               UndoItem* item);
gboolean undo_item_matches (UndoItem* self,
                            UndoItem* item);
void undo_item_replace_with_item (UndoItem* self,
                                  UndoItem* item);
gchar* undo_item_to_string (UndoItem* self);
static void undo_buffer_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
undo_buffer_get_instance_private (UndoBuffer* self)
{
	return G_STRUCT_MEMBER_P (self, UndoBuffer_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../src/UndoBuffer.vala"
	return self ? g_object_ref (self) : NULL;
#line 158 "UndoBuffer.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 37 "../src/UndoBuffer.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 166 "UndoBuffer.c"
}

static void
_vala_UndoItem_free_function_content_of (gpointer data)
{
	UndoItem* self;
#line 37 "../src/UndoBuffer.vala"
	self = *((UndoItem**) data);
#line 37 "../src/UndoBuffer.vala"
	_g_object_unref0_ (self);
#line 177 "UndoBuffer.c"
}

UndoBuffer*
undo_buffer_construct (GType object_type,
                       DrawArea* da)
{
	UndoBuffer * self = NULL;
	DrawArea* _tmp0_;
	GArray* _tmp1_;
	GArray* _tmp2_;
#line 35 "../src/UndoBuffer.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 35 "../src/UndoBuffer.vala"
	self = (UndoBuffer*) g_object_new (object_type, NULL);
#line 36 "../src/UndoBuffer.vala"
	_tmp0_ = _g_object_ref0 (da);
#line 36 "../src/UndoBuffer.vala"
	_g_object_unref0 (self->priv->_da);
#line 36 "../src/UndoBuffer.vala"
	self->priv->_da = _tmp0_;
#line 37 "../src/UndoBuffer.vala"
	_tmp1_ = g_array_new (TRUE, TRUE, sizeof (UndoItem*));
#line 37 "../src/UndoBuffer.vala"
	g_array_set_clear_func (_tmp1_, (GDestroyNotify) _vala_UndoItem_free_function_content_of);
#line 37 "../src/UndoBuffer.vala"
	_g_array_unref0 (self->priv->_undo_buffer);
#line 37 "../src/UndoBuffer.vala"
	self->priv->_undo_buffer = _tmp1_;
#line 38 "../src/UndoBuffer.vala"
	_tmp2_ = g_array_new (TRUE, TRUE, sizeof (UndoItem*));
#line 38 "../src/UndoBuffer.vala"
	g_array_set_clear_func (_tmp2_, (GDestroyNotify) _vala_UndoItem_free_function_content_of);
#line 38 "../src/UndoBuffer.vala"
	_g_array_unref0 (self->priv->_redo_buffer);
#line 38 "../src/UndoBuffer.vala"
	self->priv->_redo_buffer = _tmp2_;
#line 35 "../src/UndoBuffer.vala"
	return self;
#line 216 "UndoBuffer.c"
}

UndoBuffer*
undo_buffer_new (DrawArea* da)
{
#line 35 "../src/UndoBuffer.vala"
	return undo_buffer_construct (TYPE_UNDO_BUFFER, da);
#line 224 "UndoBuffer.c"
}

static gpointer*
vala_g_array_remove_range (GArray* self,
                           guint index,
                           guint length,
                           gint* result_length1)
{
	gpointer* result = NULL;
	gpointer* ga = NULL;
	gpointer* _tmp0_;
	gint ga_length1;
	gint _ga_size_;
	gpointer* _tmp6_;
	gint _tmp6__length1;
#line 5370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5371 "glib-2.0.vapi"
	_vala_assert (self->len >= (index + length), "this.length >= index + length");
#line 5372 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gpointer, length);
#line 5372 "glib-2.0.vapi"
	ga = _tmp0_;
#line 5372 "glib-2.0.vapi"
	ga_length1 = length;
#line 5372 "glib-2.0.vapi"
	_ga_size_ = ga_length1;
#line 252 "UndoBuffer.c"
	{
		guint i = 0U;
#line 5373 "glib-2.0.vapi"
		i = (guint) 0;
#line 257 "UndoBuffer.c"
		{
			gboolean _tmp1_ = FALSE;
#line 5373 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 5373 "glib-2.0.vapi"
			while (TRUE) {
#line 264 "UndoBuffer.c"
				gpointer* _tmp3_;
				gint _tmp3__length1;
				gpointer* _tmp4_;
				gint _tmp4__length1;
				gpointer _tmp5_;
#line 5373 "glib-2.0.vapi"
				if (!_tmp1_) {
#line 272 "UndoBuffer.c"
					guint _tmp2_;
#line 5373 "glib-2.0.vapi"
					_tmp2_ = i;
#line 5373 "glib-2.0.vapi"
					i = _tmp2_ + 1;
#line 278 "UndoBuffer.c"
				}
#line 5373 "glib-2.0.vapi"
				_tmp1_ = FALSE;
#line 5373 "glib-2.0.vapi"
				if (!(i < length)) {
#line 5373 "glib-2.0.vapi"
					break;
#line 286 "UndoBuffer.c"
				}
#line 5374 "glib-2.0.vapi"
				_tmp3_ = ga;
#line 5374 "glib-2.0.vapi"
				_tmp3__length1 = ga_length1;
#line 5374 "glib-2.0.vapi"
				_tmp4_ = self->data;
#line 5374 "glib-2.0.vapi"
				_tmp4__length1 = self->len;
#line 5374 "glib-2.0.vapi"
				_tmp5_ = _tmp4_[i + index];
#line 5374 "glib-2.0.vapi"
				_tmp4_[i + index] = NULL;
#line 5374 "glib-2.0.vapi"
				_tmp3_[i] = _tmp5_;
#line 302 "UndoBuffer.c"
			}
		}
	}
#line 5376 "glib-2.0.vapi"
	g_array_remove_range (self, index, length);
#line 5377 "glib-2.0.vapi"
	_tmp6_ = ga;
#line 5377 "glib-2.0.vapi"
	_tmp6__length1 = ga_length1;
#line 5377 "glib-2.0.vapi"
	if (result_length1) {
#line 5377 "glib-2.0.vapi"
		*result_length1 = _tmp6__length1;
#line 316 "UndoBuffer.c"
	}
#line 5377 "glib-2.0.vapi"
	result = _tmp6_;
#line 5377 "glib-2.0.vapi"
	return result;
#line 322 "UndoBuffer.c"
}

void
undo_buffer_clear (UndoBuffer* self)
{
	GArray* _tmp0_;
	GArray* _tmp1_;
	gint _tmp2_ = 0;
	gpointer* _tmp3_;
	UndoItem** _tmp4_;
	gint _tmp4__length1;
	GArray* _tmp5_;
	GArray* _tmp6_;
	gint _tmp7_ = 0;
	gpointer* _tmp8_;
	UndoItem** _tmp9_;
	gint _tmp9__length1;
	DrawArea* _tmp10_;
#line 42 "../src/UndoBuffer.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/UndoBuffer.vala"
	_tmp0_ = self->priv->_undo_buffer;
#line 43 "../src/UndoBuffer.vala"
	_tmp1_ = self->priv->_undo_buffer;
#line 43 "../src/UndoBuffer.vala"
	_tmp3_ = vala_g_array_remove_range (_tmp0_, (guint) 0, _tmp1_->len, &_tmp2_);
#line 43 "../src/UndoBuffer.vala"
	_tmp4_ = _tmp3_;
#line 43 "../src/UndoBuffer.vala"
	_tmp4__length1 = _tmp2_;
#line 43 "../src/UndoBuffer.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_object_unref), NULL);
#line 44 "../src/UndoBuffer.vala"
	_tmp5_ = self->priv->_redo_buffer;
#line 44 "../src/UndoBuffer.vala"
	_tmp6_ = self->priv->_redo_buffer;
#line 44 "../src/UndoBuffer.vala"
	_tmp8_ = vala_g_array_remove_range (_tmp5_, (guint) 0, _tmp6_->len, &_tmp7_);
#line 44 "../src/UndoBuffer.vala"
	_tmp9_ = _tmp8_;
#line 44 "../src/UndoBuffer.vala"
	_tmp9__length1 = _tmp7_;
#line 44 "../src/UndoBuffer.vala"
	_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_object_unref), NULL);
#line 45 "../src/UndoBuffer.vala"
	_tmp10_ = self->priv->_da;
#line 45 "../src/UndoBuffer.vala"
	g_signal_emit (self, undo_buffer_signals[UNDO_BUFFER_BUFFER_CHANGED_SIGNAL], 0, _tmp10_);
#line 371 "UndoBuffer.c"
}

gboolean
undo_buffer_undoable (UndoBuffer* self)
{
	gboolean result = FALSE;
	GArray* _tmp0_;
#line 49 "../src/UndoBuffer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "../src/UndoBuffer.vala"
	_tmp0_ = self->priv->_undo_buffer;
#line 50 "../src/UndoBuffer.vala"
	result = _tmp0_->len > ((guint) 0);
#line 50 "../src/UndoBuffer.vala"
	return result;
#line 387 "UndoBuffer.c"
}

gboolean
undo_buffer_redoable (UndoBuffer* self)
{
	gboolean result = FALSE;
	GArray* _tmp0_;
#line 54 "../src/UndoBuffer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "../src/UndoBuffer.vala"
	_tmp0_ = self->priv->_redo_buffer;
#line 55 "../src/UndoBuffer.vala"
	result = _tmp0_->len > ((guint) 0);
#line 55 "../src/UndoBuffer.vala"
	return result;
#line 403 "UndoBuffer.c"
}

static gpointer
vala_g_array_remove_index (GArray* self,
                           guint index)
{
	gpointer result = NULL;
	gpointer g = NULL;
	gpointer* _tmp0_;
	gint _tmp0__length1;
	gpointer _tmp1_;
#line 5356 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5357 "glib-2.0.vapi"
	_vala_assert (self->len > index, "length > index");
#line 5358 "glib-2.0.vapi"
	_tmp0_ = self->data;
#line 5358 "glib-2.0.vapi"
	_tmp0__length1 = self->len;
#line 5358 "glib-2.0.vapi"
	_tmp1_ = _tmp0_[index];
#line 5358 "glib-2.0.vapi"
	_tmp0_[index] = NULL;
#line 5358 "glib-2.0.vapi"
	g = _tmp1_;
#line 5359 "glib-2.0.vapi"
	g_array_remove_index (self, index);
#line 5360 "glib-2.0.vapi"
	result = g;
#line 5360 "glib-2.0.vapi"
	return result;
#line 435 "UndoBuffer.c"
}

void
undo_buffer_undo (UndoBuffer* self)
{
#line 59 "../src/UndoBuffer.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/UndoBuffer.vala"
	if (undo_buffer_undoable (self)) {
#line 445 "UndoBuffer.c"
		UndoItem* item = NULL;
		GArray* _tmp0_;
		GArray* _tmp1_;
		UndoItem* _tmp2_;
		UndoItem* _tmp3_;
		UndoItem* _tmp4_;
		DrawArea* _tmp5_;
		GArray* _tmp6_;
		GArray* _tmp7_;
		UndoItem* _tmp8_;
		UndoItem* _tmp9_;
		GArray* _tmp10_;
		UndoItem* _tmp11_;
		UndoItem* _tmp12_;
		DrawArea* _tmp13_;
#line 61 "../src/UndoBuffer.vala"
		_tmp0_ = self->priv->_undo_buffer;
#line 61 "../src/UndoBuffer.vala"
		_tmp1_ = self->priv->_undo_buffer;
#line 61 "../src/UndoBuffer.vala"
		_tmp2_ = g_array_index (_tmp0_, UndoItem*, _tmp1_->len - 1);
#line 61 "../src/UndoBuffer.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 61 "../src/UndoBuffer.vala"
		item = _tmp3_;
#line 62 "../src/UndoBuffer.vala"
		_tmp4_ = item;
#line 62 "../src/UndoBuffer.vala"
		_tmp5_ = self->priv->_da;
#line 62 "../src/UndoBuffer.vala"
		undo_item_undo (_tmp4_, _tmp5_);
#line 63 "../src/UndoBuffer.vala"
		_tmp6_ = self->priv->_undo_buffer;
#line 63 "../src/UndoBuffer.vala"
		_tmp7_ = self->priv->_undo_buffer;
#line 63 "../src/UndoBuffer.vala"
		_tmp8_ = vala_g_array_remove_index (_tmp6_, _tmp7_->len - 1);
#line 63 "../src/UndoBuffer.vala"
		_tmp9_ = _tmp8_;
#line 63 "../src/UndoBuffer.vala"
		_g_object_unref0 (_tmp9_);
#line 64 "../src/UndoBuffer.vala"
		_tmp10_ = self->priv->_redo_buffer;
#line 64 "../src/UndoBuffer.vala"
		_tmp11_ = item;
#line 64 "../src/UndoBuffer.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 64 "../src/UndoBuffer.vala"
		g_array_append_val (_tmp10_, _tmp12_);
#line 65 "../src/UndoBuffer.vala"
		_tmp13_ = self->priv->_da;
#line 65 "../src/UndoBuffer.vala"
		g_signal_emit (self, undo_buffer_signals[UNDO_BUFFER_BUFFER_CHANGED_SIGNAL], 0, _tmp13_);
#line 60 "../src/UndoBuffer.vala"
		_g_object_unref0 (item);
#line 501 "UndoBuffer.c"
	}
#line 67 "../src/UndoBuffer.vala"
	undo_buffer_output (self, "AFTER UNDO");
#line 505 "UndoBuffer.c"
}

void
undo_buffer_redo (UndoBuffer* self)
{
#line 71 "../src/UndoBuffer.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/UndoBuffer.vala"
	if (undo_buffer_redoable (self)) {
#line 515 "UndoBuffer.c"
		UndoItem* item = NULL;
		GArray* _tmp0_;
		GArray* _tmp1_;
		UndoItem* _tmp2_;
		UndoItem* _tmp3_;
		UndoItem* _tmp4_;
		DrawArea* _tmp5_;
		GArray* _tmp6_;
		GArray* _tmp7_;
		UndoItem* _tmp8_;
		UndoItem* _tmp9_;
		GArray* _tmp10_;
		UndoItem* _tmp11_;
		UndoItem* _tmp12_;
		DrawArea* _tmp13_;
#line 73 "../src/UndoBuffer.vala"
		_tmp0_ = self->priv->_redo_buffer;
#line 73 "../src/UndoBuffer.vala"
		_tmp1_ = self->priv->_redo_buffer;
#line 73 "../src/UndoBuffer.vala"
		_tmp2_ = g_array_index (_tmp0_, UndoItem*, _tmp1_->len - 1);
#line 73 "../src/UndoBuffer.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 73 "../src/UndoBuffer.vala"
		item = _tmp3_;
#line 74 "../src/UndoBuffer.vala"
		_tmp4_ = item;
#line 74 "../src/UndoBuffer.vala"
		_tmp5_ = self->priv->_da;
#line 74 "../src/UndoBuffer.vala"
		undo_item_redo (_tmp4_, _tmp5_);
#line 75 "../src/UndoBuffer.vala"
		_tmp6_ = self->priv->_redo_buffer;
#line 75 "../src/UndoBuffer.vala"
		_tmp7_ = self->priv->_redo_buffer;
#line 75 "../src/UndoBuffer.vala"
		_tmp8_ = vala_g_array_remove_index (_tmp6_, _tmp7_->len - 1);
#line 75 "../src/UndoBuffer.vala"
		_tmp9_ = _tmp8_;
#line 75 "../src/UndoBuffer.vala"
		_g_object_unref0 (_tmp9_);
#line 76 "../src/UndoBuffer.vala"
		_tmp10_ = self->priv->_undo_buffer;
#line 76 "../src/UndoBuffer.vala"
		_tmp11_ = item;
#line 76 "../src/UndoBuffer.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 76 "../src/UndoBuffer.vala"
		g_array_append_val (_tmp10_, _tmp12_);
#line 77 "../src/UndoBuffer.vala"
		_tmp13_ = self->priv->_da;
#line 77 "../src/UndoBuffer.vala"
		g_signal_emit (self, undo_buffer_signals[UNDO_BUFFER_BUFFER_CHANGED_SIGNAL], 0, _tmp13_);
#line 72 "../src/UndoBuffer.vala"
		_g_object_unref0 (item);
#line 571 "UndoBuffer.c"
	}
#line 79 "../src/UndoBuffer.vala"
	undo_buffer_output (self, "AFTER REDO");
#line 575 "UndoBuffer.c"
}

gchar*
undo_buffer_undo_tooltip (UndoBuffer* self)
{
	gchar* result = NULL;
	GArray* _tmp0_;
	GArray* _tmp2_;
	GArray* _tmp3_;
	UndoItem* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
#line 83 "../src/UndoBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "../src/UndoBuffer.vala"
	_tmp0_ = self->priv->_undo_buffer;
#line 84 "../src/UndoBuffer.vala"
	if (_tmp0_->len == ((guint) 0)) {
#line 595 "UndoBuffer.c"
		gchar* _tmp1_;
#line 84 "../src/UndoBuffer.vala"
		_tmp1_ = g_strdup ("");
#line 84 "../src/UndoBuffer.vala"
		result = _tmp1_;
#line 84 "../src/UndoBuffer.vala"
		return result;
#line 603 "UndoBuffer.c"
	}
#line 85 "../src/UndoBuffer.vala"
	_tmp2_ = self->priv->_undo_buffer;
#line 85 "../src/UndoBuffer.vala"
	_tmp3_ = self->priv->_undo_buffer;
#line 85 "../src/UndoBuffer.vala"
	_tmp4_ = g_array_index (_tmp2_, UndoItem*, _tmp3_->len - 1);
#line 85 "../src/UndoBuffer.vala"
	_tmp5_ = undo_item_get_name (_tmp4_);
#line 85 "../src/UndoBuffer.vala"
	_tmp6_ = _tmp5_;
#line 85 "../src/UndoBuffer.vala"
	_tmp7_ = g_strconcat (_ ("Undo "), _tmp6_, NULL);
#line 85 "../src/UndoBuffer.vala"
	result = _tmp7_;
#line 85 "../src/UndoBuffer.vala"
	return result;
#line 621 "UndoBuffer.c"
}

gchar*
undo_buffer_redo_tooltip (UndoBuffer* self)
{
	gchar* result = NULL;
	GArray* _tmp0_;
	GArray* _tmp2_;
	GArray* _tmp3_;
	UndoItem* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
#line 89 "../src/UndoBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "../src/UndoBuffer.vala"
	_tmp0_ = self->priv->_redo_buffer;
#line 90 "../src/UndoBuffer.vala"
	if (_tmp0_->len == ((guint) 0)) {
#line 641 "UndoBuffer.c"
		gchar* _tmp1_;
#line 90 "../src/UndoBuffer.vala"
		_tmp1_ = g_strdup ("");
#line 90 "../src/UndoBuffer.vala"
		result = _tmp1_;
#line 90 "../src/UndoBuffer.vala"
		return result;
#line 649 "UndoBuffer.c"
	}
#line 91 "../src/UndoBuffer.vala"
	_tmp2_ = self->priv->_redo_buffer;
#line 91 "../src/UndoBuffer.vala"
	_tmp3_ = self->priv->_redo_buffer;
#line 91 "../src/UndoBuffer.vala"
	_tmp4_ = g_array_index (_tmp2_, UndoItem*, _tmp3_->len - 1);
#line 91 "../src/UndoBuffer.vala"
	_tmp5_ = undo_item_get_name (_tmp4_);
#line 91 "../src/UndoBuffer.vala"
	_tmp6_ = _tmp5_;
#line 91 "../src/UndoBuffer.vala"
	_tmp7_ = g_strconcat (_ ("Redo "), _tmp6_, NULL);
#line 91 "../src/UndoBuffer.vala"
	result = _tmp7_;
#line 91 "../src/UndoBuffer.vala"
	return result;
#line 667 "UndoBuffer.c"
}

void
undo_buffer_add_item (UndoBuffer* self,
                      UndoItem* item)
{
	gint _tmp0_;
	GArray* _tmp1_;
	UndoItem* _tmp2_;
	GArray* _tmp3_;
	GArray* _tmp4_;
	gint _tmp5_ = 0;
	gpointer* _tmp6_;
	UndoItem** _tmp7_;
	gint _tmp7__length1;
	DrawArea* _tmp8_;
#line 95 "../src/UndoBuffer.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/UndoBuffer.vala"
	g_return_if_fail (item != NULL);
#line 96 "../src/UndoBuffer.vala"
	_tmp0_ = undo_buffer__current_id;
#line 96 "../src/UndoBuffer.vala"
	undo_buffer__current_id = _tmp0_ + 1;
#line 96 "../src/UndoBuffer.vala"
	undo_item_set_id (item, _tmp0_);
#line 97 "../src/UndoBuffer.vala"
	_tmp1_ = self->priv->_undo_buffer;
#line 97 "../src/UndoBuffer.vala"
	_tmp2_ = _g_object_ref0 (item);
#line 97 "../src/UndoBuffer.vala"
	g_array_append_val (_tmp1_, _tmp2_);
#line 98 "../src/UndoBuffer.vala"
	_tmp3_ = self->priv->_redo_buffer;
#line 98 "../src/UndoBuffer.vala"
	_tmp4_ = self->priv->_redo_buffer;
#line 98 "../src/UndoBuffer.vala"
	_tmp6_ = vala_g_array_remove_range (_tmp3_, (guint) 0, _tmp4_->len, &_tmp5_);
#line 98 "../src/UndoBuffer.vala"
	_tmp7_ = _tmp6_;
#line 98 "../src/UndoBuffer.vala"
	_tmp7__length1 = _tmp5_;
#line 98 "../src/UndoBuffer.vala"
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_object_unref), NULL);
#line 99 "../src/UndoBuffer.vala"
	_tmp8_ = self->priv->_da;
#line 99 "../src/UndoBuffer.vala"
	g_signal_emit (self, undo_buffer_signals[UNDO_BUFFER_BUFFER_CHANGED_SIGNAL], 0, _tmp8_);
#line 100 "../src/UndoBuffer.vala"
	undo_buffer_output (self, "ITEM ADDED");
#line 718 "UndoBuffer.c"
}

void
undo_buffer_replace_item (UndoBuffer* self,
                          UndoItem* item)
{
	gint _tmp0_;
	GArray* _tmp1_;
#line 107 "../src/UndoBuffer.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/UndoBuffer.vala"
	g_return_if_fail (item != NULL);
#line 108 "../src/UndoBuffer.vala"
	_tmp0_ = undo_buffer__current_id;
#line 108 "../src/UndoBuffer.vala"
	undo_buffer__current_id = _tmp0_ + 1;
#line 108 "../src/UndoBuffer.vala"
	undo_item_set_id (item, _tmp0_);
#line 109 "../src/UndoBuffer.vala"
	_tmp1_ = self->priv->_undo_buffer;
#line 109 "../src/UndoBuffer.vala"
	if (_tmp1_->len > ((guint) 0)) {
#line 741 "UndoBuffer.c"
		UndoItem* last = NULL;
		GArray* _tmp2_;
		GArray* _tmp3_;
		UndoItem* _tmp4_;
		UndoItem* _tmp5_;
		gboolean _tmp6_ = FALSE;
		UndoItem* _tmp7_;
#line 110 "../src/UndoBuffer.vala"
		_tmp2_ = self->priv->_undo_buffer;
#line 110 "../src/UndoBuffer.vala"
		_tmp3_ = self->priv->_undo_buffer;
#line 110 "../src/UndoBuffer.vala"
		_tmp4_ = g_array_index (_tmp2_, UndoItem*, _tmp3_->len - 1);
#line 110 "../src/UndoBuffer.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 110 "../src/UndoBuffer.vala"
		last = _tmp5_;
#line 111 "../src/UndoBuffer.vala"
		_tmp7_ = last;
#line 111 "../src/UndoBuffer.vala"
		if (G_TYPE_FROM_INSTANCE ((GObject*) _tmp7_) == G_TYPE_FROM_INSTANCE ((GObject*) item)) {
#line 763 "UndoBuffer.c"
			UndoItem* _tmp8_;
#line 111 "../src/UndoBuffer.vala"
			_tmp8_ = last;
#line 111 "../src/UndoBuffer.vala"
			_tmp6_ = undo_item_matches (_tmp8_, item);
#line 769 "UndoBuffer.c"
		} else {
#line 111 "../src/UndoBuffer.vala"
			_tmp6_ = FALSE;
#line 773 "UndoBuffer.c"
		}
#line 111 "../src/UndoBuffer.vala"
		if (_tmp6_) {
#line 777 "UndoBuffer.c"
			UndoItem* _tmp9_;
			DrawArea* _tmp10_;
#line 112 "../src/UndoBuffer.vala"
			_tmp9_ = last;
#line 112 "../src/UndoBuffer.vala"
			undo_item_replace_with_item (_tmp9_, item);
#line 113 "../src/UndoBuffer.vala"
			_tmp10_ = self->priv->_da;
#line 113 "../src/UndoBuffer.vala"
			g_signal_emit (self, undo_buffer_signals[UNDO_BUFFER_BUFFER_CHANGED_SIGNAL], 0, _tmp10_);
#line 114 "../src/UndoBuffer.vala"
			undo_buffer_output (self, "ITEM REPLACED");
#line 115 "../src/UndoBuffer.vala"
			_g_object_unref0 (last);
#line 115 "../src/UndoBuffer.vala"
			return;
#line 794 "UndoBuffer.c"
		}
#line 109 "../src/UndoBuffer.vala"
		_g_object_unref0 (last);
#line 798 "UndoBuffer.c"
	}
#line 118 "../src/UndoBuffer.vala"
	undo_buffer_add_item (self, item);
#line 802 "UndoBuffer.c"
}

void
undo_buffer_output (UndoBuffer* self,
                    const gchar* msg)
{
#line 122 "../src/UndoBuffer.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/UndoBuffer.vala"
	g_return_if_fail (msg != NULL);
#line 123 "../src/UndoBuffer.vala"
	if (self->priv->_debug) {
#line 815 "UndoBuffer.c"
		FILE* _tmp0_;
		FILE* _tmp9_;
#line 124 "../src/UndoBuffer.vala"
		_tmp0_ = stdout;
#line 124 "../src/UndoBuffer.vala"
		fprintf (_tmp0_, "%s\n  Undo Buffer\n-----------\n", msg);
#line 822 "UndoBuffer.c"
		{
			gint i = 0;
#line 125 "../src/UndoBuffer.vala"
			i = 0;
#line 827 "UndoBuffer.c"
			{
				gboolean _tmp1_ = FALSE;
#line 125 "../src/UndoBuffer.vala"
				_tmp1_ = TRUE;
#line 125 "../src/UndoBuffer.vala"
				while (TRUE) {
#line 834 "UndoBuffer.c"
					GArray* _tmp3_;
					FILE* _tmp4_;
					GArray* _tmp5_;
					UndoItem* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
#line 125 "../src/UndoBuffer.vala"
					if (!_tmp1_) {
#line 843 "UndoBuffer.c"
						gint _tmp2_;
#line 125 "../src/UndoBuffer.vala"
						_tmp2_ = i;
#line 125 "../src/UndoBuffer.vala"
						i = _tmp2_ + 1;
#line 849 "UndoBuffer.c"
					}
#line 125 "../src/UndoBuffer.vala"
					_tmp1_ = FALSE;
#line 125 "../src/UndoBuffer.vala"
					_tmp3_ = self->priv->_undo_buffer;
#line 125 "../src/UndoBuffer.vala"
					if (!(((guint) i) < _tmp3_->len)) {
#line 125 "../src/UndoBuffer.vala"
						break;
#line 859 "UndoBuffer.c"
					}
#line 126 "../src/UndoBuffer.vala"
					_tmp4_ = stdout;
#line 126 "../src/UndoBuffer.vala"
					_tmp5_ = self->priv->_undo_buffer;
#line 126 "../src/UndoBuffer.vala"
					_tmp6_ = g_array_index (_tmp5_, UndoItem*, (guint) i);
#line 126 "../src/UndoBuffer.vala"
					_tmp7_ = undo_item_to_string (_tmp6_);
#line 126 "../src/UndoBuffer.vala"
					_tmp8_ = _tmp7_;
#line 126 "../src/UndoBuffer.vala"
					fprintf (_tmp4_, "    %s\n", _tmp8_);
#line 126 "../src/UndoBuffer.vala"
					_g_free0 (_tmp8_);
#line 875 "UndoBuffer.c"
				}
			}
		}
#line 128 "../src/UndoBuffer.vala"
		_tmp9_ = stdout;
#line 128 "../src/UndoBuffer.vala"
		fprintf (_tmp9_, "  Redo Buffer\n-----------\n");
#line 883 "UndoBuffer.c"
		{
			gint i = 0;
#line 129 "../src/UndoBuffer.vala"
			i = 0;
#line 888 "UndoBuffer.c"
			{
				gboolean _tmp10_ = FALSE;
#line 129 "../src/UndoBuffer.vala"
				_tmp10_ = TRUE;
#line 129 "../src/UndoBuffer.vala"
				while (TRUE) {
#line 895 "UndoBuffer.c"
					GArray* _tmp12_;
					FILE* _tmp13_;
					GArray* _tmp14_;
					UndoItem* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
#line 129 "../src/UndoBuffer.vala"
					if (!_tmp10_) {
#line 904 "UndoBuffer.c"
						gint _tmp11_;
#line 129 "../src/UndoBuffer.vala"
						_tmp11_ = i;
#line 129 "../src/UndoBuffer.vala"
						i = _tmp11_ + 1;
#line 910 "UndoBuffer.c"
					}
#line 129 "../src/UndoBuffer.vala"
					_tmp10_ = FALSE;
#line 129 "../src/UndoBuffer.vala"
					_tmp12_ = self->priv->_redo_buffer;
#line 129 "../src/UndoBuffer.vala"
					if (!(((guint) i) < _tmp12_->len)) {
#line 129 "../src/UndoBuffer.vala"
						break;
#line 920 "UndoBuffer.c"
					}
#line 130 "../src/UndoBuffer.vala"
					_tmp13_ = stdout;
#line 130 "../src/UndoBuffer.vala"
					_tmp14_ = self->priv->_redo_buffer;
#line 130 "../src/UndoBuffer.vala"
					_tmp15_ = g_array_index (_tmp14_, UndoItem*, (guint) i);
#line 130 "../src/UndoBuffer.vala"
					_tmp16_ = undo_item_to_string (_tmp15_);
#line 130 "../src/UndoBuffer.vala"
					_tmp17_ = _tmp16_;
#line 130 "../src/UndoBuffer.vala"
					fprintf (_tmp13_, "    %s\n", _tmp17_);
#line 130 "../src/UndoBuffer.vala"
					_g_free0 (_tmp17_);
#line 936 "UndoBuffer.c"
				}
			}
		}
	}
}

static void
undo_buffer_class_init (UndoBufferClass * klass,
                        gpointer klass_data)
{
#line 24 "../src/UndoBuffer.vala"
	undo_buffer_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/UndoBuffer.vala"
	g_type_class_adjust_private_offset (klass, &UndoBuffer_private_offset);
#line 24 "../src/UndoBuffer.vala"
	G_OBJECT_CLASS (klass)->finalize = undo_buffer_finalize;
#line 24 "../src/UndoBuffer.vala"
	undo_buffer_signals[UNDO_BUFFER_BUFFER_CHANGED_SIGNAL] = g_signal_new ("buffer-changed", TYPE_UNDO_BUFFER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DRAW_AREA);
#line 955 "UndoBuffer.c"
}

static void
undo_buffer_instance_init (UndoBuffer * self,
                           gpointer klass)
{
#line 24 "../src/UndoBuffer.vala"
	self->priv = undo_buffer_get_instance_private (self);
#line 29 "../src/UndoBuffer.vala"
	self->priv->_debug = FALSE;
#line 966 "UndoBuffer.c"
}

static void
undo_buffer_finalize (GObject * obj)
{
	UndoBuffer * self;
#line 24 "../src/UndoBuffer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UNDO_BUFFER, UndoBuffer);
#line 26 "../src/UndoBuffer.vala"
	_g_object_unref0 (self->priv->_da);
#line 27 "../src/UndoBuffer.vala"
	_g_array_unref0 (self->priv->_undo_buffer);
#line 28 "../src/UndoBuffer.vala"
	_g_array_unref0 (self->priv->_redo_buffer);
#line 24 "../src/UndoBuffer.vala"
	G_OBJECT_CLASS (undo_buffer_parent_class)->finalize (obj);
#line 983 "UndoBuffer.c"
}

GType
undo_buffer_get_type (void)
{
	static volatile gsize undo_buffer_type_id__volatile = 0;
	if (g_once_init_enter (&undo_buffer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UndoBufferClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) undo_buffer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UndoBuffer), 0, (GInstanceInitFunc) undo_buffer_instance_init, NULL };
		GType undo_buffer_type_id;
		undo_buffer_type_id = g_type_register_static (G_TYPE_OBJECT, "UndoBuffer", &g_define_type_info, 0);
		UndoBuffer_private_offset = g_type_add_instance_private (undo_buffer_type_id, sizeof (UndoBufferPrivate));
		g_once_init_leave (&undo_buffer_type_id__volatile, undo_buffer_type_id);
	}
	return undo_buffer_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

