/* Utils.c generated by valac 0.45.91, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/

#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gobject/gvaluecollector.h>

#define TYPE_UTILS (utils_get_type ())
#define UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UTILS, Utils))
#define UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UTILS, UtilsClass))
#define IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UTILS))
#define IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UTILS))
#define UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UTILS, UtilsClass))

typedef struct _Utils Utils;
typedef struct _UtilsClass UtilsClass;
typedef struct _UtilsPrivate UtilsPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_CONNECTION (connection_get_type ())
#define CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONNECTION, Connection))
#define CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONNECTION, ConnectionClass))
#define IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONNECTION))
#define IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONNECTION))
#define CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONNECTION, ConnectionClass))

typedef struct _Connection Connection;
typedef struct _ConnectionClass ConnectionClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecUtils ParamSpecUtils;

struct _Utils {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UtilsPrivate * priv;
};

struct _UtilsClass {
	GTypeClass parent_class;
	void (*finalize) (Utils *self);
};

struct _ParamSpecUtils {
	GParamSpec parent_instance;
};

static gpointer utils_parent_class = NULL;

gpointer utils_ref (gpointer instance);
void utils_unref (gpointer instance);
GParamSpec* param_spec_utils (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
void value_set_utils (GValue* value,
                      gpointer v_object);
void value_take_utils (GValue* value,
                       gpointer v_object);
gpointer value_get_utils (const GValue* value);
GType utils_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Utils, utils_unref)
gchar* utils_color_from_rgba (GdkRGBA* rgba);
void utils_set_context_color (cairo_t* ctx,
                              GdkRGBA* color);
void utils_set_context_color_with_alpha (cairo_t* ctx,
                                         GdkRGBA* color,
                                         gdouble alpha);
void utils_add_accel_label (GtkMenuItem* item,
                            guint key,
                            GdkModifierType mods);
GType node_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Node, g_object_unref)
GType connection_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Connection, g_object_unref)
void utils_match_string (const gchar* pattern,
                         const gchar* value,
                         const gchar* type,
                         Node* node,
                         Connection* conn,
                         GtkListStore* * matches);
gboolean utils_is_within_bounds (gdouble x,
                                 gdouble y,
                                 gdouble bx,
                                 gdouble by,
                                 gdouble bw,
                                 gdouble bh);
gchar* utils_make_title (const gchar* str);
gchar* utils_tooltip_with_accel (const gchar* tooltip,
                                 const gchar* accel);
Utils* utils_new (void);
Utils* utils_construct (GType object_type);
static void utils_finalize (Utils * obj);

gchar*
utils_color_from_rgba (GdkRGBA* rgba)
{
	gchar* result = NULL;
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	gchar* _tmp3_;
#line 32 "../src/Utils.vala"
	g_return_val_if_fail (rgba != NULL, NULL);
#line 33 "../src/Utils.vala"
	_tmp0_ = *rgba;
#line 33 "../src/Utils.vala"
	_tmp1_ = *rgba;
#line 33 "../src/Utils.vala"
	_tmp2_ = *rgba;
#line 33 "../src/Utils.vala"
	_tmp3_ = g_strdup_printf ("#%02x%02x%02x", (guint) ((gint) (_tmp0_.red * 255)), (guint) ((gint) (_tmp1_.green * 255)), (guint) ((gint) (_tmp2_.blue * 255)));
#line 33 "../src/Utils.vala"
	result = _tmp3_;
#line 33 "../src/Utils.vala"
	return result;
#line 156 "Utils.c"
}

void
utils_set_context_color (cairo_t* ctx,
                         GdkRGBA* color)
{
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
	GdkRGBA _tmp3_;
#line 37 "../src/Utils.vala"
	g_return_if_fail (ctx != NULL);
#line 37 "../src/Utils.vala"
	g_return_if_fail (color != NULL);
#line 38 "../src/Utils.vala"
	_tmp0_ = *color;
#line 38 "../src/Utils.vala"
	_tmp1_ = *color;
#line 38 "../src/Utils.vala"
	_tmp2_ = *color;
#line 38 "../src/Utils.vala"
	_tmp3_ = *color;
#line 38 "../src/Utils.vala"
	cairo_set_source_rgba (ctx, _tmp0_.red, _tmp1_.green, _tmp2_.blue, _tmp3_.alpha);
#line 181 "Utils.c"
}

void
utils_set_context_color_with_alpha (cairo_t* ctx,
                                    GdkRGBA* color,
                                    gdouble alpha)
{
	GdkRGBA _tmp0_;
	GdkRGBA _tmp1_;
	GdkRGBA _tmp2_;
#line 45 "../src/Utils.vala"
	g_return_if_fail (ctx != NULL);
#line 45 "../src/Utils.vala"
	g_return_if_fail (color != NULL);
#line 46 "../src/Utils.vala"
	_tmp0_ = *color;
#line 46 "../src/Utils.vala"
	_tmp1_ = *color;
#line 46 "../src/Utils.vala"
	_tmp2_ = *color;
#line 46 "../src/Utils.vala"
	cairo_set_source_rgba (ctx, _tmp0_.red, _tmp1_.green, _tmp2_.blue, alpha);
#line 204 "Utils.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 55 "../src/Utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 212 "Utils.c"
}

void
utils_add_accel_label (GtkMenuItem* item,
                       guint key,
                       GdkModifierType mods)
{
	GtkAccelLabel* label = NULL;
	GtkWidget* _tmp0_;
	GtkAccelLabel* _tmp1_;
	GtkAccelLabel* _tmp2_;
	GtkAccelLabel* _tmp3_;
	GtkAccelLabel* _tmp4_;
#line 52 "../src/Utils.vala"
	g_return_if_fail (item != NULL);
#line 55 "../src/Utils.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) item);
#line 55 "../src/Utils.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_accel_label_get_type ()) ? ((GtkAccelLabel*) _tmp0_) : NULL);
#line 55 "../src/Utils.vala"
	label = _tmp1_;
#line 57 "../src/Utils.vala"
	_tmp2_ = label;
#line 57 "../src/Utils.vala"
	if (_tmp2_ == NULL) {
#line 57 "../src/Utils.vala"
		_g_object_unref0 (label);
#line 57 "../src/Utils.vala"
		return;
#line 242 "Utils.c"
	}
#line 60 "../src/Utils.vala"
	_tmp3_ = label;
#line 60 "../src/Utils.vala"
	gtk_accel_label_set_accel (_tmp3_, key, mods);
#line 61 "../src/Utils.vala"
	_tmp4_ = label;
#line 61 "../src/Utils.vala"
	gtk_accel_label_refetch (_tmp4_);
#line 52 "../src/Utils.vala"
	_g_object_unref0 (label);
#line 254 "Utils.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 278 "Utils.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 286 "Utils.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 292 "Utils.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1395 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1395 "glib-2.0.vapi"
	end = _tmp0_;
#line 1396 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1396 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1397 "glib-2.0.vapi"
		result = maxlen;
#line 1397 "glib-2.0.vapi"
		return result;
#line 316 "Utils.c"
	} else {
		gchar* _tmp2_;
#line 1399 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1399 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1399 "glib-2.0.vapi"
		return result;
#line 325 "Utils.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1408 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 344 "Utils.c"
	} else {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 348 "Utils.c"
	}
#line 1408 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1410 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 354 "Utils.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1412 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1412 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1412 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 364 "Utils.c"
	}
#line 1415 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1416 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1417 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 372 "Utils.c"
	} else {
#line 1419 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 376 "Utils.c"
	}
#line 1421 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1422 "glib-2.0.vapi"
		len = string_length - offset;
#line 382 "Utils.c"
	}
#line 1424 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1425 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1425 "glib-2.0.vapi"
	result = _tmp3_;
#line 1425 "glib-2.0.vapi"
	return result;
#line 392 "Utils.c"
}

void
utils_match_string (const gchar* pattern,
                    const gchar* value,
                    const gchar* type,
                    Node* node,
                    Connection* conn,
                    GtkListStore* * matches)
{
	gint index = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
#line 69 "../src/Utils.vala"
	g_return_if_fail (pattern != NULL);
#line 69 "../src/Utils.vala"
	g_return_if_fail (value != NULL);
#line 69 "../src/Utils.vala"
	g_return_if_fail (type != NULL);
#line 69 "../src/Utils.vala"
	g_return_if_fail (*matches != NULL);
#line 70 "../src/Utils.vala"
	_tmp0_ = g_utf8_casefold (value, (gssize) -1);
#line 70 "../src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 70 "../src/Utils.vala"
	_tmp2_ = string_index_of (_tmp1_, pattern, 0);
#line 70 "../src/Utils.vala"
	_g_free0 (_tmp1_);
#line 70 "../src/Utils.vala"
	index = _tmp2_;
#line 71 "../src/Utils.vala"
	if (index != -1) {
#line 427 "Utils.c"
		GtkTreeIter it = {0};
		gint _tmp3_ = 0;
		gint start_index = 0;
		const gchar* _tmp4_ = NULL;
		gchar* prefix = NULL;
		gchar* _tmp5_;
		gchar* str = NULL;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		GtkTreeIter _tmp27_ = {0};
		GtkTreeIter _tmp28_;
		const gchar* _tmp29_;
#line 73 "../src/Utils.vala"
		if (index > 20) {
#line 73 "../src/Utils.vala"
			_tmp3_ = index - 20;
#line 463 "Utils.c"
		} else {
#line 73 "../src/Utils.vala"
			_tmp3_ = 0;
#line 467 "Utils.c"
		}
#line 73 "../src/Utils.vala"
		start_index = _tmp3_;
#line 74 "../src/Utils.vala"
		if (index > 20) {
#line 74 "../src/Utils.vala"
			_tmp4_ = "…";
#line 475 "Utils.c"
		} else {
#line 74 "../src/Utils.vala"
			_tmp4_ = "";
#line 479 "Utils.c"
		}
#line 74 "../src/Utils.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 74 "../src/Utils.vala"
		prefix = _tmp5_;
#line 75 "../src/Utils.vala"
		_tmp6_ = prefix;
#line 75 "../src/Utils.vala"
		_tmp7_ = string_substring (value, (glong) start_index, (glong) (index - start_index));
#line 75 "../src/Utils.vala"
		_tmp8_ = _tmp7_;
#line 75 "../src/Utils.vala"
		_tmp9_ = g_strconcat (_tmp6_, _tmp8_, NULL);
#line 75 "../src/Utils.vala"
		_tmp10_ = _tmp9_;
#line 75 "../src/Utils.vala"
		_tmp11_ = g_strconcat (_tmp10_, "<u>", NULL);
#line 75 "../src/Utils.vala"
		_tmp12_ = _tmp11_;
#line 75 "../src/Utils.vala"
		_tmp13_ = strlen (pattern);
#line 75 "../src/Utils.vala"
		_tmp14_ = _tmp13_;
#line 75 "../src/Utils.vala"
		_tmp15_ = string_substring (value, (glong) index, (glong) _tmp14_);
#line 75 "../src/Utils.vala"
		_tmp16_ = _tmp15_;
#line 75 "../src/Utils.vala"
		_tmp17_ = g_strconcat (_tmp12_, _tmp16_, NULL);
#line 75 "../src/Utils.vala"
		_tmp18_ = _tmp17_;
#line 75 "../src/Utils.vala"
		_tmp19_ = g_strconcat (_tmp18_, "</u>", NULL);
#line 75 "../src/Utils.vala"
		_tmp20_ = _tmp19_;
#line 75 "../src/Utils.vala"
		_tmp21_ = strlen (pattern);
#line 75 "../src/Utils.vala"
		_tmp22_ = _tmp21_;
#line 75 "../src/Utils.vala"
		_tmp23_ = string_substring (value, (glong) (index + _tmp22_), (glong) -1);
#line 75 "../src/Utils.vala"
		_tmp24_ = _tmp23_;
#line 75 "../src/Utils.vala"
		_tmp25_ = g_strconcat (_tmp20_, _tmp24_, NULL);
#line 75 "../src/Utils.vala"
		_tmp26_ = _tmp25_;
#line 75 "../src/Utils.vala"
		_g_free0 (_tmp24_);
#line 75 "../src/Utils.vala"
		_g_free0 (_tmp20_);
#line 75 "../src/Utils.vala"
		_g_free0 (_tmp18_);
#line 75 "../src/Utils.vala"
		_g_free0 (_tmp16_);
#line 75 "../src/Utils.vala"
		_g_free0 (_tmp12_);
#line 75 "../src/Utils.vala"
		_g_free0 (_tmp10_);
#line 75 "../src/Utils.vala"
		_g_free0 (_tmp8_);
#line 75 "../src/Utils.vala"
		str = _tmp26_;
#line 79 "../src/Utils.vala"
		gtk_list_store_append (*matches, &_tmp27_);
#line 79 "../src/Utils.vala"
		it = _tmp27_;
#line 80 "../src/Utils.vala"
		_tmp28_ = it;
#line 80 "../src/Utils.vala"
		_tmp29_ = str;
#line 80 "../src/Utils.vala"
		gtk_list_store_set (*matches, &_tmp28_, 0, type, 1, _tmp29_, 2, node, 3, conn, -1, -1);
#line 71 "../src/Utils.vala"
		_g_free0 (str);
#line 71 "../src/Utils.vala"
		_g_free0 (prefix);
#line 557 "Utils.c"
	}
}

gboolean
utils_is_within_bounds (gdouble x,
                        gdouble y,
                        gdouble bx,
                        gdouble by,
                        gdouble bw,
                        gdouble bh)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 86 "../src/Utils.vala"
	if (bx < x) {
#line 86 "../src/Utils.vala"
		_tmp2_ = x < (bx + bw);
#line 577 "Utils.c"
	} else {
#line 86 "../src/Utils.vala"
		_tmp2_ = FALSE;
#line 581 "Utils.c"
	}
#line 86 "../src/Utils.vala"
	if (_tmp2_) {
#line 86 "../src/Utils.vala"
		_tmp1_ = by < y;
#line 587 "Utils.c"
	} else {
#line 86 "../src/Utils.vala"
		_tmp1_ = FALSE;
#line 591 "Utils.c"
	}
#line 86 "../src/Utils.vala"
	if (_tmp1_) {
#line 86 "../src/Utils.vala"
		_tmp0_ = y < (by + bh);
#line 597 "Utils.c"
	} else {
#line 86 "../src/Utils.vala"
		_tmp0_ = FALSE;
#line 601 "Utils.c"
	}
#line 86 "../src/Utils.vala"
	result = _tmp0_;
#line 86 "../src/Utils.vala"
	return result;
#line 607 "Utils.c"
}

gchar*
utils_make_title (const gchar* str)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 90 "../src/Utils.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 91 "../src/Utils.vala"
	_tmp0_ = g_strconcat ("<b>", str, NULL);
#line 91 "../src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 91 "../src/Utils.vala"
	_tmp2_ = g_strconcat (_tmp1_, "</b>", NULL);
#line 91 "../src/Utils.vala"
	_tmp3_ = _tmp2_;
#line 91 "../src/Utils.vala"
	_g_free0 (_tmp1_);
#line 91 "../src/Utils.vala"
	result = _tmp3_;
#line 91 "../src/Utils.vala"
	return result;
#line 634 "Utils.c"
}

gchar*
utils_tooltip_with_accel (const gchar* tooltip,
                          const gchar* accel)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 95 "../src/Utils.vala"
	g_return_val_if_fail (tooltip != NULL, NULL);
#line 95 "../src/Utils.vala"
	g_return_val_if_fail (accel != NULL, NULL);
#line 96 "../src/Utils.vala"
	_tmp0_ = g_strdup_printf ("%s   <i>(%s)</i>", tooltip, accel);
#line 96 "../src/Utils.vala"
	result = _tmp0_;
#line 96 "../src/Utils.vala"
	return result;
#line 653 "Utils.c"
}

Utils*
utils_construct (GType object_type)
{
	Utils* self = NULL;
#line 26 "../src/Utils.vala"
	self = (Utils*) g_type_create_instance (object_type);
#line 26 "../src/Utils.vala"
	return self;
#line 664 "Utils.c"
}

Utils*
utils_new (void)
{
#line 26 "../src/Utils.vala"
	return utils_construct (TYPE_UTILS);
#line 672 "Utils.c"
}

static void
value_utils_init (GValue* value)
{
#line 26 "../src/Utils.vala"
	value->data[0].v_pointer = NULL;
#line 680 "Utils.c"
}

static void
value_utils_free_value (GValue* value)
{
#line 26 "../src/Utils.vala"
	if (value->data[0].v_pointer) {
#line 26 "../src/Utils.vala"
		utils_unref (value->data[0].v_pointer);
#line 690 "Utils.c"
	}
}

static void
value_utils_copy_value (const GValue* src_value,
                        GValue* dest_value)
{
#line 26 "../src/Utils.vala"
	if (src_value->data[0].v_pointer) {
#line 26 "../src/Utils.vala"
		dest_value->data[0].v_pointer = utils_ref (src_value->data[0].v_pointer);
#line 702 "Utils.c"
	} else {
#line 26 "../src/Utils.vala"
		dest_value->data[0].v_pointer = NULL;
#line 706 "Utils.c"
	}
}

static gpointer
value_utils_peek_pointer (const GValue* value)
{
#line 26 "../src/Utils.vala"
	return value->data[0].v_pointer;
#line 715 "Utils.c"
}

static gchar*
value_utils_collect_value (GValue* value,
                           guint n_collect_values,
                           GTypeCValue* collect_values,
                           guint collect_flags)
{
#line 26 "../src/Utils.vala"
	if (collect_values[0].v_pointer) {
#line 726 "Utils.c"
		Utils * object;
		object = collect_values[0].v_pointer;
#line 26 "../src/Utils.vala"
		if (object->parent_instance.g_class == NULL) {
#line 26 "../src/Utils.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 733 "Utils.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 26 "../src/Utils.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 737 "Utils.c"
		}
#line 26 "../src/Utils.vala"
		value->data[0].v_pointer = utils_ref (object);
#line 741 "Utils.c"
	} else {
#line 26 "../src/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 745 "Utils.c"
	}
#line 26 "../src/Utils.vala"
	return NULL;
#line 749 "Utils.c"
}

static gchar*
value_utils_lcopy_value (const GValue* value,
                         guint n_collect_values,
                         GTypeCValue* collect_values,
                         guint collect_flags)
{
	Utils ** object_p;
	object_p = collect_values[0].v_pointer;
#line 26 "../src/Utils.vala"
	if (!object_p) {
#line 26 "../src/Utils.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 764 "Utils.c"
	}
#line 26 "../src/Utils.vala"
	if (!value->data[0].v_pointer) {
#line 26 "../src/Utils.vala"
		*object_p = NULL;
#line 770 "Utils.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 26 "../src/Utils.vala"
		*object_p = value->data[0].v_pointer;
#line 774 "Utils.c"
	} else {
#line 26 "../src/Utils.vala"
		*object_p = utils_ref (value->data[0].v_pointer);
#line 778 "Utils.c"
	}
#line 26 "../src/Utils.vala"
	return NULL;
#line 782 "Utils.c"
}

GParamSpec*
param_spec_utils (const gchar* name,
                  const gchar* nick,
                  const gchar* blurb,
                  GType object_type,
                  GParamFlags flags)
{
	ParamSpecUtils* spec;
#line 26 "../src/Utils.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_UTILS), NULL);
#line 26 "../src/Utils.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 26 "../src/Utils.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 26 "../src/Utils.vala"
	return G_PARAM_SPEC (spec);
#line 801 "Utils.c"
}

gpointer
value_get_utils (const GValue* value)
{
#line 26 "../src/Utils.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UTILS), NULL);
#line 26 "../src/Utils.vala"
	return value->data[0].v_pointer;
#line 811 "Utils.c"
}

void
value_set_utils (GValue* value,
                 gpointer v_object)
{
	Utils * old;
#line 26 "../src/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UTILS));
#line 26 "../src/Utils.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/Utils.vala"
	if (v_object) {
#line 26 "../src/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UTILS));
#line 26 "../src/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 26 "../src/Utils.vala"
		utils_ref (value->data[0].v_pointer);
#line 833 "Utils.c"
	} else {
#line 26 "../src/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 837 "Utils.c"
	}
#line 26 "../src/Utils.vala"
	if (old) {
#line 26 "../src/Utils.vala"
		utils_unref (old);
#line 843 "Utils.c"
	}
}

void
value_take_utils (GValue* value,
                  gpointer v_object)
{
	Utils * old;
#line 26 "../src/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_UTILS));
#line 26 "../src/Utils.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/Utils.vala"
	if (v_object) {
#line 26 "../src/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_UTILS));
#line 26 "../src/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 864 "Utils.c"
	} else {
#line 26 "../src/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 868 "Utils.c"
	}
#line 26 "../src/Utils.vala"
	if (old) {
#line 26 "../src/Utils.vala"
		utils_unref (old);
#line 874 "Utils.c"
	}
}

static void
utils_class_init (UtilsClass * klass,
                  gpointer klass_data)
{
#line 26 "../src/Utils.vala"
	utils_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/Utils.vala"
	((UtilsClass *) klass)->finalize = utils_finalize;
#line 886 "Utils.c"
}

static void
utils_instance_init (Utils * self,
                     gpointer klass)
{
#line 26 "../src/Utils.vala"
	self->ref_count = 1;
#line 895 "Utils.c"
}

static void
utils_finalize (Utils * obj)
{
	Utils * self;
#line 26 "../src/Utils.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UTILS, Utils);
#line 26 "../src/Utils.vala"
	g_signal_handlers_destroy (self);
#line 906 "Utils.c"
}

GType
utils_get_type (void)
{
	static volatile gsize utils_type_id__volatile = 0;
	if (g_once_init_enter (&utils_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_utils_init, value_utils_free_value, value_utils_copy_value, value_utils_peek_pointer, "p", value_utils_collect_value, "p", value_utils_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (UtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Utils), 0, (GInstanceInitFunc) utils_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType utils_type_id;
		utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Utils", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&utils_type_id__volatile, utils_type_id);
	}
	return utils_type_id__volatile;
}

gpointer
utils_ref (gpointer instance)
{
	Utils * self;
	self = instance;
#line 26 "../src/Utils.vala"
	g_atomic_int_inc (&self->ref_count);
#line 26 "../src/Utils.vala"
	return instance;
#line 933 "Utils.c"
}

void
utils_unref (gpointer instance)
{
	Utils * self;
	self = instance;
#line 26 "../src/Utils.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 26 "../src/Utils.vala"
		UTILS_GET_CLASS (self)->finalize (self);
#line 26 "../src/Utils.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 947 "Utils.c"
	}
}

