/* DynamicNotebook.c generated by valac 0.45.91, the Vala compiler
 * generated from DynamicNotebook.vala, do not modify */

/*
 *  Copyright (C) 2011-2013 Tom Beckmann <tom@elementaryos.org>
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */
/* a mask to ignore modifiers like num lock or caps lock that are irrelevant to keyboard shortcuts*/

#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <cairo.h>
#include <float.h>
#include <math.h>

#define TYPE_TAB_PAGE_CONTAINER (tab_page_container_get_type ())
#define TAB_PAGE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAB_PAGE_CONTAINER, TabPageContainer))
#define TAB_PAGE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAB_PAGE_CONTAINER, TabPageContainerClass))
#define IS_TAB_PAGE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAB_PAGE_CONTAINER))
#define IS_TAB_PAGE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAB_PAGE_CONTAINER))
#define TAB_PAGE_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAB_PAGE_CONTAINER, TabPageContainerClass))

typedef struct _TabPageContainer TabPageContainer;
typedef struct _TabPageContainerClass TabPageContainerClass;
typedef struct _TabPageContainerPrivate TabPageContainerPrivate;

#define TYPE_TAB (tab_get_type ())
#define TAB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAB, Tab))
#define TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAB, TabClass))
#define IS_TAB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAB))
#define IS_TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAB))
#define TAB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAB, TabClass))

typedef struct _Tab Tab;
typedef struct _TabClass TabClass;
enum  {
	TAB_PAGE_CONTAINER_0_PROPERTY,
	TAB_PAGE_CONTAINER_TAB_PROPERTY,
	TAB_PAGE_CONTAINER_NUM_PROPERTIES
};
static GParamSpec* tab_page_container_properties[TAB_PAGE_CONTAINER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _TabPrivate TabPrivate;
enum  {
	TAB_0_PROPERTY,
	TAB_LABEL_PROPERTY,
	TAB_TOOLTIP_PROPERTY,
	TAB_PINNED_PROPERTY,
	TAB_PINNABLE_PROPERTY,
	TAB_RESTORE_DATA_PROPERTY,
	TAB_PAGE_PROPERTY,
	TAB_ICON_PROPERTY,
	TAB_WORKING_PROPERTY,
	TAB_ELLIPSIZE_MODE_PROPERTY,
	TAB_FIXED_PROPERTY,
	TAB_MENU_PROPERTY,
	TAB_CLOSABLE_PROPERTY,
	TAB_IS_CURRENT_TAB_PROPERTY,
	TAB_NUM_PROPERTIES
};
static GParamSpec* tab_properties[TAB_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block7Data Block7Data;
enum  {
	TAB_CLOSED_SIGNAL,
	TAB_CLOSE_OTHERS_SIGNAL,
	TAB_NEW_WINDOW_SIGNAL,
	TAB_DUPLICATE_SIGNAL,
	TAB_PIN_SWITCH_SIGNAL,
	TAB_NUM_SIGNALS
};
static guint tab_signals[TAB_NUM_SIGNALS] = {0};

#define TYPE_CLOSED_TABS (closed_tabs_get_type ())
#define CLOSED_TABS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLOSED_TABS, ClosedTabs))
#define CLOSED_TABS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLOSED_TABS, ClosedTabsClass))
#define IS_CLOSED_TABS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLOSED_TABS))
#define IS_CLOSED_TABS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLOSED_TABS))
#define CLOSED_TABS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLOSED_TABS, ClosedTabsClass))

typedef struct _ClosedTabs ClosedTabs;
typedef struct _ClosedTabsClass ClosedTabsClass;
typedef struct _ClosedTabsPrivate ClosedTabsPrivate;

#define CLOSED_TABS_TYPE_ENTRY (closed_tabs_entry_get_type ())
typedef struct _ClosedTabsEntry ClosedTabsEntry;
enum  {
	CLOSED_TABS_0_PROPERTY,
	CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY,
	CLOSED_TABS_EMPTY_PROPERTY,
	CLOSED_TABS_MENU_PROPERTY,
	CLOSED_TABS_NUM_PROPERTIES
};
static GParamSpec* closed_tabs_properties[CLOSED_TABS_NUM_PROPERTIES];
#define _closed_tabs_entry_free0(var) ((var == NULL) ? NULL : (var = (closed_tabs_entry_free (var), NULL)))
typedef struct _Block8Data Block8Data;
enum  {
	CLOSED_TABS_RESTORED_SIGNAL,
	CLOSED_TABS_CLEARED_SIGNAL,
	CLOSED_TABS_NUM_SIGNALS
};
static guint closed_tabs_signals[CLOSED_TABS_NUM_SIGNALS] = {0};

#define TYPE_DYNAMIC_NOTEBOOK (dynamic_notebook_get_type ())
#define DYNAMIC_NOTEBOOK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook))
#define DYNAMIC_NOTEBOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DYNAMIC_NOTEBOOK, DynamicNotebookClass))
#define IS_DYNAMIC_NOTEBOOK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DYNAMIC_NOTEBOOK))
#define IS_DYNAMIC_NOTEBOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DYNAMIC_NOTEBOOK))
#define DYNAMIC_NOTEBOOK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DYNAMIC_NOTEBOOK, DynamicNotebookClass))

typedef struct _DynamicNotebook DynamicNotebook;
typedef struct _DynamicNotebookClass DynamicNotebookClass;
typedef struct _DynamicNotebookPrivate DynamicNotebookPrivate;
typedef enum  {
	DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS = 0,
	DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_SINGLE = 1,
	DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_NEVER = 2
} DynamicNotebookTabBarBehavior;

#define DYNAMIC_NOTEBOOK_TYPE_TAB_BAR_BEHAVIOR (dynamic_notebook_tab_bar_behavior_get_type ())
enum  {
	DYNAMIC_NOTEBOOK_0_PROPERTY,
	DYNAMIC_NOTEBOOK_N_TABS_PROPERTY,
	DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY,
	DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY,
	DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY,
	DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY,
	DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY,
	DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY,
	DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY,
	DYNAMIC_NOTEBOOK_CURRENT_PROPERTY,
	DYNAMIC_NOTEBOOK_TABS_PROPERTY,
	DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY,
	DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY,
	DYNAMIC_NOTEBOOK_MENU_PROPERTY,
	DYNAMIC_NOTEBOOK_NUM_PROPERTIES
};
static GParamSpec* dynamic_notebook_properties[DYNAMIC_NOTEBOOK_NUM_PROPERTIES];
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
enum  {
	DYNAMIC_NOTEBOOK_TAB_ADDED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_REMOVED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_SWITCHED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_REORDERED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_MOVED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_DUPLICATED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_RESTORED_SIGNAL,
	DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL,
	DYNAMIC_NOTEBOOK_CLOSE_TAB_REQUESTED_SIGNAL,
	DYNAMIC_NOTEBOOK_NUM_SIGNALS
};
static guint dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TabPageContainer {
	GtkEventBox parent_instance;
	TabPageContainerPrivate * priv;
};

struct _TabPageContainerClass {
	GtkEventBoxClass parent_class;
};

struct _TabPageContainerPrivate {
	Tab* _tab;
};

struct _Tab {
	GtkEventBox parent_instance;
	TabPrivate * priv;
	GraniteWidgetsDroppedDelegate dropped_callback;
	gpointer dropped_callback_target;
	GDestroyNotify dropped_callback_target_destroy_notify;
	TabPageContainer* page_container;
	GtkImage* _icon;
	GtkMenuItem* new_window_m;
	GtkMenuItem* duplicate_m;
	GtkMenuItem* pin_m;
};

struct _TabClass {
	GtkEventBoxClass parent_class;
};

struct _TabPrivate {
	GtkLabel* _label;
	gboolean _pinned;
	gboolean _pinnable;
	gchar* _restore_data;
	GtkSpinner* _working;
	gboolean __working;
	gboolean _fixed;
	GtkMenu* _menu;
	gboolean _closable;
	gboolean _is_current_tab;
	gboolean cursor_over_tab;
	gboolean cursor_over_close_button;
	GtkRevealer* close_button_revealer;
};

struct _Block7Data {
	int _ref_count_;
	Tab* self;
	GtkMenuItem* close_other_m;
};

struct _ClosedTabs {
	GObject parent_instance;
	ClosedTabsPrivate * priv;
};

struct _ClosedTabsClass {
	GObjectClass parent_class;
};

struct _ClosedTabsEntry {
	gchar* label;
	gchar* restore_data;
	GIcon* icon;
	GraniteWidgetsDroppedDelegate dropped_callback;
	gpointer dropped_callback_target;
};

struct _ClosedTabsPrivate {
	gint _max_restorable_tabs;
	GeeLinkedList* closed_tabs;
};

struct _Block8Data {
	int _ref_count_;
	ClosedTabs* self;
	ClosedTabsEntry* entry;
};

struct _DynamicNotebook {
	GtkEventBox parent_instance;
	DynamicNotebookPrivate * priv;
};

struct _DynamicNotebookClass {
	GtkEventBoxClass parent_class;
};

struct _DynamicNotebookPrivate {
	gboolean _show_icons;
	gboolean _tabs_closable;
	gboolean _allow_drag;
	gboolean _allow_new_window;
	gboolean _allow_duplication;
	gboolean _allow_restoring;
	gboolean _add_button_visible;
	gboolean _allow_pinning;
	gboolean _force_left;
	gchar* _add_button_tooltip;
	GList* _tabs;
	DynamicNotebookTabBarBehavior _tab_bar_behavior;
	GtkMenu* _menu;
	ClosedTabs* closed_tabs;
	GtkNotebook* notebook;
	gint tab_width;
	Tab* old_tab;
	GtkMenuItem* new_tab_m;
	GtkMenuItem* restore_tab_m;
	GtkButton* add_button;
	GtkButton* restore_button;
};

struct _Block9Data {
	int _ref_count_;
	DynamicNotebook* self;
	gboolean value;
};

struct _Block10Data {
	int _ref_count_;
	DynamicNotebook* self;
	gboolean value;
};

struct _Block11Data {
	int _ref_count_;
	DynamicNotebook* self;
	gboolean value;
};

static gint TabPageContainer_private_offset;
static gpointer tab_page_container_parent_class = NULL;
static gint Tab_private_offset;
static gpointer tab_parent_class = NULL;
static gint ClosedTabs_private_offset;
static gpointer closed_tabs_parent_class = NULL;
static gint DynamicNotebook_private_offset;
static gpointer dynamic_notebook_parent_class = NULL;

#define MODIFIER_MASK (((GDK_SHIFT_MASK | GDK_SUPER_MASK) | GDK_CONTROL_MASK) | GDK_MOD1_MASK)
GType tab_page_container_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TabPageContainer, g_object_unref)
GType tab_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tab, g_object_unref)
TabPageContainer* tab_page_container_new (Tab* tab);
TabPageContainer* tab_page_container_construct (GType object_type,
                                                Tab* tab);
Tab* tab_page_container_get_tab (TabPageContainer* self);
void tab_page_container_set_tab (TabPageContainer* self,
                                 Tab* value);
static GObject * tab_page_container_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void tab_page_container_finalize (GObject * obj);
static void _vala_tab_page_container_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_tab_page_container_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
Tab* tab_new (const gchar* label,
              GIcon* icon,
              GtkWidget* page);
Tab* tab_construct (GType object_type,
                    const gchar* label,
                    GIcon* icon,
                    GtkWidget* page);
void tab_set_page (Tab* self,
                   GtkWidget* value);
void tab_close (Tab* self);
static void tab_update_close_button_visibility (Tab* self);
static gboolean tab_close_button_is_visible (Tab* self);
const gchar* tab_get_label (Tab* self);
void tab_set_label (Tab* self,
                    const gchar* value);
gchar* tab_get_tooltip (Tab* self);
void tab_set_tooltip (Tab* self,
                      const gchar* value);
gboolean tab_get_pinned (Tab* self);
void tab_set_pinned (Tab* self,
                     gboolean value);
gboolean tab_get_pinnable (Tab* self);
void tab_set_pinnable (Tab* self,
                       gboolean value);
const gchar* tab_get_restore_data (Tab* self);
void tab_set_restore_data (Tab* self,
                           const gchar* value);
GtkWidget* tab_get_page (Tab* self);
GIcon* tab_get_icon (Tab* self);
void tab_set_icon (Tab* self,
                   GIcon* value);
gboolean tab_get_working (Tab* self);
void tab_set_working (Tab* self,
                      gboolean value);
PangoEllipsizeMode tab_get_ellipsize_mode (Tab* self);
void tab_set_ellipsize_mode (Tab* self,
                             PangoEllipsizeMode value);
gboolean tab_get_fixed (Tab* self) G_GNUC_DEPRECATED;
void tab_set_fixed (Tab* self,
                    gboolean value) G_GNUC_DEPRECATED;
GtkMenu* tab_get_menu (Tab* self);
void tab_set_menu (Tab* self,
                   GtkMenu* value);
void tab_set_closable (Tab* self,
                       gboolean value);
void tab_set_is_current_tab (Tab* self,
                             gboolean value);
static GObject * tab_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _tab___lambda4_ (Tab* self);
static void __tab___lambda4__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void _tab___lambda5_ (Tab* self);
static void __tab___lambda5__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void _tab___lambda6_ (Tab* self);
static void __tab___lambda6__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void _tab___lambda7_ (Tab* self);
static void __tab___lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void _tab___lambda8_ (Tab* self);
static void __tab___lambda8__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static gboolean _tab___lambda9_ (Tab* self,
                          GdkEventScroll* e);
static gboolean __tab___lambda9__gtk_widget_scroll_event (GtkWidget* _sender,
                                                   GdkEventScroll* event,
                                                   gpointer self);
static gboolean _tab___lambda10_ (Block7Data* _data7_,
                           GdkEventButton* e);
static gboolean __tab___lambda10__gtk_widget_button_press_event (GtkWidget* _sender,
                                                          GdkEventButton* event,
                                                          gpointer self);
static gboolean _tab___lambda11_ (Tab* self,
                           GdkEventCrossing* e);
static gboolean __tab___lambda11__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                          GdkEventCrossing* event,
                                                          gpointer self);
static gboolean _tab___lambda12_ (Tab* self,
                           GdkEventCrossing* e);
static gboolean __tab___lambda12__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                          GdkEventCrossing* event,
                                                          gpointer self);
static gboolean _tab___lambda13_ (Tab* self,
                           GdkEventCrossing* e);
static gboolean __tab___lambda13__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                          GdkEventCrossing* event,
                                                          gpointer self);
static gboolean _tab___lambda14_ (Tab* self,
                           GdkEventCrossing* e);
static gboolean __tab___lambda14__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                          GdkEventCrossing* event,
                                                          gpointer self);
static gboolean _tab___lambda15_ (Tab* self);
static gboolean __tab___lambda15__gtk_widget_button_press_event (GtkWidget* _sender,
                                                          GdkEventButton* event,
                                                          gpointer self);
static void _tab___lambda16_ (Tab* self);
static void __tab___lambda16__gtk_button_clicked (GtkButton* _sender,
                                           gpointer self);
static void tab_finalize (GObject * obj);
static void _vala_tab_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec);
static void _vala_tab_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec);
GType closed_tabs_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ClosedTabs, g_object_unref)
GType closed_tabs_entry_get_type (void) G_GNUC_CONST;
ClosedTabsEntry* closed_tabs_entry_dup (const ClosedTabsEntry* self);
void closed_tabs_entry_free (ClosedTabsEntry* self);
void closed_tabs_entry_copy (const ClosedTabsEntry* self,
                             ClosedTabsEntry* dest);
void closed_tabs_entry_destroy (ClosedTabsEntry* self);
ClosedTabs* closed_tabs_new (void);
ClosedTabs* closed_tabs_construct (GType object_type);
void closed_tabs_push (ClosedTabs* self,
                       Tab* tab);
gint closed_tabs_get_max_restorable_tabs (ClosedTabs* self);
void closed_tabs_pop (ClosedTabs* self,
                      ClosedTabsEntry* result);
void closed_tabs_pick (ClosedTabs* self,
                       const gchar* search,
                       ClosedTabsEntry* result);
void closed_tabs_set_max_restorable_tabs (ClosedTabs* self,
                                          gint value);
gboolean closed_tabs_get_empty (ClosedTabs* self);
GtkMenu* closed_tabs_get_menu (ClosedTabs* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void _closed_tabs_menu_____lambda17_ (Block8Data* _data8_);
static void __closed_tabs_menu_____lambda17__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self);
static void _closed_tabs_menu____lambda18_ (ClosedTabs* self);
static void __closed_tabs_menu____lambda18__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self);
static void g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static GObject * closed_tabs_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void closed_tabs_finalize (GObject * obj);
static void _vala_closed_tabs_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_closed_tabs_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
GType dynamic_notebook_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DynamicNotebook, g_object_unref)
GType dynamic_notebook_tab_bar_behavior_get_type (void) G_GNUC_CONST;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
#define DYNAMIC_NOTEBOOK_MAX_TAB_WIDTH 174
#define DYNAMIC_NOTEBOOK_TAB_WIDTH_PINNED 18
#define DYNAMIC_NOTEBOOK_ADD_BUTTON_PADDING 5
DynamicNotebook* dynamic_notebook_new (void);
DynamicNotebook* dynamic_notebook_construct (GType object_type);
static void dynamic_notebook_on_switch_page (DynamicNotebook* self,
                                      GtkWidget* page,
                                      guint pagenum);
static void dynamic_notebook_on_page_added (DynamicNotebook* self,
                                     GtkWidget* page,
                                     guint pagenum);
static void dynamic_notebook_insert_callbacks (DynamicNotebook* self,
                                        Tab* tab);
static void dynamic_notebook_update_tabs_visibility (DynamicNotebook* self);
static void dynamic_notebook_on_page_removed (DynamicNotebook* self,
                                       GtkWidget* page,
                                       guint pagenum);
static void dynamic_notebook_remove_callbacks (DynamicNotebook* self,
                                        Tab* tab);
static void dynamic_notebook_on_page_reordered (DynamicNotebook* self,
                                         GtkWidget* page,
                                         guint pagenum);
static void dynamic_notebook_recalc_order (DynamicNotebook* self);
static GtkNotebook* dynamic_notebook_on_create_window (DynamicNotebook* self,
                                                GtkWidget* page,
                                                gint x,
                                                gint y);
gint dynamic_notebook_get_n_tabs (DynamicNotebook* self);
gboolean dynamic_notebook_get_force_left (DynamicNotebook* self);
static void dynamic_notebook_recalc_size (DynamicNotebook* self);
static void dynamic_notebook_restore_last_tab (DynamicNotebook* self);
gboolean dynamic_notebook_get_allow_restoring (DynamicNotebook* self);
static void dynamic_notebook_switch_pin_tab (DynamicNotebook* self,
                                      Tab* tab);
gboolean dynamic_notebook_get_allow_pinning (DynamicNotebook* self);
void dynamic_notebook_remove_tab (DynamicNotebook* self,
                                  Tab* tab);
gint dynamic_notebook_get_tab_position (DynamicNotebook* self,
                                        Tab* tab);
void dynamic_notebook_next_page (DynamicNotebook* self);
void dynamic_notebook_previous_page (DynamicNotebook* self);
static void dynamic_notebook_real_show (GtkWidget* base);
GList* dynamic_notebook_get_children (DynamicNotebook* self);
void dynamic_notebook_set_tab_position (DynamicNotebook* self,
                                        Tab* tab,
                                        gint position);
Tab* dynamic_notebook_get_tab_by_index (DynamicNotebook* self,
                                        gint index);
Tab* dynamic_notebook_get_tab_by_widget (DynamicNotebook* self,
                                         GtkWidget* widget);
GtkWidget* dynamic_notebook_get_nth_page (DynamicNotebook* self,
                                          gint index);
guint dynamic_notebook_insert_tab (DynamicNotebook* self,
                                   Tab* tab,
                                   gint index);
GList* dynamic_notebook_get_tabs (DynamicNotebook* self);
gboolean dynamic_notebook_get_allow_drag (DynamicNotebook* self);
gboolean dynamic_notebook_get_allow_new_window (DynamicNotebook* self);
gboolean dynamic_notebook_get_allow_duplication (DynamicNotebook* self);
gboolean dynamic_notebook_get_tabs_closable (DynamicNotebook* self);
static void dynamic_notebook_on_tab_closed (DynamicNotebook* self,
                                     Tab* tab);
static void _dynamic_notebook_on_tab_closed_tab_closed (Tab* _sender,
                                                 gpointer self);
static void dynamic_notebook_on_close_others (DynamicNotebook* self,
                                       Tab* tab);
static void _dynamic_notebook_on_close_others_tab_close_others (Tab* _sender,
                                                         gpointer self);
static void dynamic_notebook_on_new_window (DynamicNotebook* self,
                                     Tab* tab);
static void _dynamic_notebook_on_new_window_tab_new_window (Tab* _sender,
                                                     gpointer self);
static void dynamic_notebook_on_duplicate (DynamicNotebook* self,
                                    Tab* tab);
static void _dynamic_notebook_on_duplicate_tab_duplicate (Tab* _sender,
                                                   gpointer self);
static void dynamic_notebook_on_pin_switch (DynamicNotebook* self,
                                     Tab* tab);
static void _dynamic_notebook_on_pin_switch_tab_pin_switch (Tab* _sender,
                                                     gpointer self);
gboolean dynamic_notebook_get_show_tabs (DynamicNotebook* self);
void dynamic_notebook_set_show_tabs (DynamicNotebook* self,
                                     gboolean value);
gboolean dynamic_notebook_get_show_icons (DynamicNotebook* self) G_GNUC_DEPRECATED;
void dynamic_notebook_set_show_icons (DynamicNotebook* self,
                                      gboolean value) G_GNUC_DEPRECATED;
void dynamic_notebook_set_tabs_closable (DynamicNotebook* self,
                                         gboolean value);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void _dynamic_notebook_tabs_closable____lambda21_ (Block9Data* _data9_,
                                                   Tab* t);
static void __dynamic_notebook_tabs_closable____lambda21__gfunc (gconstpointer data,
                                                          gpointer self);
void dynamic_notebook_set_allow_drag (DynamicNotebook* self,
                                      gboolean value);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void _dynamic_notebook_allow_drag___lambda19_ (Block10Data* _data10_,
                                               Tab* t);
static void __dynamic_notebook_allow_drag___lambda19__gfunc (gconstpointer data,
                                                      gpointer self);
void dynamic_notebook_set_allow_new_window (DynamicNotebook* self,
                                            gboolean value);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void _dynamic_notebook_allow_new_window___lambda20_ (Block11Data* _data11_,
                                                     Tab* t);
static void __dynamic_notebook_allow_new_window___lambda20__gfunc (gconstpointer data,
                                                            gpointer self);
void dynamic_notebook_set_allow_duplication (DynamicNotebook* self,
                                             gboolean value);
void dynamic_notebook_set_allow_restoring (DynamicNotebook* self,
                                           gboolean value);
gint dynamic_notebook_get_max_restorable_tabs (DynamicNotebook* self);
void dynamic_notebook_set_max_restorable_tabs (DynamicNotebook* self,
                                               gint value);
gboolean dynamic_notebook_get_add_button_visible (DynamicNotebook* self);
void dynamic_notebook_set_add_button_visible (DynamicNotebook* self,
                                              gboolean value);
void dynamic_notebook_set_allow_pinning (DynamicNotebook* self,
                                         gboolean value);
void dynamic_notebook_set_force_left (DynamicNotebook* self,
                                      gboolean value);
const gchar* dynamic_notebook_get_add_button_tooltip (DynamicNotebook* self);
void dynamic_notebook_set_add_button_tooltip (DynamicNotebook* self,
                                              const gchar* value);
Tab* dynamic_notebook_get_current (DynamicNotebook* self);
void dynamic_notebook_set_current (DynamicNotebook* self,
                                   Tab* value);
const gchar* dynamic_notebook_get_group_name (DynamicNotebook* self);
void dynamic_notebook_set_group_name (DynamicNotebook* self,
                                      const gchar* value);
DynamicNotebookTabBarBehavior dynamic_notebook_get_tab_bar_behavior (DynamicNotebook* self);
void dynamic_notebook_set_tab_bar_behavior (DynamicNotebook* self,
                                            DynamicNotebookTabBarBehavior value);
GtkMenu* dynamic_notebook_get_menu (DynamicNotebook* self);
static void dynamic_notebook_set_menu (DynamicNotebook* self,
                                GtkMenu* value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_INT_INT (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static GObject * dynamic_notebook_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static gboolean _dynamic_notebook___lambda22_ (DynamicNotebook* self,
                                        cairo_t* ctx);
static gboolean __dynamic_notebook___lambda22__gtk_widget_draw (GtkWidget* _sender,
                                                         cairo_t* cr,
                                                         gpointer self);
static void _dynamic_notebook___lambda23_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda23__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                            gpointer self);
static void _dynamic_notebook___lambda24_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda24__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                            gpointer self);
static void _dynamic_notebook___lambda25_ (DynamicNotebook* self,
                                    const gchar* label,
                                    const gchar* restore_data,
                                    GIcon* icon);
static void __dynamic_notebook___lambda25__closed_tabs_restored (ClosedTabs* _sender,
                                                          const gchar* label,
                                                          const gchar* restore_data,
                                                          GIcon* icon,
                                                          gpointer self);
static void _dynamic_notebook___lambda26_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda26__closed_tabs_cleared (ClosedTabs* _sender,
                                                         gpointer self);
static void _dynamic_notebook___lambda27_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static gboolean _dynamic_notebook___lambda28_ (DynamicNotebook* self,
                                        GdkEventButton* e);
static gboolean __dynamic_notebook___lambda28__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                       GdkEventButton* event,
                                                                       gpointer self);
static void _dynamic_notebook___lambda29_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _dynamic_notebook___lambda30_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda30__gtk_widget_size_allocate (GtkWidget* _sender,
                                                              GtkAllocation* allocation,
                                                              gpointer self);
static gboolean _dynamic_notebook___lambda31_ (DynamicNotebook* self,
                                        GdkEventButton* e);
static gboolean __dynamic_notebook___lambda31__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                       GdkEventButton* event,
                                                                       gpointer self);
static gboolean _dynamic_notebook___lambda32_ (DynamicNotebook* self,
                                        GdkEventKey* e);
static gboolean __dynamic_notebook___lambda32__gtk_widget_key_press_event (GtkWidget* _sender,
                                                                    GdkEventKey* event,
                                                                    gpointer self);
static void _dynamic_notebook___lambda33_ (DynamicNotebook* self);
static void _dynamic_notebook_on_switch_page_gtk_notebook_switch_page (GtkNotebook* _sender,
                                                                GtkWidget* page,
                                                                guint page_num,
                                                                gpointer self);
static void _dynamic_notebook_on_page_added_gtk_notebook_page_added (GtkNotebook* _sender,
                                                              GtkWidget* child,
                                                              guint page_num,
                                                              gpointer self);
static void _dynamic_notebook_on_page_removed_gtk_notebook_page_removed (GtkNotebook* _sender,
                                                                  GtkWidget* child,
                                                                  guint page_num,
                                                                  gpointer self);
static void _dynamic_notebook_on_page_reordered_gtk_notebook_page_reordered (GtkNotebook* _sender,
                                                                      GtkWidget* child,
                                                                      guint page_num,
                                                                      gpointer self);
static GtkNotebook* _dynamic_notebook_on_create_window_gtk_notebook_create_window (GtkNotebook* _sender,
                                                                            GtkWidget* page,
                                                                            gint x,
                                                                            gint y,
                                                                            gpointer self);
static void __dynamic_notebook___lambda33__gtk_widget_destroy (GtkWidget* _sender,
                                                        gpointer self);
static void dynamic_notebook_finalize (GObject * obj);
static void _vala_dynamic_notebook_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_dynamic_notebook_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
tab_page_container_get_instance_private (TabPageContainer* self)
{
	return G_STRUCT_MEMBER_P (self, TabPageContainer_private_offset);
}

TabPageContainer*
tab_page_container_construct (GType object_type,
                              Tab* tab)
{
	TabPageContainer * self = NULL;
#line 34 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (tab != NULL, NULL);
#line 35 "../src/DynamicNotebook.vala"
	self = (TabPageContainer*) g_object_new (object_type, "tab", tab, NULL);
#line 34 "../src/DynamicNotebook.vala"
	return self;
#line 783 "DynamicNotebook.c"
}

TabPageContainer*
tab_page_container_new (Tab* tab)
{
#line 34 "../src/DynamicNotebook.vala"
	return tab_page_container_construct (TYPE_TAB_PAGE_CONTAINER, tab);
#line 791 "DynamicNotebook.c"
}

Tab*
tab_page_container_get_tab (TabPageContainer* self)
{
	Tab* result;
	Tab* _tmp0_;
#line 30 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_tab;
#line 30 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 30 "../src/DynamicNotebook.vala"
	return result;
#line 807 "DynamicNotebook.c"
}

void
tab_page_container_set_tab (TabPageContainer* self,
                            Tab* value)
{
#line 31 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/DynamicNotebook.vala"
	self->priv->_tab = value;
#line 31 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_page_container_properties[TAB_PAGE_CONTAINER_TAB_PROPERTY]);
#line 820 "DynamicNotebook.c"
}

static GObject *
tab_page_container_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TabPageContainer * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
#line 38 "../src/DynamicNotebook.vala"
	parent_class = G_OBJECT_CLASS (tab_page_container_parent_class);
#line 38 "../src/DynamicNotebook.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 38 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAB_PAGE_CONTAINER, TabPageContainer);
#line 39 "../src/DynamicNotebook.vala"
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
#line 39 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp0_);
#line 39 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 39 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
#line 39 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp1_);
#line 38 "../src/DynamicNotebook.vala"
	return obj;
#line 851 "DynamicNotebook.c"
}

static void
tab_page_container_class_init (TabPageContainerClass * klass,
                               gpointer klass_data)
{
#line 26 "../src/DynamicNotebook.vala"
	tab_page_container_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/DynamicNotebook.vala"
	g_type_class_adjust_private_offset (klass, &TabPageContainer_private_offset);
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tab_page_container_get_property;
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tab_page_container_set_property;
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->constructor = tab_page_container_constructor;
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->finalize = tab_page_container_finalize;
#line 26 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_PAGE_CONTAINER_TAB_PROPERTY, tab_page_container_properties[TAB_PAGE_CONTAINER_TAB_PROPERTY] = g_param_spec_object ("tab", "tab", "tab", TYPE_TAB, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 872 "DynamicNotebook.c"
}

static void
tab_page_container_instance_init (TabPageContainer * self,
                                  gpointer klass)
{
#line 26 "../src/DynamicNotebook.vala"
	self->priv = tab_page_container_get_instance_private (self);
#line 27 "../src/DynamicNotebook.vala"
	self->priv->_tab = NULL;
#line 883 "DynamicNotebook.c"
}

static void
tab_page_container_finalize (GObject * obj)
{
	TabPageContainer * self;
#line 26 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAB_PAGE_CONTAINER, TabPageContainer);
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (tab_page_container_parent_class)->finalize (obj);
#line 894 "DynamicNotebook.c"
}

GType
tab_page_container_get_type (void)
{
	static volatile gsize tab_page_container_type_id__volatile = 0;
	if (g_once_init_enter (&tab_page_container_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TabPageContainerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tab_page_container_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TabPageContainer), 0, (GInstanceInitFunc) tab_page_container_instance_init, NULL };
		GType tab_page_container_type_id;
		tab_page_container_type_id = g_type_register_static (gtk_event_box_get_type (), "TabPageContainer", &g_define_type_info, 0);
		TabPageContainer_private_offset = g_type_add_instance_private (tab_page_container_type_id, sizeof (TabPageContainerPrivate));
		g_once_init_leave (&tab_page_container_type_id__volatile, tab_page_container_type_id);
	}
	return tab_page_container_type_id__volatile;
}

static void
_vala_tab_page_container_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	TabPageContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAB_PAGE_CONTAINER, TabPageContainer);
#line 26 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 26 "../src/DynamicNotebook.vala"
		case TAB_PAGE_CONTAINER_TAB_PROPERTY:
#line 26 "../src/DynamicNotebook.vala"
		g_value_set_object (value, tab_page_container_get_tab (self));
#line 26 "../src/DynamicNotebook.vala"
		break;
#line 927 "DynamicNotebook.c"
		default:
#line 26 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/DynamicNotebook.vala"
		break;
#line 933 "DynamicNotebook.c"
	}
}

static void
_vala_tab_page_container_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	TabPageContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAB_PAGE_CONTAINER, TabPageContainer);
#line 26 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 26 "../src/DynamicNotebook.vala"
		case TAB_PAGE_CONTAINER_TAB_PROPERTY:
#line 26 "../src/DynamicNotebook.vala"
		tab_page_container_set_tab (self, g_value_get_object (value));
#line 26 "../src/DynamicNotebook.vala"
		break;
#line 953 "DynamicNotebook.c"
		default:
#line 26 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/DynamicNotebook.vala"
		break;
#line 959 "DynamicNotebook.c"
	}
}

static inline gpointer
tab_get_instance_private (Tab* self)
{
	return G_STRUCT_MEMBER_P (self, Tab_private_offset);
}

/**
         * With this you can construct a Tab. It is linked to the page that is shown on focus.
         * A Tab can have a icon on the right side. You can pass null on the constructor to
         * create a tab without a icon.
         **/
Tab*
tab_construct (GType object_type,
               const gchar* label,
               GIcon* icon,
               GtkWidget* page)
{
	Tab * self = NULL;
#line 212 "../src/DynamicNotebook.vala"
	self = (Tab*) g_object_new (object_type, "label", label, "icon", icon, NULL);
#line 213 "../src/DynamicNotebook.vala"
	if (page != NULL) {
#line 214 "../src/DynamicNotebook.vala"
		tab_set_page (self, page);
#line 987 "DynamicNotebook.c"
	}
#line 211 "../src/DynamicNotebook.vala"
	return self;
#line 991 "DynamicNotebook.c"
}

Tab*
tab_new (const gchar* label,
         GIcon* icon,
         GtkWidget* page)
{
#line 211 "../src/DynamicNotebook.vala"
	return tab_construct (TYPE_TAB, label, icon, page);
#line 1001 "DynamicNotebook.c"
}

void
tab_close (Tab* self)
{
#line 373 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 374 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 1011 "DynamicNotebook.c"
}

static void
tab_update_close_button_visibility (Tab* self)
{
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GtkRevealer* _tmp6_;
#line 377 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 380 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->close_button_revealer;
#line 380 "../src/DynamicNotebook.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp0_, self->priv->_pinned);
#line 381 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->close_button_revealer;
#line 381 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, !self->priv->_pinned);
#line 383 "../src/DynamicNotebook.vala"
	if (self->priv->_closable) {
#line 383 "../src/DynamicNotebook.vala"
		_tmp3_ = !self->priv->_pinned;
#line 1036 "DynamicNotebook.c"
	} else {
#line 383 "../src/DynamicNotebook.vala"
		_tmp3_ = FALSE;
#line 1040 "DynamicNotebook.c"
	}
#line 383 "../src/DynamicNotebook.vala"
	if (_tmp3_) {
#line 1044 "DynamicNotebook.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
#line 384 "../src/DynamicNotebook.vala"
		if (self->priv->cursor_over_tab) {
#line 384 "../src/DynamicNotebook.vala"
			_tmp5_ = TRUE;
#line 1051 "DynamicNotebook.c"
		} else {
#line 384 "../src/DynamicNotebook.vala"
			_tmp5_ = self->priv->cursor_over_close_button;
#line 1055 "DynamicNotebook.c"
		}
#line 384 "../src/DynamicNotebook.vala"
		if (_tmp5_) {
#line 384 "../src/DynamicNotebook.vala"
			_tmp4_ = TRUE;
#line 1061 "DynamicNotebook.c"
		} else {
#line 384 "../src/DynamicNotebook.vala"
			_tmp4_ = self->priv->_is_current_tab;
#line 1065 "DynamicNotebook.c"
		}
#line 384 "../src/DynamicNotebook.vala"
		_tmp2_ = _tmp4_;
#line 1069 "DynamicNotebook.c"
	} else {
#line 383 "../src/DynamicNotebook.vala"
		_tmp2_ = FALSE;
#line 1073 "DynamicNotebook.c"
	}
#line 383 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->close_button_revealer;
#line 383 "../src/DynamicNotebook.vala"
	gtk_revealer_set_reveal_child (_tmp6_, _tmp2_);
#line 1079 "DynamicNotebook.c"
}

static gboolean
tab_close_button_is_visible (Tab* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GtkRevealer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 387 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 388 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->close_button_revealer;
#line 388 "../src/DynamicNotebook.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 388 "../src/DynamicNotebook.vala"
	_tmp3_ = _tmp2_;
#line 388 "../src/DynamicNotebook.vala"
	if (_tmp3_) {
#line 1100 "DynamicNotebook.c"
		GtkRevealer* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 388 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->close_button_revealer;
#line 388 "../src/DynamicNotebook.vala"
		_tmp5_ = gtk_revealer_get_child_revealed (_tmp4_);
#line 388 "../src/DynamicNotebook.vala"
		_tmp6_ = _tmp5_;
#line 388 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp6_;
#line 1112 "DynamicNotebook.c"
	} else {
#line 388 "../src/DynamicNotebook.vala"
		_tmp0_ = FALSE;
#line 1116 "DynamicNotebook.c"
	}
#line 388 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 388 "../src/DynamicNotebook.vala"
	return result;
#line 1122 "DynamicNotebook.c"
}

const gchar*
tab_get_label (Tab* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 49 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 49 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 49 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 49 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 49 "../src/DynamicNotebook.vala"
	return result;
#line 1144 "DynamicNotebook.c"
}

void
tab_set_label (Tab* self,
               const gchar* value)
{
	GtkLabel* _tmp0_;
#line 51 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 52 "../src/DynamicNotebook.vala"
	gtk_label_set_label (_tmp0_, value);
#line 51 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_LABEL_PROPERTY]);
#line 1160 "DynamicNotebook.c"
}

gchar*
tab_get_tooltip (Tab* self)
{
	gchar* result;
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
#line 56 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 56 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_widget_get_tooltip_text ((GtkWidget*) _tmp0_);
#line 56 "../src/DynamicNotebook.vala"
	result = _tmp1_;
#line 56 "../src/DynamicNotebook.vala"
	return result;
#line 1179 "DynamicNotebook.c"
}

void
tab_set_tooltip (Tab* self,
                 const gchar* value)
{
	GtkLabel* _tmp0_;
#line 57 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 57 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp0_, value);
#line 57 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_TOOLTIP_PROPERTY]);
#line 1195 "DynamicNotebook.c"
}

gboolean
tab_get_pinned (Tab* self)
{
	gboolean result;
#line 62 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../src/DynamicNotebook.vala"
	result = self->priv->_pinned;
#line 62 "../src/DynamicNotebook.vala"
	return result;
#line 1208 "DynamicNotebook.c"
}

void
tab_set_pinned (Tab* self,
                gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 64 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/DynamicNotebook.vala"
	_tmp0_ = tab_get_pinnable (self);
#line 65 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/DynamicNotebook.vala"
	if (_tmp1_) {
#line 66 "../src/DynamicNotebook.vala"
		if (value != self->priv->_pinned) {
#line 67 "../src/DynamicNotebook.vala"
			if (value) {
#line 1229 "DynamicNotebook.c"
				GtkLabel* _tmp2_;
				GtkImage* _tmp3_;
				GtkSpinner* _tmp4_;
#line 68 "../src/DynamicNotebook.vala"
				_tmp2_ = self->priv->_label;
#line 68 "../src/DynamicNotebook.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 69 "../src/DynamicNotebook.vala"
				_tmp3_ = self->_icon;
#line 69 "../src/DynamicNotebook.vala"
				gtk_widget_set_margin_start ((GtkWidget*) _tmp3_, 1);
#line 70 "../src/DynamicNotebook.vala"
				_tmp4_ = self->priv->_working;
#line 70 "../src/DynamicNotebook.vala"
				gtk_widget_set_margin_start ((GtkWidget*) _tmp4_, 1);
#line 1245 "DynamicNotebook.c"
			} else {
				GtkLabel* _tmp5_;
				GtkImage* _tmp6_;
				GtkSpinner* _tmp7_;
#line 72 "../src/DynamicNotebook.vala"
				_tmp5_ = self->priv->_label;
#line 72 "../src/DynamicNotebook.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
#line 73 "../src/DynamicNotebook.vala"
				_tmp6_ = self->_icon;
#line 73 "../src/DynamicNotebook.vala"
				gtk_widget_set_margin_start ((GtkWidget*) _tmp6_, 0);
#line 74 "../src/DynamicNotebook.vala"
				_tmp7_ = self->priv->_working;
#line 74 "../src/DynamicNotebook.vala"
				gtk_widget_set_margin_start ((GtkWidget*) _tmp7_, 0);
#line 1262 "DynamicNotebook.c"
			}
#line 77 "../src/DynamicNotebook.vala"
			self->priv->_pinned = value;
#line 78 "../src/DynamicNotebook.vala"
			tab_update_close_button_visibility (self);
#line 79 "../src/DynamicNotebook.vala"
			g_signal_emit (self, tab_signals[TAB_PIN_SWITCH_SIGNAL], 0);
#line 1270 "DynamicNotebook.c"
		}
	}
#line 64 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_PINNED_PROPERTY]);
#line 1275 "DynamicNotebook.c"
}

gboolean
tab_get_pinnable (Tab* self)
{
	gboolean result;
#line 87 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 87 "../src/DynamicNotebook.vala"
	result = self->priv->_pinnable;
#line 87 "../src/DynamicNotebook.vala"
	return result;
#line 1288 "DynamicNotebook.c"
}

void
tab_set_pinnable (Tab* self,
                  gboolean value)
{
#line 88 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/DynamicNotebook.vala"
	if (!value) {
#line 90 "../src/DynamicNotebook.vala"
		tab_set_pinned (self, FALSE);
#line 1301 "DynamicNotebook.c"
	}
#line 93 "../src/DynamicNotebook.vala"
	self->priv->_pinnable = value;
#line 88 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_PINNABLE_PROPERTY]);
#line 1307 "DynamicNotebook.c"
}

const gchar*
tab_get_restore_data (Tab* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 102 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_restore_data;
#line 102 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 102 "../src/DynamicNotebook.vala"
	return result;
#line 1323 "DynamicNotebook.c"
}

void
tab_set_restore_data (Tab* self,
                      const gchar* value)
{
#line 102 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/DynamicNotebook.vala"
	if (g_strcmp0 (value, tab_get_restore_data (self)) != 0) {
#line 1334 "DynamicNotebook.c"
		gchar* _tmp0_;
#line 102 "../src/DynamicNotebook.vala"
		_tmp0_ = g_strdup (value);
#line 102 "../src/DynamicNotebook.vala"
		_g_free0 (self->priv->_restore_data);
#line 102 "../src/DynamicNotebook.vala"
		self->priv->_restore_data = _tmp0_;
#line 102 "../src/DynamicNotebook.vala"
		g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_RESTORE_DATA_PROPERTY]);
#line 1344 "DynamicNotebook.c"
	}
}

GtkWidget*
tab_get_page (Tab* self)
{
	GtkWidget* result;
	TabPageContainer* _tmp0_;
	GtkWidget* _tmp1_;
#line 115 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "../src/DynamicNotebook.vala"
	_tmp0_ = self->page_container;
#line 116 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
#line 116 "../src/DynamicNotebook.vala"
	result = _tmp1_;
#line 116 "../src/DynamicNotebook.vala"
	return result;
#line 1364 "DynamicNotebook.c"
}

void
tab_set_page (Tab* self,
              GtkWidget* value)
{
	GtkWidget* container_child = NULL;
	TabPageContainer* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkContainer* value_parent = NULL;
	GtkContainer* _tmp5_;
	GtkContainer* _tmp6_;
	TabPageContainer* _tmp10_;
#line 118 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/DynamicNotebook.vala"
	_tmp0_ = self->page_container;
#line 119 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
#line 119 "../src/DynamicNotebook.vala"
	container_child = _tmp1_;
#line 120 "../src/DynamicNotebook.vala"
	_tmp2_ = container_child;
#line 120 "../src/DynamicNotebook.vala"
	if (_tmp2_ != NULL) {
#line 1391 "DynamicNotebook.c"
		TabPageContainer* _tmp3_;
		GtkWidget* _tmp4_;
#line 121 "../src/DynamicNotebook.vala"
		_tmp3_ = self->page_container;
#line 121 "../src/DynamicNotebook.vala"
		_tmp4_ = container_child;
#line 121 "../src/DynamicNotebook.vala"
		gtk_container_remove ((GtkContainer*) _tmp3_, _tmp4_);
#line 1400 "DynamicNotebook.c"
	}
#line 124 "../src/DynamicNotebook.vala"
	_tmp5_ = gtk_widget_get_parent (value);
#line 124 "../src/DynamicNotebook.vala"
	value_parent = _tmp5_;
#line 125 "../src/DynamicNotebook.vala"
	_tmp6_ = value_parent;
#line 125 "../src/DynamicNotebook.vala"
	if (_tmp6_ != NULL) {
#line 1410 "DynamicNotebook.c"
		GtkContainer* _tmp7_;
		TabPageContainer* _tmp8_;
#line 126 "../src/DynamicNotebook.vala"
		_tmp7_ = value_parent;
#line 126 "../src/DynamicNotebook.vala"
		gtk_container_remove (_tmp7_, value);
#line 127 "../src/DynamicNotebook.vala"
		_tmp8_ = self->page_container;
#line 127 "../src/DynamicNotebook.vala"
		gtk_container_add ((GtkContainer*) _tmp8_, value);
#line 1421 "DynamicNotebook.c"
	} else {
		TabPageContainer* _tmp9_;
#line 129 "../src/DynamicNotebook.vala"
		_tmp9_ = self->page_container;
#line 129 "../src/DynamicNotebook.vala"
		gtk_container_add ((GtkContainer*) _tmp9_, value);
#line 1428 "DynamicNotebook.c"
	}
#line 132 "../src/DynamicNotebook.vala"
	_tmp10_ = self->page_container;
#line 132 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp10_);
#line 118 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_PAGE_PROPERTY]);
#line 1436 "DynamicNotebook.c"
}

GIcon*
tab_get_icon (Tab* self)
{
	GIcon* result;
	GtkImage* _tmp0_;
	GIcon* _tmp1_;
	GIcon* _tmp2_;
#line 138 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 138 "../src/DynamicNotebook.vala"
	_tmp0_ = self->_icon;
#line 138 "../src/DynamicNotebook.vala"
	g_object_get (_tmp0_, "gicon", &_tmp1_, NULL);
#line 138 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 138 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 138 "../src/DynamicNotebook.vala"
	return result;
#line 1458 "DynamicNotebook.c"
}

void
tab_set_icon (Tab* self,
              GIcon* value)
{
	GtkImage* _tmp0_;
#line 139 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/DynamicNotebook.vala"
	_tmp0_ = self->_icon;
#line 139 "../src/DynamicNotebook.vala"
	g_object_set (_tmp0_, "gicon", value, NULL);
#line 139 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_ICON_PROPERTY]);
#line 1474 "DynamicNotebook.c"
}

gboolean
tab_get_working (Tab* self)
{
	gboolean result;
#line 145 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 145 "../src/DynamicNotebook.vala"
	result = self->priv->__working;
#line 145 "../src/DynamicNotebook.vala"
	return result;
#line 1487 "DynamicNotebook.c"
}

void
tab_set_working (Tab* self,
                 gboolean value)
{
	GtkSpinner* _tmp0_;
	GtkImage* _tmp1_;
#line 147 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_working;
#line 148 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, value);
#line 148 "../src/DynamicNotebook.vala"
	self->priv->__working = value;
#line 149 "../src/DynamicNotebook.vala"
	_tmp1_ = self->_icon;
#line 149 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, !value);
#line 147 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_WORKING_PROPERTY]);
#line 1510 "DynamicNotebook.c"
}

PangoEllipsizeMode
tab_get_ellipsize_mode (Tab* self)
{
	PangoEllipsizeMode result;
	GtkLabel* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	PangoEllipsizeMode _tmp2_;
#line 154 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 154 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 154 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_label_get_ellipsize (_tmp0_);
#line 154 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 154 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 154 "../src/DynamicNotebook.vala"
	return result;
#line 1532 "DynamicNotebook.c"
}

void
tab_set_ellipsize_mode (Tab* self,
                        PangoEllipsizeMode value)
{
	GtkLabel* _tmp0_;
#line 155 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 155 "../src/DynamicNotebook.vala"
	gtk_label_set_ellipsize (_tmp0_, value);
#line 155 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_ELLIPSIZE_MODE_PROPERTY]);
#line 1548 "DynamicNotebook.c"
}

gboolean
tab_get_fixed (Tab* self)
{
	gboolean result;
#line 161 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 161 "../src/DynamicNotebook.vala"
	result = self->priv->_fixed;
#line 161 "../src/DynamicNotebook.vala"
	return result;
#line 1561 "DynamicNotebook.c"
}

void
tab_set_fixed (Tab* self,
               gboolean value)
{
#line 162 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/DynamicNotebook.vala"
	if (value != self->priv->_fixed) {
#line 1572 "DynamicNotebook.c"
		GtkLabel* _tmp0_;
#line 164 "../src/DynamicNotebook.vala"
		self->priv->_fixed = value;
#line 165 "../src/DynamicNotebook.vala"
		_tmp0_ = self->priv->_label;
#line 165 "../src/DynamicNotebook.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, value);
#line 1580 "DynamicNotebook.c"
	}
#line 162 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_FIXED_PROPERTY]);
#line 1584 "DynamicNotebook.c"
}

GtkMenu*
tab_get_menu (Tab* self)
{
	GtkMenu* result;
	GtkMenu* _tmp0_;
#line 170 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 170 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_menu;
#line 170 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 170 "../src/DynamicNotebook.vala"
	return result;
#line 1600 "DynamicNotebook.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 170 "../src/DynamicNotebook.vala"
	return self ? g_object_ref (self) : NULL;
#line 1608 "DynamicNotebook.c"
}

void
tab_set_menu (Tab* self,
              GtkMenu* value)
{
#line 170 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/DynamicNotebook.vala"
	if (tab_get_menu (self) != value) {
#line 1619 "DynamicNotebook.c"
		GtkMenu* _tmp0_;
#line 170 "../src/DynamicNotebook.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 170 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self->priv->_menu);
#line 170 "../src/DynamicNotebook.vala"
		self->priv->_menu = _tmp0_;
#line 170 "../src/DynamicNotebook.vala"
		g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_MENU_PROPERTY]);
#line 1629 "DynamicNotebook.c"
	}
}

void
tab_set_closable (Tab* self,
                  gboolean value)
{
#line 174 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/DynamicNotebook.vala"
	if (value == self->priv->_closable) {
#line 176 "../src/DynamicNotebook.vala"
		return;
#line 1643 "DynamicNotebook.c"
	}
#line 178 "../src/DynamicNotebook.vala"
	self->priv->_closable = value;
#line 179 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 174 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_CLOSABLE_PROPERTY]);
#line 1651 "DynamicNotebook.c"
}

void
tab_set_is_current_tab (Tab* self,
                        gboolean value)
{
#line 190 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/DynamicNotebook.vala"
	self->priv->_is_current_tab = value;
#line 192 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 190 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_IS_CURRENT_TAB_PROPERTY]);
#line 1666 "DynamicNotebook.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 218 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 218 "../src/DynamicNotebook.vala"
	return _data7_;
#line 1676 "DynamicNotebook.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 218 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 1686 "DynamicNotebook.c"
		Tab* self;
#line 218 "../src/DynamicNotebook.vala"
		self = _data7_->self;
#line 218 "../src/DynamicNotebook.vala"
		_g_object_unref0 (_data7_->close_other_m);
#line 218 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 218 "../src/DynamicNotebook.vala"
		g_slice_free (Block7Data, _data7_);
#line 1696 "DynamicNotebook.c"
	}
}

static void
_tab___lambda4_ (Tab* self)
{
#line 270 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 1705 "DynamicNotebook.c"
}

static void
__tab___lambda4__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 270 "../src/DynamicNotebook.vala"
	_tab___lambda4_ ((Tab*) self);
#line 1714 "DynamicNotebook.c"
}

static void
_tab___lambda5_ (Tab* self)
{
#line 271 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_CLOSE_OTHERS_SIGNAL], 0);
#line 1722 "DynamicNotebook.c"
}

static void
__tab___lambda5__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 271 "../src/DynamicNotebook.vala"
	_tab___lambda5_ ((Tab*) self);
#line 1731 "DynamicNotebook.c"
}

static void
_tab___lambda6_ (Tab* self)
{
#line 272 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_NEW_WINDOW_SIGNAL], 0);
#line 1739 "DynamicNotebook.c"
}

static void
__tab___lambda6__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 272 "../src/DynamicNotebook.vala"
	_tab___lambda6_ ((Tab*) self);
#line 1748 "DynamicNotebook.c"
}

static void
_tab___lambda7_ (Tab* self)
{
#line 273 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_DUPLICATE_SIGNAL], 0);
#line 1756 "DynamicNotebook.c"
}

static void
__tab___lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 273 "../src/DynamicNotebook.vala"
	_tab___lambda7_ ((Tab*) self);
#line 1765 "DynamicNotebook.c"
}

static void
_tab___lambda8_ (Tab* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 274 "../src/DynamicNotebook.vala"
	_tmp0_ = tab_get_pinned (self);
#line 274 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 274 "../src/DynamicNotebook.vala"
	tab_set_pinned (self, !_tmp1_);
#line 1779 "DynamicNotebook.c"
}

static void
__tab___lambda8__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 274 "../src/DynamicNotebook.vala"
	_tab___lambda8_ ((Tab*) self);
#line 1788 "DynamicNotebook.c"
}

static gboolean
_tab___lambda9_ (Tab* self,
                 GdkEventScroll* e)
{
	gboolean result = FALSE;
	GtkNotebook* notebook = NULL;
	GtkContainer* _tmp0_;
	GtkNotebook* _tmp1_;
	GdkScrollDirection _tmp2_;
#line 276 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 277 "../src/DynamicNotebook.vala"
	_tmp0_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 277 "../src/DynamicNotebook.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_notebook_get_type ()) ? ((GtkNotebook*) _tmp0_) : NULL);
#line 277 "../src/DynamicNotebook.vala"
	notebook = _tmp1_;
#line 278 "../src/DynamicNotebook.vala"
	_tmp2_ = e->direction;
#line 278 "../src/DynamicNotebook.vala"
	switch (_tmp2_) {
#line 278 "../src/DynamicNotebook.vala"
		case GDK_SCROLL_UP:
#line 278 "../src/DynamicNotebook.vala"
		case GDK_SCROLL_LEFT:
#line 1816 "DynamicNotebook.c"
		{
			GtkNotebook* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
#line 281 "../src/DynamicNotebook.vala"
			_tmp3_ = notebook;
#line 281 "../src/DynamicNotebook.vala"
			g_object_get (_tmp3_, "page", &_tmp4_, NULL);
#line 281 "../src/DynamicNotebook.vala"
			_tmp5_ = _tmp4_;
#line 281 "../src/DynamicNotebook.vala"
			if (_tmp5_ > 0) {
#line 1829 "DynamicNotebook.c"
				GtkNotebook* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 282 "../src/DynamicNotebook.vala"
				_tmp6_ = notebook;
#line 282 "../src/DynamicNotebook.vala"
				g_object_get (_tmp6_, "page", &_tmp7_, NULL);
#line 282 "../src/DynamicNotebook.vala"
				_tmp8_ = _tmp7_;
#line 282 "../src/DynamicNotebook.vala"
				g_object_set (_tmp6_, "page", _tmp8_ - 1, NULL);
#line 283 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 283 "../src/DynamicNotebook.vala"
				_g_object_unref0 (notebook);
#line 283 "../src/DynamicNotebook.vala"
				return result;
#line 1847 "DynamicNotebook.c"
			}
#line 285 "../src/DynamicNotebook.vala"
			break;
#line 1851 "DynamicNotebook.c"
		}
#line 278 "../src/DynamicNotebook.vala"
		case GDK_SCROLL_DOWN:
#line 278 "../src/DynamicNotebook.vala"
		case GDK_SCROLL_RIGHT:
#line 1857 "DynamicNotebook.c"
		{
			GtkNotebook* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			GtkNotebook* _tmp12_;
#line 289 "../src/DynamicNotebook.vala"
			_tmp9_ = notebook;
#line 289 "../src/DynamicNotebook.vala"
			g_object_get (_tmp9_, "page", &_tmp10_, NULL);
#line 289 "../src/DynamicNotebook.vala"
			_tmp11_ = _tmp10_;
#line 289 "../src/DynamicNotebook.vala"
			_tmp12_ = notebook;
#line 289 "../src/DynamicNotebook.vala"
			if (_tmp11_ < gtk_notebook_get_n_pages (_tmp12_)) {
#line 1873 "DynamicNotebook.c"
				GtkNotebook* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
#line 290 "../src/DynamicNotebook.vala"
				_tmp13_ = notebook;
#line 290 "../src/DynamicNotebook.vala"
				g_object_get (_tmp13_, "page", &_tmp14_, NULL);
#line 290 "../src/DynamicNotebook.vala"
				_tmp15_ = _tmp14_;
#line 290 "../src/DynamicNotebook.vala"
				g_object_set (_tmp13_, "page", _tmp15_ + 1, NULL);
#line 291 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 291 "../src/DynamicNotebook.vala"
				_g_object_unref0 (notebook);
#line 291 "../src/DynamicNotebook.vala"
				return result;
#line 1891 "DynamicNotebook.c"
			}
#line 293 "../src/DynamicNotebook.vala"
			break;
#line 1895 "DynamicNotebook.c"
		}
		default:
#line 278 "../src/DynamicNotebook.vala"
		break;
#line 1900 "DynamicNotebook.c"
	}
#line 296 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 296 "../src/DynamicNotebook.vala"
	_g_object_unref0 (notebook);
#line 296 "../src/DynamicNotebook.vala"
	return result;
#line 1908 "DynamicNotebook.c"
}

static gboolean
__tab___lambda9__gtk_widget_scroll_event (GtkWidget* _sender,
                                          GdkEventScroll* event,
                                          gpointer self)
{
	gboolean result;
	result = _tab___lambda9_ ((Tab*) self, event);
#line 276 "../src/DynamicNotebook.vala"
	return result;
#line 1920 "DynamicNotebook.c"
}

static gboolean
_tab___lambda10_ (Block7Data* _data7_,
                  GdkEventButton* e)
{
	Tab* self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 299 "../src/DynamicNotebook.vala"
	self = _data7_->self;
#line 299 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 300 "../src/DynamicNotebook.vala"
	if (e->button == ((guint) 2)) {
#line 300 "../src/DynamicNotebook.vala"
		_tmp0_ = tab_close_button_is_visible (self);
#line 1938 "DynamicNotebook.c"
	} else {
#line 300 "../src/DynamicNotebook.vala"
		_tmp0_ = FALSE;
#line 1942 "DynamicNotebook.c"
	}
#line 300 "../src/DynamicNotebook.vala"
	if (_tmp0_) {
#line 1946 "DynamicNotebook.c"
		GdkModifierType _tmp1_;
		GdkModifierType _tmp2_;
#line 301 "../src/DynamicNotebook.vala"
		_tmp1_ = e->state;
#line 301 "../src/DynamicNotebook.vala"
		e->state = _tmp1_ & MODIFIER_MASK;
#line 303 "../src/DynamicNotebook.vala"
		_tmp2_ = e->state;
#line 303 "../src/DynamicNotebook.vala"
		if (_tmp2_ == 0) {
#line 304 "../src/DynamicNotebook.vala"
			g_signal_emit (self, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 1959 "DynamicNotebook.c"
		} else {
			GdkModifierType _tmp3_;
#line 305 "../src/DynamicNotebook.vala"
			_tmp3_ = e->state;
#line 305 "../src/DynamicNotebook.vala"
			if (_tmp3_ == GDK_SHIFT_MASK) {
#line 306 "../src/DynamicNotebook.vala"
				g_signal_emit (self, tab_signals[TAB_CLOSE_OTHERS_SIGNAL], 0);
#line 1968 "DynamicNotebook.c"
			}
		}
	} else {
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
#line 308 "../src/DynamicNotebook.vala"
		if (e->button == ((guint) 1)) {
#line 1976 "DynamicNotebook.c"
			GdkEventType _tmp6_;
#line 308 "../src/DynamicNotebook.vala"
			_tmp6_ = e->type;
#line 308 "../src/DynamicNotebook.vala"
			_tmp5_ = _tmp6_ == GDK_2BUTTON_PRESS;
#line 1982 "DynamicNotebook.c"
		} else {
#line 308 "../src/DynamicNotebook.vala"
			_tmp5_ = FALSE;
#line 1986 "DynamicNotebook.c"
		}
#line 308 "../src/DynamicNotebook.vala"
		if (_tmp5_) {
#line 1990 "DynamicNotebook.c"
			GtkMenuItem* _tmp7_;
			gboolean _tmp8_;
			gboolean _tmp9_;
#line 308 "../src/DynamicNotebook.vala"
			_tmp7_ = self->duplicate_m;
#line 308 "../src/DynamicNotebook.vala"
			_tmp8_ = gtk_widget_get_visible ((GtkWidget*) _tmp7_);
#line 308 "../src/DynamicNotebook.vala"
			_tmp9_ = _tmp8_;
#line 308 "../src/DynamicNotebook.vala"
			_tmp4_ = _tmp9_;
#line 2002 "DynamicNotebook.c"
		} else {
#line 308 "../src/DynamicNotebook.vala"
			_tmp4_ = FALSE;
#line 2006 "DynamicNotebook.c"
		}
#line 308 "../src/DynamicNotebook.vala"
		if (_tmp4_) {
#line 309 "../src/DynamicNotebook.vala"
			g_signal_emit (self, tab_signals[TAB_DUPLICATE_SIGNAL], 0);
#line 2012 "DynamicNotebook.c"
		} else {
#line 310 "../src/DynamicNotebook.vala"
			if (e->button == ((guint) 3)) {
#line 2016 "DynamicNotebook.c"
				GtkMenu* _tmp10_;
				guint num_tabs = 0U;
				GtkContainer* _tmp11_;
				GList* _tmp12_;
				GList* _tmp13_;
				guint _tmp14_;
				GtkMenuItem* _tmp15_;
				GtkMenuItem* _tmp16_;
				GtkMenuItem* _tmp17_;
				GtkMenuItem* _tmp18_;
				gboolean _tmp19_;
				gboolean _tmp20_;
#line 311 "../src/DynamicNotebook.vala"
				_tmp10_ = self->priv->_menu;
#line 311 "../src/DynamicNotebook.vala"
				gtk_menu_popup_at_pointer (_tmp10_, (GdkEvent*) e);
#line 312 "../src/DynamicNotebook.vala"
				_tmp11_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 312 "../src/DynamicNotebook.vala"
				_tmp12_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, gtk_container_get_type ()) ? ((GtkContainer*) _tmp11_) : NULL);
#line 312 "../src/DynamicNotebook.vala"
				_tmp13_ = _tmp12_;
#line 312 "../src/DynamicNotebook.vala"
				_tmp14_ = g_list_length (_tmp13_);
#line 312 "../src/DynamicNotebook.vala"
				(_tmp13_ == NULL) ? NULL : (_tmp13_ = (g_list_free (_tmp13_), NULL));
#line 312 "../src/DynamicNotebook.vala"
				num_tabs = _tmp14_;
#line 313 "../src/DynamicNotebook.vala"
				_tmp15_ = _data7_->close_other_m;
#line 313 "../src/DynamicNotebook.vala"
				gtk_menu_item_set_label (_tmp15_, ngettext (_ ("Close Other Tab"), _ ("Close Other Tabs"), (gulong) (num_tabs - 1)));
#line 314 "../src/DynamicNotebook.vala"
				_tmp16_ = _data7_->close_other_m;
#line 314 "../src/DynamicNotebook.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp16_, num_tabs != ((guint) 1));
#line 315 "../src/DynamicNotebook.vala"
				_tmp17_ = self->new_window_m;
#line 315 "../src/DynamicNotebook.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp17_, num_tabs != ((guint) 1));
#line 316 "../src/DynamicNotebook.vala"
				_tmp18_ = self->pin_m;
#line 316 "../src/DynamicNotebook.vala"
				gtk_menu_item_set_label (_tmp18_, "Pin");
#line 317 "../src/DynamicNotebook.vala"
				_tmp19_ = tab_get_pinned (self);
#line 317 "../src/DynamicNotebook.vala"
				_tmp20_ = _tmp19_;
#line 317 "../src/DynamicNotebook.vala"
				if (_tmp20_) {
#line 2067 "DynamicNotebook.c"
					GtkMenuItem* _tmp21_;
#line 318 "../src/DynamicNotebook.vala"
					_tmp21_ = self->pin_m;
#line 318 "../src/DynamicNotebook.vala"
					gtk_menu_item_set_label (_tmp21_, "Unpin");
#line 2073 "DynamicNotebook.c"
				}
			} else {
#line 321 "../src/DynamicNotebook.vala"
				result = FALSE;
#line 321 "../src/DynamicNotebook.vala"
				return result;
#line 2080 "DynamicNotebook.c"
			}
		}
	}
#line 324 "../src/DynamicNotebook.vala"
	result = TRUE;
#line 324 "../src/DynamicNotebook.vala"
	return result;
#line 2088 "DynamicNotebook.c"
}

static gboolean
__tab___lambda10__gtk_widget_button_press_event (GtkWidget* _sender,
                                                 GdkEventButton* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda10_ (self, event);
#line 299 "../src/DynamicNotebook.vala"
	return result;
#line 2100 "DynamicNotebook.c"
}

static gboolean
_tab___lambda11_ (Tab* self,
                  GdkEventCrossing* e)
{
	gboolean result = FALSE;
#line 327 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 328 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_tab = TRUE;
#line 329 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 330 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 330 "../src/DynamicNotebook.vala"
	return result;
#line 2118 "DynamicNotebook.c"
}

static gboolean
__tab___lambda11__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                 GdkEventCrossing* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda11_ ((Tab*) self, event);
#line 327 "../src/DynamicNotebook.vala"
	return result;
#line 2130 "DynamicNotebook.c"
}

static gboolean
_tab___lambda12_ (Tab* self,
                  GdkEventCrossing* e)
{
	gboolean result = FALSE;
#line 333 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 336 "../src/DynamicNotebook.vala"
	if (!self->priv->cursor_over_tab) {
#line 337 "../src/DynamicNotebook.vala"
		result = FALSE;
#line 337 "../src/DynamicNotebook.vala"
		return result;
#line 2146 "DynamicNotebook.c"
	}
#line 339 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_tab = FALSE;
#line 340 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 341 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 341 "../src/DynamicNotebook.vala"
	return result;
#line 2156 "DynamicNotebook.c"
}

static gboolean
__tab___lambda12__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                 GdkEventCrossing* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda12_ ((Tab*) self, event);
#line 333 "../src/DynamicNotebook.vala"
	return result;
#line 2168 "DynamicNotebook.c"
}

static gboolean
_tab___lambda13_ (Tab* self,
                  GdkEventCrossing* e)
{
	gboolean result = FALSE;
#line 349 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 350 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_close_button = TRUE;
#line 351 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 352 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 352 "../src/DynamicNotebook.vala"
	return result;
#line 2186 "DynamicNotebook.c"
}

static gboolean
__tab___lambda13__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                 GdkEventCrossing* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda13_ ((Tab*) self, event);
#line 349 "../src/DynamicNotebook.vala"
	return result;
#line 2198 "DynamicNotebook.c"
}

static gboolean
_tab___lambda14_ (Tab* self,
                  GdkEventCrossing* e)
{
	gboolean result = FALSE;
#line 355 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 358 "../src/DynamicNotebook.vala"
	if (!self->priv->cursor_over_close_button) {
#line 359 "../src/DynamicNotebook.vala"
		result = FALSE;
#line 359 "../src/DynamicNotebook.vala"
		return result;
#line 2214 "DynamicNotebook.c"
	}
#line 361 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_close_button = FALSE;
#line 362 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 363 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 363 "../src/DynamicNotebook.vala"
	return result;
#line 2224 "DynamicNotebook.c"
}

static gboolean
__tab___lambda14__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                 GdkEventCrossing* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda14_ ((Tab*) self, event);
#line 355 "../src/DynamicNotebook.vala"
	return result;
#line 2236 "DynamicNotebook.c"
}

static gboolean
_tab___lambda15_ (Tab* self)
{
	gboolean result = FALSE;
#line 366 "../src/DynamicNotebook.vala"
	result = TRUE;
#line 366 "../src/DynamicNotebook.vala"
	return result;
#line 2247 "DynamicNotebook.c"
}

static gboolean
__tab___lambda15__gtk_widget_button_press_event (GtkWidget* _sender,
                                                 GdkEventButton* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda15_ ((Tab*) self);
#line 366 "../src/DynamicNotebook.vala"
	return result;
#line 2259 "DynamicNotebook.c"
}

static void
_tab___lambda16_ (Tab* self)
{
#line 367 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 2267 "DynamicNotebook.c"
}

static void
__tab___lambda16__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self)
{
#line 367 "../src/DynamicNotebook.vala"
	_tab___lambda16_ ((Tab*) self);
#line 2276 "DynamicNotebook.c"
}

static GObject *
tab_constructor (GType type,
                 guint n_construct_properties,
                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Tab * self;
	Block7Data* _data7_;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkSpinner* _tmp10_;
	GtkSpinner* _tmp11_;
	GtkSpinner* _tmp12_;
	GtkButton* close_button = NULL;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	GtkButton* _tmp16_;
	GtkRevealer* _tmp17_;
	GtkRevealer* _tmp18_;
	GtkRevealer* _tmp19_;
	GtkButton* _tmp20_;
	GtkGrid* tab_layout = NULL;
	GtkGrid* _tmp21_;
	GtkGrid* _tmp22_;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkRevealer* _tmp25_;
	GtkGrid* _tmp26_;
	GtkLabel* _tmp27_;
	GtkGrid* _tmp28_;
	GtkImage* _tmp29_;
	GtkGrid* _tmp30_;
	GtkSpinner* _tmp31_;
	GtkGrid* _tmp32_;
	TabPageContainer* _tmp33_;
	GtkMenu* _tmp34_;
	GtkMenu* _tmp35_;
	GtkMenuItem* close_m = NULL;
	GtkMenuItem* _tmp36_;
	GtkMenuItem* _tmp37_;
	GtkMenuItem* _tmp38_;
	GtkMenuItem* _tmp39_;
	GtkMenuItem* _tmp40_;
	GtkMenu* _tmp41_;
	GtkMenuItem* _tmp42_;
	GtkMenu* _tmp43_;
	GtkMenuItem* _tmp44_;
	GtkMenu* _tmp45_;
	GtkMenuItem* _tmp46_;
	GtkMenu* _tmp47_;
	GtkMenuItem* _tmp48_;
	GtkMenu* _tmp49_;
	GtkMenuItem* _tmp50_;
	GtkMenu* _tmp51_;
	GtkMenuItem* _tmp52_;
	GtkMenuItem* _tmp53_;
	GtkMenuItem* _tmp54_;
	GtkMenuItem* _tmp55_;
	GtkMenuItem* _tmp56_;
	GtkButton* _tmp57_;
	GtkButton* _tmp58_;
	TabPageContainer* _tmp59_;
	GtkButton* _tmp60_;
#line 218 "../src/DynamicNotebook.vala"
	parent_class = G_OBJECT_CLASS (tab_parent_class);
#line 218 "../src/DynamicNotebook.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 218 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAB, Tab);
#line 218 "../src/DynamicNotebook.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 218 "../src/DynamicNotebook.vala"
	_data7_->_ref_count_ = 1;
#line 218 "../src/DynamicNotebook.vala"
	_data7_->self = g_object_ref (self);
#line 219 "../src/DynamicNotebook.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
#line 219 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp0_);
#line 219 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_label);
#line 219 "../src/DynamicNotebook.vala"
	self->priv->_label = _tmp0_;
#line 220 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->_label;
#line 220 "../src/DynamicNotebook.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
#line 221 "../src/DynamicNotebook.vala"
	_tmp2_ = self->priv->_label;
#line 221 "../src/DynamicNotebook.vala"
	_tmp3_ = tab_get_label (self);
#line 221 "../src/DynamicNotebook.vala"
	_tmp4_ = _tmp3_;
#line 221 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp2_, _tmp4_);
#line 222 "../src/DynamicNotebook.vala"
	_tmp5_ = self->priv->_label;
#line 222 "../src/DynamicNotebook.vala"
	gtk_label_set_ellipsize (_tmp5_, PANGO_ELLIPSIZE_END);
#line 224 "../src/DynamicNotebook.vala"
	_tmp6_ = (GtkImage*) gtk_image_new ();
#line 224 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp6_);
#line 224 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->_icon);
#line 224 "../src/DynamicNotebook.vala"
	self->_icon = _tmp6_;
#line 225 "../src/DynamicNotebook.vala"
	_tmp7_ = self->_icon;
#line 225 "../src/DynamicNotebook.vala"
	g_object_set (_tmp7_, "icon-size", (gint) GTK_ICON_SIZE_MENU, NULL);
#line 226 "../src/DynamicNotebook.vala"
	_tmp8_ = self->_icon;
#line 226 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
#line 227 "../src/DynamicNotebook.vala"
	_tmp9_ = self->_icon;
#line 227 "../src/DynamicNotebook.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp9_, 16, 16);
#line 229 "../src/DynamicNotebook.vala"
	_tmp10_ = (GtkSpinner*) gtk_spinner_new ();
#line 229 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp10_);
#line 229 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_working);
#line 229 "../src/DynamicNotebook.vala"
	self->priv->_working = _tmp10_;
#line 230 "../src/DynamicNotebook.vala"
	_tmp11_ = self->priv->_working;
#line 230 "../src/DynamicNotebook.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp11_, 16, 16);
#line 231 "../src/DynamicNotebook.vala"
	_tmp12_ = self->priv->_working;
#line 231 "../src/DynamicNotebook.vala"
	gtk_spinner_start (_tmp12_);
#line 233 "../src/DynamicNotebook.vala"
	_tmp13_ = (GtkButton*) gtk_button_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 233 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp13_);
#line 233 "../src/DynamicNotebook.vala"
	close_button = _tmp13_;
#line 234 "../src/DynamicNotebook.vala"
	_tmp14_ = close_button;
#line 234 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp14_, _ ("Close Tab"));
#line 235 "../src/DynamicNotebook.vala"
	_tmp15_ = close_button;
#line 235 "../src/DynamicNotebook.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp15_, GTK_ALIGN_CENTER);
#line 236 "../src/DynamicNotebook.vala"
	_tmp16_ = close_button;
#line 236 "../src/DynamicNotebook.vala"
	gtk_button_set_relief (_tmp16_, GTK_RELIEF_NONE);
#line 238 "../src/DynamicNotebook.vala"
	_tmp17_ = (GtkRevealer*) gtk_revealer_new ();
#line 238 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp17_);
#line 238 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->close_button_revealer);
#line 238 "../src/DynamicNotebook.vala"
	self->priv->close_button_revealer = _tmp17_;
#line 239 "../src/DynamicNotebook.vala"
	_tmp18_ = self->priv->close_button_revealer;
#line 239 "../src/DynamicNotebook.vala"
	gtk_revealer_set_transition_type (_tmp18_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
#line 240 "../src/DynamicNotebook.vala"
	_tmp19_ = self->priv->close_button_revealer;
#line 240 "../src/DynamicNotebook.vala"
	_tmp20_ = close_button;
#line 240 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 242 "../src/DynamicNotebook.vala"
	_tmp21_ = (GtkGrid*) gtk_grid_new ();
#line 242 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp21_);
#line 242 "../src/DynamicNotebook.vala"
	tab_layout = _tmp21_;
#line 243 "../src/DynamicNotebook.vala"
	_tmp22_ = tab_layout;
#line 243 "../src/DynamicNotebook.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp22_, FALSE);
#line 244 "../src/DynamicNotebook.vala"
	_tmp23_ = tab_layout;
#line 244 "../src/DynamicNotebook.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp23_, GTK_ORIENTATION_HORIZONTAL);
#line 245 "../src/DynamicNotebook.vala"
	_tmp24_ = tab_layout;
#line 245 "../src/DynamicNotebook.vala"
	_tmp25_ = self->priv->close_button_revealer;
#line 245 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
#line 246 "../src/DynamicNotebook.vala"
	_tmp26_ = tab_layout;
#line 246 "../src/DynamicNotebook.vala"
	_tmp27_ = self->priv->_label;
#line 246 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
#line 247 "../src/DynamicNotebook.vala"
	_tmp28_ = tab_layout;
#line 247 "../src/DynamicNotebook.vala"
	_tmp29_ = self->_icon;
#line 247 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
#line 248 "../src/DynamicNotebook.vala"
	_tmp30_ = tab_layout;
#line 248 "../src/DynamicNotebook.vala"
	_tmp31_ = self->priv->_working;
#line 248 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
#line 250 "../src/DynamicNotebook.vala"
	gtk_event_box_set_visible_window ((GtkEventBox*) self, TRUE);
#line 252 "../src/DynamicNotebook.vala"
	_tmp32_ = tab_layout;
#line 252 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp32_);
#line 253 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 255 "../src/DynamicNotebook.vala"
	_tmp33_ = tab_page_container_new (self);
#line 255 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp33_);
#line 255 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->page_container);
#line 255 "../src/DynamicNotebook.vala"
	self->page_container = _tmp33_;
#line 257 "../src/DynamicNotebook.vala"
	_tmp34_ = (GtkMenu*) gtk_menu_new ();
#line 257 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp34_);
#line 257 "../src/DynamicNotebook.vala"
	_tmp35_ = _tmp34_;
#line 257 "../src/DynamicNotebook.vala"
	tab_set_menu (self, _tmp35_);
#line 257 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp35_);
#line 258 "../src/DynamicNotebook.vala"
	_tmp36_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Close Tab"));
#line 258 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp36_);
#line 258 "../src/DynamicNotebook.vala"
	close_m = _tmp36_;
#line 259 "../src/DynamicNotebook.vala"
	_tmp37_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("");
#line 259 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp37_);
#line 259 "../src/DynamicNotebook.vala"
	_data7_->close_other_m = _tmp37_;
#line 260 "../src/DynamicNotebook.vala"
	_tmp38_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("");
#line 260 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp38_);
#line 260 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->pin_m);
#line 260 "../src/DynamicNotebook.vala"
	self->pin_m = _tmp38_;
#line 261 "../src/DynamicNotebook.vala"
	_tmp39_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Open in a New Window"));
#line 261 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp39_);
#line 261 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->new_window_m);
#line 261 "../src/DynamicNotebook.vala"
	self->new_window_m = _tmp39_;
#line 262 "../src/DynamicNotebook.vala"
	_tmp40_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Duplicate"));
#line 262 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp40_);
#line 262 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->duplicate_m);
#line 262 "../src/DynamicNotebook.vala"
	self->duplicate_m = _tmp40_;
#line 263 "../src/DynamicNotebook.vala"
	_tmp41_ = self->priv->_menu;
#line 263 "../src/DynamicNotebook.vala"
	_tmp42_ = _data7_->close_other_m;
#line 263 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp41_, _tmp42_);
#line 264 "../src/DynamicNotebook.vala"
	_tmp43_ = self->priv->_menu;
#line 264 "../src/DynamicNotebook.vala"
	_tmp44_ = close_m;
#line 264 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp43_, _tmp44_);
#line 265 "../src/DynamicNotebook.vala"
	_tmp45_ = self->priv->_menu;
#line 265 "../src/DynamicNotebook.vala"
	_tmp46_ = self->new_window_m;
#line 265 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp45_, _tmp46_);
#line 266 "../src/DynamicNotebook.vala"
	_tmp47_ = self->priv->_menu;
#line 266 "../src/DynamicNotebook.vala"
	_tmp48_ = self->duplicate_m;
#line 266 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp47_, _tmp48_);
#line 267 "../src/DynamicNotebook.vala"
	_tmp49_ = self->priv->_menu;
#line 267 "../src/DynamicNotebook.vala"
	_tmp50_ = self->pin_m;
#line 267 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp49_, _tmp50_);
#line 268 "../src/DynamicNotebook.vala"
	_tmp51_ = self->priv->_menu;
#line 268 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp51_);
#line 270 "../src/DynamicNotebook.vala"
	_tmp52_ = close_m;
#line 270 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp52_, "activate", (GCallback) __tab___lambda4__gtk_menu_item_activate, self, 0);
#line 271 "../src/DynamicNotebook.vala"
	_tmp53_ = _data7_->close_other_m;
#line 271 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp53_, "activate", (GCallback) __tab___lambda5__gtk_menu_item_activate, self, 0);
#line 272 "../src/DynamicNotebook.vala"
	_tmp54_ = self->new_window_m;
#line 272 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp54_, "activate", (GCallback) __tab___lambda6__gtk_menu_item_activate, self, 0);
#line 273 "../src/DynamicNotebook.vala"
	_tmp55_ = self->duplicate_m;
#line 273 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp55_, "activate", (GCallback) __tab___lambda7__gtk_menu_item_activate, self, 0);
#line 274 "../src/DynamicNotebook.vala"
	_tmp56_ = self->pin_m;
#line 274 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp56_, "activate", (GCallback) __tab___lambda8__gtk_menu_item_activate, self, 0);
#line 276 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "scroll-event", (GCallback) __tab___lambda9__gtk_widget_scroll_event, self, 0);
#line 299 "../src/DynamicNotebook.vala"
	g_signal_connect_data ((GtkWidget*) self, "button-press-event", (GCallback) __tab___lambda10__gtk_widget_button_press_event, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 327 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "enter-notify-event", (GCallback) __tab___lambda11__gtk_widget_enter_notify_event, self, 0);
#line 333 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "leave-notify-event", (GCallback) __tab___lambda12__gtk_widget_leave_notify_event, self, 0);
#line 349 "../src/DynamicNotebook.vala"
	_tmp57_ = close_button;
#line 349 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) _tmp57_, "enter-notify-event", (GCallback) __tab___lambda13__gtk_widget_enter_notify_event, self, 0);
#line 355 "../src/DynamicNotebook.vala"
	_tmp58_ = close_button;
#line 355 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) _tmp58_, "leave-notify-event", (GCallback) __tab___lambda14__gtk_widget_leave_notify_event, self, 0);
#line 366 "../src/DynamicNotebook.vala"
	_tmp59_ = self->page_container;
#line 366 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) _tmp59_, "button-press-event", (GCallback) __tab___lambda15__gtk_widget_button_press_event, self, 0);
#line 367 "../src/DynamicNotebook.vala"
	_tmp60_ = close_button;
#line 367 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp60_, "clicked", (GCallback) __tab___lambda16__gtk_button_clicked, self, 0);
#line 368 "../src/DynamicNotebook.vala"
	tab_set_working (self, FALSE);
#line 370 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 218 "../src/DynamicNotebook.vala"
	_g_object_unref0 (close_m);
#line 218 "../src/DynamicNotebook.vala"
	_g_object_unref0 (tab_layout);
#line 218 "../src/DynamicNotebook.vala"
	_g_object_unref0 (close_button);
#line 218 "../src/DynamicNotebook.vala"
	block7_data_unref (_data7_);
#line 218 "../src/DynamicNotebook.vala"
	_data7_ = NULL;
#line 218 "../src/DynamicNotebook.vala"
	return obj;
#line 2654 "DynamicNotebook.c"
}

static void
tab_class_init (TabClass * klass,
                gpointer klass_data)
{
#line 46 "../src/DynamicNotebook.vala"
	tab_parent_class = g_type_class_peek_parent (klass);
#line 46 "../src/DynamicNotebook.vala"
	g_type_class_adjust_private_offset (klass, &Tab_private_offset);
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tab_get_property;
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tab_set_property;
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->constructor = tab_constructor;
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->finalize = tab_finalize;
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_LABEL_PROPERTY, tab_properties[TAB_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_TOOLTIP_PROPERTY, tab_properties[TAB_TOOLTIP_PROPERTY] = g_param_spec_string ("tooltip", "tooltip", "tooltip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_PINNED_PROPERTY, tab_properties[TAB_PINNED_PROPERTY] = g_param_spec_boolean ("pinned", "pinned", "pinned", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_PINNABLE_PROPERTY, tab_properties[TAB_PINNABLE_PROPERTY] = g_param_spec_boolean ("pinnable", "pinnable", "pinnable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2681 "DynamicNotebook.c"
	/**
	         * Data which will be kept once the tab is deleted, and which will be used by
	         * the application to restore the data into the restored tab. Let it empty if
	         * the tab should not be restored.
	         **/
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_RESTORE_DATA_PROPERTY, tab_properties[TAB_RESTORE_DATA_PROPERTY] = g_param_spec_string ("restore-data", "restore-data", "restore-data", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_PAGE_PROPERTY, tab_properties[TAB_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_ICON_PROPERTY, tab_properties[TAB_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_WORKING_PROPERTY, tab_properties[TAB_WORKING_PROPERTY] = g_param_spec_boolean ("working", "working", "working", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_ELLIPSIZE_MODE_PROPERTY, tab_properties[TAB_ELLIPSIZE_MODE_PROPERTY] = g_param_spec_enum ("ellipsize-mode", "ellipsize-mode", "ellipsize-mode", pango_ellipsize_mode_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_FIXED_PROPERTY, tab_properties[TAB_FIXED_PROPERTY] = g_param_spec_boolean ("fixed", "fixed", "fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_DEPRECATED));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_MENU_PROPERTY, tab_properties[TAB_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", gtk_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_CLOSABLE_PROPERTY, tab_properties[TAB_CLOSABLE_PROPERTY] = g_param_spec_boolean ("closable", "closable", "closable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_IS_CURRENT_TAB_PROPERTY, tab_properties[TAB_IS_CURRENT_TAB_PROPERTY] = g_param_spec_boolean ("is-current-tab", "is-current-tab", "is-current-tab", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_CLOSED_SIGNAL] = g_signal_new ("closed", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_CLOSE_OTHERS_SIGNAL] = g_signal_new ("close-others", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_NEW_WINDOW_SIGNAL] = g_signal_new ("new-window", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_DUPLICATE_SIGNAL] = g_signal_new ("duplicate", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_PIN_SWITCH_SIGNAL] = g_signal_new ("pin-switch", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2715 "DynamicNotebook.c"
}

static void
tab_instance_init (Tab * self,
                   gpointer klass)
{
	gchar* _tmp0_;
#line 46 "../src/DynamicNotebook.vala"
	self->priv = tab_get_instance_private (self);
#line 60 "../src/DynamicNotebook.vala"
	self->priv->_pinned = FALSE;
#line 85 "../src/DynamicNotebook.vala"
	self->priv->_pinnable = TRUE;
#line 102 "../src/DynamicNotebook.vala"
	_tmp0_ = g_strdup ("");
#line 102 "../src/DynamicNotebook.vala"
	self->priv->_restore_data = _tmp0_;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback = NULL;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback_target = self;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback_target_destroy_notify = NULL;
#line 172 "../src/DynamicNotebook.vala"
	self->priv->_closable = TRUE;
#line 188 "../src/DynamicNotebook.vala"
	self->priv->_is_current_tab = FALSE;
#line 196 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_tab = FALSE;
#line 197 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_close_button = FALSE;
#line 2747 "DynamicNotebook.c"
}

static void
tab_finalize (GObject * obj)
{
	Tab * self;
#line 46 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAB, Tab);
#line 47 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_label);
#line 102 "../src/DynamicNotebook.vala"
	_g_free0 (self->priv->_restore_data);
#line 111 "../src/DynamicNotebook.vala"
	(self->dropped_callback_target_destroy_notify == NULL) ? NULL : (self->dropped_callback_target_destroy_notify (self->dropped_callback_target), NULL);
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback = NULL;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback_target = NULL;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback_target_destroy_notify = NULL;
#line 113 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->page_container);
#line 136 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->_icon);
#line 142 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_working);
#line 170 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_menu);
#line 184 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->new_window_m);
#line 185 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->duplicate_m);
#line 186 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->pin_m);
#line 198 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->close_button_revealer);
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (tab_parent_class)->finalize (obj);
#line 2786 "DynamicNotebook.c"
}

/**
     * This is a standard tab which can be used in a notebook to form a tabbed UI.
     */
GType
tab_get_type (void)
{
	static volatile gsize tab_type_id__volatile = 0;
	if (g_once_init_enter (&tab_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TabClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tab_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Tab), 0, (GInstanceInitFunc) tab_instance_init, NULL };
		GType tab_type_id;
		tab_type_id = g_type_register_static (gtk_event_box_get_type (), "Tab", &g_define_type_info, 0);
		Tab_private_offset = g_type_add_instance_private (tab_type_id, sizeof (TabPrivate));
		g_once_init_leave (&tab_type_id__volatile, tab_type_id);
	}
	return tab_type_id__volatile;
}

static void
_vala_tab_get_property (GObject * object,
                        guint property_id,
                        GValue * value,
                        GParamSpec * pspec)
{
	Tab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAB, Tab);
#line 46 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 46 "../src/DynamicNotebook.vala"
		case TAB_LABEL_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_string (value, tab_get_label (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_TOOLTIP_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_take_string (value, tab_get_tooltip (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PINNED_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, tab_get_pinned (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PINNABLE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, tab_get_pinnable (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_RESTORE_DATA_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_string (value, tab_get_restore_data (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PAGE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_object (value, tab_get_page (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_ICON_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_take_object (value, tab_get_icon (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_WORKING_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, tab_get_working (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_ELLIPSIZE_MODE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_enum (value, tab_get_ellipsize_mode (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_FIXED_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 2873 "DynamicNotebook.c"
		g_value_set_boolean (value, tab_get_fixed (self));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_MENU_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_object (value, tab_get_menu (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 2884 "DynamicNotebook.c"
		default:
#line 46 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 2890 "DynamicNotebook.c"
	}
}

static void
_vala_tab_set_property (GObject * object,
                        guint property_id,
                        const GValue * value,
                        GParamSpec * pspec)
{
	Tab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAB, Tab);
#line 46 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 46 "../src/DynamicNotebook.vala"
		case TAB_LABEL_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_label (self, g_value_get_string (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_TOOLTIP_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_tooltip (self, g_value_get_string (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PINNED_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_pinned (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PINNABLE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_pinnable (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_RESTORE_DATA_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_restore_data (self, g_value_get_string (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PAGE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_page (self, g_value_get_object (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_ICON_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_icon (self, g_value_get_object (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_WORKING_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_working (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_ELLIPSIZE_MODE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_ellipsize_mode (self, g_value_get_enum (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_FIXED_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 2961 "DynamicNotebook.c"
		tab_set_fixed (self, g_value_get_boolean (value));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_MENU_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_menu (self, g_value_get_object (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_CLOSABLE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_closable (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_IS_CURRENT_TAB_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_is_current_tab (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 2984 "DynamicNotebook.c"
		default:
#line 46 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 2990 "DynamicNotebook.c"
	}
}

static inline gpointer
closed_tabs_get_instance_private (ClosedTabs* self)
{
	return G_STRUCT_MEMBER_P (self, ClosedTabs_private_offset);
}

ClosedTabs*
closed_tabs_construct (GType object_type)
{
	ClosedTabs * self = NULL;
#line 415 "../src/DynamicNotebook.vala"
	self = (ClosedTabs*) g_object_new (object_type, NULL);
#line 415 "../src/DynamicNotebook.vala"
	return self;
#line 3008 "DynamicNotebook.c"
}

ClosedTabs*
closed_tabs_new (void)
{
#line 415 "../src/DynamicNotebook.vala"
	return closed_tabs_construct (TYPE_CLOSED_TABS);
#line 3016 "DynamicNotebook.c"
}

void
closed_tabs_push (ClosedTabs* self,
                  Tab* tab)
{
	ClosedTabsEntry e = {0};
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	GIcon* _tmp17_;
	GIcon* _tmp18_;
	GraniteWidgetsDroppedDelegate _tmp19_;
	gpointer _tmp19__target;
	ClosedTabsEntry _tmp20_ = {0};
	GeeLinkedList* _tmp21_;
	ClosedTabsEntry _tmp22_;
	GeeLinkedList* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
#line 429 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 429 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 3046 "DynamicNotebook.c"
	{
		GeeLinkedList* _entry_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _entry_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _entry_index = 0;
#line 430 "../src/DynamicNotebook.vala"
		_tmp0_ = self->priv->closed_tabs;
#line 430 "../src/DynamicNotebook.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 430 "../src/DynamicNotebook.vala"
		_entry_list = _tmp1_;
#line 430 "../src/DynamicNotebook.vala"
		_tmp2_ = _entry_list;
#line 430 "../src/DynamicNotebook.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 430 "../src/DynamicNotebook.vala"
		_tmp4_ = _tmp3_;
#line 430 "../src/DynamicNotebook.vala"
		_entry_size = _tmp4_;
#line 430 "../src/DynamicNotebook.vala"
		_entry_index = -1;
#line 430 "../src/DynamicNotebook.vala"
		while (TRUE) {
#line 3074 "DynamicNotebook.c"
			ClosedTabsEntry* entry = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			ClosedTabsEntry* _tmp9_;
			const gchar* _tmp10_;
#line 430 "../src/DynamicNotebook.vala"
			_entry_index = _entry_index + 1;
#line 430 "../src/DynamicNotebook.vala"
			if (!(_entry_index < _entry_size)) {
#line 430 "../src/DynamicNotebook.vala"
				break;
#line 3088 "DynamicNotebook.c"
			}
#line 430 "../src/DynamicNotebook.vala"
			_tmp5_ = _entry_list;
#line 430 "../src/DynamicNotebook.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _entry_index);
#line 430 "../src/DynamicNotebook.vala"
			entry = (ClosedTabsEntry*) _tmp6_;
#line 431 "../src/DynamicNotebook.vala"
			_tmp7_ = tab_get_restore_data (tab);
#line 431 "../src/DynamicNotebook.vala"
			_tmp8_ = _tmp7_;
#line 431 "../src/DynamicNotebook.vala"
			_tmp9_ = entry;
#line 431 "../src/DynamicNotebook.vala"
			_tmp10_ = (*_tmp9_).restore_data;
#line 431 "../src/DynamicNotebook.vala"
			if (g_strcmp0 (_tmp8_, _tmp10_) == 0) {
#line 432 "../src/DynamicNotebook.vala"
				_closed_tabs_entry_free0 (entry);
#line 432 "../src/DynamicNotebook.vala"
				_g_object_unref0 (_entry_list);
#line 432 "../src/DynamicNotebook.vala"
				return;
#line 3112 "DynamicNotebook.c"
			}
#line 430 "../src/DynamicNotebook.vala"
			_closed_tabs_entry_free0 (entry);
#line 3116 "DynamicNotebook.c"
		}
#line 430 "../src/DynamicNotebook.vala"
		_g_object_unref0 (_entry_list);
#line 3120 "DynamicNotebook.c"
	}
#line 435 "../src/DynamicNotebook.vala"
	_tmp11_ = tab_get_label (tab);
#line 435 "../src/DynamicNotebook.vala"
	_tmp12_ = _tmp11_;
#line 435 "../src/DynamicNotebook.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 435 "../src/DynamicNotebook.vala"
	_tmp14_ = tab_get_restore_data (tab);
#line 435 "../src/DynamicNotebook.vala"
	_tmp15_ = _tmp14_;
#line 435 "../src/DynamicNotebook.vala"
	_tmp16_ = g_strdup (_tmp15_);
#line 435 "../src/DynamicNotebook.vala"
	_tmp17_ = tab_get_icon (tab);
#line 435 "../src/DynamicNotebook.vala"
	_tmp18_ = _tmp17_;
#line 435 "../src/DynamicNotebook.vala"
	_tmp19_ = tab->dropped_callback;
#line 435 "../src/DynamicNotebook.vala"
	_tmp19__target = tab->dropped_callback_target;
#line 435 "../src/DynamicNotebook.vala"
	_g_free0 (_tmp20_.label);
#line 435 "../src/DynamicNotebook.vala"
	_tmp20_.label = _tmp13_;
#line 435 "../src/DynamicNotebook.vala"
	_g_free0 (_tmp20_.restore_data);
#line 435 "../src/DynamicNotebook.vala"
	_tmp20_.restore_data = _tmp16_;
#line 435 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp20_.icon);
#line 435 "../src/DynamicNotebook.vala"
	_tmp20_.icon = _tmp18_;
#line 435 "../src/DynamicNotebook.vala"
	_tmp20_.dropped_callback = _tmp19_;
#line 435 "../src/DynamicNotebook.vala"
	_tmp20_.dropped_callback_target = _tmp19__target;
#line 435 "../src/DynamicNotebook.vala"
	e = _tmp20_;
#line 436 "../src/DynamicNotebook.vala"
	_tmp21_ = self->priv->closed_tabs;
#line 436 "../src/DynamicNotebook.vala"
	_tmp22_ = e;
#line 436 "../src/DynamicNotebook.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, &_tmp22_);
#line 439 "../src/DynamicNotebook.vala"
	_tmp23_ = self->priv->closed_tabs;
#line 439 "../src/DynamicNotebook.vala"
	_tmp24_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp23_);
#line 439 "../src/DynamicNotebook.vala"
	_tmp25_ = _tmp24_;
#line 439 "../src/DynamicNotebook.vala"
	_tmp26_ = closed_tabs_get_max_restorable_tabs (self);
#line 439 "../src/DynamicNotebook.vala"
	_tmp27_ = _tmp26_;
#line 439 "../src/DynamicNotebook.vala"
	if (_tmp25_ > _tmp27_) {
#line 3178 "DynamicNotebook.c"
		ClosedTabsEntry* elem = NULL;
		GeeLinkedList* _tmp28_;
		gpointer _tmp29_;
		GraniteWidgetsDroppedDelegate dropped_callback = NULL;
		ClosedTabsEntry* _tmp30_;
		GraniteWidgetsDroppedDelegate _tmp31_;
		gpointer _tmp31__target;
		gpointer dropped_callback_target;
		GraniteWidgetsDroppedDelegate _tmp32_;
		gpointer _tmp32__target;
#line 440 "../src/DynamicNotebook.vala"
		_tmp28_ = self->priv->closed_tabs;
#line 440 "../src/DynamicNotebook.vala"
		_tmp29_ = gee_deque_poll_head ((GeeDeque*) _tmp28_);
#line 440 "../src/DynamicNotebook.vala"
		elem = (ClosedTabsEntry*) _tmp29_;
#line 441 "../src/DynamicNotebook.vala"
		_tmp30_ = elem;
#line 441 "../src/DynamicNotebook.vala"
		_tmp31_ = (*_tmp30_).dropped_callback;
#line 441 "../src/DynamicNotebook.vala"
		_tmp31__target = (*_tmp30_).dropped_callback_target;
#line 441 "../src/DynamicNotebook.vala"
		dropped_callback = _tmp31_;
#line 441 "../src/DynamicNotebook.vala"
		dropped_callback_target = _tmp31__target;
#line 443 "../src/DynamicNotebook.vala"
		_tmp32_ = dropped_callback;
#line 443 "../src/DynamicNotebook.vala"
		_tmp32__target = dropped_callback_target;
#line 443 "../src/DynamicNotebook.vala"
		if (_tmp32_ != NULL) {
#line 3211 "DynamicNotebook.c"
			GraniteWidgetsDroppedDelegate _tmp33_;
			gpointer _tmp33__target;
#line 444 "../src/DynamicNotebook.vala"
			_tmp33_ = dropped_callback;
#line 444 "../src/DynamicNotebook.vala"
			_tmp33__target = dropped_callback_target;
#line 444 "../src/DynamicNotebook.vala"
			_tmp33_ (_tmp33__target);
#line 3220 "DynamicNotebook.c"
		}
#line 439 "../src/DynamicNotebook.vala"
		_closed_tabs_entry_free0 (elem);
#line 3224 "DynamicNotebook.c"
	}
#line 429 "../src/DynamicNotebook.vala"
	closed_tabs_entry_destroy (&e);
#line 3228 "DynamicNotebook.c"
}

void
closed_tabs_pop (ClosedTabs* self,
                 ClosedTabsEntry* result)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeLinkedList* _tmp3_;
	gpointer _tmp4_;
	ClosedTabsEntry* _tmp5_;
	ClosedTabsEntry _tmp6_;
	ClosedTabsEntry _tmp7_ = {0};
	ClosedTabsEntry _tmp8_;
#line 448 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 449 "../src/DynamicNotebook.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 449 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 449 "../src/DynamicNotebook.vala"
	_vala_assert (_tmp2_ > 0, "closed_tabs.size > 0");
#line 450 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->closed_tabs;
#line 450 "../src/DynamicNotebook.vala"
	_tmp4_ = gee_deque_poll_tail ((GeeDeque*) _tmp3_);
#line 450 "../src/DynamicNotebook.vala"
	_tmp5_ = (ClosedTabsEntry*) _tmp4_;
#line 450 "../src/DynamicNotebook.vala"
	_tmp6_ = *_tmp5_;
#line 450 "../src/DynamicNotebook.vala"
	closed_tabs_entry_copy (&_tmp6_, &_tmp7_);
#line 450 "../src/DynamicNotebook.vala"
	_tmp8_ = _tmp7_;
#line 450 "../src/DynamicNotebook.vala"
	_closed_tabs_entry_free0 (_tmp5_);
#line 450 "../src/DynamicNotebook.vala"
	*result = _tmp8_;
#line 450 "../src/DynamicNotebook.vala"
	return;
#line 3272 "DynamicNotebook.c"
}

void
closed_tabs_pick (ClosedTabs* self,
                  const gchar* search,
                  ClosedTabsEntry* result)
{
	ClosedTabsEntry picked = {0};
	ClosedTabsEntry _tmp0_ = {0};
#line 453 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 453 "../src/DynamicNotebook.vala"
	g_return_if_fail (search != NULL);
#line 454 "../src/DynamicNotebook.vala"
	_g_free0 (_tmp0_.label);
#line 454 "../src/DynamicNotebook.vala"
	_tmp0_.label = NULL;
#line 454 "../src/DynamicNotebook.vala"
	_g_free0 (_tmp0_.restore_data);
#line 454 "../src/DynamicNotebook.vala"
	_tmp0_.restore_data = NULL;
#line 454 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp0_.icon);
#line 454 "../src/DynamicNotebook.vala"
	_tmp0_.icon = NULL;
#line 454 "../src/DynamicNotebook.vala"
	picked = _tmp0_;
#line 3300 "DynamicNotebook.c"
	{
		gint i = 0;
#line 456 "../src/DynamicNotebook.vala"
		i = 0;
#line 3305 "DynamicNotebook.c"
		{
			gboolean _tmp1_ = FALSE;
#line 456 "../src/DynamicNotebook.vala"
			_tmp1_ = TRUE;
#line 456 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 3312 "DynamicNotebook.c"
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				ClosedTabsEntry* entry = NULL;
				GeeLinkedList* _tmp6_;
				gpointer _tmp7_;
				ClosedTabsEntry* _tmp8_;
				const gchar* _tmp9_;
#line 456 "../src/DynamicNotebook.vala"
				if (!_tmp1_) {
#line 3323 "DynamicNotebook.c"
					gint _tmp2_;
#line 456 "../src/DynamicNotebook.vala"
					_tmp2_ = i;
#line 456 "../src/DynamicNotebook.vala"
					i = _tmp2_ + 1;
#line 3329 "DynamicNotebook.c"
				}
#line 456 "../src/DynamicNotebook.vala"
				_tmp1_ = FALSE;
#line 456 "../src/DynamicNotebook.vala"
				_tmp3_ = self->priv->closed_tabs;
#line 456 "../src/DynamicNotebook.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 456 "../src/DynamicNotebook.vala"
				_tmp5_ = _tmp4_;
#line 456 "../src/DynamicNotebook.vala"
				if (!(i < _tmp5_)) {
#line 456 "../src/DynamicNotebook.vala"
					break;
#line 3343 "DynamicNotebook.c"
				}
#line 457 "../src/DynamicNotebook.vala"
				_tmp6_ = self->priv->closed_tabs;
#line 457 "../src/DynamicNotebook.vala"
				_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, i);
#line 457 "../src/DynamicNotebook.vala"
				entry = (ClosedTabsEntry*) _tmp7_;
#line 459 "../src/DynamicNotebook.vala"
				_tmp8_ = entry;
#line 459 "../src/DynamicNotebook.vala"
				_tmp9_ = (*_tmp8_).restore_data;
#line 459 "../src/DynamicNotebook.vala"
				if (g_strcmp0 (_tmp9_, search) == 0) {
#line 3357 "DynamicNotebook.c"
					GeeLinkedList* _tmp10_;
					gpointer _tmp11_;
					ClosedTabsEntry* _tmp12_;
					ClosedTabsEntry _tmp13_;
					ClosedTabsEntry _tmp14_ = {0};
#line 460 "../src/DynamicNotebook.vala"
					_tmp10_ = self->priv->closed_tabs;
#line 460 "../src/DynamicNotebook.vala"
					_tmp11_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp10_, i);
#line 460 "../src/DynamicNotebook.vala"
					_tmp12_ = (ClosedTabsEntry*) _tmp11_;
#line 460 "../src/DynamicNotebook.vala"
					_tmp13_ = *_tmp12_;
#line 460 "../src/DynamicNotebook.vala"
					closed_tabs_entry_copy (&_tmp13_, &_tmp14_);
#line 460 "../src/DynamicNotebook.vala"
					closed_tabs_entry_destroy (&picked);
#line 460 "../src/DynamicNotebook.vala"
					picked = _tmp14_;
#line 460 "../src/DynamicNotebook.vala"
					_closed_tabs_entry_free0 (_tmp12_);
#line 461 "../src/DynamicNotebook.vala"
					_closed_tabs_entry_free0 (entry);
#line 461 "../src/DynamicNotebook.vala"
					break;
#line 3383 "DynamicNotebook.c"
				}
#line 456 "../src/DynamicNotebook.vala"
				_closed_tabs_entry_free0 (entry);
#line 3387 "DynamicNotebook.c"
			}
		}
	}
#line 465 "../src/DynamicNotebook.vala"
	*result = picked;
#line 465 "../src/DynamicNotebook.vala"
	return;
#line 3395 "DynamicNotebook.c"
}

gint
closed_tabs_get_max_restorable_tabs (ClosedTabs* self)
{
	gint result;
#line 399 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 399 "../src/DynamicNotebook.vala"
	result = self->priv->_max_restorable_tabs;
#line 399 "../src/DynamicNotebook.vala"
	return result;
#line 3408 "DynamicNotebook.c"
}

void
closed_tabs_set_max_restorable_tabs (ClosedTabs* self,
                                     gint value)
{
#line 400 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 401 "../src/DynamicNotebook.vala"
	_vala_assert (value > 0, "value > 0");
#line 402 "../src/DynamicNotebook.vala"
	self->priv->_max_restorable_tabs = value;
#line 400 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, closed_tabs_properties[CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY]);
#line 3423 "DynamicNotebook.c"
}

gboolean
closed_tabs_get_empty (ClosedTabs* self)
{
	gboolean result;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 424 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 425 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 425 "../src/DynamicNotebook.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 425 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 425 "../src/DynamicNotebook.vala"
	result = _tmp2_ == 0;
#line 425 "../src/DynamicNotebook.vala"
	return result;
#line 3445 "DynamicNotebook.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 472 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 472 "../src/DynamicNotebook.vala"
	return _data8_;
#line 3455 "DynamicNotebook.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 472 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 3465 "DynamicNotebook.c"
		ClosedTabs* self;
#line 472 "../src/DynamicNotebook.vala"
		self = _data8_->self;
#line 472 "../src/DynamicNotebook.vala"
		_closed_tabs_entry_free0 (_data8_->entry);
#line 472 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 472 "../src/DynamicNotebook.vala"
		g_slice_free (Block8Data, _data8_);
#line 3475 "DynamicNotebook.c"
	}
}

static void
_closed_tabs_menu_____lambda17_ (Block8Data* _data8_)
{
	ClosedTabs* self;
	ClosedTabsEntry e = {0};
	ClosedTabsEntry* _tmp0_;
	const gchar* _tmp1_;
	ClosedTabsEntry _tmp2_ = {0};
	ClosedTabsEntry _tmp3_;
	const gchar* _tmp4_;
	ClosedTabsEntry _tmp5_;
	const gchar* _tmp6_;
	ClosedTabsEntry _tmp7_;
	GIcon* _tmp8_;
#line 476 "../src/DynamicNotebook.vala"
	self = _data8_->self;
#line 477 "../src/DynamicNotebook.vala"
	_tmp0_ = _data8_->entry;
#line 477 "../src/DynamicNotebook.vala"
	_tmp1_ = (*_tmp0_).restore_data;
#line 477 "../src/DynamicNotebook.vala"
	closed_tabs_pick (self, _tmp1_, &_tmp2_);
#line 477 "../src/DynamicNotebook.vala"
	e = _tmp2_;
#line 478 "../src/DynamicNotebook.vala"
	_tmp3_ = e;
#line 478 "../src/DynamicNotebook.vala"
	_tmp4_ = _tmp3_.label;
#line 478 "../src/DynamicNotebook.vala"
	_tmp5_ = e;
#line 478 "../src/DynamicNotebook.vala"
	_tmp6_ = _tmp5_.restore_data;
#line 478 "../src/DynamicNotebook.vala"
	_tmp7_ = e;
#line 478 "../src/DynamicNotebook.vala"
	_tmp8_ = _tmp7_.icon;
#line 478 "../src/DynamicNotebook.vala"
	g_signal_emit (self, closed_tabs_signals[CLOSED_TABS_RESTORED_SIGNAL], 0, _tmp4_, _tmp6_, _tmp8_);
#line 476 "../src/DynamicNotebook.vala"
	closed_tabs_entry_destroy (&e);
#line 3519 "DynamicNotebook.c"
}

static void
__closed_tabs_menu_____lambda17__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                         gpointer self)
{
#line 476 "../src/DynamicNotebook.vala"
	_closed_tabs_menu_____lambda17_ (self);
#line 3528 "DynamicNotebook.c"
}

static void
_closed_tabs_menu____lambda18_ (ClosedTabs* self)
{
	GeeLinkedList* _tmp11_;
	{
		GeeLinkedList* _entry_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _entry_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _entry_index = 0;
#line 490 "../src/DynamicNotebook.vala"
		_tmp0_ = self->priv->closed_tabs;
#line 490 "../src/DynamicNotebook.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 490 "../src/DynamicNotebook.vala"
		_entry_list = _tmp1_;
#line 490 "../src/DynamicNotebook.vala"
		_tmp2_ = _entry_list;
#line 490 "../src/DynamicNotebook.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 490 "../src/DynamicNotebook.vala"
		_tmp4_ = _tmp3_;
#line 490 "../src/DynamicNotebook.vala"
		_entry_size = _tmp4_;
#line 490 "../src/DynamicNotebook.vala"
		_entry_index = -1;
#line 490 "../src/DynamicNotebook.vala"
		while (TRUE) {
#line 3562 "DynamicNotebook.c"
			ClosedTabsEntry* entry = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			ClosedTabsEntry* _tmp7_;
			GraniteWidgetsDroppedDelegate _tmp8_;
			gpointer _tmp8__target;
#line 490 "../src/DynamicNotebook.vala"
			_entry_index = _entry_index + 1;
#line 490 "../src/DynamicNotebook.vala"
			if (!(_entry_index < _entry_size)) {
#line 490 "../src/DynamicNotebook.vala"
				break;
#line 3575 "DynamicNotebook.c"
			}
#line 490 "../src/DynamicNotebook.vala"
			_tmp5_ = _entry_list;
#line 490 "../src/DynamicNotebook.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _entry_index);
#line 490 "../src/DynamicNotebook.vala"
			entry = (ClosedTabsEntry*) _tmp6_;
#line 491 "../src/DynamicNotebook.vala"
			_tmp7_ = entry;
#line 491 "../src/DynamicNotebook.vala"
			_tmp8_ = (*_tmp7_).dropped_callback;
#line 491 "../src/DynamicNotebook.vala"
			_tmp8__target = (*_tmp7_).dropped_callback_target;
#line 491 "../src/DynamicNotebook.vala"
			if (_tmp8_ != NULL) {
#line 3591 "DynamicNotebook.c"
				ClosedTabsEntry* _tmp9_;
				GraniteWidgetsDroppedDelegate _tmp10_;
				gpointer _tmp10__target;
#line 492 "../src/DynamicNotebook.vala"
				_tmp9_ = entry;
#line 492 "../src/DynamicNotebook.vala"
				_tmp10_ = (*_tmp9_).dropped_callback;
#line 492 "../src/DynamicNotebook.vala"
				_tmp10__target = (*_tmp9_).dropped_callback_target;
#line 492 "../src/DynamicNotebook.vala"
				_tmp10_ (_tmp10__target);
#line 3603 "DynamicNotebook.c"
			}
#line 490 "../src/DynamicNotebook.vala"
			_closed_tabs_entry_free0 (entry);
#line 3607 "DynamicNotebook.c"
		}
#line 490 "../src/DynamicNotebook.vala"
		_g_object_unref0 (_entry_list);
#line 3611 "DynamicNotebook.c"
	}
#line 496 "../src/DynamicNotebook.vala"
	_tmp11_ = self->priv->closed_tabs;
#line 496 "../src/DynamicNotebook.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp11_);
#line 497 "../src/DynamicNotebook.vala"
	g_signal_emit (self, closed_tabs_signals[CLOSED_TABS_CLEARED_SIGNAL], 0);
#line 3619 "DynamicNotebook.c"
}

static void
__closed_tabs_menu____lambda18__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                        gpointer self)
{
#line 489 "../src/DynamicNotebook.vala"
	_closed_tabs_menu____lambda18_ ((ClosedTabs*) self);
#line 3628 "DynamicNotebook.c"
}

GtkMenu*
closed_tabs_get_menu (ClosedTabs* self)
{
	GtkMenu* result;
	GtkMenu* _menu = NULL;
	GtkMenu* _tmp0_;
	gboolean _tmp14_;
	gboolean _tmp15_;
#line 469 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 470 "../src/DynamicNotebook.vala"
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
#line 470 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp0_);
#line 470 "../src/DynamicNotebook.vala"
	_menu = _tmp0_;
#line 3647 "DynamicNotebook.c"
	{
		GeeLinkedList* _entry_list = NULL;
		GeeLinkedList* _tmp1_;
		GeeLinkedList* _tmp2_;
		gint _entry_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _entry_index = 0;
#line 472 "../src/DynamicNotebook.vala"
		_tmp1_ = self->priv->closed_tabs;
#line 472 "../src/DynamicNotebook.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 472 "../src/DynamicNotebook.vala"
		_entry_list = _tmp2_;
#line 472 "../src/DynamicNotebook.vala"
		_tmp3_ = _entry_list;
#line 472 "../src/DynamicNotebook.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 472 "../src/DynamicNotebook.vala"
		_tmp5_ = _tmp4_;
#line 472 "../src/DynamicNotebook.vala"
		_entry_size = _tmp5_;
#line 472 "../src/DynamicNotebook.vala"
		_entry_index = -1;
#line 472 "../src/DynamicNotebook.vala"
		while (TRUE) {
#line 3675 "DynamicNotebook.c"
			Block8Data* _data8_;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			GtkMenuItem* item = NULL;
			ClosedTabsEntry* _tmp8_;
			const gchar* _tmp9_;
			GtkMenuItem* _tmp10_;
			GtkMenu* _tmp11_;
			GtkMenuItem* _tmp12_;
			GtkMenuItem* _tmp13_;
#line 472 "../src/DynamicNotebook.vala"
			_data8_ = g_slice_new0 (Block8Data);
#line 472 "../src/DynamicNotebook.vala"
			_data8_->_ref_count_ = 1;
#line 472 "../src/DynamicNotebook.vala"
			_data8_->self = g_object_ref (self);
#line 472 "../src/DynamicNotebook.vala"
			_entry_index = _entry_index + 1;
#line 472 "../src/DynamicNotebook.vala"
			if (!(_entry_index < _entry_size)) {
#line 472 "../src/DynamicNotebook.vala"
				block8_data_unref (_data8_);
#line 472 "../src/DynamicNotebook.vala"
				_data8_ = NULL;
#line 472 "../src/DynamicNotebook.vala"
				break;
#line 3702 "DynamicNotebook.c"
			}
#line 472 "../src/DynamicNotebook.vala"
			_tmp6_ = _entry_list;
#line 472 "../src/DynamicNotebook.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _entry_index);
#line 472 "../src/DynamicNotebook.vala"
			_data8_->entry = (ClosedTabsEntry*) _tmp7_;
#line 473 "../src/DynamicNotebook.vala"
			_tmp8_ = _data8_->entry;
#line 473 "../src/DynamicNotebook.vala"
			_tmp9_ = (*_tmp8_).label;
#line 473 "../src/DynamicNotebook.vala"
			_tmp10_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp9_);
#line 473 "../src/DynamicNotebook.vala"
			g_object_ref_sink (_tmp10_);
#line 473 "../src/DynamicNotebook.vala"
			item = _tmp10_;
#line 474 "../src/DynamicNotebook.vala"
			_tmp11_ = _menu;
#line 474 "../src/DynamicNotebook.vala"
			_tmp12_ = item;
#line 474 "../src/DynamicNotebook.vala"
			gtk_menu_shell_prepend ((GtkMenuShell*) _tmp11_, (GtkWidget*) _tmp12_);
#line 476 "../src/DynamicNotebook.vala"
			_tmp13_ = item;
#line 476 "../src/DynamicNotebook.vala"
			g_signal_connect_data (_tmp13_, "activate", (GCallback) __closed_tabs_menu_____lambda17__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 472 "../src/DynamicNotebook.vala"
			_g_object_unref0 (item);
#line 472 "../src/DynamicNotebook.vala"
			block8_data_unref (_data8_);
#line 472 "../src/DynamicNotebook.vala"
			_data8_ = NULL;
#line 3736 "DynamicNotebook.c"
		}
#line 472 "../src/DynamicNotebook.vala"
		_g_object_unref0 (_entry_list);
#line 3740 "DynamicNotebook.c"
	}
#line 482 "../src/DynamicNotebook.vala"
	_tmp14_ = closed_tabs_get_empty (self);
#line 482 "../src/DynamicNotebook.vala"
	_tmp15_ = _tmp14_;
#line 482 "../src/DynamicNotebook.vala"
	if (!_tmp15_) {
#line 3748 "DynamicNotebook.c"
		GtkSeparatorMenuItem* separator = NULL;
		GtkSeparatorMenuItem* _tmp16_;
		GtkMenuItem* item = NULL;
		GtkMenuItem* _tmp17_;
		GtkMenu* _tmp18_;
		GtkSeparatorMenuItem* _tmp19_;
		GtkMenu* _tmp20_;
		GtkMenuItem* _tmp21_;
		GtkMenuItem* _tmp22_;
#line 483 "../src/DynamicNotebook.vala"
		_tmp16_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 483 "../src/DynamicNotebook.vala"
		g_object_ref_sink (_tmp16_);
#line 483 "../src/DynamicNotebook.vala"
		separator = _tmp16_;
#line 484 "../src/DynamicNotebook.vala"
		_tmp17_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Clear All"));
#line 484 "../src/DynamicNotebook.vala"
		g_object_ref_sink (_tmp17_);
#line 484 "../src/DynamicNotebook.vala"
		item = _tmp17_;
#line 486 "../src/DynamicNotebook.vala"
		_tmp18_ = _menu;
#line 486 "../src/DynamicNotebook.vala"
		_tmp19_ = separator;
#line 486 "../src/DynamicNotebook.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp18_, (GtkMenuItem*) _tmp19_);
#line 487 "../src/DynamicNotebook.vala"
		_tmp20_ = _menu;
#line 487 "../src/DynamicNotebook.vala"
		_tmp21_ = item;
#line 487 "../src/DynamicNotebook.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp20_, _tmp21_);
#line 489 "../src/DynamicNotebook.vala"
		_tmp22_ = item;
#line 489 "../src/DynamicNotebook.vala"
		g_signal_connect_object (_tmp22_, "activate", (GCallback) __closed_tabs_menu____lambda18__gtk_menu_item_activate, self, 0);
#line 482 "../src/DynamicNotebook.vala"
		_g_object_unref0 (item);
#line 482 "../src/DynamicNotebook.vala"
		_g_object_unref0 (separator);
#line 3790 "DynamicNotebook.c"
	}
#line 501 "../src/DynamicNotebook.vala"
	result = _menu;
#line 501 "../src/DynamicNotebook.vala"
	return result;
#line 3796 "DynamicNotebook.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING_OBJECT) (gpointer data1, const char* arg_1, const char* arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 392 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 4);
#line 392 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 392 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 392 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 3821 "DynamicNotebook.c"
	} else {
#line 392 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 392 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 3827 "DynamicNotebook.c"
	}
#line 392 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 392 "../src/DynamicNotebook.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_object (param_values + 3), data2);
#line 3833 "DynamicNotebook.c"
}

static GObject *
closed_tabs_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ClosedTabs * self;
	GeeLinkedList* _tmp0_;
#line 419 "../src/DynamicNotebook.vala"
	parent_class = G_OBJECT_CLASS (closed_tabs_parent_class);
#line 419 "../src/DynamicNotebook.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 419 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOSED_TABS, ClosedTabs);
#line 420 "../src/DynamicNotebook.vala"
	_tmp0_ = gee_linked_list_new (CLOSED_TABS_TYPE_ENTRY, (GBoxedCopyFunc) closed_tabs_entry_dup, (GDestroyNotify) closed_tabs_entry_free, NULL, NULL, NULL);
#line 420 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->closed_tabs);
#line 420 "../src/DynamicNotebook.vala"
	self->priv->closed_tabs = _tmp0_;
#line 419 "../src/DynamicNotebook.vala"
	return obj;
#line 3859 "DynamicNotebook.c"
}

void
closed_tabs_entry_copy (const ClosedTabsEntry* self,
                        ClosedTabsEntry* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GraniteWidgetsDroppedDelegate _tmp6_;
	gpointer _tmp6__target;
#line 406 "../src/DynamicNotebook.vala"
	_tmp0_ = (*self).label;
#line 406 "../src/DynamicNotebook.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 406 "../src/DynamicNotebook.vala"
	_g_free0 ((*dest).label);
#line 406 "../src/DynamicNotebook.vala"
	(*dest).label = _tmp1_;
#line 406 "../src/DynamicNotebook.vala"
	_tmp2_ = (*self).restore_data;
#line 406 "../src/DynamicNotebook.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 406 "../src/DynamicNotebook.vala"
	_g_free0 ((*dest).restore_data);
#line 406 "../src/DynamicNotebook.vala"
	(*dest).restore_data = _tmp3_;
#line 406 "../src/DynamicNotebook.vala"
	_tmp4_ = (*self).icon;
#line 406 "../src/DynamicNotebook.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 406 "../src/DynamicNotebook.vala"
	_g_object_unref0 ((*dest).icon);
#line 406 "../src/DynamicNotebook.vala"
	(*dest).icon = _tmp5_;
#line 406 "../src/DynamicNotebook.vala"
	_tmp6_ = (*self).dropped_callback;
#line 406 "../src/DynamicNotebook.vala"
	_tmp6__target = (*self).dropped_callback_target;
#line 406 "../src/DynamicNotebook.vala"
	(*dest).dropped_callback = _tmp6_;
#line 406 "../src/DynamicNotebook.vala"
	(*dest).dropped_callback_target = _tmp6__target;
#line 3906 "DynamicNotebook.c"
}

void
closed_tabs_entry_destroy (ClosedTabsEntry* self)
{
#line 407 "../src/DynamicNotebook.vala"
	_g_free0 ((*self).label);
#line 408 "../src/DynamicNotebook.vala"
	_g_free0 ((*self).restore_data);
#line 409 "../src/DynamicNotebook.vala"
	_g_object_unref0 ((*self).icon);
#line 3918 "DynamicNotebook.c"
}

ClosedTabsEntry*
closed_tabs_entry_dup (const ClosedTabsEntry* self)
{
	ClosedTabsEntry* dup;
#line 406 "../src/DynamicNotebook.vala"
	dup = g_new0 (ClosedTabsEntry, 1);
#line 406 "../src/DynamicNotebook.vala"
	closed_tabs_entry_copy (self, dup);
#line 406 "../src/DynamicNotebook.vala"
	return dup;
#line 3931 "DynamicNotebook.c"
}

void
closed_tabs_entry_free (ClosedTabsEntry* self)
{
#line 406 "../src/DynamicNotebook.vala"
	closed_tabs_entry_destroy (self);
#line 406 "../src/DynamicNotebook.vala"
	g_free (self);
#line 3941 "DynamicNotebook.c"
}

GType
closed_tabs_entry_get_type (void)
{
	static volatile gsize closed_tabs_entry_type_id__volatile = 0;
	if (g_once_init_enter (&closed_tabs_entry_type_id__volatile)) {
		GType closed_tabs_entry_type_id;
		closed_tabs_entry_type_id = g_boxed_type_register_static ("ClosedTabsEntry", (GBoxedCopyFunc) closed_tabs_entry_dup, (GBoxedFreeFunc) closed_tabs_entry_free);
		g_once_init_leave (&closed_tabs_entry_type_id__volatile, closed_tabs_entry_type_id);
	}
	return closed_tabs_entry_type_id__volatile;
}

static void
closed_tabs_class_init (ClosedTabsClass * klass,
                        gpointer klass_data)
{
#line 392 "../src/DynamicNotebook.vala"
	closed_tabs_parent_class = g_type_class_peek_parent (klass);
#line 392 "../src/DynamicNotebook.vala"
	g_type_class_adjust_private_offset (klass, &ClosedTabs_private_offset);
#line 392 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_closed_tabs_get_property;
#line 392 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_closed_tabs_set_property;
#line 392 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->constructor = closed_tabs_constructor;
#line 392 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->finalize = closed_tabs_finalize;
#line 392 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY, closed_tabs_properties[CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY] = g_param_spec_int ("max-restorable-tabs", "max-restorable-tabs", "max-restorable-tabs", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 392 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOSED_TABS_EMPTY_PROPERTY, closed_tabs_properties[CLOSED_TABS_EMPTY_PROPERTY] = g_param_spec_boolean ("empty", "empty", "empty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 392 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOSED_TABS_MENU_PROPERTY, closed_tabs_properties[CLOSED_TABS_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", gtk_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 392 "../src/DynamicNotebook.vala"
	closed_tabs_signals[CLOSED_TABS_RESTORED_SIGNAL] = g_signal_new ("restored", TYPE_CLOSED_TABS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_STRING, g_icon_get_type ());
#line 392 "../src/DynamicNotebook.vala"
	closed_tabs_signals[CLOSED_TABS_CLEARED_SIGNAL] = g_signal_new ("cleared", TYPE_CLOSED_TABS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3982 "DynamicNotebook.c"
}

static void
closed_tabs_instance_init (ClosedTabs * self,
                           gpointer klass)
{
#line 392 "../src/DynamicNotebook.vala"
	self->priv = closed_tabs_get_instance_private (self);
#line 397 "../src/DynamicNotebook.vala"
	self->priv->_max_restorable_tabs = 10;
#line 3993 "DynamicNotebook.c"
}

static void
closed_tabs_finalize (GObject * obj)
{
	ClosedTabs * self;
#line 392 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOSED_TABS, ClosedTabs);
#line 413 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->closed_tabs);
#line 392 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (closed_tabs_parent_class)->finalize (obj);
#line 4006 "DynamicNotebook.c"
}

GType
closed_tabs_get_type (void)
{
	static volatile gsize closed_tabs_type_id__volatile = 0;
	if (g_once_init_enter (&closed_tabs_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ClosedTabsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) closed_tabs_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClosedTabs), 0, (GInstanceInitFunc) closed_tabs_instance_init, NULL };
		GType closed_tabs_type_id;
		closed_tabs_type_id = g_type_register_static (G_TYPE_OBJECT, "ClosedTabs", &g_define_type_info, 0);
		ClosedTabs_private_offset = g_type_add_instance_private (closed_tabs_type_id, sizeof (ClosedTabsPrivate));
		g_once_init_leave (&closed_tabs_type_id__volatile, closed_tabs_type_id);
	}
	return closed_tabs_type_id__volatile;
}

static void
_vala_closed_tabs_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ClosedTabs * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOSED_TABS, ClosedTabs);
#line 392 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 392 "../src/DynamicNotebook.vala"
		case CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY:
#line 392 "../src/DynamicNotebook.vala"
		g_value_set_int (value, closed_tabs_get_max_restorable_tabs (self));
#line 392 "../src/DynamicNotebook.vala"
		break;
#line 392 "../src/DynamicNotebook.vala"
		case CLOSED_TABS_EMPTY_PROPERTY:
#line 392 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, closed_tabs_get_empty (self));
#line 392 "../src/DynamicNotebook.vala"
		break;
#line 392 "../src/DynamicNotebook.vala"
		case CLOSED_TABS_MENU_PROPERTY:
#line 392 "../src/DynamicNotebook.vala"
		g_value_take_object (value, closed_tabs_get_menu (self));
#line 392 "../src/DynamicNotebook.vala"
		break;
#line 4051 "DynamicNotebook.c"
		default:
#line 392 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 392 "../src/DynamicNotebook.vala"
		break;
#line 4057 "DynamicNotebook.c"
	}
}

static void
_vala_closed_tabs_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	ClosedTabs * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOSED_TABS, ClosedTabs);
#line 392 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 392 "../src/DynamicNotebook.vala"
		case CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY:
#line 392 "../src/DynamicNotebook.vala"
		closed_tabs_set_max_restorable_tabs (self, g_value_get_int (value));
#line 392 "../src/DynamicNotebook.vala"
		break;
#line 4077 "DynamicNotebook.c"
		default:
#line 392 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 392 "../src/DynamicNotebook.vala"
		break;
#line 4083 "DynamicNotebook.c"
	}
}

static inline gpointer
dynamic_notebook_get_instance_private (DynamicNotebook* self)
{
	return G_STRUCT_MEMBER_P (self, DynamicNotebook_private_offset);
}

GType
dynamic_notebook_tab_bar_behavior_get_type (void)
{
	static volatile gsize dynamic_notebook_tab_bar_behavior_type_id__volatile = 0;
	if (g_once_init_enter (&dynamic_notebook_tab_bar_behavior_type_id__volatile)) {
		static const GEnumValue values[] = {{DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS, "DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS", "always"}, {DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_SINGLE, "DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_SINGLE", "single"}, {DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_NEVER, "DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_NEVER", "never"}, {0, NULL, NULL}};
		GType dynamic_notebook_tab_bar_behavior_type_id;
		dynamic_notebook_tab_bar_behavior_type_id = g_enum_register_static ("DynamicNotebookTabBarBehavior", values);
		g_once_init_leave (&dynamic_notebook_tab_bar_behavior_type_id__volatile, dynamic_notebook_tab_bar_behavior_type_id);
	}
	return dynamic_notebook_tab_bar_behavior_type_id__volatile;
}

static void
_g_object_unref0_ (gpointer var)
{
#line 673 "../src/DynamicNotebook.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 4111 "DynamicNotebook.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 673 "../src/DynamicNotebook.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 4119 "DynamicNotebook.c"
}

/**
         * Create a new dynamic notebook
         */
DynamicNotebook*
dynamic_notebook_construct (GType object_type)
{
	DynamicNotebook * self = NULL;
#line 744 "../src/DynamicNotebook.vala"
	self = (DynamicNotebook*) g_object_new (object_type, NULL);
#line 744 "../src/DynamicNotebook.vala"
	return self;
#line 4133 "DynamicNotebook.c"
}

DynamicNotebook*
dynamic_notebook_new (void)
{
#line 744 "../src/DynamicNotebook.vala"
	return dynamic_notebook_construct (TYPE_DYNAMIC_NOTEBOOK);
#line 4141 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_switch_page (DynamicNotebook* self,
                                 GtkWidget* page,
                                 guint pagenum)
{
	Tab* new_tab = NULL;
	Tab* _tmp0_;
	Tab* _tmp1_;
	Tab* _tmp2_;
	Tab* _tmp3_;
	Tab* _tmp5_;
	Tab* _tmp6_;
	Tab* _tmp7_;
	Tab* _tmp8_;
	Tab* _tmp9_;
#line 942 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 942 "../src/DynamicNotebook.vala"
	g_return_if_fail (page != NULL);
#line 943 "../src/DynamicNotebook.vala"
	_tmp0_ = tab_page_container_get_tab (IS_TAB_PAGE_CONTAINER (page) ? ((TabPageContainer*) page) : NULL);
#line 943 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 943 "../src/DynamicNotebook.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 943 "../src/DynamicNotebook.vala"
	new_tab = _tmp2_;
#line 946 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->old_tab;
#line 946 "../src/DynamicNotebook.vala"
	if (_tmp3_ != NULL) {
#line 4175 "DynamicNotebook.c"
		Tab* _tmp4_;
#line 947 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->old_tab;
#line 947 "../src/DynamicNotebook.vala"
		tab_set_is_current_tab (_tmp4_, FALSE);
#line 4181 "DynamicNotebook.c"
	}
#line 950 "../src/DynamicNotebook.vala"
	_tmp5_ = new_tab;
#line 950 "../src/DynamicNotebook.vala"
	tab_set_is_current_tab (_tmp5_, TRUE);
#line 952 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->old_tab;
#line 952 "../src/DynamicNotebook.vala"
	_tmp7_ = new_tab;
#line 952 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_SWITCHED_SIGNAL], 0, _tmp6_, _tmp7_);
#line 954 "../src/DynamicNotebook.vala"
	_tmp8_ = new_tab;
#line 954 "../src/DynamicNotebook.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 954 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->old_tab);
#line 954 "../src/DynamicNotebook.vala"
	self->priv->old_tab = _tmp9_;
#line 942 "../src/DynamicNotebook.vala"
	_g_object_unref0 (new_tab);
#line 4203 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_page_added (DynamicNotebook* self,
                                GtkWidget* page,
                                guint pagenum)
{
	Tab* t = NULL;
	Tab* _tmp0_;
	Tab* _tmp1_;
	Tab* _tmp2_;
#line 957 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 957 "../src/DynamicNotebook.vala"
	g_return_if_fail (page != NULL);
#line 958 "../src/DynamicNotebook.vala"
	_tmp0_ = tab_page_container_get_tab (IS_TAB_PAGE_CONTAINER (page) ? ((TabPageContainer*) page) : NULL);
#line 958 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 958 "../src/DynamicNotebook.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 958 "../src/DynamicNotebook.vala"
	t = _tmp2_;
#line 960 "../src/DynamicNotebook.vala"
	dynamic_notebook_insert_callbacks (self, t);
#line 961 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_ADDED_SIGNAL], 0, t);
#line 962 "../src/DynamicNotebook.vala"
	dynamic_notebook_update_tabs_visibility (self);
#line 957 "../src/DynamicNotebook.vala"
	_g_object_unref0 (t);
#line 4235 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_page_removed (DynamicNotebook* self,
                                  GtkWidget* page,
                                  guint pagenum)
{
	Tab* t = NULL;
	Tab* _tmp0_;
	Tab* _tmp1_;
	Tab* _tmp2_;
#line 965 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 965 "../src/DynamicNotebook.vala"
	g_return_if_fail (page != NULL);
#line 966 "../src/DynamicNotebook.vala"
	_tmp0_ = tab_page_container_get_tab (IS_TAB_PAGE_CONTAINER (page) ? ((TabPageContainer*) page) : NULL);
#line 966 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 966 "../src/DynamicNotebook.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 966 "../src/DynamicNotebook.vala"
	t = _tmp2_;
#line 968 "../src/DynamicNotebook.vala"
	dynamic_notebook_remove_callbacks (self, t);
#line 969 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REMOVED_SIGNAL], 0, t);
#line 970 "../src/DynamicNotebook.vala"
	dynamic_notebook_update_tabs_visibility (self);
#line 965 "../src/DynamicNotebook.vala"
	_g_object_unref0 (t);
#line 4267 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_page_reordered (DynamicNotebook* self,
                                    GtkWidget* page,
                                    guint pagenum)
{
	Tab* _tmp0_;
	Tab* _tmp1_;
#line 973 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 973 "../src/DynamicNotebook.vala"
	g_return_if_fail (page != NULL);
#line 974 "../src/DynamicNotebook.vala"
	_tmp0_ = tab_page_container_get_tab (IS_TAB_PAGE_CONTAINER (page) ? ((TabPageContainer*) page) : NULL);
#line 974 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 974 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REORDERED_SIGNAL], 0, _tmp1_, (gint) pagenum);
#line 975 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 4289 "DynamicNotebook.c"
}

static GtkNotebook*
dynamic_notebook_on_create_window (DynamicNotebook* self,
                                   GtkWidget* page,
                                   gint x,
                                   gint y)
{
	GtkNotebook* result = NULL;
	Tab* tab = NULL;
	GtkNotebook* _tmp0_;
	GtkWidget* _tmp1_;
	Tab* _tmp2_;
#line 978 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 978 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 979 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 979 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_notebook_get_tab_label (_tmp0_, page);
#line 979 "../src/DynamicNotebook.vala"
	_tmp2_ = _g_object_ref0 (IS_TAB (_tmp1_) ? ((Tab*) _tmp1_) : NULL);
#line 979 "../src/DynamicNotebook.vala"
	tab = _tmp2_;
#line 980 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_MOVED_SIGNAL], 0, tab, x, y);
#line 981 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 982 "../src/DynamicNotebook.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (NULL, gtk_notebook_get_type (), GtkNotebook);
#line 982 "../src/DynamicNotebook.vala"
	_g_object_unref0 (tab);
#line 982 "../src/DynamicNotebook.vala"
	return result;
#line 4325 "DynamicNotebook.c"
}

static void
dynamic_notebook_recalc_order (DynamicNotebook* self)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gint pinned_tabs = 0;
#line 985 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 986 "../src/DynamicNotebook.vala"
	_tmp1_ = dynamic_notebook_get_n_tabs (self);
#line 986 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 986 "../src/DynamicNotebook.vala"
	if (_tmp2_ == 0) {
#line 986 "../src/DynamicNotebook.vala"
		_tmp0_ = TRUE;
#line 4345 "DynamicNotebook.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 986 "../src/DynamicNotebook.vala"
		_tmp3_ = dynamic_notebook_get_force_left (self);
#line 986 "../src/DynamicNotebook.vala"
		_tmp4_ = _tmp3_;
#line 986 "../src/DynamicNotebook.vala"
		_tmp0_ = !_tmp4_;
#line 4355 "DynamicNotebook.c"
	}
#line 986 "../src/DynamicNotebook.vala"
	if (_tmp0_) {
#line 987 "../src/DynamicNotebook.vala"
		return;
#line 4361 "DynamicNotebook.c"
	}
#line 989 "../src/DynamicNotebook.vala"
	pinned_tabs = 0;
#line 4365 "DynamicNotebook.c"
	{
		gint i = 0;
#line 990 "../src/DynamicNotebook.vala"
		i = 0;
#line 4370 "DynamicNotebook.c"
		{
			gboolean _tmp5_ = FALSE;
#line 990 "../src/DynamicNotebook.vala"
			_tmp5_ = TRUE;
#line 990 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 4377 "DynamicNotebook.c"
				GtkNotebook* _tmp7_;
				GtkNotebook* _tmp8_;
				GtkNotebook* _tmp9_;
				GtkWidget* _tmp10_;
				GtkWidget* _tmp11_;
				gboolean _tmp12_;
				gboolean _tmp13_;
#line 990 "../src/DynamicNotebook.vala"
				if (!_tmp5_) {
#line 4387 "DynamicNotebook.c"
					gint _tmp6_;
#line 990 "../src/DynamicNotebook.vala"
					_tmp6_ = i;
#line 990 "../src/DynamicNotebook.vala"
					i = _tmp6_ + 1;
#line 4393 "DynamicNotebook.c"
				}
#line 990 "../src/DynamicNotebook.vala"
				_tmp5_ = FALSE;
#line 990 "../src/DynamicNotebook.vala"
				_tmp7_ = self->priv->notebook;
#line 990 "../src/DynamicNotebook.vala"
				if (!(i < gtk_notebook_get_n_pages (_tmp7_))) {
#line 990 "../src/DynamicNotebook.vala"
					break;
#line 4403 "DynamicNotebook.c"
				}
#line 991 "../src/DynamicNotebook.vala"
				_tmp8_ = self->priv->notebook;
#line 991 "../src/DynamicNotebook.vala"
				_tmp9_ = self->priv->notebook;
#line 991 "../src/DynamicNotebook.vala"
				_tmp10_ = gtk_notebook_get_nth_page (_tmp9_, i);
#line 991 "../src/DynamicNotebook.vala"
				_tmp11_ = gtk_notebook_get_tab_label (_tmp8_, _tmp10_);
#line 991 "../src/DynamicNotebook.vala"
				_tmp12_ = tab_get_pinned (IS_TAB (_tmp11_) ? ((Tab*) _tmp11_) : NULL);
#line 991 "../src/DynamicNotebook.vala"
				_tmp13_ = _tmp12_;
#line 991 "../src/DynamicNotebook.vala"
				if (_tmp13_) {
#line 4419 "DynamicNotebook.c"
					gint _tmp14_;
#line 992 "../src/DynamicNotebook.vala"
					_tmp14_ = pinned_tabs;
#line 992 "../src/DynamicNotebook.vala"
					pinned_tabs = _tmp14_ + 1;
#line 4425 "DynamicNotebook.c"
				}
			}
		}
	}
	{
		gint p = 0;
#line 996 "../src/DynamicNotebook.vala"
		p = 0;
#line 4434 "DynamicNotebook.c"
		{
			gboolean _tmp15_ = FALSE;
#line 996 "../src/DynamicNotebook.vala"
			_tmp15_ = TRUE;
#line 996 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 4441 "DynamicNotebook.c"
				gint sel = 0;
#line 996 "../src/DynamicNotebook.vala"
				if (!_tmp15_) {
#line 4445 "DynamicNotebook.c"
					gint _tmp16_;
#line 996 "../src/DynamicNotebook.vala"
					_tmp16_ = p;
#line 996 "../src/DynamicNotebook.vala"
					p = _tmp16_ + 1;
#line 4451 "DynamicNotebook.c"
				}
#line 996 "../src/DynamicNotebook.vala"
				_tmp15_ = FALSE;
#line 996 "../src/DynamicNotebook.vala"
				if (!(p < pinned_tabs)) {
#line 996 "../src/DynamicNotebook.vala"
					break;
#line 4459 "DynamicNotebook.c"
				}
#line 997 "../src/DynamicNotebook.vala"
				sel = p;
#line 4463 "DynamicNotebook.c"
				{
					gint i = 0;
#line 998 "../src/DynamicNotebook.vala"
					i = p;
#line 4468 "DynamicNotebook.c"
					{
						gboolean _tmp17_ = FALSE;
#line 998 "../src/DynamicNotebook.vala"
						_tmp17_ = TRUE;
#line 998 "../src/DynamicNotebook.vala"
						while (TRUE) {
#line 4475 "DynamicNotebook.c"
							GtkNotebook* _tmp19_;
							GtkNotebook* _tmp20_;
							GtkNotebook* _tmp21_;
							GtkWidget* _tmp22_;
							GtkWidget* _tmp23_;
							gboolean _tmp24_;
							gboolean _tmp25_;
#line 998 "../src/DynamicNotebook.vala"
							if (!_tmp17_) {
#line 4485 "DynamicNotebook.c"
								gint _tmp18_;
#line 998 "../src/DynamicNotebook.vala"
								_tmp18_ = i;
#line 998 "../src/DynamicNotebook.vala"
								i = _tmp18_ + 1;
#line 4491 "DynamicNotebook.c"
							}
#line 998 "../src/DynamicNotebook.vala"
							_tmp17_ = FALSE;
#line 998 "../src/DynamicNotebook.vala"
							_tmp19_ = self->priv->notebook;
#line 998 "../src/DynamicNotebook.vala"
							if (!(i < gtk_notebook_get_n_pages (_tmp19_))) {
#line 998 "../src/DynamicNotebook.vala"
								break;
#line 4501 "DynamicNotebook.c"
							}
#line 999 "../src/DynamicNotebook.vala"
							_tmp20_ = self->priv->notebook;
#line 999 "../src/DynamicNotebook.vala"
							_tmp21_ = self->priv->notebook;
#line 999 "../src/DynamicNotebook.vala"
							_tmp22_ = gtk_notebook_get_nth_page (_tmp21_, i);
#line 999 "../src/DynamicNotebook.vala"
							_tmp23_ = gtk_notebook_get_tab_label (_tmp20_, _tmp22_);
#line 999 "../src/DynamicNotebook.vala"
							_tmp24_ = tab_get_pinned (IS_TAB (_tmp23_) ? ((Tab*) _tmp23_) : NULL);
#line 999 "../src/DynamicNotebook.vala"
							_tmp25_ = _tmp24_;
#line 999 "../src/DynamicNotebook.vala"
							if (_tmp25_) {
#line 1000 "../src/DynamicNotebook.vala"
								sel = i;
#line 1001 "../src/DynamicNotebook.vala"
								break;
#line 4521 "DynamicNotebook.c"
							}
						}
					}
				}
#line 1005 "../src/DynamicNotebook.vala"
				if (sel != p) {
#line 4528 "DynamicNotebook.c"
					GtkNotebook* _tmp26_;
					GtkNotebook* _tmp27_;
					GtkWidget* _tmp28_;
#line 1006 "../src/DynamicNotebook.vala"
					_tmp26_ = self->priv->notebook;
#line 1006 "../src/DynamicNotebook.vala"
					_tmp27_ = self->priv->notebook;
#line 1006 "../src/DynamicNotebook.vala"
					_tmp28_ = gtk_notebook_get_nth_page (_tmp27_, sel);
#line 1006 "../src/DynamicNotebook.vala"
					gtk_notebook_reorder_child (_tmp26_, _tmp28_, p);
#line 4540 "DynamicNotebook.c"
				}
			}
		}
	}
}

static void
dynamic_notebook_recalc_size (DynamicNotebook* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint pinned_tabs = 0;
	gint unpinned_tabs = 0;
	gint offset = 0;
	GtkNotebook* _tmp30_;
#line 1011 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1012 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_n_tabs (self);
#line 1012 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 1012 "../src/DynamicNotebook.vala"
	if (_tmp1_ == 0) {
#line 1013 "../src/DynamicNotebook.vala"
		return;
#line 4566 "DynamicNotebook.c"
	}
#line 1015 "../src/DynamicNotebook.vala"
	pinned_tabs = 0;
#line 1016 "../src/DynamicNotebook.vala"
	unpinned_tabs = 0;
#line 4572 "DynamicNotebook.c"
	{
		gint i = 0;
#line 1017 "../src/DynamicNotebook.vala"
		i = 0;
#line 4577 "DynamicNotebook.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1017 "../src/DynamicNotebook.vala"
			_tmp2_ = TRUE;
#line 1017 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 4584 "DynamicNotebook.c"
				GtkNotebook* _tmp4_;
				GtkNotebook* _tmp5_;
				GtkNotebook* _tmp6_;
				GtkWidget* _tmp7_;
				GtkWidget* _tmp8_;
				gboolean _tmp9_;
				gboolean _tmp10_;
#line 1017 "../src/DynamicNotebook.vala"
				if (!_tmp2_) {
#line 4594 "DynamicNotebook.c"
					gint _tmp3_;
#line 1017 "../src/DynamicNotebook.vala"
					_tmp3_ = i;
#line 1017 "../src/DynamicNotebook.vala"
					i = _tmp3_ + 1;
#line 4600 "DynamicNotebook.c"
				}
#line 1017 "../src/DynamicNotebook.vala"
				_tmp2_ = FALSE;
#line 1017 "../src/DynamicNotebook.vala"
				_tmp4_ = self->priv->notebook;
#line 1017 "../src/DynamicNotebook.vala"
				if (!(i < gtk_notebook_get_n_pages (_tmp4_))) {
#line 1017 "../src/DynamicNotebook.vala"
					break;
#line 4610 "DynamicNotebook.c"
				}
#line 1018 "../src/DynamicNotebook.vala"
				_tmp5_ = self->priv->notebook;
#line 1018 "../src/DynamicNotebook.vala"
				_tmp6_ = self->priv->notebook;
#line 1018 "../src/DynamicNotebook.vala"
				_tmp7_ = gtk_notebook_get_nth_page (_tmp6_, i);
#line 1018 "../src/DynamicNotebook.vala"
				_tmp8_ = gtk_notebook_get_tab_label (_tmp5_, _tmp7_);
#line 1018 "../src/DynamicNotebook.vala"
				_tmp9_ = tab_get_pinned (IS_TAB (_tmp8_) ? ((Tab*) _tmp8_) : NULL);
#line 1018 "../src/DynamicNotebook.vala"
				_tmp10_ = _tmp9_;
#line 1018 "../src/DynamicNotebook.vala"
				if (_tmp10_) {
#line 4626 "DynamicNotebook.c"
					gint _tmp11_;
#line 1019 "../src/DynamicNotebook.vala"
					_tmp11_ = pinned_tabs;
#line 1019 "../src/DynamicNotebook.vala"
					pinned_tabs = _tmp11_ + 1;
#line 4632 "DynamicNotebook.c"
				} else {
					gint _tmp12_;
#line 1021 "../src/DynamicNotebook.vala"
					_tmp12_ = unpinned_tabs;
#line 1021 "../src/DynamicNotebook.vala"
					unpinned_tabs = _tmp12_ + 1;
#line 4639 "DynamicNotebook.c"
				}
			}
		}
	}
#line 1025 "../src/DynamicNotebook.vala"
	if (unpinned_tabs == 0) {
#line 1026 "../src/DynamicNotebook.vala"
		unpinned_tabs = 1;
#line 4648 "DynamicNotebook.c"
	}
#line 1029 "../src/DynamicNotebook.vala"
	offset = 130;
#line 1030 "../src/DynamicNotebook.vala"
	self->priv->tab_width = ((gtk_widget_get_allocated_width ((GtkWidget*) self) - offset) - (pinned_tabs * DYNAMIC_NOTEBOOK_TAB_WIDTH_PINNED)) / unpinned_tabs;
#line 1031 "../src/DynamicNotebook.vala"
	if (self->priv->tab_width > DYNAMIC_NOTEBOOK_MAX_TAB_WIDTH) {
#line 1032 "../src/DynamicNotebook.vala"
		self->priv->tab_width = DYNAMIC_NOTEBOOK_MAX_TAB_WIDTH;
#line 4658 "DynamicNotebook.c"
	}
#line 1034 "../src/DynamicNotebook.vala"
	if (self->priv->tab_width < 0) {
#line 1035 "../src/DynamicNotebook.vala"
		self->priv->tab_width = 0;
#line 4664 "DynamicNotebook.c"
	}
	{
		gint i = 0;
#line 1037 "../src/DynamicNotebook.vala"
		i = 0;
#line 4670 "DynamicNotebook.c"
		{
			gboolean _tmp13_ = FALSE;
#line 1037 "../src/DynamicNotebook.vala"
			_tmp13_ = TRUE;
#line 1037 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 4677 "DynamicNotebook.c"
				GtkNotebook* _tmp15_;
				GtkNotebook* _tmp16_;
				GtkNotebook* _tmp17_;
				GtkWidget* _tmp18_;
				GtkWidget* _tmp19_;
				GtkNotebook* _tmp20_;
				GtkNotebook* _tmp21_;
				GtkWidget* _tmp22_;
				GtkWidget* _tmp23_;
				gboolean _tmp24_;
				gboolean _tmp25_;
#line 1037 "../src/DynamicNotebook.vala"
				if (!_tmp13_) {
#line 4691 "DynamicNotebook.c"
					gint _tmp14_;
#line 1037 "../src/DynamicNotebook.vala"
					_tmp14_ = i;
#line 1037 "../src/DynamicNotebook.vala"
					i = _tmp14_ + 1;
#line 4697 "DynamicNotebook.c"
				}
#line 1037 "../src/DynamicNotebook.vala"
				_tmp13_ = FALSE;
#line 1037 "../src/DynamicNotebook.vala"
				_tmp15_ = self->priv->notebook;
#line 1037 "../src/DynamicNotebook.vala"
				if (!(i < gtk_notebook_get_n_pages (_tmp15_))) {
#line 1037 "../src/DynamicNotebook.vala"
					break;
#line 4707 "DynamicNotebook.c"
				}
#line 1038 "../src/DynamicNotebook.vala"
				_tmp16_ = self->priv->notebook;
#line 1038 "../src/DynamicNotebook.vala"
				_tmp17_ = self->priv->notebook;
#line 1038 "../src/DynamicNotebook.vala"
				_tmp18_ = gtk_notebook_get_nth_page (_tmp17_, i);
#line 1038 "../src/DynamicNotebook.vala"
				_tmp19_ = gtk_notebook_get_tab_label (_tmp16_, _tmp18_);
#line 1038 "../src/DynamicNotebook.vala"
				g_object_set (_tmp19_, "width-request", self->priv->tab_width, NULL);
#line 1040 "../src/DynamicNotebook.vala"
				_tmp20_ = self->priv->notebook;
#line 1040 "../src/DynamicNotebook.vala"
				_tmp21_ = self->priv->notebook;
#line 1040 "../src/DynamicNotebook.vala"
				_tmp22_ = gtk_notebook_get_nth_page (_tmp21_, i);
#line 1040 "../src/DynamicNotebook.vala"
				_tmp23_ = gtk_notebook_get_tab_label (_tmp20_, _tmp22_);
#line 1040 "../src/DynamicNotebook.vala"
				_tmp24_ = tab_get_pinned (IS_TAB (_tmp23_) ? ((Tab*) _tmp23_) : NULL);
#line 1040 "../src/DynamicNotebook.vala"
				_tmp25_ = _tmp24_;
#line 1040 "../src/DynamicNotebook.vala"
				if (_tmp25_) {
#line 4733 "DynamicNotebook.c"
					GtkNotebook* _tmp26_;
					GtkNotebook* _tmp27_;
					GtkWidget* _tmp28_;
					GtkWidget* _tmp29_;
#line 1041 "../src/DynamicNotebook.vala"
					_tmp26_ = self->priv->notebook;
#line 1041 "../src/DynamicNotebook.vala"
					_tmp27_ = self->priv->notebook;
#line 1041 "../src/DynamicNotebook.vala"
					_tmp28_ = gtk_notebook_get_nth_page (_tmp27_, i);
#line 1041 "../src/DynamicNotebook.vala"
					_tmp29_ = gtk_notebook_get_tab_label (_tmp26_, _tmp28_);
#line 1041 "../src/DynamicNotebook.vala"
					g_object_set (_tmp29_, "width-request", DYNAMIC_NOTEBOOK_TAB_WIDTH_PINNED, NULL);
#line 4748 "DynamicNotebook.c"
				}
			}
		}
	}
#line 1045 "../src/DynamicNotebook.vala"
	_tmp30_ = self->priv->notebook;
#line 1045 "../src/DynamicNotebook.vala"
	gtk_container_resize_children ((GtkContainer*) _tmp30_);
#line 4757 "DynamicNotebook.c"
}

static void
dynamic_notebook_restore_last_tab (DynamicNotebook* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ClosedTabsEntry restored = {0};
	ClosedTabs* _tmp6_;
	ClosedTabsEntry _tmp7_ = {0};
	GtkButton* _tmp8_;
	ClosedTabs* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GtkMenuItem* _tmp12_;
	ClosedTabs* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	ClosedTabsEntry _tmp16_;
	const gchar* _tmp17_;
	ClosedTabsEntry _tmp18_;
	const gchar* _tmp19_;
	ClosedTabsEntry _tmp20_;
	GIcon* _tmp21_;
#line 1048 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1049 "../src/DynamicNotebook.vala"
	_tmp1_ = dynamic_notebook_get_allow_restoring (self);
#line 1049 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 1049 "../src/DynamicNotebook.vala"
	if (!_tmp2_) {
#line 1049 "../src/DynamicNotebook.vala"
		_tmp0_ = TRUE;
#line 4793 "DynamicNotebook.c"
	} else {
		ClosedTabs* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 1049 "../src/DynamicNotebook.vala"
		_tmp3_ = self->priv->closed_tabs;
#line 1049 "../src/DynamicNotebook.vala"
		_tmp4_ = closed_tabs_get_empty (_tmp3_);
#line 1049 "../src/DynamicNotebook.vala"
		_tmp5_ = _tmp4_;
#line 1049 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp5_;
#line 4806 "DynamicNotebook.c"
	}
#line 1049 "../src/DynamicNotebook.vala"
	if (_tmp0_) {
#line 1050 "../src/DynamicNotebook.vala"
		return;
#line 4812 "DynamicNotebook.c"
	}
#line 1052 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->closed_tabs;
#line 1052 "../src/DynamicNotebook.vala"
	closed_tabs_pop (_tmp6_, &_tmp7_);
#line 1052 "../src/DynamicNotebook.vala"
	restored = _tmp7_;
#line 1053 "../src/DynamicNotebook.vala"
	_tmp8_ = self->priv->restore_button;
#line 1053 "../src/DynamicNotebook.vala"
	_tmp9_ = self->priv->closed_tabs;
#line 1053 "../src/DynamicNotebook.vala"
	_tmp10_ = closed_tabs_get_empty (_tmp9_);
#line 1053 "../src/DynamicNotebook.vala"
	_tmp11_ = _tmp10_;
#line 1053 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, !_tmp11_);
#line 1054 "../src/DynamicNotebook.vala"
	_tmp12_ = self->priv->restore_tab_m;
#line 1054 "../src/DynamicNotebook.vala"
	_tmp13_ = self->priv->closed_tabs;
#line 1054 "../src/DynamicNotebook.vala"
	_tmp14_ = closed_tabs_get_empty (_tmp13_);
#line 1054 "../src/DynamicNotebook.vala"
	_tmp15_ = _tmp14_;
#line 1054 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, !_tmp15_);
#line 1055 "../src/DynamicNotebook.vala"
	_tmp16_ = restored;
#line 1055 "../src/DynamicNotebook.vala"
	_tmp17_ = _tmp16_.label;
#line 1055 "../src/DynamicNotebook.vala"
	_tmp18_ = restored;
#line 1055 "../src/DynamicNotebook.vala"
	_tmp19_ = _tmp18_.restore_data;
#line 1055 "../src/DynamicNotebook.vala"
	_tmp20_ = restored;
#line 1055 "../src/DynamicNotebook.vala"
	_tmp21_ = _tmp20_.icon;
#line 1055 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_RESTORED_SIGNAL], 0, _tmp17_, _tmp19_, _tmp21_);
#line 1048 "../src/DynamicNotebook.vala"
	closed_tabs_entry_destroy (&restored);
#line 4856 "DynamicNotebook.c"
}

static void
dynamic_notebook_switch_pin_tab (DynamicNotebook* self,
                                 Tab* tab)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 1058 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1058 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1059 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_allow_pinning (self);
#line 1059 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 1059 "../src/DynamicNotebook.vala"
	if (!_tmp1_) {
#line 1060 "../src/DynamicNotebook.vala"
		return;
#line 4877 "DynamicNotebook.c"
	}
#line 1063 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 1064 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_size (self);
#line 4883 "DynamicNotebook.c"
}

void
dynamic_notebook_remove_tab (DynamicNotebook* self,
                             Tab* tab)
{
	gint pos = 0;
#line 1067 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1067 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1068 "../src/DynamicNotebook.vala"
	pos = dynamic_notebook_get_tab_position (self, tab);
#line 1070 "../src/DynamicNotebook.vala"
	if (pos != -1) {
#line 4899 "DynamicNotebook.c"
		GtkNotebook* _tmp0_;
#line 1071 "../src/DynamicNotebook.vala"
		_tmp0_ = self->priv->notebook;
#line 1071 "../src/DynamicNotebook.vala"
		gtk_notebook_remove_page (_tmp0_, pos);
#line 4905 "DynamicNotebook.c"
	}
}

void
dynamic_notebook_next_page (DynamicNotebook* self)
{
	gint _tmp0_ = 0;
	GtkNotebook* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkNotebook* _tmp4_;
	GtkNotebook* _tmp9_;
#line 1074 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1075 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->notebook;
#line 1075 "../src/DynamicNotebook.vala"
	g_object_get (_tmp1_, "page", &_tmp2_, NULL);
#line 1075 "../src/DynamicNotebook.vala"
	_tmp3_ = _tmp2_;
#line 1075 "../src/DynamicNotebook.vala"
	_tmp4_ = self->priv->notebook;
#line 1075 "../src/DynamicNotebook.vala"
	if ((_tmp3_ + 1) >= gtk_notebook_get_n_pages (_tmp4_)) {
#line 4930 "DynamicNotebook.c"
		GtkNotebook* _tmp5_;
#line 1075 "../src/DynamicNotebook.vala"
		_tmp5_ = self->priv->notebook;
#line 1075 "../src/DynamicNotebook.vala"
		g_object_set (_tmp5_, "page", 0, NULL);
#line 1075 "../src/DynamicNotebook.vala"
		_tmp0_ = 0;
#line 4938 "DynamicNotebook.c"
	} else {
		GtkNotebook* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 1075 "../src/DynamicNotebook.vala"
		_tmp6_ = self->priv->notebook;
#line 1075 "../src/DynamicNotebook.vala"
		g_object_get (_tmp6_, "page", &_tmp7_, NULL);
#line 1075 "../src/DynamicNotebook.vala"
		_tmp8_ = _tmp7_;
#line 1075 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp8_ + 1;
#line 4951 "DynamicNotebook.c"
	}
#line 1075 "../src/DynamicNotebook.vala"
	_tmp9_ = self->priv->notebook;
#line 1075 "../src/DynamicNotebook.vala"
	g_object_set (_tmp9_, "page", _tmp0_, NULL);
#line 4957 "DynamicNotebook.c"
}

void
dynamic_notebook_previous_page (DynamicNotebook* self)
{
	gint _tmp0_ = 0;
	GtkNotebook* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkNotebook* _tmp9_;
#line 1078 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1079 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->notebook;
#line 1079 "../src/DynamicNotebook.vala"
	g_object_get (_tmp1_, "page", &_tmp2_, NULL);
#line 1079 "../src/DynamicNotebook.vala"
	_tmp3_ = _tmp2_;
#line 1079 "../src/DynamicNotebook.vala"
	if ((_tmp3_ - 1) < 0) {
#line 4978 "DynamicNotebook.c"
		GtkNotebook* _tmp4_;
		GtkNotebook* _tmp5_;
#line 1080 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->notebook;
#line 1080 "../src/DynamicNotebook.vala"
		_tmp5_ = self->priv->notebook;
#line 1080 "../src/DynamicNotebook.vala"
		g_object_set (_tmp4_, "page", gtk_notebook_get_n_pages (_tmp5_) - 1, NULL);
#line 1080 "../src/DynamicNotebook.vala"
		_tmp0_ = gtk_notebook_get_n_pages (_tmp5_) - 1;
#line 4989 "DynamicNotebook.c"
	} else {
		GtkNotebook* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 1080 "../src/DynamicNotebook.vala"
		_tmp6_ = self->priv->notebook;
#line 1080 "../src/DynamicNotebook.vala"
		g_object_get (_tmp6_, "page", &_tmp7_, NULL);
#line 1080 "../src/DynamicNotebook.vala"
		_tmp8_ = _tmp7_;
#line 1080 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp8_ - 1;
#line 5002 "DynamicNotebook.c"
	}
#line 1079 "../src/DynamicNotebook.vala"
	_tmp9_ = self->priv->notebook;
#line 1079 "../src/DynamicNotebook.vala"
	g_object_set (_tmp9_, "page", _tmp0_, NULL);
#line 5008 "DynamicNotebook.c"
}

static void
dynamic_notebook_real_show (GtkWidget* base)
{
	DynamicNotebook * self;
	GtkNotebook* _tmp0_;
#line 1083 "../src/DynamicNotebook.vala"
	self = (DynamicNotebook*) base;
#line 1084 "../src/DynamicNotebook.vala"
	GTK_WIDGET_CLASS (dynamic_notebook_parent_class)->show ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_event_box_get_type (), GtkEventBox));
#line 1085 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1085 "../src/DynamicNotebook.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 5024 "DynamicNotebook.c"
}

GList*
dynamic_notebook_get_children (DynamicNotebook* self)
{
	GList* result = NULL;
	GList* list = NULL;
	GtkNotebook* _tmp0_;
	GList* _tmp1_;
#line 1088 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1089 "../src/DynamicNotebook.vala"
	list = NULL;
#line 1091 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1091 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 5042 "DynamicNotebook.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 1091 "../src/DynamicNotebook.vala"
		child_collection = _tmp1_;
#line 1091 "../src/DynamicNotebook.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 5050 "DynamicNotebook.c"
			GtkWidget* child = NULL;
#line 1091 "../src/DynamicNotebook.vala"
			child = (GtkWidget*) child_it->data;
#line 5054 "DynamicNotebook.c"
			{
				GtkWidget* _tmp2_;
				GList* _tmp3_;
				GList* _tmp4_;
				gconstpointer _tmp5_;
				GtkWidget* _tmp6_;
#line 1092 "../src/DynamicNotebook.vala"
				_tmp2_ = child;
#line 1092 "../src/DynamicNotebook.vala"
				_tmp3_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_container_get_type ()) ? ((GtkContainer*) _tmp2_) : NULL);
#line 1092 "../src/DynamicNotebook.vala"
				_tmp4_ = _tmp3_;
#line 1092 "../src/DynamicNotebook.vala"
				_tmp5_ = g_list_nth_data (_tmp4_, (guint) 0);
#line 1092 "../src/DynamicNotebook.vala"
				_tmp6_ = _g_object_ref0 ((GtkWidget*) _tmp5_);
#line 1092 "../src/DynamicNotebook.vala"
				list = g_list_append (list, _tmp6_);
#line 1092 "../src/DynamicNotebook.vala"
				(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
#line 5075 "DynamicNotebook.c"
			}
		}
#line 1091 "../src/DynamicNotebook.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 5080 "DynamicNotebook.c"
	}
#line 1095 "../src/DynamicNotebook.vala"
	result = list;
#line 1095 "../src/DynamicNotebook.vala"
	return result;
#line 5086 "DynamicNotebook.c"
}

gint
dynamic_notebook_get_tab_position (DynamicNotebook* self,
                                   Tab* tab)
{
	gint result = 0;
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
#line 1098 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1098 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (tab != NULL, 0);
#line 1099 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1099 "../src/DynamicNotebook.vala"
	_tmp1_ = tab->page_container;
#line 1099 "../src/DynamicNotebook.vala"
	result = gtk_notebook_page_num (_tmp0_, (GtkWidget*) _tmp1_);
#line 1099 "../src/DynamicNotebook.vala"
	return result;
#line 5108 "DynamicNotebook.c"
}

void
dynamic_notebook_set_tab_position (DynamicNotebook* self,
                                   Tab* tab,
                                   gint position)
{
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
#line 1102 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1102 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1103 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1103 "../src/DynamicNotebook.vala"
	_tmp1_ = tab->page_container;
#line 1103 "../src/DynamicNotebook.vala"
	gtk_notebook_reorder_child (_tmp0_, (GtkWidget*) _tmp1_, position);
#line 1104 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REORDERED_SIGNAL], 0, tab, position);
#line 1105 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 5132 "DynamicNotebook.c"
}

Tab*
dynamic_notebook_get_tab_by_index (DynamicNotebook* self,
                                   gint index)
{
	Tab* result = NULL;
	GtkNotebook* _tmp0_;
	GtkNotebook* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	Tab* _tmp4_;
#line 1108 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1109 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1109 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->notebook;
#line 1109 "../src/DynamicNotebook.vala"
	_tmp2_ = gtk_notebook_get_nth_page (_tmp1_, index);
#line 1109 "../src/DynamicNotebook.vala"
	_tmp3_ = gtk_notebook_get_tab_label (_tmp0_, _tmp2_);
#line 1109 "../src/DynamicNotebook.vala"
	_tmp4_ = _g_object_ref0 (IS_TAB (_tmp3_) ? ((Tab*) _tmp3_) : NULL);
#line 1109 "../src/DynamicNotebook.vala"
	result = _tmp4_;
#line 1109 "../src/DynamicNotebook.vala"
	return result;
#line 5161 "DynamicNotebook.c"
}

Tab*
dynamic_notebook_get_tab_by_widget (DynamicNotebook* self,
                                    GtkWidget* widget)
{
	Tab* result = NULL;
	GtkNotebook* _tmp0_;
	GtkContainer* _tmp1_;
	GtkWidget* _tmp2_;
	Tab* _tmp3_;
#line 1112 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1112 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 1113 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1113 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_widget_get_parent (widget);
#line 1113 "../src/DynamicNotebook.vala"
	_tmp2_ = gtk_notebook_get_tab_label (_tmp0_, (GtkWidget*) _tmp1_);
#line 1113 "../src/DynamicNotebook.vala"
	_tmp3_ = _g_object_ref0 (IS_TAB (_tmp2_) ? ((Tab*) _tmp2_) : NULL);
#line 1113 "../src/DynamicNotebook.vala"
	result = _tmp3_;
#line 1113 "../src/DynamicNotebook.vala"
	return result;
#line 5189 "DynamicNotebook.c"
}

GtkWidget*
dynamic_notebook_get_nth_page (DynamicNotebook* self,
                               gint index)
{
	GtkWidget* result = NULL;
	GtkNotebook* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
#line 1116 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1117 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1117 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_notebook_get_nth_page (_tmp0_, index);
#line 1117 "../src/DynamicNotebook.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1117 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 1117 "../src/DynamicNotebook.vala"
	return result;
#line 5212 "DynamicNotebook.c"
}

guint
dynamic_notebook_insert_tab (DynamicNotebook* self,
                             Tab* tab,
                             gint index)
{
	guint result = 0U;
	GList* _tmp0_;
	GList* _tmp1_;
	gint i = 0;
	GtkNotebook* _tmp7_;
	TabPageContainer* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GtkNotebook* _tmp11_;
	TabPageContainer* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GtkMenuItem* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	GtkMenuItem* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	GtkMenuItem* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
#line 1120 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1120 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (tab != NULL, 0U);
#line 1121 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 1121 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 1121 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (g_list_index (_tmp1_, tab) < 0, 0);
#line 1123 "../src/DynamicNotebook.vala"
	i = 0;
#line 1124 "../src/DynamicNotebook.vala"
	if (index <= -1) {
#line 5259 "DynamicNotebook.c"
		GtkNotebook* _tmp2_;
		TabPageContainer* _tmp3_;
		GtkNotebook* _tmp4_;
#line 1125 "../src/DynamicNotebook.vala"
		_tmp2_ = self->priv->notebook;
#line 1125 "../src/DynamicNotebook.vala"
		_tmp3_ = tab->page_container;
#line 1125 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->notebook;
#line 1125 "../src/DynamicNotebook.vala"
		i = gtk_notebook_insert_page (_tmp2_, (GtkWidget*) _tmp3_, (GtkWidget*) tab, gtk_notebook_get_n_pages (_tmp4_));
#line 5271 "DynamicNotebook.c"
	} else {
		GtkNotebook* _tmp5_;
		TabPageContainer* _tmp6_;
#line 1127 "../src/DynamicNotebook.vala"
		_tmp5_ = self->priv->notebook;
#line 1127 "../src/DynamicNotebook.vala"
		_tmp6_ = tab->page_container;
#line 1127 "../src/DynamicNotebook.vala"
		i = gtk_notebook_insert_page (_tmp5_, (GtkWidget*) _tmp6_, (GtkWidget*) tab, index);
#line 5281 "DynamicNotebook.c"
	}
#line 1129 "../src/DynamicNotebook.vala"
	_tmp7_ = self->priv->notebook;
#line 1129 "../src/DynamicNotebook.vala"
	_tmp8_ = tab->page_container;
#line 1129 "../src/DynamicNotebook.vala"
	_tmp9_ = dynamic_notebook_get_allow_drag (self);
#line 1129 "../src/DynamicNotebook.vala"
	_tmp10_ = _tmp9_;
#line 1129 "../src/DynamicNotebook.vala"
	gtk_notebook_set_tab_reorderable (_tmp7_, (GtkWidget*) _tmp8_, _tmp10_);
#line 1130 "../src/DynamicNotebook.vala"
	_tmp11_ = self->priv->notebook;
#line 1130 "../src/DynamicNotebook.vala"
	_tmp12_ = tab->page_container;
#line 1130 "../src/DynamicNotebook.vala"
	_tmp13_ = dynamic_notebook_get_allow_new_window (self);
#line 1130 "../src/DynamicNotebook.vala"
	_tmp14_ = _tmp13_;
#line 1130 "../src/DynamicNotebook.vala"
	gtk_notebook_set_tab_detachable (_tmp11_, (GtkWidget*) _tmp12_, _tmp14_);
#line 1132 "../src/DynamicNotebook.vala"
	_tmp15_ = tab->duplicate_m;
#line 1132 "../src/DynamicNotebook.vala"
	_tmp16_ = dynamic_notebook_get_allow_duplication (self);
#line 1132 "../src/DynamicNotebook.vala"
	_tmp17_ = _tmp16_;
#line 1132 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp15_, _tmp17_);
#line 1133 "../src/DynamicNotebook.vala"
	_tmp18_ = tab->new_window_m;
#line 1133 "../src/DynamicNotebook.vala"
	_tmp19_ = dynamic_notebook_get_allow_new_window (self);
#line 1133 "../src/DynamicNotebook.vala"
	_tmp20_ = _tmp19_;
#line 1133 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp18_, _tmp20_);
#line 1134 "../src/DynamicNotebook.vala"
	_tmp21_ = tab->pin_m;
#line 1134 "../src/DynamicNotebook.vala"
	_tmp22_ = dynamic_notebook_get_allow_pinning (self);
#line 1134 "../src/DynamicNotebook.vala"
	_tmp23_ = _tmp22_;
#line 1134 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp21_, _tmp23_);
#line 1135 "../src/DynamicNotebook.vala"
	_tmp24_ = dynamic_notebook_get_allow_pinning (self);
#line 1135 "../src/DynamicNotebook.vala"
	_tmp25_ = _tmp24_;
#line 1135 "../src/DynamicNotebook.vala"
	tab_set_pinnable (tab, _tmp25_);
#line 1136 "../src/DynamicNotebook.vala"
	tab_set_pinned (tab, FALSE);
#line 1138 "../src/DynamicNotebook.vala"
	g_object_set ((GtkWidget*) tab, "width-request", self->priv->tab_width, NULL);
#line 1139 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_size (self);
#line 1140 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 1142 "../src/DynamicNotebook.vala"
	_tmp26_ = dynamic_notebook_get_tabs_closable (self);
#line 1142 "../src/DynamicNotebook.vala"
	_tmp27_ = _tmp26_;
#line 1142 "../src/DynamicNotebook.vala"
	if (!_tmp27_) {
#line 1143 "../src/DynamicNotebook.vala"
		tab_set_closable (tab, FALSE);
#line 5349 "DynamicNotebook.c"
	}
#line 1145 "../src/DynamicNotebook.vala"
	result = (guint) i;
#line 1145 "../src/DynamicNotebook.vala"
	return result;
#line 5355 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_tab_closed_tab_closed (Tab* _sender,
                                            gpointer self)
{
#line 1149 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_tab_closed ((DynamicNotebook*) self, _sender);
#line 5364 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_close_others_tab_close_others (Tab* _sender,
                                                    gpointer self)
{
#line 1150 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_close_others ((DynamicNotebook*) self, _sender);
#line 5373 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_new_window_tab_new_window (Tab* _sender,
                                                gpointer self)
{
#line 1151 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_new_window ((DynamicNotebook*) self, _sender);
#line 5382 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_duplicate_tab_duplicate (Tab* _sender,
                                              gpointer self)
{
#line 1152 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_duplicate ((DynamicNotebook*) self, _sender);
#line 5391 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_pin_switch_tab_pin_switch (Tab* _sender,
                                                gpointer self)
{
#line 1153 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_pin_switch ((DynamicNotebook*) self, _sender);
#line 5400 "DynamicNotebook.c"
}

static void
dynamic_notebook_insert_callbacks (DynamicNotebook* self,
                                   Tab* tab)
{
#line 1148 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1148 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1149 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "closed", (GCallback) _dynamic_notebook_on_tab_closed_tab_closed, self, 0);
#line 1150 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "close-others", (GCallback) _dynamic_notebook_on_close_others_tab_close_others, self, 0);
#line 1151 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "new-window", (GCallback) _dynamic_notebook_on_new_window_tab_new_window, self, 0);
#line 1152 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "duplicate", (GCallback) _dynamic_notebook_on_duplicate_tab_duplicate, self, 0);
#line 1153 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "pin-switch", (GCallback) _dynamic_notebook_on_pin_switch_tab_pin_switch, self, 0);
#line 5421 "DynamicNotebook.c"
}

static void
dynamic_notebook_remove_callbacks (DynamicNotebook* self,
                                   Tab* tab)
{
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
#line 1156 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1156 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1157 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("closed", TYPE_TAB, &_tmp0_, NULL, FALSE);
#line 1157 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _dynamic_notebook_on_tab_closed_tab_closed, self);
#line 1158 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("close-others", TYPE_TAB, &_tmp1_, NULL, FALSE);
#line 1158 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _dynamic_notebook_on_close_others_tab_close_others, self);
#line 1159 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("new-window", TYPE_TAB, &_tmp2_, NULL, FALSE);
#line 1159 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _dynamic_notebook_on_new_window_tab_new_window, self);
#line 1160 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("duplicate", TYPE_TAB, &_tmp3_, NULL, FALSE);
#line 1160 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _dynamic_notebook_on_duplicate_tab_duplicate, self);
#line 1161 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("pin-switch", TYPE_TAB, &_tmp4_, NULL, FALSE);
#line 1161 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _dynamic_notebook_on_pin_switch_tab_pin_switch, self);
#line 5457 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_tab_closed (DynamicNotebook* self,
                                Tab* tab)
{
	gint pos = 0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
#line 1164 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1164 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1165 "../src/DynamicNotebook.vala"
	if (g_signal_has_handler_pending (self, g_signal_lookup ("close-tab-requested", TYPE_DYNAMIC_NOTEBOOK), (GQuark) 0, TRUE)) {
#line 5475 "DynamicNotebook.c"
		gboolean sure = FALSE;
		gboolean _tmp0_ = FALSE;
#line 1166 "../src/DynamicNotebook.vala"
		g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_CLOSE_TAB_REQUESTED_SIGNAL], 0, tab, &_tmp0_);
#line 1166 "../src/DynamicNotebook.vala"
		sure = _tmp0_;
#line 1168 "../src/DynamicNotebook.vala"
		if (!sure) {
#line 1169 "../src/DynamicNotebook.vala"
			return;
#line 5486 "DynamicNotebook.c"
		}
	}
#line 1172 "../src/DynamicNotebook.vala"
	pos = dynamic_notebook_get_tab_position (self, tab);
#line 1174 "../src/DynamicNotebook.vala"
	dynamic_notebook_remove_tab (self, tab);
#line 1176 "../src/DynamicNotebook.vala"
	if (pos != -1) {
#line 5495 "DynamicNotebook.c"
		GtkWidget* _tmp2_;
		GtkWidget* _tmp3_;
		GtkContainer* _tmp4_;
#line 1176 "../src/DynamicNotebook.vala"
		_tmp2_ = tab_get_page (tab);
#line 1176 "../src/DynamicNotebook.vala"
		_tmp3_ = _tmp2_;
#line 1176 "../src/DynamicNotebook.vala"
		_tmp4_ = gtk_widget_get_parent (_tmp3_);
#line 1176 "../src/DynamicNotebook.vala"
		_tmp1_ = _tmp4_ != NULL;
#line 5507 "DynamicNotebook.c"
	} else {
#line 1176 "../src/DynamicNotebook.vala"
		_tmp1_ = FALSE;
#line 5511 "DynamicNotebook.c"
	}
#line 1176 "../src/DynamicNotebook.vala"
	if (_tmp1_) {
#line 5515 "DynamicNotebook.c"
		GtkWidget* _tmp5_;
		GtkWidget* _tmp6_;
#line 1177 "../src/DynamicNotebook.vala"
		_tmp5_ = tab_get_page (tab);
#line 1177 "../src/DynamicNotebook.vala"
		_tmp6_ = _tmp5_;
#line 1177 "../src/DynamicNotebook.vala"
		gtk_widget_unparent (_tmp6_);
#line 5524 "DynamicNotebook.c"
	}
#line 1179 "../src/DynamicNotebook.vala"
	_tmp8_ = tab_get_label (tab);
#line 1179 "../src/DynamicNotebook.vala"
	_tmp9_ = _tmp8_;
#line 1179 "../src/DynamicNotebook.vala"
	if (g_strcmp0 (_tmp9_, "") != 0) {
#line 5532 "DynamicNotebook.c"
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 1179 "../src/DynamicNotebook.vala"
		_tmp10_ = tab_get_restore_data (tab);
#line 1179 "../src/DynamicNotebook.vala"
		_tmp11_ = _tmp10_;
#line 1179 "../src/DynamicNotebook.vala"
		_tmp7_ = g_strcmp0 (_tmp11_, "") != 0;
#line 5541 "DynamicNotebook.c"
	} else {
#line 1179 "../src/DynamicNotebook.vala"
		_tmp7_ = FALSE;
#line 5545 "DynamicNotebook.c"
	}
#line 1179 "../src/DynamicNotebook.vala"
	if (_tmp7_) {
#line 5549 "DynamicNotebook.c"
		ClosedTabs* _tmp12_;
		GtkButton* _tmp13_;
		ClosedTabs* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
		GtkMenuItem* _tmp17_;
		ClosedTabs* _tmp18_;
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 1180 "../src/DynamicNotebook.vala"
		_tmp12_ = self->priv->closed_tabs;
#line 1180 "../src/DynamicNotebook.vala"
		closed_tabs_push (_tmp12_, tab);
#line 1181 "../src/DynamicNotebook.vala"
		_tmp13_ = self->priv->restore_button;
#line 1181 "../src/DynamicNotebook.vala"
		_tmp14_ = self->priv->closed_tabs;
#line 1181 "../src/DynamicNotebook.vala"
		_tmp15_ = closed_tabs_get_empty (_tmp14_);
#line 1181 "../src/DynamicNotebook.vala"
		_tmp16_ = _tmp15_;
#line 1181 "../src/DynamicNotebook.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, !_tmp16_);
#line 1182 "../src/DynamicNotebook.vala"
		_tmp17_ = self->priv->restore_tab_m;
#line 1182 "../src/DynamicNotebook.vala"
		_tmp18_ = self->priv->closed_tabs;
#line 1182 "../src/DynamicNotebook.vala"
		_tmp19_ = closed_tabs_get_empty (_tmp18_);
#line 1182 "../src/DynamicNotebook.vala"
		_tmp20_ = _tmp19_;
#line 1182 "../src/DynamicNotebook.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp17_, !_tmp20_);
#line 5583 "DynamicNotebook.c"
	}
}

static void
dynamic_notebook_on_close_others (DynamicNotebook* self,
                                  Tab* tab)
{
	gint num = 0;
#line 1186 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1186 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1187 "../src/DynamicNotebook.vala"
	num = 0;
#line 5598 "DynamicNotebook.c"
	{
		gint j = 0;
#line 1189 "../src/DynamicNotebook.vala"
		j = 0;
#line 5603 "DynamicNotebook.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1189 "../src/DynamicNotebook.vala"
			_tmp0_ = TRUE;
#line 1189 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 5610 "DynamicNotebook.c"
				GList* _tmp2_;
				GList* _tmp3_;
				GList* _tmp4_;
				GList* _tmp5_;
				gconstpointer _tmp6_;
				gint _tmp13_;
				gint _tmp14_;
#line 1189 "../src/DynamicNotebook.vala"
				if (!_tmp0_) {
#line 5620 "DynamicNotebook.c"
					gint _tmp1_;
#line 1189 "../src/DynamicNotebook.vala"
					_tmp1_ = j;
#line 1189 "../src/DynamicNotebook.vala"
					j = _tmp1_ + 1;
#line 5626 "DynamicNotebook.c"
				}
#line 1189 "../src/DynamicNotebook.vala"
				_tmp0_ = FALSE;
#line 1189 "../src/DynamicNotebook.vala"
				_tmp2_ = dynamic_notebook_get_tabs (self);
#line 1189 "../src/DynamicNotebook.vala"
				_tmp3_ = _tmp2_;
#line 1189 "../src/DynamicNotebook.vala"
				if (!(((guint) j) < g_list_length (_tmp3_))) {
#line 1189 "../src/DynamicNotebook.vala"
					break;
#line 5638 "DynamicNotebook.c"
				}
#line 1190 "../src/DynamicNotebook.vala"
				_tmp4_ = dynamic_notebook_get_tabs (self);
#line 1190 "../src/DynamicNotebook.vala"
				_tmp5_ = _tmp4_;
#line 1190 "../src/DynamicNotebook.vala"
				_tmp6_ = g_list_nth_data (_tmp5_, (guint) j);
#line 1190 "../src/DynamicNotebook.vala"
				if (tab != ((Tab*) _tmp6_)) {
#line 5648 "DynamicNotebook.c"
					GList* _tmp7_;
					GList* _tmp8_;
					gconstpointer _tmp9_;
					gint _tmp10_;
					gint _tmp11_;
					gint _tmp12_;
#line 1191 "../src/DynamicNotebook.vala"
					_tmp7_ = dynamic_notebook_get_tabs (self);
#line 1191 "../src/DynamicNotebook.vala"
					_tmp8_ = _tmp7_;
#line 1191 "../src/DynamicNotebook.vala"
					_tmp9_ = g_list_nth_data (_tmp8_, (guint) j);
#line 1191 "../src/DynamicNotebook.vala"
					g_signal_emit ((Tab*) _tmp9_, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 1192 "../src/DynamicNotebook.vala"
					_tmp10_ = dynamic_notebook_get_n_tabs (self);
#line 1192 "../src/DynamicNotebook.vala"
					_tmp11_ = _tmp10_;
#line 1192 "../src/DynamicNotebook.vala"
					if (num == _tmp11_) {
#line 1192 "../src/DynamicNotebook.vala"
						break;
#line 5671 "DynamicNotebook.c"
					}
#line 1193 "../src/DynamicNotebook.vala"
					_tmp12_ = j;
#line 1193 "../src/DynamicNotebook.vala"
					j = _tmp12_ - 1;
#line 5677 "DynamicNotebook.c"
				}
#line 1196 "../src/DynamicNotebook.vala"
				_tmp13_ = dynamic_notebook_get_n_tabs (self);
#line 1196 "../src/DynamicNotebook.vala"
				_tmp14_ = _tmp13_;
#line 1196 "../src/DynamicNotebook.vala"
				num = _tmp14_;
#line 5685 "DynamicNotebook.c"
			}
		}
	}
}

static void
dynamic_notebook_on_new_window (DynamicNotebook* self,
                                Tab* tab)
{
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
	GtkNotebook* _tmp2_ = NULL;
#line 1200 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1200 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1201 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1201 "../src/DynamicNotebook.vala"
	_tmp1_ = tab->page_container;
#line 1201 "../src/DynamicNotebook.vala"
	g_signal_emit_by_name (_tmp0_, "create-window", (GtkWidget*) _tmp1_, 0, 0, &_tmp2_);
#line 5708 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_duplicate (DynamicNotebook* self,
                               Tab* tab)
{
#line 1204 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1204 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1205 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_DUPLICATED_SIGNAL], 0, tab);
#line 5721 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_pin_switch (DynamicNotebook* self,
                                Tab* tab)
{
#line 1208 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1208 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1209 "../src/DynamicNotebook.vala"
	dynamic_notebook_switch_pin_tab (self, tab);
#line 5734 "DynamicNotebook.c"
}

static void
dynamic_notebook_update_tabs_visibility (DynamicNotebook* self)
{
	DynamicNotebookTabBarBehavior _tmp0_;
#line 1212 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1213 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_tab_bar_behavior;
#line 1213 "../src/DynamicNotebook.vala"
	if (_tmp0_ == DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_SINGLE) {
#line 5747 "DynamicNotebook.c"
		GtkNotebook* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 1214 "../src/DynamicNotebook.vala"
		_tmp1_ = self->priv->notebook;
#line 1214 "../src/DynamicNotebook.vala"
		_tmp2_ = dynamic_notebook_get_n_tabs (self);
#line 1214 "../src/DynamicNotebook.vala"
		_tmp3_ = _tmp2_;
#line 1214 "../src/DynamicNotebook.vala"
		gtk_notebook_set_show_tabs (_tmp1_, _tmp3_ > 1);
#line 5759 "DynamicNotebook.c"
	} else {
		DynamicNotebookTabBarBehavior _tmp4_;
#line 1215 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->_tab_bar_behavior;
#line 1215 "../src/DynamicNotebook.vala"
		if (_tmp4_ == DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_NEVER) {
#line 5766 "DynamicNotebook.c"
			GtkNotebook* _tmp5_;
#line 1216 "../src/DynamicNotebook.vala"
			_tmp5_ = self->priv->notebook;
#line 1216 "../src/DynamicNotebook.vala"
			gtk_notebook_set_show_tabs (_tmp5_, FALSE);
#line 5772 "DynamicNotebook.c"
		} else {
			DynamicNotebookTabBarBehavior _tmp6_;
#line 1217 "../src/DynamicNotebook.vala"
			_tmp6_ = self->priv->_tab_bar_behavior;
#line 1217 "../src/DynamicNotebook.vala"
			if (_tmp6_ == DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS) {
#line 5779 "DynamicNotebook.c"
				GtkNotebook* _tmp7_;
#line 1218 "../src/DynamicNotebook.vala"
				_tmp7_ = self->priv->notebook;
#line 1218 "../src/DynamicNotebook.vala"
				gtk_notebook_set_show_tabs (_tmp7_, TRUE);
#line 5785 "DynamicNotebook.c"
			}
		}
	}
}

gint
dynamic_notebook_get_n_tabs (DynamicNotebook* self)
{
	gint result;
	GtkNotebook* _tmp0_;
#line 517 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 517 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 517 "../src/DynamicNotebook.vala"
	result = gtk_notebook_get_n_pages (_tmp0_);
#line 517 "../src/DynamicNotebook.vala"
	return result;
#line 5804 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_show_tabs (DynamicNotebook* self)
{
	gboolean result;
	GtkNotebook* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 524 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 524 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 524 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_notebook_get_show_tabs (_tmp0_);
#line 524 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 524 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 524 "../src/DynamicNotebook.vala"
	return result;
#line 5826 "DynamicNotebook.c"
}

void
dynamic_notebook_set_show_tabs (DynamicNotebook* self,
                                gboolean value)
{
	GtkNotebook* _tmp0_;
#line 525 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 525 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 525 "../src/DynamicNotebook.vala"
	gtk_notebook_set_show_tabs (_tmp0_, value);
#line 525 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY]);
#line 5842 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_show_icons (DynamicNotebook* self)
{
	gboolean result;
#line 534 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 534 "../src/DynamicNotebook.vala"
	result = self->priv->_show_icons;
#line 534 "../src/DynamicNotebook.vala"
	return result;
#line 5855 "DynamicNotebook.c"
}

void
dynamic_notebook_set_show_icons (DynamicNotebook* self,
                                 gboolean value)
{
#line 535 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 536 "../src/DynamicNotebook.vala"
	self->priv->_show_icons = value;
#line 535 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY]);
#line 5868 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_tabs_closable (DynamicNotebook* self)
{
	gboolean result;
#line 545 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 545 "../src/DynamicNotebook.vala"
	result = self->priv->_tabs_closable;
#line 545 "../src/DynamicNotebook.vala"
	return result;
#line 5881 "DynamicNotebook.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 546 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 546 "../src/DynamicNotebook.vala"
	return _data9_;
#line 5891 "DynamicNotebook.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 546 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 5901 "DynamicNotebook.c"
		DynamicNotebook* self;
#line 546 "../src/DynamicNotebook.vala"
		self = _data9_->self;
#line 546 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 546 "../src/DynamicNotebook.vala"
		g_slice_free (Block9Data, _data9_);
#line 5909 "DynamicNotebook.c"
	}
}

static void
_dynamic_notebook_tabs_closable____lambda21_ (Block9Data* _data9_,
                                              Tab* t)
{
	DynamicNotebook* self;
#line 548 "../src/DynamicNotebook.vala"
	self = _data9_->self;
#line 548 "../src/DynamicNotebook.vala"
	g_return_if_fail (t != NULL);
#line 549 "../src/DynamicNotebook.vala"
	tab_set_closable (t, _data9_->value);
#line 5924 "DynamicNotebook.c"
}

static void
__dynamic_notebook_tabs_closable____lambda21__gfunc (gconstpointer data,
                                                     gpointer self)
{
#line 548 "../src/DynamicNotebook.vala"
	_dynamic_notebook_tabs_closable____lambda21_ (self, (Tab*) data);
#line 5933 "DynamicNotebook.c"
}

void
dynamic_notebook_set_tabs_closable (DynamicNotebook* self,
                                    gboolean value)
{
	Block9Data* _data9_;
#line 546 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 546 "../src/DynamicNotebook.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 546 "../src/DynamicNotebook.vala"
	_data9_->_ref_count_ = 1;
#line 546 "../src/DynamicNotebook.vala"
	_data9_->self = g_object_ref (self);
#line 546 "../src/DynamicNotebook.vala"
	_data9_->value = value;
#line 547 "../src/DynamicNotebook.vala"
	if (_data9_->value != self->priv->_tabs_closable) {
#line 5953 "DynamicNotebook.c"
		GList* _tmp0_;
		GList* _tmp1_;
#line 548 "../src/DynamicNotebook.vala"
		_tmp0_ = dynamic_notebook_get_tabs (self);
#line 548 "../src/DynamicNotebook.vala"
		_tmp1_ = _tmp0_;
#line 548 "../src/DynamicNotebook.vala"
		g_list_foreach (_tmp1_, __dynamic_notebook_tabs_closable____lambda21__gfunc, _data9_);
#line 5962 "DynamicNotebook.c"
	}
#line 551 "../src/DynamicNotebook.vala"
	self->priv->_tabs_closable = _data9_->value;
#line 546 "../src/DynamicNotebook.vala"
	block9_data_unref (_data9_);
#line 546 "../src/DynamicNotebook.vala"
	_data9_ = NULL;
#line 546 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY]);
#line 5972 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_allow_drag (DynamicNotebook* self)
{
	gboolean result;
#line 560 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 560 "../src/DynamicNotebook.vala"
	result = self->priv->_allow_drag;
#line 560 "../src/DynamicNotebook.vala"
	return result;
#line 5985 "DynamicNotebook.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 561 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 561 "../src/DynamicNotebook.vala"
	return _data10_;
#line 5995 "DynamicNotebook.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 561 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 6005 "DynamicNotebook.c"
		DynamicNotebook* self;
#line 561 "../src/DynamicNotebook.vala"
		self = _data10_->self;
#line 561 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 561 "../src/DynamicNotebook.vala"
		g_slice_free (Block10Data, _data10_);
#line 6013 "DynamicNotebook.c"
	}
}

static void
_dynamic_notebook_allow_drag___lambda19_ (Block10Data* _data10_,
                                          Tab* t)
{
	DynamicNotebook* self;
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
#line 563 "../src/DynamicNotebook.vala"
	self = _data10_->self;
#line 563 "../src/DynamicNotebook.vala"
	g_return_if_fail (t != NULL);
#line 564 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 564 "../src/DynamicNotebook.vala"
	_tmp1_ = t->page_container;
#line 564 "../src/DynamicNotebook.vala"
	gtk_notebook_set_tab_reorderable (_tmp0_, (GtkWidget*) _tmp1_, _data10_->value);
#line 6034 "DynamicNotebook.c"
}

static void
__dynamic_notebook_allow_drag___lambda19__gfunc (gconstpointer data,
                                                 gpointer self)
{
#line 563 "../src/DynamicNotebook.vala"
	_dynamic_notebook_allow_drag___lambda19_ (self, (Tab*) data);
#line 6043 "DynamicNotebook.c"
}

void
dynamic_notebook_set_allow_drag (DynamicNotebook* self,
                                 gboolean value)
{
	Block10Data* _data10_;
	GList* _tmp0_;
	GList* _tmp1_;
#line 561 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 561 "../src/DynamicNotebook.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 561 "../src/DynamicNotebook.vala"
	_data10_->_ref_count_ = 1;
#line 561 "../src/DynamicNotebook.vala"
	_data10_->self = g_object_ref (self);
#line 561 "../src/DynamicNotebook.vala"
	_data10_->value = value;
#line 562 "../src/DynamicNotebook.vala"
	self->priv->_allow_drag = _data10_->value;
#line 563 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 563 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 563 "../src/DynamicNotebook.vala"
	g_list_foreach (_tmp1_, __dynamic_notebook_allow_drag___lambda19__gfunc, _data10_);
#line 561 "../src/DynamicNotebook.vala"
	block10_data_unref (_data10_);
#line 561 "../src/DynamicNotebook.vala"
	_data10_ = NULL;
#line 561 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY]);
#line 6077 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_allow_new_window (DynamicNotebook* self)
{
	gboolean result;
#line 574 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 574 "../src/DynamicNotebook.vala"
	result = self->priv->_allow_new_window;
#line 574 "../src/DynamicNotebook.vala"
	return result;
#line 6090 "DynamicNotebook.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 575 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 575 "../src/DynamicNotebook.vala"
	return _data11_;
#line 6100 "DynamicNotebook.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 575 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 6110 "DynamicNotebook.c"
		DynamicNotebook* self;
#line 575 "../src/DynamicNotebook.vala"
		self = _data11_->self;
#line 575 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 575 "../src/DynamicNotebook.vala"
		g_slice_free (Block11Data, _data11_);
#line 6118 "DynamicNotebook.c"
	}
}

static void
_dynamic_notebook_allow_new_window___lambda20_ (Block11Data* _data11_,
                                                Tab* t)
{
	DynamicNotebook* self;
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
#line 577 "../src/DynamicNotebook.vala"
	self = _data11_->self;
#line 577 "../src/DynamicNotebook.vala"
	g_return_if_fail (t != NULL);
#line 578 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 578 "../src/DynamicNotebook.vala"
	_tmp1_ = t->page_container;
#line 578 "../src/DynamicNotebook.vala"
	gtk_notebook_set_tab_detachable (_tmp0_, (GtkWidget*) _tmp1_, _data11_->value);
#line 6139 "DynamicNotebook.c"
}

static void
__dynamic_notebook_allow_new_window___lambda20__gfunc (gconstpointer data,
                                                       gpointer self)
{
#line 577 "../src/DynamicNotebook.vala"
	_dynamic_notebook_allow_new_window___lambda20_ (self, (Tab*) data);
#line 6148 "DynamicNotebook.c"
}

void
dynamic_notebook_set_allow_new_window (DynamicNotebook* self,
                                       gboolean value)
{
	Block11Data* _data11_;
	GList* _tmp0_;
	GList* _tmp1_;
#line 575 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 575 "../src/DynamicNotebook.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 575 "../src/DynamicNotebook.vala"
	_data11_->_ref_count_ = 1;
#line 575 "../src/DynamicNotebook.vala"
	_data11_->self = g_object_ref (self);
#line 575 "../src/DynamicNotebook.vala"
	_data11_->value = value;
#line 576 "../src/DynamicNotebook.vala"
	self->priv->_allow_new_window = _data11_->value;
#line 577 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 577 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 577 "../src/DynamicNotebook.vala"
	g_list_foreach (_tmp1_, __dynamic_notebook_allow_new_window___lambda20__gfunc, _data11_);
#line 575 "../src/DynamicNotebook.vala"
	block11_data_unref (_data11_);
#line 575 "../src/DynamicNotebook.vala"
	_data11_ = NULL;
#line 575 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY]);
#line 6182 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_allow_duplication (DynamicNotebook* self)
{
	gboolean result;
#line 588 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 588 "../src/DynamicNotebook.vala"
	result = self->priv->_allow_duplication;
#line 588 "../src/DynamicNotebook.vala"
	return result;
#line 6195 "DynamicNotebook.c"
}

void
dynamic_notebook_set_allow_duplication (DynamicNotebook* self,
                                        gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 589 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 590 "../src/DynamicNotebook.vala"
	self->priv->_allow_duplication = value;
#line 592 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 592 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 6212 "DynamicNotebook.c"
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
#line 592 "../src/DynamicNotebook.vala"
		tab_collection = _tmp1_;
#line 592 "../src/DynamicNotebook.vala"
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
#line 6220 "DynamicNotebook.c"
			Tab* _tmp2_;
			Tab* tab = NULL;
#line 592 "../src/DynamicNotebook.vala"
			_tmp2_ = _g_object_ref0 ((Tab*) tab_it->data);
#line 592 "../src/DynamicNotebook.vala"
			tab = _tmp2_;
#line 6227 "DynamicNotebook.c"
			{
				Tab* _tmp3_;
				GtkMenuItem* _tmp4_;
#line 593 "../src/DynamicNotebook.vala"
				_tmp3_ = tab;
#line 593 "../src/DynamicNotebook.vala"
				_tmp4_ = _tmp3_->duplicate_m;
#line 593 "../src/DynamicNotebook.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp4_, value);
#line 592 "../src/DynamicNotebook.vala"
				_g_object_unref0 (tab);
#line 6239 "DynamicNotebook.c"
			}
		}
	}
#line 589 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY]);
#line 6245 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_allow_restoring (DynamicNotebook* self)
{
	gboolean result;
#line 603 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 603 "../src/DynamicNotebook.vala"
	result = self->priv->_allow_restoring;
#line 603 "../src/DynamicNotebook.vala"
	return result;
#line 6258 "DynamicNotebook.c"
}

void
dynamic_notebook_set_allow_restoring (DynamicNotebook* self,
                                      gboolean value)
{
	GtkMenuItem* _tmp0_;
	GtkButton* _tmp1_;
#line 604 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 605 "../src/DynamicNotebook.vala"
	self->priv->_allow_restoring = value;
#line 606 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->restore_tab_m;
#line 606 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, value);
#line 607 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->restore_button;
#line 607 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, value);
#line 604 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY]);
#line 6281 "DynamicNotebook.c"
}

gint
dynamic_notebook_get_max_restorable_tabs (DynamicNotebook* self)
{
	gint result;
	ClosedTabs* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 616 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 616 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 616 "../src/DynamicNotebook.vala"
	_tmp1_ = closed_tabs_get_max_restorable_tabs (_tmp0_);
#line 616 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 616 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 616 "../src/DynamicNotebook.vala"
	return result;
#line 6303 "DynamicNotebook.c"
}

void
dynamic_notebook_set_max_restorable_tabs (DynamicNotebook* self,
                                          gint value)
{
	ClosedTabs* _tmp0_;
#line 617 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 617 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 617 "../src/DynamicNotebook.vala"
	closed_tabs_set_max_restorable_tabs (_tmp0_, value);
#line 617 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY]);
#line 6319 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_add_button_visible (DynamicNotebook* self)
{
	gboolean result;
#line 625 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 625 "../src/DynamicNotebook.vala"
	result = self->priv->_add_button_visible;
#line 625 "../src/DynamicNotebook.vala"
	return result;
#line 6332 "DynamicNotebook.c"
}

void
dynamic_notebook_set_add_button_visible (DynamicNotebook* self,
                                         gboolean value)
{
#line 626 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 627 "../src/DynamicNotebook.vala"
	if (value != self->priv->_add_button_visible) {
#line 6343 "DynamicNotebook.c"
		GtkMenuItem* _tmp4_;
#line 628 "../src/DynamicNotebook.vala"
		if (self->priv->_add_button_visible) {
#line 6347 "DynamicNotebook.c"
			GtkNotebook* _tmp0_;
			GtkButton* _tmp1_;
#line 629 "../src/DynamicNotebook.vala"
			_tmp0_ = self->priv->notebook;
#line 629 "../src/DynamicNotebook.vala"
			_tmp1_ = self->priv->add_button;
#line 629 "../src/DynamicNotebook.vala"
			gtk_container_remove ((GtkContainer*) _tmp0_, (GtkWidget*) _tmp1_);
#line 6356 "DynamicNotebook.c"
		} else {
			GtkNotebook* _tmp2_;
			GtkButton* _tmp3_;
#line 631 "../src/DynamicNotebook.vala"
			_tmp2_ = self->priv->notebook;
#line 631 "../src/DynamicNotebook.vala"
			_tmp3_ = self->priv->add_button;
#line 631 "../src/DynamicNotebook.vala"
			gtk_notebook_set_action_widget (_tmp2_, (GtkWidget*) _tmp3_, GTK_PACK_START);
#line 6366 "DynamicNotebook.c"
		}
#line 634 "../src/DynamicNotebook.vala"
		self->priv->_add_button_visible = value;
#line 635 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->new_tab_m;
#line 635 "../src/DynamicNotebook.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, value);
#line 6374 "DynamicNotebook.c"
	}
#line 626 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY]);
#line 6378 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_allow_pinning (DynamicNotebook* self)
{
	gboolean result;
#line 642 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 642 "../src/DynamicNotebook.vala"
	result = self->priv->_allow_pinning;
#line 642 "../src/DynamicNotebook.vala"
	return result;
#line 6391 "DynamicNotebook.c"
}

void
dynamic_notebook_set_allow_pinning (DynamicNotebook* self,
                                    gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 643 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 644 "../src/DynamicNotebook.vala"
	self->priv->_allow_pinning = value;
#line 646 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 646 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 6408 "DynamicNotebook.c"
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
#line 646 "../src/DynamicNotebook.vala"
		tab_collection = _tmp1_;
#line 646 "../src/DynamicNotebook.vala"
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
#line 6416 "DynamicNotebook.c"
			Tab* _tmp2_;
			Tab* tab = NULL;
#line 646 "../src/DynamicNotebook.vala"
			_tmp2_ = _g_object_ref0 ((Tab*) tab_it->data);
#line 646 "../src/DynamicNotebook.vala"
			tab = _tmp2_;
#line 6423 "DynamicNotebook.c"
			{
				Tab* _tmp3_;
#line 647 "../src/DynamicNotebook.vala"
				_tmp3_ = tab;
#line 647 "../src/DynamicNotebook.vala"
				tab_set_pinnable (_tmp3_, value);
#line 646 "../src/DynamicNotebook.vala"
				_g_object_unref0 (tab);
#line 6432 "DynamicNotebook.c"
			}
		}
	}
#line 643 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY]);
#line 6438 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_force_left (DynamicNotebook* self)
{
	gboolean result;
#line 654 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 654 "../src/DynamicNotebook.vala"
	result = self->priv->_force_left;
#line 654 "../src/DynamicNotebook.vala"
	return result;
#line 6451 "DynamicNotebook.c"
}

void
dynamic_notebook_set_force_left (DynamicNotebook* self,
                                 gboolean value)
{
#line 655 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 655 "../src/DynamicNotebook.vala"
	self->priv->_force_left = value;
#line 655 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY]);
#line 6464 "DynamicNotebook.c"
}

const gchar*
dynamic_notebook_get_add_button_tooltip (DynamicNotebook* self)
{
	const gchar* result;
	GtkButton* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
#line 662 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 662 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->add_button;
#line 662 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_widget_get_tooltip_text ((GtkWidget*) _tmp0_);
#line 662 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 662 "../src/DynamicNotebook.vala"
	_g_free0 (self->priv->_add_button_tooltip);
#line 662 "../src/DynamicNotebook.vala"
	self->priv->_add_button_tooltip = _tmp2_;
#line 662 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->_add_button_tooltip;
#line 662 "../src/DynamicNotebook.vala"
	result = _tmp3_;
#line 662 "../src/DynamicNotebook.vala"
	return result;
#line 6493 "DynamicNotebook.c"
}

void
dynamic_notebook_set_add_button_tooltip (DynamicNotebook* self,
                                         const gchar* value)
{
	GtkButton* _tmp0_;
#line 663 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 663 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->add_button;
#line 663 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp0_, value);
#line 663 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY]);
#line 6509 "DynamicNotebook.c"
}

Tab*
dynamic_notebook_get_current (DynamicNotebook* self)
{
	Tab* result;
	GList* _tmp0_;
	GList* _tmp1_;
	GtkNotebook* _tmp2_;
	gconstpointer _tmp3_;
#line 669 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 669 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 669 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 669 "../src/DynamicNotebook.vala"
	_tmp2_ = self->priv->notebook;
#line 669 "../src/DynamicNotebook.vala"
	_tmp3_ = g_list_nth_data (_tmp1_, (guint) gtk_notebook_get_current_page (_tmp2_));
#line 669 "../src/DynamicNotebook.vala"
	result = (Tab*) _tmp3_;
#line 669 "../src/DynamicNotebook.vala"
	return result;
#line 6534 "DynamicNotebook.c"
}

void
dynamic_notebook_set_current (DynamicNotebook* self,
                              Tab* value)
{
	GtkNotebook* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 670 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 670 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 670 "../src/DynamicNotebook.vala"
	_tmp1_ = dynamic_notebook_get_tabs (self);
#line 670 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 670 "../src/DynamicNotebook.vala"
	gtk_notebook_set_current_page (_tmp0_, g_list_index (_tmp2_, value));
#line 670 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_CURRENT_PROPERTY]);
#line 6556 "DynamicNotebook.c"
}

GList*
dynamic_notebook_get_tabs (DynamicNotebook* self)
{
	GList* result;
	GList* _tmp9_;
#line 675 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 676 "../src/DynamicNotebook.vala"
	(self->priv->_tabs == NULL) ? NULL : (self->priv->_tabs = (_g_list_free__g_object_unref0_ (self->priv->_tabs), NULL));
#line 676 "../src/DynamicNotebook.vala"
	self->priv->_tabs = NULL;
#line 6570 "DynamicNotebook.c"
	{
		gint i = 0;
#line 677 "../src/DynamicNotebook.vala"
		i = 0;
#line 6575 "DynamicNotebook.c"
		{
			gboolean _tmp0_ = FALSE;
#line 677 "../src/DynamicNotebook.vala"
			_tmp0_ = TRUE;
#line 677 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 6582 "DynamicNotebook.c"
				gint _tmp2_;
				gint _tmp3_;
				GtkNotebook* _tmp4_;
				GtkNotebook* _tmp5_;
				GtkWidget* _tmp6_;
				GtkWidget* _tmp7_;
				Tab* _tmp8_;
#line 677 "../src/DynamicNotebook.vala"
				if (!_tmp0_) {
#line 6592 "DynamicNotebook.c"
					gint _tmp1_;
#line 677 "../src/DynamicNotebook.vala"
					_tmp1_ = i;
#line 677 "../src/DynamicNotebook.vala"
					i = _tmp1_ + 1;
#line 6598 "DynamicNotebook.c"
				}
#line 677 "../src/DynamicNotebook.vala"
				_tmp0_ = FALSE;
#line 677 "../src/DynamicNotebook.vala"
				_tmp2_ = dynamic_notebook_get_n_tabs (self);
#line 677 "../src/DynamicNotebook.vala"
				_tmp3_ = _tmp2_;
#line 677 "../src/DynamicNotebook.vala"
				if (!(i < _tmp3_)) {
#line 677 "../src/DynamicNotebook.vala"
					break;
#line 6610 "DynamicNotebook.c"
				}
#line 678 "../src/DynamicNotebook.vala"
				_tmp4_ = self->priv->notebook;
#line 678 "../src/DynamicNotebook.vala"
				_tmp5_ = self->priv->notebook;
#line 678 "../src/DynamicNotebook.vala"
				_tmp6_ = gtk_notebook_get_nth_page (_tmp5_, i);
#line 678 "../src/DynamicNotebook.vala"
				_tmp7_ = gtk_notebook_get_tab_label (_tmp4_, _tmp6_);
#line 678 "../src/DynamicNotebook.vala"
				_tmp8_ = _g_object_ref0 (IS_TAB (_tmp7_) ? ((Tab*) _tmp7_) : NULL);
#line 678 "../src/DynamicNotebook.vala"
				self->priv->_tabs = g_list_append (self->priv->_tabs, _tmp8_);
#line 6624 "DynamicNotebook.c"
			}
		}
	}
#line 680 "../src/DynamicNotebook.vala"
	_tmp9_ = self->priv->_tabs;
#line 680 "../src/DynamicNotebook.vala"
	result = _tmp9_;
#line 680 "../src/DynamicNotebook.vala"
	return result;
#line 6634 "DynamicNotebook.c"
}

const gchar*
dynamic_notebook_get_group_name (DynamicNotebook* self)
{
	const gchar* result;
	GtkNotebook* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 685 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 685 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 685 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_notebook_get_group_name (_tmp0_);
#line 685 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 685 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 685 "../src/DynamicNotebook.vala"
	return result;
#line 6656 "DynamicNotebook.c"
}

void
dynamic_notebook_set_group_name (DynamicNotebook* self,
                                 const gchar* value)
{
	GtkNotebook* _tmp0_;
#line 686 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 686 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 686 "../src/DynamicNotebook.vala"
	gtk_notebook_set_group_name (_tmp0_, value);
#line 686 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY]);
#line 6672 "DynamicNotebook.c"
}

DynamicNotebookTabBarBehavior
dynamic_notebook_get_tab_bar_behavior (DynamicNotebook* self)
{
	DynamicNotebookTabBarBehavior result;
	DynamicNotebookTabBarBehavior _tmp0_;
#line 704 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 704 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_tab_bar_behavior;
#line 704 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 704 "../src/DynamicNotebook.vala"
	return result;
#line 6688 "DynamicNotebook.c"
}

void
dynamic_notebook_set_tab_bar_behavior (DynamicNotebook* self,
                                       DynamicNotebookTabBarBehavior value)
{
#line 699 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 700 "../src/DynamicNotebook.vala"
	self->priv->_tab_bar_behavior = value;
#line 701 "../src/DynamicNotebook.vala"
	dynamic_notebook_update_tabs_visibility (self);
#line 699 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY]);
#line 6703 "DynamicNotebook.c"
}

GtkMenu*
dynamic_notebook_get_menu (DynamicNotebook* self)
{
	GtkMenu* result;
	GtkMenu* _tmp0_;
#line 712 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 712 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_menu;
#line 712 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 712 "../src/DynamicNotebook.vala"
	return result;
#line 6719 "DynamicNotebook.c"
}

static void
dynamic_notebook_set_menu (DynamicNotebook* self,
                           GtkMenu* value)
{
#line 712 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 712 "../src/DynamicNotebook.vala"
	if (dynamic_notebook_get_menu (self) != value) {
#line 6730 "DynamicNotebook.c"
		GtkMenu* _tmp0_;
#line 712 "../src/DynamicNotebook.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 712 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self->priv->_menu);
#line 712 "../src/DynamicNotebook.vala"
		self->priv->_menu = _tmp0_;
#line 712 "../src/DynamicNotebook.vala"
		g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_MENU_PROPERTY]);
#line 6740 "DynamicNotebook.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 512 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 3);
#line 512 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 512 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 512 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 6766 "DynamicNotebook.c"
	} else {
#line 512 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 512 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 6772 "DynamicNotebook.c"
	}
#line 512 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 512 "../src/DynamicNotebook.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 6778 "DynamicNotebook.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 512 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 3);
#line 512 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 512 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 512 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 6803 "DynamicNotebook.c"
	} else {
#line 512 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 512 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 6809 "DynamicNotebook.c"
	}
#line 512 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT) (marshal_data ? marshal_data : cc->callback);
#line 512 "../src/DynamicNotebook.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 6815 "DynamicNotebook.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_INT_INT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 512 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 4);
#line 512 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 512 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 512 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 6840 "DynamicNotebook.c"
	} else {
#line 512 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 512 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 6846 "DynamicNotebook.c"
	}
#line 512 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 512 "../src/DynamicNotebook.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), data2);
#line 6852 "DynamicNotebook.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__OBJECT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 512 "../src/DynamicNotebook.vala"
	g_return_if_fail (return_value != NULL);
#line 512 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 2);
#line 512 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 512 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 512 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 6880 "DynamicNotebook.c"
	} else {
#line 512 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 512 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 6886 "DynamicNotebook.c"
	}
#line 512 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_BOOLEAN__OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 512 "../src/DynamicNotebook.vala"
	v_return = callback (data1, g_value_get_object (param_values + 1), data2);
#line 512 "../src/DynamicNotebook.vala"
	g_value_set_boolean (return_value, v_return);
#line 6894 "DynamicNotebook.c"
}

static gboolean
_dynamic_notebook___lambda22_ (DynamicNotebook* self,
                               cairo_t* ctx)
{
	gboolean result = FALSE;
	GtkStyleContext* _tmp0_;
#line 758 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 759 "../src/DynamicNotebook.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 759 "../src/DynamicNotebook.vala"
	gtk_render_activity (_tmp0_, ctx, (gdouble) 0, (gdouble) 0, (gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self), (gdouble) 27);
#line 760 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 760 "../src/DynamicNotebook.vala"
	return result;
#line 6913 "DynamicNotebook.c"
}

static gboolean
__dynamic_notebook___lambda22__gtk_widget_draw (GtkWidget* _sender,
                                                cairo_t* cr,
                                                gpointer self)
{
	gboolean result;
	result = _dynamic_notebook___lambda22_ ((DynamicNotebook*) self, cr);
#line 758 "../src/DynamicNotebook.vala"
	return result;
#line 6925 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda23_ (DynamicNotebook* self)
{
#line 774 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 6933 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda23__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self)
{
#line 773 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda23_ ((DynamicNotebook*) self);
#line 6942 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda24_ (DynamicNotebook* self)
{
#line 778 "../src/DynamicNotebook.vala"
	dynamic_notebook_restore_last_tab (self);
#line 6950 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda24__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self)
{
#line 777 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda24_ ((DynamicNotebook*) self);
#line 6959 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda25_ (DynamicNotebook* self,
                               const gchar* label,
                               const gchar* restore_data,
                               GIcon* icon)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkButton* _tmp2_;
	ClosedTabs* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkMenuItem* _tmp6_;
	ClosedTabs* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
#line 782 "../src/DynamicNotebook.vala"
	g_return_if_fail (label != NULL);
#line 782 "../src/DynamicNotebook.vala"
	g_return_if_fail (restore_data != NULL);
#line 783 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_allow_restoring (self);
#line 783 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 783 "../src/DynamicNotebook.vala"
	if (!_tmp1_) {
#line 784 "../src/DynamicNotebook.vala"
		return;
#line 6990 "DynamicNotebook.c"
	}
#line 785 "../src/DynamicNotebook.vala"
	_tmp2_ = self->priv->restore_button;
#line 785 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->closed_tabs;
#line 785 "../src/DynamicNotebook.vala"
	_tmp4_ = closed_tabs_get_empty (_tmp3_);
#line 785 "../src/DynamicNotebook.vala"
	_tmp5_ = _tmp4_;
#line 785 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, !_tmp5_);
#line 786 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->restore_tab_m;
#line 786 "../src/DynamicNotebook.vala"
	_tmp7_ = self->priv->closed_tabs;
#line 786 "../src/DynamicNotebook.vala"
	_tmp8_ = closed_tabs_get_empty (_tmp7_);
#line 786 "../src/DynamicNotebook.vala"
	_tmp9_ = _tmp8_;
#line 786 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, !_tmp9_);
#line 787 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_RESTORED_SIGNAL], 0, label, restore_data, icon);
#line 7014 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda25__closed_tabs_restored (ClosedTabs* _sender,
                                                     const gchar* label,
                                                     const gchar* restore_data,
                                                     GIcon* icon,
                                                     gpointer self)
{
#line 782 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda25_ ((DynamicNotebook*) self, label, restore_data, icon);
#line 7026 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda26_ (DynamicNotebook* self)
{
	GtkButton* _tmp0_;
	GtkMenuItem* _tmp1_;
#line 791 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->restore_button;
#line 791 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 792 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->restore_tab_m;
#line 792 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 7042 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda26__closed_tabs_cleared (ClosedTabs* _sender,
                                                    gpointer self)
{
#line 790 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda26_ ((DynamicNotebook*) self);
#line 7051 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda27_ (DynamicNotebook* self)
{
#line 818 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 7059 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 817 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda27_ ((DynamicNotebook*) self);
#line 7068 "DynamicNotebook.c"
}

static gboolean
_dynamic_notebook___lambda28_ (DynamicNotebook* self,
                               GdkEventButton* e)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GdkEventType _tmp1_;
#line 821 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 823 "../src/DynamicNotebook.vala"
	_tmp1_ = e->type;
#line 823 "../src/DynamicNotebook.vala"
	if (_tmp1_ == GDK_2BUTTON_PRESS) {
#line 823 "../src/DynamicNotebook.vala"
		_tmp0_ = e->button == ((guint) 1);
#line 7086 "DynamicNotebook.c"
	} else {
#line 823 "../src/DynamicNotebook.vala"
		_tmp0_ = FALSE;
#line 7090 "DynamicNotebook.c"
	}
#line 823 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 823 "../src/DynamicNotebook.vala"
	return result;
#line 7096 "DynamicNotebook.c"
}

static gboolean
__dynamic_notebook___lambda28__gtk_widget_button_press_event (GtkWidget* _sender,
                                                              GdkEventButton* event,
                                                              gpointer self)
{
	gboolean result;
	result = _dynamic_notebook___lambda28_ ((DynamicNotebook*) self, event);
#line 821 "../src/DynamicNotebook.vala"
	return result;
#line 7108 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda29_ (DynamicNotebook* self)
{
	GtkMenu* menu = NULL;
	ClosedTabs* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	GtkMenu* _tmp3_;
	GtkButton* _tmp4_;
	GtkMenu* _tmp5_;
	GtkMenu* _tmp6_;
	GtkButton* _tmp7_;
#line 827 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 827 "../src/DynamicNotebook.vala"
	_tmp1_ = closed_tabs_get_menu (_tmp0_);
#line 827 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 827 "../src/DynamicNotebook.vala"
	menu = _tmp2_;
#line 828 "../src/DynamicNotebook.vala"
	_tmp3_ = menu;
#line 828 "../src/DynamicNotebook.vala"
	_tmp4_ = self->priv->restore_button;
#line 828 "../src/DynamicNotebook.vala"
	g_object_set (_tmp3_, "attach-widget", (GtkWidget*) _tmp4_, NULL);
#line 829 "../src/DynamicNotebook.vala"
	_tmp5_ = menu;
#line 829 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp5_);
#line 830 "../src/DynamicNotebook.vala"
	_tmp6_ = menu;
#line 830 "../src/DynamicNotebook.vala"
	_tmp7_ = self->priv->restore_button;
#line 830 "../src/DynamicNotebook.vala"
	gtk_menu_popup_at_widget (_tmp6_, (GtkWidget*) _tmp7_, GDK_GRAVITY_SOUTH_EAST, GDK_GRAVITY_NORTH_EAST, NULL);
#line 826 "../src/DynamicNotebook.vala"
	_g_object_unref0 (menu);
#line 7149 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 826 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda29_ ((DynamicNotebook*) self);
#line 7158 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda30_ (DynamicNotebook* self)
{
#line 837 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_size (self);
#line 7166 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda30__gtk_widget_size_allocate (GtkWidget* _sender,
                                                         GtkAllocation* allocation,
                                                         gpointer self)
{
#line 836 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda30_ ((DynamicNotebook*) self);
#line 7176 "DynamicNotebook.c"
}

static gboolean
_dynamic_notebook___lambda31_ (DynamicNotebook* self,
                               GdkEventButton* e)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GdkEventType _tmp1_;
#line 840 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 841 "../src/DynamicNotebook.vala"
	_tmp1_ = e->type;
#line 841 "../src/DynamicNotebook.vala"
	if (_tmp1_ == GDK_2BUTTON_PRESS) {
#line 841 "../src/DynamicNotebook.vala"
		_tmp0_ = e->button == ((guint) 1);
#line 7194 "DynamicNotebook.c"
	} else {
#line 841 "../src/DynamicNotebook.vala"
		_tmp0_ = FALSE;
#line 7198 "DynamicNotebook.c"
	}
#line 841 "../src/DynamicNotebook.vala"
	if (_tmp0_) {
#line 842 "../src/DynamicNotebook.vala"
		g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 7204 "DynamicNotebook.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 843 "../src/DynamicNotebook.vala"
		if (e->button == ((guint) 2)) {
#line 7209 "DynamicNotebook.c"
			gboolean _tmp3_;
			gboolean _tmp4_;
#line 843 "../src/DynamicNotebook.vala"
			_tmp3_ = dynamic_notebook_get_allow_restoring (self);
#line 843 "../src/DynamicNotebook.vala"
			_tmp4_ = _tmp3_;
#line 843 "../src/DynamicNotebook.vala"
			_tmp2_ = _tmp4_;
#line 7218 "DynamicNotebook.c"
		} else {
#line 843 "../src/DynamicNotebook.vala"
			_tmp2_ = FALSE;
#line 7222 "DynamicNotebook.c"
		}
#line 843 "../src/DynamicNotebook.vala"
		if (_tmp2_) {
#line 844 "../src/DynamicNotebook.vala"
			dynamic_notebook_restore_last_tab (self);
#line 845 "../src/DynamicNotebook.vala"
			result = TRUE;
#line 845 "../src/DynamicNotebook.vala"
			return result;
#line 7232 "DynamicNotebook.c"
		} else {
			gboolean _tmp5_ = FALSE;
#line 846 "../src/DynamicNotebook.vala"
			if (e->button == ((guint) 3)) {
#line 7237 "DynamicNotebook.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_;
				gboolean _tmp8_;
#line 846 "../src/DynamicNotebook.vala"
				_tmp7_ = dynamic_notebook_get_allow_restoring (self);
#line 846 "../src/DynamicNotebook.vala"
				_tmp8_ = _tmp7_;
#line 846 "../src/DynamicNotebook.vala"
				if (_tmp8_) {
#line 846 "../src/DynamicNotebook.vala"
					_tmp6_ = TRUE;
#line 7249 "DynamicNotebook.c"
				} else {
					gboolean _tmp9_;
					gboolean _tmp10_;
#line 846 "../src/DynamicNotebook.vala"
					_tmp9_ = dynamic_notebook_get_add_button_visible (self);
#line 846 "../src/DynamicNotebook.vala"
					_tmp10_ = _tmp9_;
#line 846 "../src/DynamicNotebook.vala"
					_tmp6_ = _tmp10_;
#line 7259 "DynamicNotebook.c"
				}
#line 846 "../src/DynamicNotebook.vala"
				_tmp5_ = _tmp6_;
#line 7263 "DynamicNotebook.c"
			} else {
#line 846 "../src/DynamicNotebook.vala"
				_tmp5_ = FALSE;
#line 7267 "DynamicNotebook.c"
			}
#line 846 "../src/DynamicNotebook.vala"
			if (_tmp5_) {
#line 7271 "DynamicNotebook.c"
				GtkMenu* _tmp11_;
#line 847 "../src/DynamicNotebook.vala"
				_tmp11_ = self->priv->_menu;
#line 847 "../src/DynamicNotebook.vala"
				gtk_menu_popup_at_pointer (_tmp11_, (GdkEvent*) e);
#line 7277 "DynamicNotebook.c"
			}
		}
	}
#line 850 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 850 "../src/DynamicNotebook.vala"
	return result;
#line 7285 "DynamicNotebook.c"
}

static gboolean
__dynamic_notebook___lambda31__gtk_widget_button_press_event (GtkWidget* _sender,
                                                              GdkEventButton* event,
                                                              gpointer self)
{
	gboolean result;
	result = _dynamic_notebook___lambda31_ ((DynamicNotebook*) self, event);
#line 840 "../src/DynamicNotebook.vala"
	return result;
#line 7297 "DynamicNotebook.c"
}

static gboolean
_dynamic_notebook___lambda32_ (DynamicNotebook* self,
                               GdkEventKey* e)
{
	gboolean result = FALSE;
	GdkModifierType _tmp0_;
#line 853 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 854 "../src/DynamicNotebook.vala"
	_tmp0_ = e->state;
#line 854 "../src/DynamicNotebook.vala"
	e->state = _tmp0_ & MODIFIER_MASK;
#line 856 "../src/DynamicNotebook.vala"
	switch (e->keyval) {
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_w:
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_W:
#line 7318 "DynamicNotebook.c"
		{
			GdkModifierType _tmp1_;
#line 859 "../src/DynamicNotebook.vala"
			_tmp1_ = e->state;
#line 859 "../src/DynamicNotebook.vala"
			if (_tmp1_ == GDK_CONTROL_MASK) {
#line 7325 "DynamicNotebook.c"
				gboolean _tmp2_;
				gboolean _tmp3_;
				Tab* _tmp4_;
				Tab* _tmp5_;
#line 860 "../src/DynamicNotebook.vala"
				_tmp2_ = dynamic_notebook_get_tabs_closable (self);
#line 860 "../src/DynamicNotebook.vala"
				_tmp3_ = _tmp2_;
#line 860 "../src/DynamicNotebook.vala"
				if (!_tmp3_) {
#line 861 "../src/DynamicNotebook.vala"
					break;
#line 7338 "DynamicNotebook.c"
				}
#line 864 "../src/DynamicNotebook.vala"
				_tmp4_ = dynamic_notebook_get_current (self);
#line 864 "../src/DynamicNotebook.vala"
				_tmp5_ = _tmp4_;
#line 864 "../src/DynamicNotebook.vala"
				tab_close (_tmp5_);
#line 865 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 865 "../src/DynamicNotebook.vala"
				return result;
#line 7350 "DynamicNotebook.c"
			}
#line 868 "../src/DynamicNotebook.vala"
			break;
#line 7354 "DynamicNotebook.c"
		}
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_t:
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_T:
#line 7360 "DynamicNotebook.c"
		{
			GdkModifierType _tmp6_;
#line 872 "../src/DynamicNotebook.vala"
			_tmp6_ = e->state;
#line 872 "../src/DynamicNotebook.vala"
			if (_tmp6_ == GDK_CONTROL_MASK) {
#line 873 "../src/DynamicNotebook.vala"
				g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 874 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 874 "../src/DynamicNotebook.vala"
				return result;
#line 7373 "DynamicNotebook.c"
			} else {
				gboolean _tmp7_ = FALSE;
				GdkModifierType _tmp8_;
#line 875 "../src/DynamicNotebook.vala"
				_tmp8_ = e->state;
#line 875 "../src/DynamicNotebook.vala"
				if (_tmp8_ == (GDK_CONTROL_MASK | GDK_SHIFT_MASK)) {
#line 7381 "DynamicNotebook.c"
					gboolean _tmp9_;
					gboolean _tmp10_;
#line 875 "../src/DynamicNotebook.vala"
					_tmp9_ = dynamic_notebook_get_allow_restoring (self);
#line 875 "../src/DynamicNotebook.vala"
					_tmp10_ = _tmp9_;
#line 875 "../src/DynamicNotebook.vala"
					_tmp7_ = _tmp10_;
#line 7390 "DynamicNotebook.c"
				} else {
#line 875 "../src/DynamicNotebook.vala"
					_tmp7_ = FALSE;
#line 7394 "DynamicNotebook.c"
				}
#line 875 "../src/DynamicNotebook.vala"
				if (_tmp7_) {
#line 876 "../src/DynamicNotebook.vala"
					dynamic_notebook_restore_last_tab (self);
#line 877 "../src/DynamicNotebook.vala"
					result = TRUE;
#line 877 "../src/DynamicNotebook.vala"
					return result;
#line 7404 "DynamicNotebook.c"
				}
			}
#line 880 "../src/DynamicNotebook.vala"
			break;
#line 7409 "DynamicNotebook.c"
		}
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_Page_Up:
#line 7413 "DynamicNotebook.c"
		{
			GdkModifierType _tmp11_;
#line 883 "../src/DynamicNotebook.vala"
			_tmp11_ = e->state;
#line 883 "../src/DynamicNotebook.vala"
			if (_tmp11_ == GDK_CONTROL_MASK) {
#line 884 "../src/DynamicNotebook.vala"
				dynamic_notebook_next_page (self);
#line 885 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 885 "../src/DynamicNotebook.vala"
				return result;
#line 7426 "DynamicNotebook.c"
			}
#line 888 "../src/DynamicNotebook.vala"
			break;
#line 7430 "DynamicNotebook.c"
		}
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_Page_Down:
#line 7434 "DynamicNotebook.c"
		{
			GdkModifierType _tmp12_;
#line 891 "../src/DynamicNotebook.vala"
			_tmp12_ = e->state;
#line 891 "../src/DynamicNotebook.vala"
			if (_tmp12_ == GDK_CONTROL_MASK) {
#line 892 "../src/DynamicNotebook.vala"
				dynamic_notebook_previous_page (self);
#line 893 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 893 "../src/DynamicNotebook.vala"
				return result;
#line 7447 "DynamicNotebook.c"
			}
#line 896 "../src/DynamicNotebook.vala"
			break;
#line 7451 "DynamicNotebook.c"
		}
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_1:
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_2:
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_3:
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_4:
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_5:
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_6:
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_7:
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_8:
#line 7469 "DynamicNotebook.c"
		{
			GdkModifierType _tmp13_;
#line 906 "../src/DynamicNotebook.vala"
			_tmp13_ = e->state;
#line 906 "../src/DynamicNotebook.vala"
			if ((_tmp13_ & GDK_MOD1_MASK) == GDK_MOD1_MASK) {
#line 7476 "DynamicNotebook.c"
				guint i = 0U;
				gint n_pages = 0;
				GtkNotebook* _tmp14_;
				guint _tmp15_ = 0U;
				GtkNotebook* _tmp16_;
#line 907 "../src/DynamicNotebook.vala"
				i = e->keyval - 49;
#line 908 "../src/DynamicNotebook.vala"
				_tmp14_ = self->priv->notebook;
#line 908 "../src/DynamicNotebook.vala"
				n_pages = gtk_notebook_get_n_pages (_tmp14_);
#line 909 "../src/DynamicNotebook.vala"
				if (i >= ((guint) n_pages)) {
#line 909 "../src/DynamicNotebook.vala"
					_tmp15_ = (guint) (n_pages - 1);
#line 7492 "DynamicNotebook.c"
				} else {
#line 909 "../src/DynamicNotebook.vala"
					_tmp15_ = i;
#line 7496 "DynamicNotebook.c"
				}
#line 909 "../src/DynamicNotebook.vala"
				_tmp16_ = self->priv->notebook;
#line 909 "../src/DynamicNotebook.vala"
				g_object_set (_tmp16_, "page", (gint) _tmp15_, NULL);
#line 910 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 910 "../src/DynamicNotebook.vala"
				return result;
#line 7506 "DynamicNotebook.c"
			}
#line 913 "../src/DynamicNotebook.vala"
			break;
#line 7510 "DynamicNotebook.c"
		}
#line 856 "../src/DynamicNotebook.vala"
		case GDK_KEY_9:
#line 7514 "DynamicNotebook.c"
		{
			GdkModifierType _tmp17_;
#line 916 "../src/DynamicNotebook.vala"
			_tmp17_ = e->state;
#line 916 "../src/DynamicNotebook.vala"
			if ((_tmp17_ & GDK_MOD1_MASK) == GDK_MOD1_MASK) {
#line 7521 "DynamicNotebook.c"
				GtkNotebook* _tmp18_;
				GtkNotebook* _tmp19_;
#line 917 "../src/DynamicNotebook.vala"
				_tmp18_ = self->priv->notebook;
#line 917 "../src/DynamicNotebook.vala"
				_tmp19_ = self->priv->notebook;
#line 917 "../src/DynamicNotebook.vala"
				g_object_set (_tmp18_, "page", gtk_notebook_get_n_pages (_tmp19_) - 1, NULL);
#line 918 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 918 "../src/DynamicNotebook.vala"
				return result;
#line 7534 "DynamicNotebook.c"
			}
#line 921 "../src/DynamicNotebook.vala"
			break;
#line 7538 "DynamicNotebook.c"
		}
		default:
#line 856 "../src/DynamicNotebook.vala"
		break;
#line 7543 "DynamicNotebook.c"
	}
#line 924 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 924 "../src/DynamicNotebook.vala"
	return result;
#line 7549 "DynamicNotebook.c"
}

static gboolean
__dynamic_notebook___lambda32__gtk_widget_key_press_event (GtkWidget* _sender,
                                                           GdkEventKey* event,
                                                           gpointer self)
{
	gboolean result;
	result = _dynamic_notebook___lambda32_ ((DynamicNotebook*) self, event);
#line 853 "../src/DynamicNotebook.vala"
	return result;
#line 7561 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_switch_page_gtk_notebook_switch_page (GtkNotebook* _sender,
                                                           GtkWidget* page,
                                                           guint page_num,
                                                           gpointer self)
{
#line 928 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_switch_page ((DynamicNotebook*) self, page, page_num);
#line 7572 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_page_added_gtk_notebook_page_added (GtkNotebook* _sender,
                                                         GtkWidget* child,
                                                         guint page_num,
                                                         gpointer self)
{
#line 929 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_page_added ((DynamicNotebook*) self, child, page_num);
#line 7583 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_page_removed_gtk_notebook_page_removed (GtkNotebook* _sender,
                                                             GtkWidget* child,
                                                             guint page_num,
                                                             gpointer self)
{
#line 930 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_page_removed ((DynamicNotebook*) self, child, page_num);
#line 7594 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_page_reordered_gtk_notebook_page_reordered (GtkNotebook* _sender,
                                                                 GtkWidget* child,
                                                                 guint page_num,
                                                                 gpointer self)
{
#line 931 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_page_reordered ((DynamicNotebook*) self, child, page_num);
#line 7605 "DynamicNotebook.c"
}

static GtkNotebook*
_dynamic_notebook_on_create_window_gtk_notebook_create_window (GtkNotebook* _sender,
                                                               GtkWidget* page,
                                                               gint x,
                                                               gint y,
                                                               gpointer self)
{
	GtkNotebook* result;
	result = dynamic_notebook_on_create_window ((DynamicNotebook*) self, page, x, y);
#line 932 "../src/DynamicNotebook.vala"
	return result;
#line 7619 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda33_ (DynamicNotebook* self)
{
	GtkNotebook* _tmp0_;
	guint _tmp1_;
	GtkNotebook* _tmp2_;
	guint _tmp3_;
	GtkNotebook* _tmp4_;
	guint _tmp5_;
	GtkNotebook* _tmp6_;
	guint _tmp7_;
	GtkNotebook* _tmp8_;
	guint _tmp9_;
#line 928 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 928 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("switch-page", gtk_notebook_get_type (), &_tmp1_, NULL, FALSE);
#line 928 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _dynamic_notebook_on_switch_page_gtk_notebook_switch_page, self);
#line 929 "../src/DynamicNotebook.vala"
	_tmp2_ = self->priv->notebook;
#line 929 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("page-added", gtk_notebook_get_type (), &_tmp3_, NULL, FALSE);
#line 929 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _dynamic_notebook_on_page_added_gtk_notebook_page_added, self);
#line 930 "../src/DynamicNotebook.vala"
	_tmp4_ = self->priv->notebook;
#line 930 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("page-removed", gtk_notebook_get_type (), &_tmp5_, NULL, FALSE);
#line 930 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _dynamic_notebook_on_page_removed_gtk_notebook_page_removed, self);
#line 931 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->notebook;
#line 931 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("page-reordered", gtk_notebook_get_type (), &_tmp7_, NULL, FALSE);
#line 931 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _dynamic_notebook_on_page_reordered_gtk_notebook_page_reordered, self);
#line 932 "../src/DynamicNotebook.vala"
	_tmp8_ = self->priv->notebook;
#line 932 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("create-window", gtk_notebook_get_type (), &_tmp9_, NULL, FALSE);
#line 932 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _dynamic_notebook_on_create_window_gtk_notebook_create_window, self);
#line 7665 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda33__gtk_widget_destroy (GtkWidget* _sender,
                                                   gpointer self)
{
#line 927 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda33_ ((DynamicNotebook*) self);
#line 7674 "DynamicNotebook.c"
}

static GObject *
dynamic_notebook_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DynamicNotebook * self;
	GtkNotebook* _tmp0_;
	GtkNotebook* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkNotebook* _tmp3_;
	GtkNotebook* _tmp4_;
	GtkNotebook* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenu* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkMenuItem* _tmp10_;
	GtkMenu* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenu* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenu* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenuItem* _tmp17_;
	ClosedTabs* _tmp18_;
	ClosedTabs* _tmp19_;
	ClosedTabs* _tmp20_;
	GtkButton* _tmp21_;
	GtkButton* _tmp22_;
	GtkButton* _tmp23_;
	GtkButton* _tmp24_;
	GtkButton* _tmp25_;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	GtkButton* _tmp28_;
	GtkButton* _tmp29_;
	GtkNotebook* _tmp30_;
	GtkButton* _tmp31_;
	GtkNotebook* _tmp32_;
	GtkButton* _tmp33_;
	GtkButton* _tmp34_;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkMenuItem* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	GtkButton* _tmp40_;
	gboolean _tmp41_;
	gboolean _tmp42_;
	GtkNotebook* _tmp43_;
	GtkNotebook* _tmp44_;
	GtkNotebook* _tmp45_;
	GtkNotebook* _tmp46_;
	GtkNotebook* _tmp47_;
#line 748 "../src/DynamicNotebook.vala"
	parent_class = G_OBJECT_CLASS (dynamic_notebook_parent_class);
#line 748 "../src/DynamicNotebook.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 748 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook);
#line 749 "../src/DynamicNotebook.vala"
	_tmp0_ = (GtkNotebook*) gtk_notebook_new ();
#line 749 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp0_);
#line 749 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->notebook);
#line 749 "../src/DynamicNotebook.vala"
	self->priv->notebook = _tmp0_;
#line 750 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->notebook;
#line 750 "../src/DynamicNotebook.vala"
	gtk_widget_set_can_focus ((GtkWidget*) _tmp1_, FALSE);
#line 751 "../src/DynamicNotebook.vala"
	gtk_event_box_set_visible_window ((GtkEventBox*) self, FALSE);
#line 752 "../src/DynamicNotebook.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 752 "../src/DynamicNotebook.vala"
	gtk_style_context_add_class (_tmp2_, "dynamic-notebook");
#line 754 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->notebook;
#line 754 "../src/DynamicNotebook.vala"
	gtk_notebook_set_scrollable (_tmp3_, TRUE);
#line 755 "../src/DynamicNotebook.vala"
	_tmp4_ = self->priv->notebook;
#line 755 "../src/DynamicNotebook.vala"
	gtk_notebook_set_show_border (_tmp4_, FALSE);
#line 756 "../src/DynamicNotebook.vala"
	self->priv->_tab_bar_behavior = DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS;
#line 758 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "draw", (GCallback) __dynamic_notebook___lambda22__gtk_widget_draw, self, 0);
#line 763 "../src/DynamicNotebook.vala"
	_tmp5_ = self->priv->notebook;
#line 763 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp5_);
#line 765 "../src/DynamicNotebook.vala"
	_tmp6_ = (GtkMenu*) gtk_menu_new ();
#line 765 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp6_);
#line 765 "../src/DynamicNotebook.vala"
	_tmp7_ = _tmp6_;
#line 765 "../src/DynamicNotebook.vala"
	dynamic_notebook_set_menu (self, _tmp7_);
#line 765 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp7_);
#line 766 "../src/DynamicNotebook.vala"
	_tmp8_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Tab"));
#line 766 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp8_);
#line 766 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->new_tab_m);
#line 766 "../src/DynamicNotebook.vala"
	self->priv->new_tab_m = _tmp8_;
#line 767 "../src/DynamicNotebook.vala"
	_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Undo Close Tab"));
#line 767 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp9_);
#line 767 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->restore_tab_m);
#line 767 "../src/DynamicNotebook.vala"
	self->priv->restore_tab_m = _tmp9_;
#line 768 "../src/DynamicNotebook.vala"
	_tmp10_ = self->priv->restore_tab_m;
#line 768 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
#line 769 "../src/DynamicNotebook.vala"
	_tmp11_ = self->priv->_menu;
#line 769 "../src/DynamicNotebook.vala"
	_tmp12_ = self->priv->new_tab_m;
#line 769 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp11_, _tmp12_);
#line 770 "../src/DynamicNotebook.vala"
	_tmp13_ = self->priv->_menu;
#line 770 "../src/DynamicNotebook.vala"
	_tmp14_ = self->priv->restore_tab_m;
#line 770 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp13_, _tmp14_);
#line 771 "../src/DynamicNotebook.vala"
	_tmp15_ = self->priv->_menu;
#line 771 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp15_);
#line 773 "../src/DynamicNotebook.vala"
	_tmp16_ = self->priv->new_tab_m;
#line 773 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp16_, "activate", (GCallback) __dynamic_notebook___lambda23__gtk_menu_item_activate, self, 0);
#line 777 "../src/DynamicNotebook.vala"
	_tmp17_ = self->priv->restore_tab_m;
#line 777 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp17_, "activate", (GCallback) __dynamic_notebook___lambda24__gtk_menu_item_activate, self, 0);
#line 781 "../src/DynamicNotebook.vala"
	_tmp18_ = closed_tabs_new ();
#line 781 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->closed_tabs);
#line 781 "../src/DynamicNotebook.vala"
	self->priv->closed_tabs = _tmp18_;
#line 782 "../src/DynamicNotebook.vala"
	_tmp19_ = self->priv->closed_tabs;
#line 782 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp19_, "restored", (GCallback) __dynamic_notebook___lambda25__closed_tabs_restored, self, 0);
#line 790 "../src/DynamicNotebook.vala"
	_tmp20_ = self->priv->closed_tabs;
#line 790 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp20_, "cleared", (GCallback) __dynamic_notebook___lambda26__closed_tabs_cleared, self, 0);
#line 795 "../src/DynamicNotebook.vala"
	_tmp21_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 795 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp21_);
#line 795 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->add_button);
#line 795 "../src/DynamicNotebook.vala"
	self->priv->add_button = _tmp21_;
#line 796 "../src/DynamicNotebook.vala"
	_tmp22_ = self->priv->add_button;
#line 796 "../src/DynamicNotebook.vala"
	gtk_button_set_relief (_tmp22_, GTK_RELIEF_NONE);
#line 797 "../src/DynamicNotebook.vala"
	_tmp23_ = self->priv->add_button;
#line 797 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp23_, _ ("New Tab"));
#line 806 "../src/DynamicNotebook.vala"
	_tmp24_ = (GtkButton*) gtk_button_new_from_icon_name ("document-open-recent-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 806 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp24_);
#line 806 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->restore_button);
#line 806 "../src/DynamicNotebook.vala"
	self->priv->restore_button = _tmp24_;
#line 807 "../src/DynamicNotebook.vala"
	_tmp25_ = self->priv->restore_button;
#line 807 "../src/DynamicNotebook.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp25_, 3);
#line 808 "../src/DynamicNotebook.vala"
	_tmp26_ = self->priv->restore_button;
#line 808 "../src/DynamicNotebook.vala"
	gtk_button_set_relief (_tmp26_, GTK_RELIEF_NONE);
#line 809 "../src/DynamicNotebook.vala"
	_tmp27_ = self->priv->restore_button;
#line 809 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp27_, _ ("Closed Tabs"));
#line 810 "../src/DynamicNotebook.vala"
	_tmp28_ = self->priv->restore_button;
#line 810 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp28_, FALSE);
#line 811 "../src/DynamicNotebook.vala"
	_tmp29_ = self->priv->restore_button;
#line 811 "../src/DynamicNotebook.vala"
	gtk_widget_show ((GtkWidget*) _tmp29_);
#line 813 "../src/DynamicNotebook.vala"
	_tmp30_ = self->priv->notebook;
#line 813 "../src/DynamicNotebook.vala"
	_tmp31_ = self->priv->add_button;
#line 813 "../src/DynamicNotebook.vala"
	gtk_notebook_set_action_widget (_tmp30_, (GtkWidget*) _tmp31_, GTK_PACK_START);
#line 814 "../src/DynamicNotebook.vala"
	_tmp32_ = self->priv->notebook;
#line 814 "../src/DynamicNotebook.vala"
	_tmp33_ = self->priv->restore_button;
#line 814 "../src/DynamicNotebook.vala"
	gtk_notebook_set_action_widget (_tmp32_, (GtkWidget*) _tmp33_, GTK_PACK_END);
#line 817 "../src/DynamicNotebook.vala"
	_tmp34_ = self->priv->add_button;
#line 817 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp34_, "clicked", (GCallback) __dynamic_notebook___lambda27__gtk_button_clicked, self, 0);
#line 821 "../src/DynamicNotebook.vala"
	_tmp35_ = self->priv->add_button;
#line 821 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) _tmp35_, "button-press-event", (GCallback) __dynamic_notebook___lambda28__gtk_widget_button_press_event, self, 0);
#line 826 "../src/DynamicNotebook.vala"
	_tmp36_ = self->priv->restore_button;
#line 826 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp36_, "clicked", (GCallback) __dynamic_notebook___lambda29__gtk_button_clicked, self, 0);
#line 833 "../src/DynamicNotebook.vala"
	_tmp37_ = self->priv->restore_tab_m;
#line 833 "../src/DynamicNotebook.vala"
	_tmp38_ = dynamic_notebook_get_allow_restoring (self);
#line 833 "../src/DynamicNotebook.vala"
	_tmp39_ = _tmp38_;
#line 833 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp37_, _tmp39_);
#line 834 "../src/DynamicNotebook.vala"
	_tmp40_ = self->priv->restore_button;
#line 834 "../src/DynamicNotebook.vala"
	_tmp41_ = dynamic_notebook_get_allow_restoring (self);
#line 834 "../src/DynamicNotebook.vala"
	_tmp42_ = _tmp41_;
#line 834 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp40_, _tmp42_);
#line 836 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) __dynamic_notebook___lambda30__gtk_widget_size_allocate, self, 0);
#line 840 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) __dynamic_notebook___lambda31__gtk_widget_button_press_event, self, 0);
#line 853 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "key-press-event", (GCallback) __dynamic_notebook___lambda32__gtk_widget_key_press_event, self, 0);
#line 927 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) __dynamic_notebook___lambda33__gtk_widget_destroy, self, 0);
#line 935 "../src/DynamicNotebook.vala"
	_tmp43_ = self->priv->notebook;
#line 935 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp43_, "switch-page", (GCallback) _dynamic_notebook_on_switch_page_gtk_notebook_switch_page, self, 0);
#line 936 "../src/DynamicNotebook.vala"
	_tmp44_ = self->priv->notebook;
#line 936 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp44_, "page-added", (GCallback) _dynamic_notebook_on_page_added_gtk_notebook_page_added, self, 0);
#line 937 "../src/DynamicNotebook.vala"
	_tmp45_ = self->priv->notebook;
#line 937 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp45_, "page-removed", (GCallback) _dynamic_notebook_on_page_removed_gtk_notebook_page_removed, self, 0);
#line 938 "../src/DynamicNotebook.vala"
	_tmp46_ = self->priv->notebook;
#line 938 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp46_, "page-reordered", (GCallback) _dynamic_notebook_on_page_reordered_gtk_notebook_page_reordered, self, 0);
#line 939 "../src/DynamicNotebook.vala"
	_tmp47_ = self->priv->notebook;
#line 939 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp47_, "create-window", (GCallback) _dynamic_notebook_on_create_window_gtk_notebook_create_window, self, 0);
#line 748 "../src/DynamicNotebook.vala"
	return obj;
#line 7955 "DynamicNotebook.c"
}

static void
dynamic_notebook_class_init (DynamicNotebookClass * klass,
                             gpointer klass_data)
{
#line 512 "../src/DynamicNotebook.vala"
	dynamic_notebook_parent_class = g_type_class_peek_parent (klass);
#line 512 "../src/DynamicNotebook.vala"
	g_type_class_adjust_private_offset (klass, &DynamicNotebook_private_offset);
#line 512 "../src/DynamicNotebook.vala"
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget*)) dynamic_notebook_real_show;
#line 512 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_dynamic_notebook_get_property;
#line 512 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_dynamic_notebook_set_property;
#line 512 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->constructor = dynamic_notebook_constructor;
#line 512 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->finalize = dynamic_notebook_finalize;
#line 7976 "DynamicNotebook.c"
	/**
	         * number of pages
	         */
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_N_TABS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_N_TABS_PROPERTY] = g_param_spec_int ("n-tabs", "n-tabs", "n-tabs", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 7982 "DynamicNotebook.c"
	/**
	         * Hide the tab bar and only show the pages
	         */
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY] = g_param_spec_boolean ("show-tabs", "show-tabs", "show-tabs", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY] = g_param_spec_boolean ("show-icons", "show-icons", "show-icons", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_DEPRECATED));
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY] = g_param_spec_boolean ("tabs-closable", "tabs-closable", "tabs-closable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY] = g_param_spec_boolean ("allow-drag", "allow-drag", "allow-drag", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY] = g_param_spec_boolean ("allow-new-window", "allow-new-window", "allow-new-window", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY] = g_param_spec_boolean ("allow-duplication", "allow-duplication", "allow-duplication", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY] = g_param_spec_boolean ("allow-restoring", "allow-restoring", "allow-restoring", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8000 "DynamicNotebook.c"
	/**
	         * Set or get the upper limit of the size of the set
	         * of restorable tabs.
	         */
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY] = g_param_spec_int ("max-restorable-tabs", "max-restorable-tabs", "max-restorable-tabs", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY] = g_param_spec_boolean ("add-button-visible", "add-button-visible", "add-button-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY] = g_param_spec_boolean ("allow-pinning", "allow-pinning", "allow-pinning", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY] = g_param_spec_boolean ("force-left", "force-left", "force-left", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8013 "DynamicNotebook.c"
	/**
	        * The text shown in the add button tooltip
	        */
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY] = g_param_spec_string ("add-button-tooltip", "add-button-tooltip", "add-button-tooltip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_CURRENT_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_CURRENT_PROPERTY] = g_param_spec_object ("current", "current", "current", TYPE_TAB, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_TABS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TABS_PROPERTY] = g_param_spec_pointer ("tabs", "tabs", "tabs", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY] = g_param_spec_string ("group-name", "group-name", "group-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8025 "DynamicNotebook.c"
	/**
	         * The behavior of the tab bar and its visibility
	        */
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY] = g_param_spec_enum ("tab-bar-behavior", "tab-bar-behavior", "tab-bar-behavior", DYNAMIC_NOTEBOOK_TYPE_TAB_BAR_BEHAVIOR, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8031 "DynamicNotebook.c"
	/**
	         * The menu appearing when the notebook is clicked on a blank space
	         */
#line 512 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_MENU_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", gtk_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 512 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_ADDED_SIGNAL] = g_signal_new ("tab-added", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_TAB);
#line 512 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REMOVED_SIGNAL] = g_signal_new ("tab-removed", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_TAB);
#line 512 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_SWITCHED_SIGNAL] = g_signal_new ("tab-switched", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_TAB, TYPE_TAB);
#line 512 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REORDERED_SIGNAL] = g_signal_new ("tab-reordered", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT, G_TYPE_NONE, 2, TYPE_TAB, G_TYPE_INT);
#line 512 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_MOVED_SIGNAL] = g_signal_new ("tab-moved", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT_INT, G_TYPE_NONE, 3, TYPE_TAB, G_TYPE_INT, G_TYPE_INT);
#line 512 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_DUPLICATED_SIGNAL] = g_signal_new ("tab-duplicated", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_TAB);
#line 512 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_RESTORED_SIGNAL] = g_signal_new ("tab-restored", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_STRING, g_icon_get_type ());
#line 512 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL] = g_signal_new ("new-tab-requested", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 512 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_CLOSE_TAB_REQUESTED_SIGNAL] = g_signal_new ("close-tab-requested", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__OBJECT, G_TYPE_BOOLEAN, 1, TYPE_TAB);
#line 8055 "DynamicNotebook.c"
}

static void
dynamic_notebook_instance_init (DynamicNotebook * self,
                                gpointer klass)
{
#line 512 "../src/DynamicNotebook.vala"
	self->priv = dynamic_notebook_get_instance_private (self);
#line 543 "../src/DynamicNotebook.vala"
	self->priv->_tabs_closable = TRUE;
#line 558 "../src/DynamicNotebook.vala"
	self->priv->_allow_drag = TRUE;
#line 572 "../src/DynamicNotebook.vala"
	self->priv->_allow_new_window = FALSE;
#line 586 "../src/DynamicNotebook.vala"
	self->priv->_allow_duplication = FALSE;
#line 601 "../src/DynamicNotebook.vala"
	self->priv->_allow_restoring = FALSE;
#line 623 "../src/DynamicNotebook.vala"
	self->priv->_add_button_visible = TRUE;
#line 640 "../src/DynamicNotebook.vala"
	self->priv->_allow_pinning = FALSE;
#line 652 "../src/DynamicNotebook.vala"
	self->priv->_force_left = TRUE;
#line 718 "../src/DynamicNotebook.vala"
	self->priv->tab_width = 150;
#line 8082 "DynamicNotebook.c"
}

static void
dynamic_notebook_finalize (GObject * obj)
{
	DynamicNotebook * self;
#line 512 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook);
#line 666 "../src/DynamicNotebook.vala"
	_g_free0 (self->priv->_add_button_tooltip);
#line 673 "../src/DynamicNotebook.vala"
	(self->priv->_tabs == NULL) ? NULL : (self->priv->_tabs = (_g_list_free__g_object_unref0_ (self->priv->_tabs), NULL));
#line 712 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_menu);
#line 714 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->closed_tabs);
#line 716 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->notebook);
#line 724 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->old_tab);
#line 733 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->new_tab_m);
#line 734 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->restore_tab_m);
#line 736 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->add_button);
#line 737 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->restore_button);
#line 512 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (dynamic_notebook_parent_class)->finalize (obj);
#line 8113 "DynamicNotebook.c"
}

/**
    * Tab bar widget designed for a variable number of tabs.
    * Supports showing a "New tab" button, restoring closed tabs, "pinning" tabs, and more.
    *
    * {{../doc/images/DynamicNotebook.png}}
    */
GType
dynamic_notebook_get_type (void)
{
	static volatile gsize dynamic_notebook_type_id__volatile = 0;
	if (g_once_init_enter (&dynamic_notebook_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DynamicNotebookClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dynamic_notebook_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DynamicNotebook), 0, (GInstanceInitFunc) dynamic_notebook_instance_init, NULL };
		GType dynamic_notebook_type_id;
		dynamic_notebook_type_id = g_type_register_static (gtk_event_box_get_type (), "DynamicNotebook", &g_define_type_info, 0);
		DynamicNotebook_private_offset = g_type_add_instance_private (dynamic_notebook_type_id, sizeof (DynamicNotebookPrivate));
		g_once_init_leave (&dynamic_notebook_type_id__volatile, dynamic_notebook_type_id);
	}
	return dynamic_notebook_type_id__volatile;
}

static void
_vala_dynamic_notebook_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	DynamicNotebook * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook);
#line 512 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_N_TABS_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_int (value, dynamic_notebook_get_n_tabs (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_show_tabs (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 8161 "DynamicNotebook.c"
		g_value_set_boolean (value, dynamic_notebook_get_show_icons (self));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_tabs_closable (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_drag (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_new_window (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_duplication (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_restoring (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_int (value, dynamic_notebook_get_max_restorable_tabs (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_add_button_visible (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_pinning (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_force_left (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_string (value, dynamic_notebook_get_add_button_tooltip (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_CURRENT_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_object (value, dynamic_notebook_get_current (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TABS_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_pointer (value, dynamic_notebook_get_tabs (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_string (value, dynamic_notebook_get_group_name (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_enum (value, dynamic_notebook_get_tab_bar_behavior (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_MENU_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		g_value_set_object (value, dynamic_notebook_get_menu (self));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 8256 "DynamicNotebook.c"
		default:
#line 512 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 8262 "DynamicNotebook.c"
	}
}

static void
_vala_dynamic_notebook_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	DynamicNotebook * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook);
#line 512 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_show_tabs (self, g_value_get_boolean (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 8285 "DynamicNotebook.c"
		dynamic_notebook_set_show_icons (self, g_value_get_boolean (value));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_tabs_closable (self, g_value_get_boolean (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_drag (self, g_value_get_boolean (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_new_window (self, g_value_get_boolean (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_duplication (self, g_value_get_boolean (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_restoring (self, g_value_get_boolean (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_max_restorable_tabs (self, g_value_get_int (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_add_button_visible (self, g_value_get_boolean (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_pinning (self, g_value_get_boolean (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_force_left (self, g_value_get_boolean (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_add_button_tooltip (self, g_value_get_string (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_CURRENT_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_current (self, g_value_get_object (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_group_name (self, g_value_get_string (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_tab_bar_behavior (self, g_value_get_enum (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 512 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_MENU_PROPERTY:
#line 512 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_menu (self, g_value_get_object (value));
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 8374 "DynamicNotebook.c"
		default:
#line 512 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 512 "../src/DynamicNotebook.vala"
		break;
#line 8380 "DynamicNotebook.c"
	}
}

